<?php

namespace application\personal_calendar;

use repository\ExportParameters;

use repository\ContentObjectExportController;
use common\libraries\Application;
use common\libraries\Request;
use common\libraries\Breadcrumb;
use common\libraries\Translation;
use common\libraries\Utilities;
use repository\ContentObjectExport;
/**
 * $Id: ical_exporter.class.php 201 2009-11-13 12:34:51Z chellee $
 *
 * @package application.personal_calendar.personal_calendar_manager.component
 */

class PersonalCalendarManagerIcalExporterComponent extends PersonalCalendarManager
{

    /**
     * Runs this component and displays its output.
     */
    public function run()
    {
        $id = Request :: get(PersonalCalendarManager :: PARAM_PERSONAL_CALENDAR_ID);
        if ($id)
        {
            $calendar_event_publication = $this->retrieve_personal_calendar_publication($id);
            
            $parameters = new ExportParameters($this->get_user_id(), ContentObjectExport :: FORMAT_ICAL, array(
                    $calendar_event_publication->get_content_object_id()));
            $exporter = ContentObjectExportController :: factory($parameters);
            $exporter->download();
        }
        else
        {
            $this->display_header();
            $this->display_error_message(Translation :: get('NoObjectSelected', null, Utilities :: COMMON_LIBRARIES));
            $this->dipslay_footer();
        }
    }

    public function add_additional_breadcrumbs(BreadcrumbTrail $breadcrumbtrail)
    {
        $breadcrumbtrail->add(new Breadcrumb($this->get_url(array(
                Application :: PARAM_ACTION => PersonalCalendarManager :: ACTION_BROWSE_CALENDAR)), Translation :: get('PersonalCalendarManagerBrowserComponent')));
        $breadcrumbtrail->add_help('personal_calendar_ical_exporter');
    }

    public function get_additional_parameters()
    {
        return array(self :: PARAM_PERSONAL_CALENDAR_ID);
    }

}
