<?php
namespace application\personal_calendar;

use common\libraries\DelegateComponent;
use repository\content_object\calendar_event\CalendarEvent;
use repository\content_object\task\Task;
use repository\content_object\external_calendar\ExternalCalendar;
use common\libraries\BreadcrumbTrail;



/**
 * $Id: publisher.class.php 205 2009-11-13 12:57:33Z vanpouckesven $
 * 
 * @package application.personal_calendar.personal_calendar_manager.component
 */
class PersonalCalendarManagerPublisherComponent extends PersonalCalendarManager implements 
        \repository\viewer\ViewerInterface, 
        DelegateComponent
{

    /**
     * Runs this component and displays its output.
     */
    public function run()
    {
        if (! \repository\viewer\Manager :: is_ready_to_be_published())
        {
            $repository_viewer = \repository\viewer\Manager :: construct($this);
            $repository_viewer->run();
        }
        else
        {
            $publisher = new PersonalCalendarPublisher($this);
            $publisher->get_publications_form(\repository\viewer\Manager :: get_selected_objects());
        }
    }

    public function get_allowed_content_object_types()
    {
        return array(CalendarEvent :: class_name(), Task :: class_name(), ExternalCalendar :: class_name());
    }

    public function add_additional_breadcrumbs(BreadcrumbTrail $breadcrumbtrail)
    {
        $breadcrumbtrail->add_help('personal_calendar_publisher');
    }
}
