<?php
namespace application\personal_messenger;

use common\libraries\AjaxManager;
use common\libraries\JsonAjaxResult;

/** * ***************************************************************************
 * This class handles the AJAX call for the count of new replies on the 
 * discussion identified by the given id.
 *
 * @name Chamilo Personal Messenger > PersonalMessengerAjaxHasNewReplies
 * @version 1.0.0
 * @author Stijn Van Hoecke
 * **************************************************************************** */
class PersonalMessengerAjaxHasNewReplies extends AjaxManager
{
    const PARAM_MESSAGE_IDENTIFIER = 'message_id';

    const PROPERTY_HAS = 'has_replies';

    /* (non-PHPdoc)
     * @see common\libraries.AjaxManager::required_parameters()
     */
    public function required_parameters()
    {
        return array(self :: PARAM_MESSAGE_IDENTIFIER);
    }

    /* (non-PHPdoc)
     * @see common\libraries.AjaxManager::run()
     */
    public function run()
    {       
        // get count
        $has = PersonalMessengerDataManager :: has_unread_replies($this->get_parameter(self :: PARAM_MESSAGE_IDENTIFIER)) != 0;

        // construct result
        $result = new JsonAjaxResult(200);
        
        // set properties
        $result->set_property(self :: PROPERTY_HAS, $has);
        
        // return result
        $result->display();
    }
}
