<?php

namespace application\personal_messenger;

use common\libraries\ObjectTableDataProvider;

/** * ***************************************************************************
 * Data provider for a discussion user table.
 *
 * @name Chamilo Personal Messenger > DiscussionUserTableDataProvider
 * @version 1.0.0
 * @author Stijn Van Hoecke
 * **************************************************************************** */
class DiscussionUserTableDataProvider extends ObjectTableDataProvider
{

    //**************************************************************************
    // CONSTRUCTOR
    //**************************************************************************
    /**
     * Constructor
     * @param PersonalMessengerManagerComponent $user_manager
     * @param Condition $condition
     */
    public function __construct($user_manager, $condition)
    {
        parent :: __construct($user_manager, $condition);
    }

    //**************************************************************************
    // GENERAL FUNCTIONS
    //**************************************************************************
    /**
     * Gets the messages
     * @param int $offset
     * @param int $max_objects
     * @param string $order_by
     * @return ResultSet A set of matching messages.
     */
    public function get_objects($offset, $max_objects, $order_by = null)
    {
        $order_by = $this->get_order_property($order_by);

        // construct conditions
        $condition = $this->get_condition();

        // retrieve the users
        return PersonalMessengerDataManager :: get_instance()->retrieve_user_message_users(
                $condition,
                $order_by,
                $offset,
                $max_objects
        );
    }

    /**
     * Gets the number of messages
     * @return int
     */
    public function get_object_count()
    {
        // construct conditions
        $condition = $this->get_condition();

        // retrieve the users
        return PersonalMessengerDataManager :: get_instance()->count_user_message($condition);
    }

}
