<?php

namespace application\personal_messenger;

use common\libraries\StaticTableColumn;
use common\libraries\Translation;
use common\libraries\Utilities;

/** * ***************************************************************************
 * Table column model for the ignored user table.
 *
 * @name Chamilo Personal Messenger > IgnoredUserTableColumnModel
 * @version 1.0.0
 * @author Stijn Van Hoecke
 * **************************************************************************** */
class IgnoredUserTableColumnModel extends DefaultUserTableColumnModel
{

    //**************************************************************************
    // GENERAL VARIABLES
    //**************************************************************************
    /**
     * The tables modification column
     */
    private static $modification_column;

    //**************************************************************************
    // CONSTRUCTOR
    //**************************************************************************
    /**
     * Constructor
     */
    public function __construct()
    {
        parent :: __construct();
        $this->add_column(self :: get_modification_column());
    }

    //**************************************************************************
    // STATIC FUNCTIONS
    //**************************************************************************
    /**
     * Gets the modification column
     * @return MessageTableColumn
     */
    public static function get_modification_column()
    {
        if (!isset(self :: $modification_column))
        {
            self :: $modification_column = new StaticTableColumn(
                            Translation :: get('Actions', null, Utilities :: COMMON_LIBRARIES)
            );
        }
        return self :: $modification_column;
    }

}
