<?php

namespace application\personal_messenger;

use common\libraries\Request;
use common\libraries\Theme;

/** * ***************************************************************************
 * Specific implementation of Viewer to view messages.
 *
 * @name Chamilo Personal Messenger > PersonalMessengerManagerViewerMessageComponent
 * @version 1.0.0
 * @author Stijn Van Hoecke
 * @see PersonalMessengerManagerViewerComponent
 * **************************************************************************** */
class PersonalMessengerManagerViewerMessageComponent extends PersonalMessengerManagerViewerComponent
{

    //**************************************************************************
    // CONSTRUCTOR
    //**************************************************************************
    /**
     * Constructor.
     */
    public function __construct($user = null)
    {
        parent :: __construct($user);
        Request :: set_get(self :: PARAM_REFERER, self :: ACTION_VIEW_MESSAGE);
    }

    //**************************************************************************
    // INHERITED FUNCTIONS
    //**************************************************************************
    /**
     * Adds additional features specific to the viewer implementation.
     */
    public function add_viewer_additionals()
    {
        //Do nothing, no additional features with regular messages
    }

    /**
     * Returns the message itself.
     * @return Message
     */
    public function get_root_message($message_id)
    {
        if (!$this->root_message)
        {
            // retrieve the message
            $message = $this->retrieve_message_by_id($message_id);

            $this->root_message = $message;
        }

        return $this->root_message;
    }

    /**
     * Returns the global division declaration
     * @return String HTML
     */
    public function get_global_div()
    {
        $global_div = '<div class="pm" id=message_' . $this->message->get_id() . '" style="background-image: url(' . Theme :: get_image_path() . 'view_message.png);">';
        return $global_div;
    }

    /**
     * Processes the forms and redirect before headers are sent.
     */
    public function process_forms()
    {
        //Do nothing, no forms need to be processed with regular messages
    }

}
