<?php
namespace application\weblcms\course;

class Autoloader
{

    /**
     * The array mapping class names to paths
     *
     * @var multitype:string
     */
     private static $map = array(
         'Autoloader' => '/autoloader.class.php',
         'CourseManager' => '/lib/course_manager/course_manager.class.php',
         'CourseManagerBrowseComponent' => '/lib/course_manager/component/browse.class.php',
         'CourseManagerBrowseSubscribedCoursesComponent' => '/lib/course_manager/component/browse_subscribed_courses.class.php',
         'CourseManagerBrowseUnsubscribedCoursesComponent' => '/lib/course_manager/component/browse_unsubscribed_courses.class.php',
         'CourseManagerCreateComponent' => '/lib/course_manager/component/create.class.php',
         'CourseManagerDeleteComponent' => '/lib/course_manager/component/delete.class.php',
         'CourseManagerQuickCreateComponent' => '/lib/course_manager/component/quick_create.class.php',
         'CourseManagerQuickUpdateComponent' => '/lib/course_manager/component/quick_update.class.php',
         'CourseManagerSubscribeComponent' => '/lib/course_manager/component/subscribe.class.php',
         'CourseManagerUnsubscribeComponent' => '/lib/course_manager/component/unsubscribe.class.php',
         'CourseManagerUpdateComponent' => '/lib/course_manager/component/update.class.php',
         'CourseManagerBrowseSubscriptionCoursesComponent' => '/lib/course_manager/component/abstract/browse_subscription_courses.class.php',
         'CourseManagerCourseFormActionComponent' => '/lib/course_manager/component/abstract/course_form_action.class.php',
         'CourseForm' => '/lib/form/course_form.class.php',
         'HTML_QuickForm_Rule_Course_Type' => '/lib/form/rule/course_type_rule.class.php',
         'CourseSubManagerSupport' => '/lib/interfaces/course_submanager_support.class.php',
         'Course' => '/lib/storage/data_class/course.class.php',
         'CourseEntityRelation' => '/lib/storage/data_class/course_entity_relation.class.php',
         'CourseGroupRelation' => '/lib/storage/data_class/course_group_relation.class.php',
         'CourseRelCourseSetting' => '/lib/storage/data_class/course_rel_course_setting.class.php',
         'CourseRelCourseSettingValue' => '/lib/storage/data_class/course_rel_course_setting_value.class.php',
         'CourseUserRelation' => '/lib/storage/data_class/course_user_relation.class.php',
         'DataManager' => '/lib/storage/data_manager/data_manager.class.php',
         'DoctrineDataManager' => '/lib/storage/data_manager/implementation/doctrine.class.php',
         'CourseTable' => '/lib/table/course_table/course_table.class.php',
         'CourseTableCellRenderer' => '/lib/table/course_table/course_table_cell_renderer.class.php',
         'CourseTableColumnModel' => '/lib/table/course_table/course_table_column_model.class.php',
         'CourseTableDataProvider' => '/lib/table/course_table/course_table_data_provider.class.php',
         'SubscribedCourseTable' => '/lib/table/subscribed_course_table/subscribed_course_table.class.php',
         'SubscribedCourseTableCellRenderer' => '/lib/table/subscribed_course_table/subscribed_course_table_cell_renderer.class.php',
         'SubscribedCourseTableColumnModel' => '/lib/table/subscribed_course_table/subscribed_course_table_column_model.class.php',
         'SubscribedCourseTableDataProvider' => '/lib/table/subscribed_course_table/subscribed_course_table_data_provider.class.php',
         'UnsubscribedCourseTable' => '/lib/table/unsubscribed_course_table/unsubscribed_course_table.class.php',
         'UnsubscribedCourseTableCellRenderer' => '/lib/table/unsubscribed_course_table/unsubscribed_course_table_cell_renderer.class.php',
         'UnsubscribedCourseTableColumnModel' => '/lib/table/unsubscribed_course_table/unsubscribed_course_table_column_model.class.php',
         'UnsubscribedCourseTableDataProvider' => '/lib/table/unsubscribed_course_table/unsubscribed_course_table_data_provider.class.php',
         'Activator' => '/package/activate/activator.class.php',
         'Deactivator' => '/package/deactivate/deactivator.class.php',
         'Installer' => '/package/install/installer.class.php'
    );

    /**
     * Try to load the class
     *
     * @param $classname string
     * @return boolean
     */
    public static function load($classname)
    {
        if (isset(self :: $map[$classname]))
        {
            require_once __DIR__ . self :: $map[$classname];
            return true;
        }

        return false;
    }

    /**
     * Synchronize the autoloader
     *
     * @param $update boolean
     * @return multitype:string
     */
    public static function synch($update)
    {
        return \common\libraries\AutoloaderUtilities :: synch(__DIR__, __DIR__, $update);
    }

}
?>