<?php
namespace application\weblcms\integration\core\home;

use common\libraries\EqualityCondition;
use common\libraries\AndCondition;
use common\libraries\ObjectTableOrder;
use tracking\TrackingDataManager;

class Block extends \core\home\Block
{

    public function get_last_login($user_id)
    {
        return $this->get_login_logout($user_id, 'login');
    }

    public function get_last_logout($user_id)
    {
        return $this->get_login_logout($user_id, 'logout');
    }

    protected function get_login_logout($user_id, $type)
    {
        // Retrieve the last login
        $tracking_data_manager = TrackingDataManager :: get_instance();
        $conditions = array();
        $order_by = new ObjectTableOrder(\user\integration\tracking\LoginLogout :: PROPERTY_DATE, SORT_DESC);
        $conditions[] = new EqualityCondition(\user\integration\tracking\LoginLogout :: PROPERTY_USER_ID, $user_id);
        $conditions[] = new EqualityCondition(\user\integration\tracking\LoginLogout :: PROPERTY_TYPE, $type);
        $condition = new AndCondition($conditions);
        $trackers = $tracking_data_manager->retrieve_tracker_items(
                \user\integration\tracking\LoginLogout :: get_table_name(), $condition, 0, 1, $order_by,
                \user\integration\tracking\LoginLogout :: CLASS_NAME);
        $tracker = $trackers->next_result();
        if (is_null($tracker))
        {
            return '0';
        }
        return $tracker->get_date();
    }
}
