<?php
namespace application\weblcms\integration\reporting;

class Autoloader
{

    /**
     * The array mapping class names to paths
     *
     * @var multitype:string
     */
     private static $map = array(
         'Autoloader' => '/autoloader.class.php',
         'Block' => '/lib/block.class.php',
         'CourseBlock' => '/lib/course_block.class.php',
         'ToolBlock' => '/lib/tool_block.class.php',
         'CourseInformationBlock' => '/lib/blocks/admin/course_information.class.php',
         'CoursesPerCategoryBlock' => '/lib/blocks/admin/courses_per_category.class.php',
         'MostActiveInactiveLastDetailBlock' => '/lib/blocks/admin/most_active_inactive_last_detail.class.php',
         'MostActiveInactiveLastPublicationBlock' => '/lib/blocks/admin/most_active_inactive_last_publication.class.php',
         'MostActiveInactiveLastVisitBlock' => '/lib/blocks/admin/most_active_inactive_last_visit.class.php',
         'NoOfCoursesBlock' => '/lib/blocks/admin/no_of_courses.class.php',
         'NoOfCoursesByLanguageBlock' => '/lib/blocks/admin/no_of_courses_by_language.class.php',
         'NoOfObjectsPerTypeBlock' => '/lib/blocks/admin/no_of_objects_per_type.class.php',
         'NoOfPublishedObjectsPerTypeBlock' => '/lib/blocks/admin/no_of_published_objects_per_type.class.php',
         'NoOfUsersSubscribedCourseBlock' => '/lib/blocks/admin/no_of_users_subscribed_course.class.php',
         'AssessmentBlock' => '/lib/blocks/assessment/assessment.class.php',
         'AssessmentAttemptsBlock' => '/lib/blocks/assessment/assessment_attempts.class.php',
         'AssessmentAttemptsUserBlock' => '/lib/blocks/assessment/assessment_attempts_user.class.php',
         'AssessmentInformationBlock' => '/lib/blocks/assessment/assessment_information.class.php',
         'AssessmentOverviewBlock' => '/lib/blocks/assessment/assessment_overview.class.php',
         'AssessmentQuestionAttemptsBlock' => '/lib/blocks/assessment/assessment_question_attempts.class.php',
         'AssessmentQuestionAttemptsUserBlock' => '/lib/blocks/assessment/assessment_question_attempts_user.class.php',
         'AssessmentQuestionInformationBlock' => '/lib/blocks/assessment/assessment_question_information.class.php',
         'AssessmentQuestionUserInformationBlock' => '/lib/blocks/assessment/assessment_question_user_information.class.php',
         'AssessmentQuestionUsersBlock' => '/lib/blocks/assessment/assessment_question_users.class.php',
         'AssessmentQuestionsBlock' => '/lib/blocks/assessment/assessment_questions.class.php',
         'AssessmentQuestionsUsersBlock' => '/lib/blocks/assessment/assessment_questions_users.class.php',
         'AssessmentUserInformationBlock' => '/lib/blocks/assessment/assessment_user_information.class.php',
         'AssessmentUserScoresBlock' => '/lib/blocks/assessment/assessment_user_scores.class.php',
         'AssessmentUsersBlock' => '/lib/blocks/assessment/assessment_users.class.php',
         'AssessmentsBlock' => '/lib/blocks/assessment/assessments.class.php',
         'AverageExerciseScoreBlock' => '/lib/blocks/assessment/average_exercise_score.class.php',
         'CourseUserExerciseInformationBlock' => '/lib/blocks/assessment/course_user_exercise_information.class.php',
         'AssessmentHotspotQuestionOptionsBlock' => '/lib/blocks/assessment/question_options/assessment_hotspot_question_options.class.php',
         'AssessmentMatchNumericQuestionOptionsBlock' => '/lib/blocks/assessment/question_options/assessment_match_numeric_question_options.class.php',
         'AssessmentMatchTextQuestionOptionsBlock' => '/lib/blocks/assessment/question_options/assessment_match_text_question_options.class.php',
         'AssessmentMatchingQuestionOptionsBlock' => '/lib/blocks/assessment/question_options/assessment_matching_question_options.class.php',
         'AssessmentMatrixQuestionOptionsBlock' => '/lib/blocks/assessment/question_options/assessment_matrix_question_options.class.php',
         'AssessmentMultipleChoiceQuestionOptionsBlock' => '/lib/blocks/assessment/question_options/assessment_multiple_choice_question_options.class.php',
         'AssessmentOpenQuestionOptionsBlock' => '/lib/blocks/assessment/question_options/assessment_open_question_options.class.php',
         'AssessmentQuestionOptionsBlock' => '/lib/blocks/assessment/question_options/assessment_question_options.class.php',
         'AssessmentRatingQuestionOptionsBlock' => '/lib/blocks/assessment/question_options/assessment_rating_question_options.class.php',
         'AssessmentSelectQuestionOptionsBlock' => '/lib/blocks/assessment/question_options/assessment_select_question_options.class.php',
         'FillInBlanksQuestionOptionsBlock' => '/lib/blocks/assessment/question_options/fill_in_blanks_question_options.class.php',
         'MatchQuestionOptionsBlock' => '/lib/blocks/assessment/question_options/match_question_options.class.php',
         'OrderingQuestionOptionsBlock' => '/lib/blocks/assessment/question_options/ordering_question_options.class.php',
         'AssignmentBlock' => '/lib/blocks/assignment/assignment.class.php',
         'AssignmentCourseGroupInformationBlock' => '/lib/blocks/assignment/assignment_course_group_information.class.php',
         'AssignmentCourseGroupScoresBlock' => '/lib/blocks/assignment/assignment_course_group_scores.class.php',
         'AssignmentCourseGroupsBlock' => '/lib/blocks/assignment/assignment_course_groups.class.php',
         'AssignmentGroupScoresBlock' => '/lib/blocks/assignment/assignment_group_scores.class.php',
         'AssignmentInformationBlock' => '/lib/blocks/assignment/assignment_information.class.php',
         'AssignmentPlatformGroupInformationBlock' => '/lib/blocks/assignment/assignment_platform_group_information.class.php',
         'AssignmentPlatformGroupScoresBlock' => '/lib/blocks/assignment/assignment_platform_group_scores.class.php',
         'AssignmentPlatformGroupsBlock' => '/lib/blocks/assignment/assignment_platform_groups.class.php',
         'AssignmentReportingManager' => '/lib/blocks/assignment/assignment_reporting_manager.class.php',
         'AssignmentSubmissionsBlock' => '/lib/blocks/assignment/assignment_submissions.class.php',
         'AssignmentSubmissionsGroupBlock' => '/lib/blocks/assignment/assignment_submissions_group.class.php',
         'AssignmentSubmissionsUserBlock' => '/lib/blocks/assignment/assignment_submissions_user.class.php',
         'AssignmentSubmitterInformationBlock' => '/lib/blocks/assignment/assignment_submitter_information.class.php',
         'AssignmentSubmitterSubmissionsBlock' => '/lib/blocks/assignment/assignment_submitter_submissions.class.php',
         'AssignmentSubmittersBlock' => '/lib/blocks/assignment/assignment_submitters.class.php',
         'AssignmentUserInformationBlock' => '/lib/blocks/assignment/assignment_user_information.class.php',
         'AssignmentUserScoresBlock' => '/lib/blocks/assignment/assignment_user_scores.class.php',
         'AssignmentUsersBlock' => '/lib/blocks/assignment/assignment_users.class.php',
         'CourseUserAssignmentInformationBlock' => '/lib/blocks/assignment/course_user_assignment_information.class.php',
         'AverageLearningPathScoreBlock' => '/lib/blocks/learning_path/average_learning_path_score.class.php',
         'CourseUserLearningPathInformationBlock' => '/lib/blocks/learning_path/course_user_learning_path_information.class.php',
         'LearningPathBlock' => '/lib/blocks/learning_path/learning_path.class.php',
         'LearningPathAttemptProgressBlock' => '/lib/blocks/learning_path/learning_path_attempt_progress.class.php',
         'LearningPathAttemptProgressDetailsBlock' => '/lib/blocks/learning_path/learning_path_attempt_progress_details.class.php',
         'LearningPathAttemptProgressInformationBlock' => '/lib/blocks/learning_path/learning_path_attempt_progress_information.class.php',
         'LearningPathAttemptsBlock' => '/lib/blocks/learning_path/learning_path_attempts.class.php',
         'LearningPathProgressUsersBlock' => '/lib/blocks/learning_path/learning_path_progress_users.class.php',
         'PublicationAccessBlock' => '/lib/blocks/publication/publication_access.class.php',
         'PublicationDetailBlock' => '/lib/blocks/publication/publication_detail.class.php',
         'PublicationUserAccessBlock' => '/lib/blocks/publication/publication_user_access.class.php',
         'ToolPublicationsBlock' => '/lib/blocks/publication/tool_publications.class.php',
         'LastAccessToToolsBlock' => '/lib/blocks/tool/last_access_to_tools.class.php',
         'LastAccessToToolsPlatformBlock' => '/lib/blocks/tool/last_access_to_tools_platform.class.php',
         'LastAccessToToolsUserBlock' => '/lib/blocks/tool/last_access_to_tools_user.class.php',
         'ToolAccessBlock' => '/lib/blocks/tool/tool_access.class.php',
         'UserInformationBlock' => '/lib/blocks/user/user_information.class.php',
         'UsersTrackingBlock' => '/lib/blocks/user/users_tracking.class.php',
         'WikiMostEditedPageBlock' => '/lib/blocks/wiki/wiki_most_edited_page.class.php',
         'WikiMostVisitedPageBlock' => '/lib/blocks/wiki/wiki_most_visited_page.class.php',
         'WikiPageMostActiveUsersBlock' => '/lib/blocks/wiki/wiki_page_most_active_users.class.php',
         'WikiPageUsersContributionsBlock' => '/lib/blocks/wiki/wiki_page_users_contributions.class.php',
         'AssessmentAttemptsTemplate' => '/lib/templates/assessment_attempts.class.php',
         'AssessmentAttemptsUserTemplate' => '/lib/templates/assessment_attempts_user.class.php',
         'AssessmentQuestionAttemptsUserTemplate' => '/lib/templates/assessment_question_attempts_user.class.php',
         'AssessmentQuestionUsersTemplate' => '/lib/templates/assessment_question_users.class.php',
         'AssessmentScoresTemplate' => '/lib/templates/assessment_scores.class.php',
         'AssignmentScoresTemplate' => '/lib/templates/assignment_scores.class.php',
         'AssignmentSubmissionsTemplate' => '/lib/templates/assignment_submissions.class.php',
         'CourseAssignmentSubmittersTemplate' => '/lib/templates/course_assignment_submitters.class.php',
         'CourseDataTemplate' => '/lib/templates/course_data.class.php',
         'CourseStudentTrackerTemplate' => '/lib/templates/course_student_tracker.class.php',
         'CourseStudentTrackerDetailTemplate' => '/lib/templates/course_student_tracker_detail.class.php',
         'CourseSubmitterSubmissionsTemplate' => '/lib/templates/course_submitter_submissions.class.php',
         'CourseTrackerTemplate' => '/lib/templates/course_tracker.class.php',
         'LearningPathAttemptProgressTemplate' => '/lib/templates/learning_path_attempt_progress.class.php',
         'LearningPathAttemptProgressDetailsTemplate' => '/lib/templates/learning_path_attempt_progress_details.class.php',
         'LearningPathAttemptsTemplate' => '/lib/templates/learning_path_attempts.class.php',
         'LearningPathProgressTemplate' => '/lib/templates/learning_path_progress.class.php',
         'PublicationDetailTemplate' => '/lib/templates/publication_detail.class.php',
         'ToolPublicationsDetailTemplate' => '/lib/templates/tool_publications_detail.class.php',
         'WikiTemplate' => '/lib/templates/wiki.class.php',
         'WikiPageTemplate' => '/lib/templates/wiki_page.class.php',
         'Activator' => '/package/activate/activator.class.php',
         'Deactivator' => '/package/deactivate/deactivator.class.php',
         'Installer' => '/package/install/installer.class.php'
    );

    /**
     * Try to load the class
     *
     * @param $classname string
     * @return boolean
     */
    public static function load($classname)
    {
        if (isset(self :: $map[$classname]))
        {
            require_once __DIR__ . self :: $map[$classname];
            return true;
        }

        return false;
    }

    /**
     * Synchronize the autoloader
     *
     * @param $update boolean
     * @return multitype:string
     */
    public static function synch($update)
    {
        return \common\libraries\AutoloaderUtilities :: synch(__DIR__, __DIR__, $update);
    }

}
?>