<?php
namespace application\weblcms\integration\reporting;

use application\weblcms\course\Course;

use reporting\ReportingData;
use reporting\ReportingChartFormatter;
use reporting\ReportingFormatter;
use common\libraries\Translation;
use application\weblcms\course\DataManager as CourseDataManager;

class NoOfCoursesBlock extends CourseBlock
{

    public function count_data()
    {
        $reporting_data = new ReportingData();
        $count = CourseDataManager :: count(Course :: class_name());

        $reporting_data->set_categories(array(Translation :: get('CourseCount')));
        $reporting_data->set_rows(array(Translation :: get('count')));

        $reporting_data->add_data_category_row(Translation :: get('CourseCount'), Translation :: get('count'), $count);

        return $reporting_data;
    }

    public function retrieve_data()
    {
        return $this->count_data();
    }

    public function get_application()
    {
        return \application\weblcms\WeblcmsManager :: APPLICATION_NAME;
    }

    public function get_views()
    {
        return array(
            \reporting\viewer\HtmlBlockRendition :: VIEW_TABLE,
            \reporting\viewer\HtmlBlockRendition :: VIEW_PIE);
    }
}
