<?php
namespace application\weblcms\integration\reporting;

use application\weblcms\CourseSettingsConnector;
use application\weblcms\CourseSettingsController;
use application\weblcms\course\Course;
use application\weblcms\course\DataManager as CourseDataManager;
use reporting\ReportingData;
use reporting\ReportingChartFormatter;
use reporting\ReportingFormatter;
use common\libraries\Translation;

class NoOfCoursesByLanguageBlock extends CourseBlock
{

    public function count_data()
    {
        $reporting_data = new ReportingData();
        $arr = array();
        $courses = CourseDataManager :: retrieves(Course :: class_name());

        while ($course = $courses->next_result())
        {
            $lang = CourseSettingsController :: get_course_setting(
                $course->get_id(),
                CourseSettingsConnector :: LANGUAGE);

            if ($lang == 'en')
            {
                $arr[$lang] ++;
            }
            else
            {
                $arr[$lang] = 1;
            }
        }
        $reporting_data->set_categories(array('english'));
        $reporting_data->set_rows(array(Translation :: get('count')));

        $reporting_data->add_data_category_row('english', Translation :: get('count'), $arr['en']);

        return $reporting_data;
    }

    public function retrieve_data()
    {
        return $this->count_data();
    }

    public function get_application()
    {
        return \application\weblcms\WeblcmsManager :: APPLICATION_NAME;
    }

    public function get_views()
    {
        return array(
            \reporting\viewer\HtmlBlockRendition :: VIEW_TABLE,
            \reporting\viewer\HtmlBlockRendition :: VIEW_PIE);
    }
}
