<?php
namespace application\weblcms\integration\reporting;

use application\weblcms\WeblcmsManager;
use common\libraries\Request;
use reporting\ReportingTemplate;

/**
 * $Id: course_student_tracker_reporting_template.class.php 216 2009-11-13 14:08:06Z kariboe $
 *
 * @package application.lib.weblcms.reporting.templates
 */
/**
 *
 * @author Michael Kyndt
 */
class CourseStudentTrackerTemplate extends ReportingTemplate
{

    public function __construct($parent)
    {
        parent :: __construct($parent);

        $this->init_parameters();
        $this->add_reporting_block($this->get_users_tracking());
        $this->add_reporting_block($this->get_assignment_tracking());
        $this->add_reporting_block($this->get_assessment_tracking());
        $this->add_reporting_block($this->get_learning_path_tracking());
        $this->add_reporting_block($this->get_last_access_tools_tracking());
    }

    public function display_context()
    {
    }

    public function get_application()
    {
        return WeblcmsManager :: APPLICATION_NAME;
    }

    private function init_parameters()
    {
        $course_id = Request :: get(WeblcmsManager :: PARAM_COURSE);
        if ($course_id)
        {
            $this->set_parameter(WeblcmsManager :: PARAM_COURSE, $course_id);
        }
    }

    public function get_users_tracking()
    {
        $course_weblcms_block = new UsersTrackingBlock($this);
        $course_weblcms_block->set_sorting(0);
        return $course_weblcms_block;
    }

    public function get_assignment_tracking()
    {
        $course_weblcms_block = new AssignmentBlock($this);
        $course_weblcms_block->set_sorting(2, SORT_DESC);
        return $course_weblcms_block;
    }

    public function get_assessment_tracking()
    {
        $course_weblcms_block = new AssessmentsBlock($this);
        $course_weblcms_block->set_sorting(2, SORT_DESC);
        return $course_weblcms_block;
    }

    public function get_learning_path_tracking()
    {
        $course_weblcms_block = new LearningPathBlock($this);
        $course_weblcms_block->set_sorting(0);
        return $course_weblcms_block;
    }

    public function get_last_access_tools_tracking()
    {
        $course_weblcms_block = new LastAccessToToolsBlock($this);
        $course_weblcms_block->set_sorting(0);
        return $course_weblcms_block;
    }
}
