<?php
namespace application\weblcms\integration\reporting;

use application\weblcms\WeblcmsManager;
use common\libraries\BreadcrumbTrail;
use common\libraries\Request;
use common\libraries\Breadcrumb;
use reporting\ReportingTemplate;
use user\UserDataManager;

/**
 * $Id: course_student_tracker_detail_reporting_template.class.php 216 2009-11-13 14:08:06Z kariboe $
 *
 * @package application.lib.weblcms.reporting.templates
 */
/**
 *
 * @author Michael Kyndt
 */
class CourseStudentTrackerDetailTemplate extends ReportingTemplate
{

    public function __construct($parent)
    {
        parent :: __construct($parent);

        $this->user_id = request :: get(WeblcmsManager :: PARAM_USERS);

        $this->add_reporting_block($this->get_user_information());
        $this->add_reporting_block($this->get_course_user_assignment_information());
        $this->add_reporting_block($this->get_course_user_exercise_information());
        $this->add_reporting_block($this->get_course_user_learning_path_information());
        $this->add_reporting_block($this->get_last_access_to_tools_user());

        $user = UserDataManager :: get_instance()->retrieve_user($this->user_id);
        BreadcrumbTrail :: get_instance()->add(new Breadcrumb($this->get_url(), $user->get_fullname()));
    }

    public function display_context()
    {
        // publicatie, content_object, application ...
    }

    public function get_application()
    {
        return WeblcmsManager :: APPLICATION_NAME;
    }

    public function get_last_access_to_tools_user()
    {
        $course_weblcms_block = new LastAccessToToolsUserBlock($this);
        $course_weblcms_block->set_sorting(0);

        $course_id = Request :: get(WeblcmsManager :: PARAM_COURSE);
        if ($course_id)
        {
            $this->set_parameter(WeblcmsManager :: PARAM_COURSE, $course_id);
        }
        if ($this->user_id)
        {
            $this->set_parameter(WeblcmsManager :: PARAM_USERS, $this->user_id);
        }
        return $course_weblcms_block;
    }

    public function get_course_user_learning_path_information()
    {
        $course_weblcms_block = new CourseUserLearningPathInformationBlock($this);
        $course_weblcms_block->set_sorting(0);
        return $course_weblcms_block;
    }

    public function get_course_user_exercise_information()
    {
        $course_weblcms_block = new CourseUserExerciseInformationBlock($this);
        $course_weblcms_block->set_sorting(2, SORT_DESC);
        return $course_weblcms_block;
    }

    public function get_course_user_assignment_information()
    {
        $course_weblcms_block = new CourseUserAssignmentInformationBlock($this);
        $course_weblcms_block->set_sorting(2, SORT_DESC);
        return $course_weblcms_block;
    }

    public function get_user_information()
    {
        $course_weblcms_block = new UserInformationBlock($this);
        if ($this->user_id)
        {
            $this->set_parameter(WeblcmsManager :: PARAM_USERS, $this->user_id);
        }
        return $course_weblcms_block;
    }
}
