<?php
namespace application\weblcms\integration\tracking;

class Autoloader
{

    /**
     * The array mapping class names to paths
     *
     * @var multitype:string
     */
     private static $map = array(
         'Autoloader' => '/autoloader.class.php',
         'DataManager' => '/lib/data_manager/data_manager.class.php',
         'DataManagerInterface' => '/lib/data_manager/data_manager_interface.class.php',
         'DoctrineDataManager' => '/lib/data_manager/implementation/doctrine.class.php',
         'Mdb2DataManager' => '/lib/data_manager/implementation/mdb2.class.php',
         'AssessmentAttempt' => '/lib/tracker/assessment_attempt.class.php',
         'AssignmentSubmission' => '/lib/tracker/assignment_submission.class.php',
         'CourseChange' => '/lib/tracker/course_change.class.php',
         'CourseVisit' => '/lib/tracker/course_visit.class.php',
         'ForumTopicView' => '/lib/tracker/forum_topic_view.class.php',
         'LearningPathQuestionAttempt' => '/lib/tracker/learning_path_question_attempt.class.php',
         'LpAttempt' => '/lib/tracker/lp_attempt.class.php',
         'LpiAttempt' => '/lib/tracker/lpi_attempt.class.php',
         'LpiAttemptInteraction' => '/lib/tracker/lpi_attempt_interaction.class.php',
         'LpiAttemptObjective' => '/lib/tracker/lpi_attempt_objective.class.php',
         'PeerAssessmentAttempt' => '/lib/tracker/peer_assessment_attempt.class.php',
         'PeerAssessmentAttemptStatus' => '/lib/tracker/peer_assessment_attempt_status.class.php',
         'PeerAssessmentFeedback' => '/lib/tracker/peer_assessment_feedback.class.php',
         'PeerAssessmentGroup' => '/lib/tracker/peer_assessment_group.class.php',
         'PeerAssessmentGroupSubscription' => '/lib/tracker/peer_assessment_group_subscription.class.php',
         'PeerAssessmentPublicationSetting' => '/lib/tracker/peer_assessment_publication_setting.class.php',
         'PeerAssessmentScore' => '/lib/tracker/peer_assessment_score.class.php',
         'PublicationChange' => '/lib/tracker/publication_change.class.php',
         'QuestionAttempt' => '/lib/tracker/question_attempt.class.php',
         'SubmissionFeedback' => '/lib/tracker/submission_feedback.class.php',
         'SubmissionNote' => '/lib/tracker/submission_note.class.php',
         'SubmissionScore' => '/lib/tracker/submission_score.class.php',
         'UserStatusChange' => '/lib/tracker/user_status_change.class.php',
         'Activator' => '/package/activate/activator.class.php',
         'Deactivator' => '/package/deactivate/deactivator.class.php',
         'Installer' => '/package/install/installer.class.php'
    );

    /**
     * Try to load the class
     *
     * @param $classname string
     * @return boolean
     */
    public static function load($classname)
    {
        if (isset(self :: $map[$classname]))
        {
            require_once __DIR__ . self :: $map[$classname];
            return true;
        }

        return false;
    }

    /**
     * Synchronize the autoloader
     *
     * @param $update boolean
     * @return multitype:string
     */
    public static function synch($update)
    {
        return \common\libraries\AutoloaderUtilities :: synch(__DIR__, __DIR__, $update);
    }

}
?>