<?php
namespace application\weblcms\integration\tracking;

use common\libraries\EqualityCondition;

class LpAttempt extends \tracking\SimpleTracker
{
    const CLASS_NAME = __CLASS__;
    const PROPERTY_USER_ID = 'user_id';
    const PROPERTY_COURSE_ID = 'course_id';
    const PROPERTY_LP_ID = 'lp_id';
    const PROPERTY_PROGRESS = 'progress';

    public function validate_parameters(array $parameters = array())
    {
        $this->set_user_id($parameters[self :: PROPERTY_USER_ID]);
        $this->set_course_id($parameters[self :: PROPERTY_COURSE_ID]);
        $this->set_lp_id($parameters[self :: PROPERTY_LP_ID]);
        $this->set_progress($parameters[self :: PROPERTY_PROGRESS]);
    }

    public static function get_default_property_names()
    {
        return parent :: get_default_property_names(
                array(self :: PROPERTY_USER_ID, self :: PROPERTY_COURSE_ID, self :: PROPERTY_LP_ID,
                        self :: PROPERTY_PROGRESS));
    }

    public function get_user_id()
    {
        return $this->get_default_property(self :: PROPERTY_USER_ID);
    }

    public function set_user_id($user_id)
    {
        $this->set_default_property(self :: PROPERTY_USER_ID, $user_id);
    }

    public function get_course_id()
    {
        return $this->get_default_property(self :: PROPERTY_COURSE_ID);
    }

    public function set_course_id($course_id)
    {
        $this->set_default_property(self :: PROPERTY_COURSE_ID, $course_id);
    }

    public function get_lp_id()
    {
        return $this->get_default_property(self :: PROPERTY_LP_ID);
    }

    public function set_lp_id($lp_id)
    {
        $this->set_default_property(self :: PROPERTY_LP_ID, $lp_id);
    }

    public function get_progress()
    {
        return $this->get_default_property(self :: PROPERTY_PROGRESS);
    }

    public function set_progress($progress)
    {
        $this->set_default_property(self :: PROPERTY_PROGRESS, $progress);
    }

    public function delete()
    {
        $succes = parent :: delete();

        $condition = new EqualityCondition(LpiAttempt :: PROPERTY_LP_VIEW_ID, $this->get_id());
        $dummy = new LpiAttempt();
        $trackers = $dummy->retrieve_tracker_items($condition);

        foreach ($trackers as $tracker)
        {
            $succes &= $tracker->delete();
        }

        return $succes;
    }

    public static function get_table_name()
    {
        return 'weblcms_' . parent :: get_table_name();
    }
}
