<?php
namespace application\weblcms\integration\webservice;

use common\libraries\Translation;
use common\libraries\DeleteObjectWebserviceHandler;

class ContentObjectPublicationDeleteWebserviceHandler extends DeleteObjectWebserviceHandler
{

    public function get_object()
    {
        return \application\weblcms\DataManager :: retrieve(
                \application\weblcms\ContentObjectPublication :: class_name(), $this->get_id());
    }

    public function get_object_translation()
    {
        return Translation :: get('ContentObjectPublication');
    }

    public function is_allowed_to_delete_object($object)
    {
        if ($this->get_user()->is_platform_admin())
        {
            return true;
        }

        $course = \application\weblcms\course\DataManager :: retrieve_by_id(
            Course :: class_name(), $object->get_course_id()
        );
        return $course->is_course_admin($this->get_user());
    }
}
