<?php
namespace application\weblcms\integration\webservice;

use common\libraries\Translation;
use common\libraries\GetObjectListWebserviceHandler;
use common\libraries\EqualityCondition;
use common\libraries\AndCondition;
use common\libraries\Request;

class ContentObjectPublicationCategoryGetListWebserviceHandler extends GetObjectListWebserviceHandler
{

    public function get_objects()
    {
        $course_id = Request :: get(\application\weblcms\ContentObjectPublicationCategory :: PROPERTY_COURSE);
        $tool = Request :: get(\application\weblcms\ContentObjectPublicationCategory :: PROPERTY_TOOL);

        $conditions = array();
        $conditions[] = new EqualityCondition(\application\weblcms\ContentObjectPublicationCategory :: PROPERTY_COURSE,
                $course_id);
        $conditions[] = new EqualityCondition(\application\weblcms\ContentObjectPublicationCategory :: PROPERTY_TOOL,
                $tool);
        $condition = new AndCondition($conditions);

        return \application\weblcms\DataManager :: retrieves(
                \application\weblcms\ContentObjectPublicationCategory :: class_name(), $condition);
    }

    public function get_objects_translation()
    {
        return Translation :: get('ContentObjectPublicationCategories');
    }
}
