<?php
namespace application\weblcms;

use common\libraries\ObjectTableCellRenderer;
use common\libraries\Translation;

/**
 * $Id: default_course_sections_table_cell_renderer.class.php 216 2009-11-13
 * 14:08:06Z kariboe $
 *
 * @package application.lib.weblcms.course.course_sections_table
 */

class DefaultCourseSectionsTableCellRenderer extends ObjectTableCellRenderer
{

    /**
     * Constructor
     */
    public function __construct()
    {
    }

    /**
     * Renders a table cell
     *
     * @param $column CourseSectionSectionsTableColumnModel
     *            The column which should be
     *            rendered
     * @param $course_section CourseSection
     *            The course object to render
     * @return string A HTML representation of the rendered table cell
     */
    public function render_cell($column, $course_section)
    {
        if ($property = $column->get_title())
        {
            switch ($property)
            {
                case Translation :: get(ucfirst(CourseSection :: PROPERTY_NAME)) :
                    return $course_section->get_name();
            }
        }
        return '&nbsp;';
    }

    public function render_id_cell($object)
    {
        return $object->get_id();
    }
}
