<?php
namespace application\weblcms;

use common\libraries\StaticTableColumn;
use common\libraries\ObjectTableColumn;
use common\libraries\Utilities;
use common\libraries\ObjectTableColumnModel;
use common\libraries\Translation;

/**
 * $Id: default_course_sections_table_column_model.class.php 216 2009-11-13
 * 14:08:06Z kariboe $
 *
 * @package application.lib.weblcms.course.course_sections_table
 */
class DefaultCourseSectionsTableColumnModel extends ObjectTableColumnModel
{

    /**
     * Constructor
     */
    public function __construct()
    {
        parent :: __construct(self :: get_default_columns(), 1);
    }

    /**
     * Gets the default columns for this model
     *
     * @return CourseSectionTableColumn[]
     */
    private static function get_default_columns()
    {
        $columns = array();
        // $columns[] = new ObjectTableColumn(CourseSection :: PROPERTY_ID);
        $columns[] = new StaticTableColumn(
            Translation :: get(Utilities :: underscores_to_camelcase(CourseSection :: PROPERTY_NAME))
        );
        return $columns;
    }
}
