<?php
namespace application\weblcms;

use user\UserDataManager;
use common\libraries\ObjectTableCellRenderer;
use common\libraries\Translation;
use application\weblcms\course\Course;

/**
 * $Id: default_course_table_cell_renderer.class.php 216 2009-11-13 14:08:06Z
 * kariboe $
 *
 * @package application.lib.weblcms.course.course_table
 */

class DefaultCourseTableCellRenderer extends ObjectTableCellRenderer
{

    /**
     * Constructor
     */
    public function __construct()
    {
    }

    /**
     * Renders a table cell
     *
     * @param $column CourseTableColumnModel
     *            The column which should be
     *            rendered
     * @param $course Course
     *            The course object to render
     * @return string A HTML representation of the rendered table cell
     */
    public function render_cell($column, $course)
    {
        switch ($column->get_name())
        {
            case Course :: PROPERTY_ID :
                return $course->get_id();
            case Course :: PROPERTY_VISUAL_CODE :
                return $course->get_visual_code();
            case Course :: PROPERTY_TITLE :
                return $course->get_title();
            case Course :: PROPERTY_TITULAR_ID :
                $titular = UserDataManager :: get_instance()->retrieve_user($course->get_titular_id());
                if ($titular)
                {
                    return $titular->get_fullname();
                }
                return '';
            // case Course :: PROPERTY_LANGUAGE :
            // return $course->get_language();
            // case Course :: PROPERTY_SUBSCRIBE_ALLOWED :
            // $sub = $course->get_subscribe_allowed();
            // if ($sub)
            // return Translation :: get('True');
            // else
            // return Translation :: get('False');
            // case Course :: PROPERTY_UNSUBSCRIBE_ALLOWED :
            // $sub = $course->get_unsubscribe_allowed();
            // if ($sub)
            // return Translation :: get('True');
            // else
            // return Translation :: get('False');
            case Course :: PROPERTY_CATEGORY_ID :
                $cat_id = $course->get_category_id();
                $cat = DataManager :: retrieve(CourseCategory :: class_name(), $cat_id);
                if ($cat)
                {
                    return $cat->get_name();
                }
                else
                {
                    return '&nbsp;';
                }
            default :
                return '&nbsp;';
        }
    }

    public function render_id_cell($object)
    {
        return $object->get_id();
    }
}
