<?php
namespace application\weblcms;

use common\libraries\ObjectTableDataProvider;
use application\weblcms\tool\course_group\CourseGroup;
use common\libraries\DataClassRetrievesParameters;

/**
 * $Id: location_course_group_browser_table_data_provider.class.php 191
 * 2009-11-13 11:50:28Z chellee $
 *
 * @package
 *          application.common.rights_editor_manager.component.location_course_group_bowser
 */
/**
 * Data provider for a repository browser table.
 *
 * This class implements some functions to allow repository browser tables to
 * retrieve information about the learning objects to display.
 */
class LocationCourseGroupBrowserTableDataProvider extends ObjectTableDataProvider
{

    /**
     * Constructor
     *
     * @param $browser RepositoryManagerComponent
     * @param $condition Condition
     */
    /*function __construct($browser, $condition)
    {
        parent :: __construct($browser, $condition);
    }*/

    /**
     * Gets the learning objects
     *
     * @param $offset int
     * @param $count int
     * @param $order_property string
     * @return ResultSet A set of matching learning objects.
     */
    public function get_objects($offset, $count, $order_property = null)
    {
        $order_property = $this->get_order_property($order_property);

        return DataManager :: retrieves(
            CourseGroup :: class_name(),
            new DataClassRetrievesParameters($this->get_condition(), $count, $offset, $order_property)
        );
    }

    /**
     * Gets the number of learning objects in the table
     *
     * @return int
     */
    public function get_object_count()
    {
        return DataManager :: count(CourseGroup :: class_name(), $this->get_condition());
    }
}
