<?php
namespace application\weblcms;

use common\libraries\BreadcrumbTrail;
use common\libraries\Request;
use common\libraries\Translation;
use repository\ContentObjectForm;
use common\libraries\Utilities;

/**
 * $Id: edit.class.php 216 2009-11-13 14:08:06Z kariboe $
 *
 * @package application.lib.weblcms.tool.component
 *
 *
 * @deprecated Use the content_object_updater and publication_updater
 */
class ToolComponentUpdaterComponent extends ToolComponent
{

    public function run()
    {
        $pid = Request :: get(Tool :: PARAM_PUBLICATION_ID) ? Request :: get(Tool :: PARAM_PUBLICATION_ID) :
            $_POST[Tool :: PARAM_PUBLICATION_ID];
        if (is_null($pid))
        {
            $this->redirect(
                Translation :: get('NoObjectSelected', null, Utilities :: COMMON_LIBRARIES), '', array(
                    Tool :: PARAM_PUBLICATION_ID => null, 'tool_action' => null
                )
            );
        }

        $publication = DataManager :: retrieve(ContentObjectPublication :: class_name(), $pid);

        if (is_null($publication))
        {
            $this->redirect(
                Translation :: get('NoObjectSelected', null, Utilities :: COMMON_LIBRARIES), '', array(
                    Tool :: PARAM_PUBLICATION_ID => null, 'tool_action' => null
                )
            );
        }

        if ($this->is_allowed(WeblcmsRights :: EDIT_RIGHT, $publication))
        {

            $content_object = $publication->get_content_object();

            $form = ContentObjectForm :: factory(
                ContentObjectForm :: TYPE_EDIT, $content_object, 'edit', 'post', $this->get_url(
                    array(
                        Tool :: PARAM_PUBLICATION_ID => $pid
                    )
                )
            );

            if ($form->validate() || Request :: get('validated'))
            {
                if (!Request :: get('validated'))
                {
                    $form->update_content_object();
                    if ($form->is_version())
                    {
                        $publication->set_content_object_id($content_object->get_latest_version()->get_id());
                        $publication->update();
                        $message = htmlentities(
                            Translation :: get(
                                'ObjectUpdated', array(
                                    'OBJECT' => Translation :: get('Publication')
                                ), Utilities :: COMMON_LIBRARIES
                            )
                        );
                        $this->redirect($message, false, $params, $filter);
                    }
                }

                // $publication_form = new
                // ContentObjectPublicationForm(ContentObjectPublicationForm ::
                // TYPE_UPDATE, $content_object, $this->get_course(), false,
                // $this->get_parent()->get_course(), false, array(Tool ::
                // PARAM_PUBLICATION_ID => $pid, 'validated' => 1));
                // $publication_form->set_publication($publication);
                //
                // if ($publication_form->validate() ||
                // $content_object->get_type() == 'introduction')
                // {
                // $publication_form->update_content_object_publication();
                // $message = htmlentities(Translation :: get('ObjectUpdated',
                // array('OBJECT' => Translation :: get('Publication'))
                // ,Utilities:: COMMON_LIBRARIES));
                //
                // $show_details = Request :: get('details');
                // $tool = Request :: get('tool');
                //
                // $params = array();
                // if ($show_details == 1)
                // {
                // $params[Tool :: PARAM_PUBLICATION_ID] = $pid;
                // $params[Tool :: PARAM_ACTION] = Tool :: ACTION_VIEW;
                // }
                //
                // if ($tool == 'learning_path')
                // {
                // $params[Tool :: PARAM_ACTION] = null;
                // $params['display_action'] = 'view';
                // $params[Tool :: PARAM_PUBLICATION_ID] = Request :: get(Tool
                // :: PARAM_PUBLICATION_ID);
                // }
                //
                // if (! isset($show_details) && $tool != 'learning_path')
                // {
                // $filter = array('tool_action');
                // }
                // else
                // {
                // $filter = array();
                // }
                //
                // $this->redirect($message, false, $params, $filter);
                // }
                // else
                // {
                // $this->display_header();
                // $publication_form->display();
                // $this->display_footer();
                // }

                $this->redirect($message, false, $params, $filter);
            }
            else
            {
                $this->display_header();
                $form->display();
                $this->display_footer();
            }
        }
        else
        {
            $this->redirect(
                Translation :: get("NotAllowed"), '', array(
                    Tool :: PARAM_PUBLICATION_ID => null,
                    'tool_action'                => null
                )
            );
        }
    }

    public function add_additional_breadcrumbs(BreadcrumbTrail $breadcrumbtrail)
    {
        $breadcrumbtrail->add_help('courses general');
    }
}
