<?php
namespace application\weblcms;

use common\libraries\ObjectTableDataProvider;
use common\libraries\DataClassRetrievesParameters;

use application\weblcms\course\DataManager as CourseDataManager;

/**
 * Data provider for a repository browser table.
 *
 * This class implements some functions to allow repository browser tables to
 * retrieve information about the learning objects to display.
 */
class CatalogCourseBrowserTableDataProvider extends ObjectTableDataProvider
{

    /**
     * Constructor
     *
     * @param $browser WeblcmsManagerComponent
     * @param $condition Condition
     */
    /*function __construct($browser, $condition)
    {
        parent :: __construct($browser, $condition);
    }*/

    /**
     * Gets the courses
     *
     * @param $offset int
     * @param $count int
     * @param $order_property string
     * @return ResultSet A set of matching courses.
     */
    public function get_objects($offset, $count, $order_property = null)
    {
        $order_property = $this->get_order_property($order_property);

        $parameters = new DataClassRetrievesParameters(
            $this->get_condition(), $count, $offset, $order_property
        );

        return CourseDataManager :: retrieves(Course :: class_name(), $parameters);
    }

    /**
     * Gets the number of courses in the table
     *
     * @return int
     */
    public function get_object_count()
    {
        return CourseDataManager :: counts(Course :: class_name(), $this->get_condition());
    }
}
