<?php
namespace application\weblcms;

use application\weblcms\course\DataManager as CourseDataManager;
use common\libraries\Display;
use common\libraries\Application;
use common\libraries\Breadcrumb;
use common\libraries\BreadcrumbTrail;
use common\libraries\Request;
use common\libraries\Translation;

/**
 * $Id: request.class.php 224 2010-04-06 14:40:30Z Yannick $
 *
 * @package applicatie.lib.weblcms.weblcms_manager.component
 */
class WeblcmsManagerCourseCodeSubscriberComponent extends WeblcmsManager
{

    /**
     * Runs this component and displays its output.
     */
    public function run()
    {
        $course_code = Request :: get(WeblcmsManager :: PARAM_COURSE);
        $course = CourseDataManager :: retrieve(Course :: class_name(), $course_code);
        $form = new CourseCodeForm(
            $this->get_url(array(WeblcmsManager :: PARAM_COURSE => $course_code)),
            $course, $this, $this->get_user()
        );

        if ($form->validate())
        {
            $success_code = $form->check_code();
            if ($success_code == true)
            {
                $success_code = CourseDataManager :: subscribe_user_to_course($course->get_id(), '5', $this->get_user_id());
            }

            $array_type = array();
            $array_type['go'] = WeblcmsManager :: ACTION_VIEW_WEBLCMS_HOME;
            $this->redirect(
                Translation :: get($success_code ? 'Subscribed' : 'NotSubscribed'), ($success_code ? false : true),
                $array_type, array(
                    WeblcmsManager :: PARAM_COURSE
                )
            );
        }
        else
        {
            $this->display_header();
            $form->display();
            $this->display_footer();
        }
    }

    public function add_additional_breadcrumbs(BreadcrumbTrail $breadcrumbtrail)
    {

        $breadcrumbtrail->add(
            new Breadcrumb(
                $this->get_url(
                    null, array(
                        Application :: PARAM_ACTION,
                        WeblcmsManager :: PARAM_COURSE
                    )
                ), Translation :: get('MyCourses')
            )
        );
        $breadcrumbtrail->add(
            new Breadcrumb(
                $this->get_url(
                    array(
                        WeblcmsManager :: PARAM_ACTION => WeblcmsManager :: ACTION_SUBSCRIBE
                    ), array(
                        WeblcmsManager :: PARAM_COURSE
                    )
                ), Translation :: get('CourseSubscribe')
            )
        );
        $breadcrumbtrail->add_help('course code');
    }

    public function get_additional_parameters()
    {
        return array();
    }
}
