<?php
namespace application\weblcms;

use common\libraries\AdministrationComponent;
use common\libraries\DelegateComponent;
use common\libraries\Translation;
use common\libraries\Utilities;

use application\weblcms\course_type\CourseTypeManager;

/**
 * This class represents a component that runs the course type submanager
 *
 * @package \application\weblcms\course_type
 *
 * @author Sven Vanpoucke - Hogeschool Gent - Refactoring
 */
class WeblcmsManagerCourseTypeManagerComponent extends WeblcmsManager implements
    AdministrationComponent,
    DelegateComponent
{

    /**
     * Runs this component and displays its output.
     */
    public function run()
    {
        if ($this->get_user()->is_platform_admin())
        {
            CourseTypeManager :: launch($this);
        }
        else
        {
            $this->display_error_page(Translation :: get('NotAllowed', null, Utilities :: COMMON_LIBRARIES));
        }
    }
}
