<?php

namespace application\weblcms;

use common\libraries\Translation;
use common\libraries\UpdateObjectWebserviceHandler;

class ContentObjectPublicationCategoryUpdateWebserviceHandler extends UpdateObjectWebserviceHandler
{

    public function get_object()
    {
        return DataManager :: retrieve(ContentObjectPublication :: class_name(), $this->get_id());
    }

    public function get_object_translation()
    {
        return Translation :: get('ContentObjectPublicationCategory');
    }

    public function manipulate_data($object, $extra_properties = null)
    {
        return $object;
    }

    public function is_allowed_to_update_object($object)
    {
        if ($this->get_user()->is_platform_admin())
        {
            return true;
        }

        $course = \application\weblcms\course\DataManager :: retrieve(Course :: class_name(), $object->get_course());
        return $course->is_course_admin($this->get_user());
    }

}
