<?php
namespace application\weblcms\request;

use application\weblcms\CourseManagementRights;
use common\libraries\SubManager;

class Manager extends SubManager
{
    const PARAM_ACTION = 'request_action';
    const PARAM_REQUEST_ID = 'request_id';
    const PARAM_RESET_CACHE = 'reset_cache';
    const ACTION_BROWSE = 'browser';
    const ACTION_UPGRADE = 'upgrader';
    const ACTION_REQUEST = 'request';
    const ACTION_CREATE = 'creator';
    const ACTION_DELETE = 'deleter';
    const ACTION_DENY = 'denier';
    const ACTION_GRANT = 'granter';
    const ACTION_RIGHTS = 'rights';
    const DEFAULT_ACTION = self :: ACTION_BROWSE;

    static function get_action_parameter()
    {
        return self :: PARAM_ACTION;
    }

    function get_default_action()
    {
        return self :: DEFAULT_ACTION;
    }

    static function launch($application)
    {
        parent :: launch(null, $application);
    }

    public function request_allowed()
    {
        if ($this->get_user()->is_platform_admin())
        {
            return true;
        }

        $course_types = \application\weblcms\course_type\DataManager :: retrieve_active_course_types();
        while ($course_type = $course_types->next_result())
        {
            if (CourseManagementRights :: get_instance()->is_allowed(
                CourseManagementRights :: REQUEST_COURSE_RIGHT,
                $course_type->get_id(),
                CourseManagementRights :: TYPE_COURSE_TYPE))
            {
                return true;
            }
        }

        return false;
    }
}
?>