<?php
namespace application\weblcms\request;

use common\libraries\NewObjectTableFormActionsSupport;
use common\libraries\Utilities;
use common\libraries\Translation;
use common\libraries\NewObjectTableColumnModelActionsColumnSupport;
use common\libraries\ObjectTableFormAction;
use common\libraries\ObjectTableFormActions;
use common\libraries\NewObjectTable;

class RequestTable extends NewObjectTable implements NewObjectTableColumnModelActionsColumnSupport, 
    NewObjectTableFormActionsSupport
{
    const TABLE_IDENTIFIER = Manager :: PARAM_REQUEST_ID;
    const DEFAULT_ROW_COUNT = 20;
    const TYPE_PERSONAL = 1;
    const TYPE_PENDING = 2;
    const TYPE_GRANTED = 3;
    const TYPE_DENIED = 4;

    function get_implemented_form_actions()
    {
        $actions = new ObjectTableFormActions(__NAMESPACE__, Manager :: PARAM_ACTION);
        
        if ($this->get_component()->get_user()->is_platform_admin())
        {
            if ($this->get_component()->get_table_type() == self :: TYPE_PENDING ||
                 $this->get_component()->get_table_type() == self :: TYPE_DENIED)
            {
                $actions->add_form_action(
                    new ObjectTableFormAction(
                        Manager :: ACTION_GRANT, 
                        Translation :: get('GrantSelected', null, Utilities :: COMMON_LIBRARIES)));
            }
            
            if ($this->get_component()->get_table_type() == self :: TYPE_PENDING)
            {
                $actions->add_form_action(
                    new ObjectTableFormAction(
                        Manager :: ACTION_DENY, 
                        Translation :: get('DenySelected', null, Utilities :: COMMON_LIBRARIES)));
            }
        }
        
        $actions->add_form_action(
            new ObjectTableFormAction(
                Manager :: ACTION_DELETE, 
                Translation :: get('RemoveSelected', null, Utilities :: COMMON_LIBRARIES)));
        
        return $actions;
    }
}
?>