<?php
namespace application\weblcms\request;

use common\libraries\Translation;
use common\libraries\StaticTableColumn;
use common\libraries\NewObjectTableColumnModelActionsColumnSupport;
use common\libraries\NewObjectTableColumnModel;
use common\libraries\ObjectTableColumn;

class RequestTableColumnModel extends NewObjectTableColumnModel implements NewObjectTableColumnModelActionsColumnSupport
{

    /**
     * Initializes the columns for the table
     */
    public function initialize_columns()
    {
        $this->add_column(new ObjectTableColumn(Request :: PROPERTY_CREATION_DATE));
        
        if ($this->get_component()->get_table_type() != RequestTable :: TYPE_PERSONAL)
        {
            $this->add_column(new StaticTableColumn(Translation :: get('User')));
        }
        
        $this->add_column(new ObjectTableColumn(Request :: PROPERTY_NAME));
        $this->add_column(new ObjectTableColumn(Request :: PROPERTY_SUBJECT));
        $this->add_column(new ObjectTableColumn(Request :: PROPERTY_MOTIVATION));
        
        if ($this->get_component()->get_table_type() == RequestTable :: TYPE_PERSONAL)
        {
            $this->add_column(new ObjectTableColumn(Request :: PROPERTY_DECISION, false));
        }
    }
}
?>