<?php
namespace application\weblcms\tool\announcement;

class Autoloader
{

    /**
     * The array mapping class names to paths
     *
     * @var multitype:string
     */
     private static $map = array(
         'Autoloader' => '/autoloader.class.php',
         'AnnouncementTool' => '/lib/announcement_tool.class.php',
         'AnnouncementToolAttachmentViewerComponent' => '/lib/component/attachment_viewer.class.php',
         'AnnouncementToolBrowserComponent' => '/lib/component/browser.class.php',
         'AnnouncementToolCategoryManagerComponent' => '/lib/component/category_manager.class.php',
         'AnnouncementToolCategoryMoverComponent' => '/lib/component/category_mover.class.php',
         'AnnouncementToolContentObjectUpdaterComponent' => '/lib/component/content_object_updater.class.php',
         'AnnouncementToolDeleterComponent' => '/lib/component/deleter.class.php',
         'AnnouncementToolEvaluateComponent' => '/lib/component/evaluate.class.php',
         'AnnouncementToolHidePublicationComponent' => '/lib/component/hide_publication.class.php',
         'AnnouncementToolIntroductionPublisherComponent' => '/lib/component/introduction_publisher.class.php',
         'AnnouncementToolMoverComponent' => '/lib/component/mover.class.php',
         'AnnouncementToolPublicationUpdaterComponent' => '/lib/component/publication_updater.class.php',
         'AnnouncementToolPublisherComponent' => '/lib/component/publisher.class.php',
         'AnnouncementToolReportingViewerComponent' => '/lib/component/reporting_viewer.class.php',
         'AnnouncementToolRightsEditorComponent' => '/lib/component/rights_editor.class.php',
         'AnnouncementToolShareContentObjectsComponent' => '/lib/component/share_content_objects.class.php',
         'AnnouncementToolShowPublicationComponent' => '/lib/component/show_publication.class.php',
         'AnnouncementToolToggleVisibilityComponent' => '/lib/component/toggle_visibility.class.php',
         'AnnouncementToolUpdaterComponent' => '/lib/component/updater.class.php',
         'AnnouncementToolViewerComponent' => '/lib/component/viewer.class.php',
         'DataManager' => '/lib/storage/data_manager/data_manager.class.php',
         'DoctrineDataManager' => '/lib/storage/data_manager/implementation/doctrine.class.php',
         'Activator' => '/package/activate/activator.class.php',
         'Deactivator' => '/package/deactivate/deactivator.class.php',
         'Installer' => '/package/install/installer.class.php'
    );

    /**
     * Try to load the class
     *
     * @param $classname string
     * @return boolean
     */
    public static function load($classname)
    {
        if (isset(self :: $map[$classname]))
        {
            require_once __DIR__ . self :: $map[$classname];
            return true;
        }

        return false;
    }

    /**
     * Synchronize the autoloader
     *
     * @param $update boolean
     * @return multitype:string
     */
    public static function synch($update)
    {
        return \common\libraries\AutoloaderUtilities :: synch(__DIR__, __DIR__, $update);
    }

}
?>