<?php
namespace application\weblcms\tool\assessment;

use common\libraries\RecordTableDataProvider;
use application\weblcms\integration\tracking\DataManager as WeblcmsTrackingDataManager;

/**
 * This class represents a data provider for the attempts of an assessment
 *
 * @author Sven Vanpoucke - Hogeschool Gent
 */
class AssessmentAttemptTableDataProvider extends RecordTableDataProvider
{

    /**
     * Returns the data as a resultset
     *
     * @param \common\libraries\Condition $condition
     * @param $condition
     * @param int $offset
     * @param int $count
     * @param ObjectTableOrder[] $order_property
     *
     * @return \common\libraries\ResultSet
     */
    public function retrieve_data($condition, $offset, $count, $order_property = null)
    {
        return WeblcmsTrackingDataManager :: retrieve_assessment_attempts_with_user(
            $condition,
            $offset,
            $count,
            $order_property);
    }

    /**
     * Counts the data
     *
     * @param \common\libraries\Condition $condition
     *
     * @return int
     */
    public function count_data($condition)
    {
        return WeblcmsTrackingDataManager :: count_assessment_attempts_with_user($condition);
    }
}
