<?php

namespace application\weblcms\tool\assignment;

use common\libraries\DelegateComponent;

use application\weblcms\Tool;
use application\weblcms\ToolComponent;
use common\libraries\Translation;
use common\libraries\ToolbarItem;
use common\libraries\Theme;
use application\weblcms\WeblcmsManager;
use common\libraries\Request;


/**
 *
 * @package application.weblcms.tool.assignment.php.component
 *
 *          Viewer for assignments
 *
 * @author Joris Willems <joris.willems@gmail.com>
 * @author Alexander Van Paemel
 */
class AssignmentToolViewerComponent extends AssignmentTool implements DelegateComponent
{

    public function run()
    {
        ToolComponent :: launch($this);
    }

    public function get_additional_parameters()
    {
        return array(Tool :: PARAM_PUBLICATION_ID);
    }

    /**
     * Adds toolbar items to the toolbar
     *
     * @return array ToolbarItems
     */
    public function get_tool_actions()
    {
        $actions = array();
        $publication_id = Request :: get(WeblcmsManager :: PARAM_PUBLICATION);
        $actions[] = new ToolbarItem(
            Translation :: get('SubmissionSubmit'),
            Theme :: get_common_image_path() . 'action_add.png', $this->get_url(
                array(
                    Tool :: PARAM_ACTION => AssignmentTool :: ACTION_SUBMIT_SUBMISSION,
                    Tool :: PARAM_PUBLICATION_ID => $publication_id,
                    AssignmentTool :: PARAM_TARGET_ID => $this->get_user_id(),
                    AssignmentTool :: PARAM_SUBMITTER_TYPE => \application\weblcms\integration\tracking\AssignmentSubmission :: SUBMITTER_TYPE_USER
                )
            ), ToolbarItem :: DISPLAY_ICON_AND_LABEL
        );
        return $actions;
    }

}
