<?php

namespace application\weblcms\tool\course_group;

use application\weblcms\ContentObjectPublication;
use application\weblcms\ContentObjectPublicationCategory;
use application\weblcms\Tool;
use application\weblcms\tool\course_group\CourseGroup;
use application\weblcms\tool\course_group\CourseGroupTool;
use application\weblcms\WeblcmsRights;
use common\libraries\NotAllowedException;
use common\libraries\Request;
use common\libraries\Translation;
use common\libraries\Utilities;

/**
 * $Id: course_group_deleter.class.php 216 2009-11-13 14:08:06Z kariboe $
 * @package application.lib.weblcms.tool.course_group.component
 */
class CourseGroupToolDeleterComponent extends CourseGroupTool
{

    public function run()
    {
        if (!$this->is_allowed(WeblcmsRights :: DELETE_RIGHT))
        {
            throw new NotAllowedException();
        }

        if (Request :: get(Tool :: PARAM_PUBLICATION_ID))
        {
            $publication_ids = Request :: get(Tool :: PARAM_PUBLICATION_ID);
        }
        else
        {
            $publication_ids = $_POST[Tool :: PARAM_PUBLICATION_ID];
        }

        if (!is_array($publication_ids))
        {
            $publication_ids = array($publication_ids);
        }

        foreach ($publication_ids as $pid)
        {
            if (
                $publication = \application\weblcms\DataManager :: retrieve(
                    ContentObjectPublication :: class_name(),
                    $pid
                )
            )
            {
                $publication->delete();
            }
        }


        $ids = Request :: get(CourseGroupTool :: PARAM_COURSE_GROUP);
        if ($ids)
        {
            if (!is_array($ids))
                $ids = array($ids);

            //Make the course group deletable
            foreach ($ids as $group_id)
            {
                $cg = DataManager :: retrieve(
                    CourseGroup :: class_name(), $group_id
                );

                if ($cg->get_document_category_id())
                {
                    $cat = \application\weblcms\DataManager :: retrieve(
                        ContentObjectPublicationCategory :: class_name(), $cg->get_document_category_id()
                    );

                    if($cat)
                    {   
                        $cat->set_allow_change(1);
                        $cat->delete();
                    }
                }
                if ($cg->get_forum_category_id())
                {
                    
                    $cat = \application\weblcms\DataManager :: retrieve(
                        ContentObjectPublicationCategory :: class_name(), $cg->get_forum_category_id()
                    );
                    
                    if($cat)
                    {   
                        $cat->set_allow_change(1);
                        $cat->delete();
                    }
                }
                $cg->delete();
            }


            $message = Translation :: get(
                'ObjectDeleted', array('OBJECT' => Translation::get('CourseGroup')), Utilities:: COMMON_LIBRARIES
            );
            $this->redirect($message, '', array('course_group' => null, CourseGroupTool :: PARAM_ACTION => null));
        }
//        else
//        {
//            Display :: error_message('NoObjectSelected');
//        }
        $this->redirect($message, '', array('course_group' => null, CourseGroupTool :: PARAM_ACTION => null));
    }

}
