<?php

namespace application\weblcms\tool\course_group;

use application\weblcms\tool\course_group\CourseGroup;
use common\libraries\DataClassPropertyTableColumn;
use common\libraries\ObjectTableColumn;
use common\libraries\Translation;
use common\libraries\Utilities;
use user\DefaultUserTableColumnModel;
use user\User;


class CourseGroupsUsersBrowserTableColumnModel extends DefaultUserTableColumnModel
{
    // (!) SHOULD BE THE SAME VALUE AS THE MIN-FIELD IN MDB2 (retrieve_all_course_users)
    const SUBSCRIPTION_STATUS = 'subscription_status';
    // (!) SHOULD BE THE SAME VALUE AS THE SUM-FIELD IN MDB2 (retrieve_all_course_users)
    const SUBSCRIPTION_TYPE = 'subscription_type';
    const COURSE_GROUP_COLOMN = 'CourseGroup';

    //**************************************************************************
    // CONSTRUCTOR
    //**************************************************************************

    /**
     * Initializes the columns for the table
     */
    public function initialize_columns()
    {

        $this->add_column(new DataClassPropertyTableColumn(User :: class_name(), User :: PROPERTY_OFFICIAL_CODE));
        $this->add_column(new DataClassPropertyTableColumn(User :: class_name(), User :: PROPERTY_USERNAME));
        $this->add_column(new DataClassPropertyTableColumn(User :: class_name(), User :: PROPERTY_LASTNAME));
        $this->add_column(new DataClassPropertyTableColumn(User :: class_name(), User :: PROPERTY_FIRSTNAME));
        $this->add_column(new DataClassPropertyTableColumn(User :: class_name(), User :: PROPERTY_EMAIL));

        $column = new ObjectTableColumn(CourseGroup :: PROPERTY_ID, false);
        $column->set_title(Translation::get('CourseGroup'), Utilities :: COMMON_LIBRARIES);

        $this->add_column($column);

        //return $columns;
    }

}
