<?php

namespace application\weblcms\tool\course_group;

use common\libraries\NewObjectTableDataProvider;

/** * ***************************************************************************
 * Data provider for an all subscribed course_group user browser table, including users
 * subscribed through (sub-)groups.
 * **************************************************************************** */
class CourseGroupsUsersBrowserTableDataProvider extends NewObjectTableDataProvider
{
    //**************************************************************************
    // GENERAL FUNCTIONS
    //**************************************************************************

    /**
     * Gets the users.
     *
     * @param int $offset
     * @param int $count
     * @param string $order_property
     *
     * @return \common\libraries\ResultSet A set of matching users.
     */
    public function get_objects($offset, $count, $order_property = null)
    {
        return DataManager :: retrieve_course_group_users(
            $this->get_object_table()->get_component()->get_table_course_group_id(),
            $this->get_condition(), $offset, $count, $order_property
        );
    }

    /**
     * Gets the number of users.
     * @return int
     */
    public function get_object_count()
    {
        return DataManager :: count_course_group_users(
            $this->get_object_table()->get_component()->get_table_course_group_id(), $this->get_condition()
        );
    }

}
