<?php

namespace application\weblcms\tool\course_group;

use common\libraries\RecordTableCellRenderer;
use user\User;
use common\libraries\DataClassPropertyTableColumn;

/**
 * Cell renderer for the course users table
 *
 * @author Sven Vanpoucke - Hogeschool Gent - Refactoring from ObjectTable to RecordTable
 */
class CourseUsersTableCellRenderer extends RecordTableCellRenderer
{
    /****************************************************************************************************************
     * Inherited Functionality                                                                                      *
     ****************************************************************************************************************/

    /**
     * Renders a given cell.
     *
     * @param $column type
     * @param mixed[] $course_user
     *
     * @return string
     */
    public function render_cell($column, $course_user)
    {
        if ($column instanceof DataClassPropertyTableColumn)
        {
            switch ($column->get_class_name())
            {
                case CourseGroup :: class_name():
                {
                    switch ($column->get_name())
                    {
                        case CourseGroup :: PROPERTY_ID:
                        {
                            return DataManager :: get_course_groups_from_user_as_string(
                                $course_user[User :: PROPERTY_ID], $this->get_component()->get_course_id()
                            );
                        }
                    }
                }
            }
        }

        return parent :: render_cell($column, $course_user);
    }
}