<?php
namespace application\weblcms\tool\course_sections;


use common\libraries\EqualityCondition;
use common\libraries\Request;
use common\libraries\Translation;
use application\weblcms\CourseSection;

/**
 * $Id: course_sections_deleter.class.php 216 2009-11-13 14:08:06Z kariboe $
 *
 * @package application.lib.weblcms.tool.course_sections.component
 */
class CourseSectionsToolDeleterComponent extends CourseSectionsTool
{

    /**
     * Runs this component and displays its output.
     */
    public function run()
    {
        $user = $this->get_user();

        if (!$this->get_course()->is_course_admin($this->get_parent()->get_user()))
        {
            throw new \common\libraries\NotAllowedException();
        }

        $ids = Request :: get(CourseSectionsTool :: PARAM_COURSE_SECTION_ID);
        $failures = 0;

        if (!empty($ids))
        {
            if (!is_array($ids))
            {
                $ids = array($ids);
            }

            foreach ($ids as $id)
            {
                $condition = new EqualityCondition(CourseSection :: PROPERTY_ID, $id);

                $course_section = \application\weblcms\DataManager :: retrieves(
                    CourseSection :: class_name(), $condition
                )->next_result();

                if (!$course_section->delete())
                {
                    $failures++;
                }
            }

            if ($failures)
            {
                if (count($ids) == 1)
                {
                    $message = 'SelectedCourseSectionNotDeleted';
                }
                else
                {
                    $message = 'SelectedCourseSectionsNotDeleted';
                }
            }
            else
            {
                if (count($ids) == 1)
                {
                    $message = 'SelectedCourseSectionDeleted';
                }
                else
                {
                    $message = 'SelectedCourseSectionsDeleted';
                }
            }

            $this->redirect(
                Translation :: get($message), ($failures != 0 ? true : false), array(
                    CourseSectionsTool :: PARAM_ACTION => CourseSectionsTool :: ACTION_VIEW_COURSE_SECTIONS
                )
            );
        }
        else
        {
            $this->display_error_page(htmlentities(Translation :: get('NoCourseSectionsSelected')));
        }
    }
}
