<?php
namespace application\weblcms\tool\course_sections;


use common\libraries\Request;
use common\libraries\Translation;
use application\weblcms\CourseSection;

/**
 * $Id: course_sections_mover.class.php 216 2009-11-13 14:08:06Z kariboe $
 *
 * @package application.lib.weblcms.tool.course_sections.component
 */

class CourseSectionsToolMoverComponent extends CourseSectionsTool
{

    /**
     * Runs this component and displays its output.
     */
    public function run()
    {
        if (!$this->get_course()->is_course_admin($this->get_parent()->get_user()))
        {
            throw new \common\libraries\NotAllowedException();
        }

        $id = Request :: get(CourseSectionsTool :: PARAM_COURSE_SECTION_ID);
        $direction = Request :: get(CourseSectionsTool :: PARAM_DIRECTION);

        if (!empty($id))
        {
            $course_section = \application\weblcms\DataManager :: retrieve(CourseSection :: class_name(), $id);
            $course_section->set_display_order($course_section->get_display_order() + $direction);
            $success = $course_section->update();

            $message = $success ? 'CourseSectionMoved' : 'CourseSectionNotMoved';

            $this->redirect(
                Translation :: get($message), (!$success), array(
                    CourseSectionsTool :: PARAM_ACTION => CourseSectionsTool :: ACTION_VIEW_COURSE_SECTIONS
                )
            );
        }
        else
        {
            $this->display_error_page(htmlentities(Translation :: get('NoCourseSectionsSelected')));
        }
    }
}
