<?php
namespace application\weblcms\tool\document;

class Autoloader
{

    /**
     * The array mapping class names to paths
     *
     * @var multitype:string
     */
     private static $map = array(
         'Autoloader' => '/autoloader.class.php',
         'DocumentTool' => '/lib/document_tool.class.php',
         'DocumentToolBrowserComponent' => '/lib/component/browser.class.php',
         'DocumentToolCategoryManagerComponent' => '/lib/component/category_manager.class.php',
         'DocumentToolCategoryMoverComponent' => '/lib/component/category_mover.class.php',
         'DocumentToolContentObjectUpdaterComponent' => '/lib/component/content_object_updater.class.php',
         'DocumentToolDeleterComponent' => '/lib/component/deleter.class.php',
         'DocumentToolDownloaderComponent' => '/lib/component/downloader.class.php',
         'DocumentToolEvaluateComponent' => '/lib/component/evaluate.class.php',
         'DocumentToolHidePublicationComponent' => '/lib/component/hide_publication.class.php',
         'DocumentToolImporterComponent' => '/lib/component/importer.class.php',
         'DocumentToolIntroductionPublisherComponent' => '/lib/component/introduction_publisher.class.php',
         'DocumentToolMoverComponent' => '/lib/component/mover.class.php',
         'DocumentToolPublicationUpdaterComponent' => '/lib/component/publication_updater.class.php',
         'DocumentToolPublisherComponent' => '/lib/component/publisher.class.php',
         'DocumentToolReportingViewerComponent' => '/lib/component/reporting_viewer.class.php',
         'DocumentToolRightsEditorComponent' => '/lib/component/rights_editor.class.php',
         'DocumentToolShareContentObjectsComponent' => '/lib/component/share_content_objects.class.php',
         'DocumentToolShowPublicationComponent' => '/lib/component/show_publication.class.php',
         'DocumentToolToggleVisibilityComponent' => '/lib/component/toggle_visibility.class.php',
         'DocumentToolUpdaterComponent' => '/lib/component/updater.class.php',
         'DocumentToolViewerComponent' => '/lib/component/viewer.class.php',
         'DocumentToolZipAndDownloadComponent' => '/lib/component/zip_and_download.class.php',
         'DataManager' => '/lib/storage/data_manager/data_manager.class.php',
         'DoctrineDataManager' => '/lib/storage/data_manager/implementation/doctrine.class.php',
         'Activator' => '/package/activate/activator.class.php',
         'Deactivator' => '/package/deactivate/deactivator.class.php',
         'Installer' => '/package/install/installer.class.php'
    );

    /**
     * Try to load the class
     *
     * @param $classname string
     * @return boolean
     */
    public static function load($classname)
    {
        if (isset(self :: $map[$classname]))
        {
            require_once __DIR__ . self :: $map[$classname];
            return true;
        }

        return false;
    }

    /**
     * Synchronize the autoloader
     *
     * @param $update boolean
     * @return multitype:string
     */
    public static function synch($update)
    {
        return \common\libraries\AutoloaderUtilities :: synch(__DIR__, __DIR__, $update);
    }

}
?>