<?php
namespace application\weblcms\tool\forum;

use application\weblcms\Tool;
use application\weblcms\ContentObjectPublication;
use application\weblcms\WeblcmsRights;


use common\libraries\NotAllowedException;
use common\libraries\Request;
use common\libraries\Translation;

/**
 * $Id: sticky.class.php 200 2009-11-13 12:30:04Z kariboe $
 *
 * @package repository.lib.complex_builder.forum.component
 */

class ForumToolChangeLockComponent extends ForumTool
{

    public function run()
    {
        $this->publication_id = Request :: get(Tool :: PARAM_PUBLICATION_ID);

        $publication = \application\weblcms\DataManager :: retrieve(
            ContentObjectPublication :: class_name(),
            $this->publication_id
        );

        if (!$this->is_allowed(WeblcmsRights :: EDIT_RIGHT, $publication))
        {
            throw new NotAllowedException();
        }

        $object = $publication->get_content_object();
        if ($object->invert_locked())
        {
            $succes = true;
            $message = Translation :: get('LockChanged');
        }
        else
        {
            $message = Translation :: get('LockNotChanged');
        }

        $params = array();
        $params[ForumTool :: PARAM_ACTION] = ForumTool :: ACTION_BROWSE_FORUMS;

        $this->redirect($message, !$succes, $params);
    }
}
