<?php
namespace application\weblcms\tool\forum;

use application\weblcms\Tool;
use application\weblcms\ContentObjectPublication;
use common\libraries\Request;




use common\libraries\Translation;
use common\libraries\Utilities;

/**
 * this is the component for moving a forum in the list
 *
 * @author Mattias De Pauw
 */
class ForumToolMoverComponent extends ForumTool
{

    public function run()
    {
        if ($this->is_allowed(EDIT_RIGHT))
        {
            $move = 0;

            if (Request :: get(Tool :: PARAM_MOVE_DIRECTION))
            {
                $move = Request :: get(Tool :: PARAM_MOVE_DIRECTION);
            }

            $forum_publication = \application\weblcms\DataManager :: retrieve(
                ContentObjectPublication :: class_name(),
                Request :: get(ForumTool :: PARAM_PUBLICATION_ID)
            );

            if ($forum_publication->move($move))
            {
                $failure = false;
                $message = Translation :: get(
                    'ObjectMoved', array(
                        'OBJECT' => Translation :: get('Forum', null, 'repository\content_object\forum')
                    ), Utilities :: COMMON_LIBRARIES
                );
            }
            else
            {
                $failure = true;
                $message = Translation :: get(
                    'ObjectNotMoved', array(
                        'OBJECT' => Translation :: get('Forum', null, 'repository\content_object\forum')
                    ), Utilities :: COMMON_LIBRARIES
                );
            }

            $this->redirect($message, $failure, array(ForumTool :: PARAM_ACTION => ForumTool :: ACTION_BROWSE));
        }

    }

    public function get_move_direction()
    {
        return Request :: get(Tool :: PARAM_MOVE_DIRECTION);
    }
}
