<?php
namespace application\weblcms\tool\home;

class Autoloader
{

    /**
     * The array mapping class names to paths
     *
     * @var multitype:string
     */
     private static $map = array(
         'Autoloader' => '/autoloader.class.php',
         'HomeTool' => '/lib/home_tool.class.php',
         'HomeToolBrowserComponent' => '/lib/component/browser.class.php',
         'HomeToolContentObjectUpdaterComponent' => '/lib/component/content_object_updater.class.php',
         'HomeToolDeleterComponent' => '/lib/component/deleter.class.php',
         'HomeToolHidePublicationComponent' => '/lib/component/hide_publication.class.php',
         'HomeToolIntroductionPublisherComponent' => '/lib/component/introduction_publisher.class.php',
         'HomeToolLinksDeleterComponent' => '/lib/component/links_deleter.class.php',
         'HomeToolShowPublicationComponent' => '/lib/component/show_publication.class.php',
         'HomeToolToggleVisibilityComponent' => '/lib/component/toggle_visibility.class.php',
         'HomeToolToolInvisibleComponent' => '/lib/component/tool_invisible.class.php',
         'HomeToolToolVisibilityChangerComponent' => '/lib/component/tool_visibility_changer.class.php',
         'HomeToolToolVisibleComponent' => '/lib/component/tool_visible.class.php',
         'DataManager' => '/lib/storage/data_manager/data_manager.class.php',
         'DoctrineDataManager' => '/lib/storage/data_manager/implementation/doctrine.class.php',
         'Activator' => '/package/activate/activator.class.php',
         'Deactivator' => '/package/deactivate/deactivator.class.php',
         'Installer' => '/package/install/installer.class.php'
    );

    /**
     * Try to load the class
     *
     * @param $classname string
     * @return boolean
     */
    public static function load($classname)
    {
        if (isset(self :: $map[$classname]))
        {
            require_once __DIR__ . self :: $map[$classname];
            return true;
        }

        return false;
    }

    /**
     * Synchronize the autoloader
     *
     * @param $update boolean
     * @return multitype:string
     */
    public static function synch($update)
    {
        return \common\libraries\AutoloaderUtilities :: synch(__DIR__, __DIR__, $update);
    }

}
?>