<?php
namespace application\weblcms\tool\learning_path;

use tracking\Event;

use application\weblcms\WeblcmsManager;

use common\libraries\EqualityCondition;
use common\libraries\Request;

require_once dirname(__FILE__) . '/../../../../../../../common/global.inc.php';

/**
 * $Id: set_value.php 216 2009-11-13 14:08:06Z kariboe $
 *
 * @package application.lib.weblcms.tool.learning_path.javascript.scorm.ajax
 */

$tracker_id = Request :: post('tracker_id');
$variable = Request :: post('variable');
$value = Request :: post('value');

$condition = new EqualityCondition(\application\weblcms\integration\tracking\LpiAttempt :: PROPERTY_ID, $tracker_id);
$dummy = new \application\weblcms\integration\tracking\LpiAttempt();
$trackers = $dummy->retrieve_tracker_items($condition);
$tracker = $trackers[0];

$item = \repository\DataManager :: retrieve_complex_content_object_item($tracker->get_lp_item_id());

$learning_path_item = \repository\DataManager :: retrieve_content_object($item->get_ref());
$scorm_item = \repository\DataManager :: retrieve_content_object($learning_path_item->get_reference());

switch ($variable)
{
    case 'cmi.success_status' :
        $tracker->set_status('completed');
        $tracker->set_total_time($tracker->get_total_time() + (time() - $tracker->get_start_time()));
        $tracker->update();

        $objs = $scorm_item->get_objectives();
        if ($objs)
        {
            $objectives = $objs->get_objectives();

            foreach ($objectives as $index => $objective)
            {
                if ($objective && $objective->get_contributes_to_rollup())
                {
                    $parameters = array();
                    $parameters[\application\weblcms\integration\tracking\LpiAttemptObjective :: PROPERTY_LPI_VIEW_ID] =
                        $tracker->get_id();
                    $parameters[\application\weblcms\integration\tracking\LpiAttemptObjective :: PROPERTY_OBJECTIVE_ID] =
                        $objective->get_id();
                    $parameters[\application\weblcms\integration\tracking\LpiAttemptObjective :: PROPERTY_STATUS] =
                        'completed';
                    $parameters[\application\weblcms\integration\tracking\LpiAttemptObjective :: PROPERTY_DISPLAY_ORDER] =
                        $index;

                    Event :: trigger(
                        'attempt_learning_path_item_objective', WeblcmsManager :: context(), $parameters
                    );
                }
            }
        }

        break;
    case 'cmi.completion_status' :
        $tracker->set_status($value);
        $tracker->update();
        break;
    case 'cmi.core.lesson_status' :
        if ($value == 'completed')
        {
            $mastery_score = $learning_path_item->get_mastery_score();
            if ($mastery_score > $tracker->get_score())
            {
                $value = 'failed';
            }
            else
            {
                $value = 'passed';
            }
        }
        $tracker->set_status($value);
        $tracker->update();
        break;
    case 'cmi.core.lesson_location' :
        $tracker->set_lesson_location($value);
        $tracker->update();
        break;
    case 'cmi.suspend_data' :
        $tracker->set_suspend_data($value);
        $tracker->update();
        break;
    case 'cmi.core.session_time' :
        list($h, $m, $s) = explode(':', $value);
        $s = explode('.', $s);
        $s = $s[0];
        $total_seconds = ($h * 3600) + ($m * 60) + ($s);
        $tracker->set_total_time($tracker->get_total_time() + $total_seconds);
        $tracker->update();
        break;
    case 'cmi.core.score.raw' :
        $tracker->set_score($value);
        $tracker->update();
        break;
    case 'cmi.core.score.max' :
        $tracker->set_max_score($value);
        $tracker->update();
        break;
    case 'cmi.core.score.min' :
        $tracker->set_min_score($value);
        $tracker->update();
        break;
}
