<?php
namespace application\weblcms\tool\learning_path;

class Autoloader
{

    /**
     * The array mapping class names to paths
     *
     * @var multitype:string
     */
     private static $map = array(
         'Autoloader' => '/autoloader.class.php',
         'LearningPathTool' => '/lib/learning_path_tool.class.php',
         'LearningPathToolAssessmentRawResultsExporterComponent' => '/lib/component/assessment_raw_results_exporter.class.php',
         'LearningPathToolAssessmentResultsViewerComponent' => '/lib/component/assessment_results_viewer.class.php',
         'LearningPathToolBrowserComponent' => '/lib/component/browser.class.php',
         'LearningPathToolCategoryManagerComponent' => '/lib/component/category_manager.class.php',
         'LearningPathToolCategoryMoverComponent' => '/lib/component/category_mover.class.php',
         'LearningPathToolComplexBuilderComponent' => '/lib/component/complex_builder.class.php',
         'LearningPathToolComplexDisplayComponent' => '/lib/component/complex_display.class.php',
         'LearningPathToolContentObjectUpdaterComponent' => '/lib/component/content_object_updater.class.php',
         'LearningPathToolDeleterComponent' => '/lib/component/deleter.class.php',
         'LearningPathToolDocumentSaverComponent' => '/lib/component/document_saver.class.php',
         'LearningPathToolHidePublicationComponent' => '/lib/component/hide_publication.class.php',
         'LearningPathToolIntroductionPublisherComponent' => '/lib/component/introduction_publisher.class.php',
         'LearningPathToolMoverComponent' => '/lib/component/mover.class.php',
         'LearningPathToolPublicationUpdaterComponent' => '/lib/component/publication_updater.class.php',
         'LearningPathToolPublisherComponent' => '/lib/component/publisher.class.php',
         'LearningPathToolReportingViewerComponent' => '/lib/component/reporting_viewer.class.php',
         'LearningPathToolRightsEditorComponent' => '/lib/component/rights_editor.class.php',
         'LearningPathToolScormExporterComponent' => '/lib/component/scorm_exporter.class.php',
         'LearningPathToolScormImporterComponent' => '/lib/component/scorm_importer.class.php',
         'LearningPathToolShareContentObjectsComponent' => '/lib/component/share_content_objects.class.php',
         'LearningPathToolShowPublicationComponent' => '/lib/component/show_publication.class.php',
         'LearningPathToolStatisticsViewerComponent' => '/lib/component/statistics_viewer.class.php',
         'LearningPathToolToggleVisibilityComponent' => '/lib/component/toggle_visibility.class.php',
         'LearningPathToolUpdaterComponent' => '/lib/component/updater.class.php',
         'LearningPathToolViewerComponent' => '/lib/component/viewer.class.php',
         'LearningPathContentObjectDisplay' => '/lib/component/learning_path_viewer/learning_path_content_object_display.class.php',
         'LearningPathTree' => '/lib/component/learning_path_viewer/learning_path_tree.class.php',
         'PrerequisitesTranslator' => '/lib/component/learning_path_viewer/prerequisites_translator.class.php',
         'RuleConditionTranslator' => '/lib/component/learning_path_viewer/rule_condition_translator.class.php',
         'AssessmentDisplay' => '/lib/component/learning_path_viewer/content_object_display/assessment.class.php',
         'DocumentDisplay' => '/lib/component/learning_path_viewer/content_object_display/document.class.php',
         'ForumDisplay' => '/lib/component/learning_path_viewer/content_object_display/forum.class.php',
         'GlossaryDisplay' => '/lib/component/learning_path_viewer/content_object_display/glossary.class.php',
         'HotpotatoesDisplay' => '/lib/component/learning_path_viewer/content_object_display/hotpotatoes.class.php',
         'LinkDisplay' => '/lib/component/learning_path_viewer/content_object_display/link.class.php',
         'ScormItemDisplay' => '/lib/component/learning_path_viewer/content_object_display/scorm_item.class.php',
         'WikiDisplay' => '/lib/component/learning_path_viewer/content_object_display/wiki.class.php',
         'DataManager' => '/lib/storage/data_manager/data_manager.class.php',
         'DoctrineDataManager' => '/lib/storage/data_manager/implementation/doctrine.class.php',
         'AssessmentResultsTable' => '/lib/table/assessment_results/assessment_results_table.class.php',
         'AssessmentResultsTableCellRenderer' => '/lib/table/assessment_results/assessment_results_table_cell_renderer.class.php',
         'AssessmentResultsTableColumnModel' => '/lib/table/assessment_results/assessment_results_table_column_model.class.php',
         'AssessmentResultsTableDataProvider' => '/lib/table/assessment_results/assessment_results_table_data_provider.class.php',
         'PublicationTable' => '/lib/table/publication/publication_table.class.php',
         'PublicationTableCellRenderer' => '/lib/table/publication/publication_table_cell_renderer.class.php',
         'PublicationTableColumnModel' => '/lib/table/publication/publication_table_column_model.class.php',
         'PublicationTableDataProvider' => '/lib/table/publication/publication_table_data_provider.class.php',
         'Activator' => '/package/activate/activator.class.php',
         'Deactivator' => '/package/deactivate/deactivator.class.php',
         'Installer' => '/package/install/installer.class.php'
    );

    /**
     * Try to load the class
     *
     * @param $classname string
     * @return boolean
     */
    public static function load($classname)
    {
        if (isset(self :: $map[$classname]))
        {
            require_once __DIR__ . self :: $map[$classname];
            return true;
        }

        return false;
    }

    /**
     * Synchronize the autoloader
     *
     * @param $update boolean
     * @return multitype:string
     */
    public static function synch($update)
    {
        return \common\libraries\AutoloaderUtilities :: synch(__DIR__, __DIR__, $update);
    }

}
?>