<?php
namespace application\weblcms\tool\learning_path;

use common\libraries\DelegateComponent;

use application\weblcms\Tool;
use common\libraries\ToolbarItem;
use common\libraries\Theme;
use application\weblcms\ToolComponent;
use common\libraries\Translation;
use application\weblcms\WeblcmsRights;

class LearningPathToolBrowserComponent extends LearningPathTool implements DelegateComponent
{

    public function run()
    {
        ToolComponent :: launch($this);
    }

    public function get_tool_actions()
    {
        if ($this->is_allowed(WeblcmsRights :: ADD_RIGHT))
        {
            $actions[] = new ToolbarItem(
                Translation :: get('ImportScorm'),
                Theme :: get_common_image_path() . 'action_import.png',
                $this->get_url(array(Tool :: PARAM_ACTION => LearningPathTool :: ACTION_IMPORT_SCORM))
            );
        }

        return $actions;
    }

    public function get_additional_parameters()
    {
        return array(self :: PARAM_BROWSE_PUBLICATION_TYPE);
    }
}
