<?php

namespace application\weblcms\tool\learning_path;


use application\weblcms\WeblcmsManager;
use common\libraries\ObjectTableDataProvider;
use common\libraries\ObjectTableOrder;


/**
 * This component provides the data for the table.
 *
 * @author Bert De Clercq (Hogeschool Gent)
 */
class AssessmentResultsTableDataProvider extends ObjectTableDataProvider
{

    private $parent;
    private $condition;

    /**
     *
     * @param type $parent The parent
     * @param type $condition The condition to determine which data to provide
     */
    public function __construct($parent, $condition)
    {
        $this->parent = $parent;
        $this->condition = $condition;
    }

    /**
     * Returns the number of objects.
     *
     * @return int The number of objects
     */
    public function get_object_count()
    {
        return $this->get_objects()->size();
    }

    /**
     * Returns the data for the table.
     *
     * @param int $offset The offset
     * @param int $count The number of items
     * @param ObjectTableOrder $order_property
     * @return \application\weblcms\integration\tracking\LpiAttempt
     */
    public function get_objects($offset, $count, $order_property = null)
    {
        if (is_null($order_property))
        {
            $order_property = new ObjectTableOrder(\application\weblcms\integration\tracking\LpiAttempt :: PROPERTY_START_TIME);
        }

        $attempts = \application\weblcms\integration\tracking\LpiAttempt :: get_data(
            \application\weblcms\integration\tracking\LpiAttempt :: CLASS_NAME,
            WeblcmsManager :: APPLICATION_NAME, $this->condition, $offset, $count, $order_property
        );

        return $attempts;
    }

}
