<?php
namespace application\weblcms\tool\note;

class Autoloader
{

    /**
     * The array mapping class names to paths
     *
     * @var multitype:string
     */
     private static $map = array(
         'Autoloader' => '/autoloader.class.php',
         'NoteTool' => '/lib/note_tool.class.php',
         'NoteToolAttachmentViewerComponent' => '/lib/component/attachment_viewer.class.php',
         'NoteToolBrowserComponent' => '/lib/component/browser.class.php',
         'NoteToolContentObjectUpdaterComponent' => '/lib/component/content_object_updater.class.php',
         'NoteToolDeleterComponent' => '/lib/component/deleter.class.php',
         'NoteToolEvaluateComponent' => '/lib/component/evaluate.class.php',
         'NoteToolHidePublicationComponent' => '/lib/component/hide_publication.class.php',
         'NoteToolIntroductionPublisherComponent' => '/lib/component/introduction_publisher.class.php',
         'NoteToolMoverComponent' => '/lib/component/mover.class.php',
         'NoteToolPublicationUpdaterComponent' => '/lib/component/publication_updater.class.php',
         'NoteToolPublisherComponent' => '/lib/component/publisher.class.php',
         'NoteToolReportingViewerComponent' => '/lib/component/reporting_viewer.class.php',
         'NoteToolRightsEditorComponent' => '/lib/component/rights_editor.class.php',
         'NoteToolShareContentObjectsComponent' => '/lib/component/share_content_objects.class.php',
         'NoteToolShowPublicationComponent' => '/lib/component/show_publication.class.php',
         'NoteToolToggleVisibilityComponent' => '/lib/component/toggle_visibility.class.php',
         'NoteToolUpdaterComponent' => '/lib/component/updater.class.php',
         'NoteToolViewerComponent' => '/lib/component/viewer.class.php',
         'NoteBrowser' => '/lib/component/note_viewer/note_browser.class.php',
         'DataManager' => '/lib/storage/data_manager/data_manager.class.php',
         'DoctrineDataManager' => '/lib/storage/data_manager/implementation/doctrine.class.php',
         'Activator' => '/package/activate/activator.class.php',
         'Deactivator' => '/package/deactivate/deactivator.class.php',
         'Installer' => '/package/install/installer.class.php'
    );

    /**
     * Try to load the class
     *
     * @param $classname string
     * @return boolean
     */
    public static function load($classname)
    {
        if (isset(self :: $map[$classname]))
        {
            require_once __DIR__ . self :: $map[$classname];
            return true;
        }

        return false;
    }

    /**
     * Synchronize the autoloader
     *
     * @param $update boolean
     * @return multitype:string
     */
    public static function synch($update)
    {
        return \common\libraries\AutoloaderUtilities :: synch(__DIR__, __DIR__, $update);
    }

}
?>