<?php
namespace application\weblcms\tool\reporting;

use common\libraries\DelegateComponent;
use reporting\ReportingManager;
use common\libraries\Request;
use application\weblcms\WeblcmsRights;
use Exception;

/**
 * $Id: reporting_viewer.class.php 216 2009-11-13 14:08:06Z kariboe $
 *
 * @package application.lib.weblcms.tool.reporting.component
 */

/**
 *
 * @author Michael Kyndt
 */
class ReportingToolViewerComponent extends ReportingTool implements DelegateComponent
{

    public function run()
    {
        if (! $this->is_allowed(WeblcmsRights :: EDIT_RIGHT))
        {
            throw new Exception('not-allowed');
        }

        $template_id = Request :: get(ReportingManager :: PARAM_TEMPLATE_ID);

        if (! isset($template_id))
        {
            \reporting\viewer\Manager :: launch(
                $this,
                \application\weblcms\integration\reporting\CourseStudentTrackerTemplate :: class_name());
        }
        else
        {
            $this->set_parameter(ReportingManager :: PARAM_TEMPLATE_ID, $template_id);
            \reporting\viewer\Manager :: launch($this, $template_id);
        }
    }
}
