<?php
namespace application\weblcms\tool\streaming_video;

use common\libraries\Categorizable;
use repository\content_object\youtube\Youtube;
use repository\content_object\mediamosa\Mediamosa;
use repository\content_object\dailymotion\Dailymotion;
use repository\content_object\vimeo\Vimeo;
use application\weblcms\ContentObjectPublicationListRenderer;
use application\weblcms\Tool;

/**
 * $Id: announcement_tool.class.php 216 2009-11-13 14:08:06Z kariboe $
 *
 * @package application.lib.weblcms.tool.announcement.component
 */

/**
 * This tool allows a user to publish announcements in his or her course.
 */
class StreamingVideoTool extends Tool implements Categorizable
{

    public static function get_allowed_types()
    {
        return array(Youtube :: CLASS_NAME, Mediamosa :: CLASS_NAME, Dailymotion :: CLASS_NAME, Vimeo :: CLASS_NAME);
    }

    public function get_available_browser_types()
    {
        $browser_types = array();
        $browser_types[] = ContentObjectPublicationListRenderer :: TYPE_TABLE;
        $browser_types[] = ContentObjectPublicationListRenderer :: TYPE_GALLERY;
        $browser_types[] = ContentObjectPublicationListRenderer :: TYPE_SLIDESHOW;
        return $browser_types;
    }

    /**
     * Helper function for the SubManager class, pending access to class constants via variables in PHP 5.3 e.g. $name =
     * $class :: DEFAULT_ACTION DO NOT USE IN THIS SUBMANAGER'S CONTEXT Instead use: - self :: DEFAULT_ACTION in the
     * context of this class - YourSubManager :: DEFAULT_ACTION in all other application classes
     */
    public static function get_default_action()
    {
        return self :: DEFAULT_ACTION;
    }

    /**
     * Helper function for the SubManager class, pending access to class constants via variables in PHP 5.3 e.g. $name =
     * $class :: PARAM_ACTION DO NOT USE IN THIS SUBMANAGER'S CONTEXT Instead use: - self :: PARAM_ACTION in the context
     * of this class - YourSubManager :: PARAM_ACTION in all other application classes
     */
    public static function get_action_parameter()
    {
        return self :: PARAM_ACTION;
    }
}
