<?php
namespace application\weblcms\tool\user;

class Autoloader
{

    /**
     * The array mapping class names to paths
     *
     * @var multitype:string
     */
     private static $map = array(
         'Autoloader' => '/autoloader.class.php',
         'RequestForm' => '/request_form.class.php',
         'LaLaLaCourseGroupUserMenu' => '/lib/course_group_user_menu.class.php',
         'PlatformgroupMenuRenderer' => '/lib/platformgroup_menu_renderer.class.php',
         'UserCourseGroups' => '/lib/user_course_groups.class.php',
         'UserTool' => '/lib/user_tool.class.php',
         'WeblcmsUserToolConnector' => '/lib/user_tool_connector.class.php',
         'UserToolContentObjectUpdaterComponent' => '/lib/component/content_object_updater.class.php',
         'UserToolDeleterComponent' => '/lib/component/deleter.class.php',
         'UserToolDetailsComponent' => '/lib/component/details.class.php',
         'UserToolEmailerComponent' => '/lib/component/emailer.class.php',
         'UserToolGroupSubscribeComponent' => '/lib/component/group_subscribe.class.php',
         'UserToolGroupSubscribeBrowserComponent' => '/lib/component/group_subscribe_browser.class.php',
         'UserToolGroupUnsubscribeComponent' => '/lib/component/group_unsubscribe.class.php',
         'UserToolGroupUsersSubscribeComponent' => '/lib/component/group_users_subscribe.class.php',
         'UserToolIntroductionPublisherComponent' => '/lib/component/introduction_publisher.class.php',
         'UserToolReportingViewerComponent' => '/lib/component/reporting_viewer.class.php',
         'UserToolRequestSubscribeUserComponent' => '/lib/component/request_subscribe_user.class.php',
         'UserToolStatusChangerComponent' => '/lib/component/status_changer.class.php',
         'UserToolStatusChangerPlatformgroupStudentComponent' => '/lib/component/status_changer_platformgroup_student.class.php',
         'UserToolStatusChangerPlatformgroupTeacherComponent' => '/lib/component/status_changer_platformgroup_teacher.class.php',
         'UserToolStatusChangerUserStudentComponent' => '/lib/component/status_changer_user_student.class.php',
         'UserToolStatusChangerUserTeacherComponent' => '/lib/component/status_changer_user_teacher.class.php',
         'UserToolSubscribeComponent' => '/lib/component/subscribe.class.php',
         'UserToolSubscribeAsAdminComponent' => '/lib/component/subscribe_as_admin.class.php',
         'UserToolSubscribeBrowserComponent' => '/lib/component/subscribe_browser.class.php',
         'UserToolUnsubscribeComponent' => '/lib/component/unsubscribe.class.php',
         'UserToolUnsubscribeBrowserComponent' => '/lib/component/unsubscribe_browser.class.php',
         'UserToolViewAsComponent' => '/lib/component/view_as.class.php',
         'AllSubscribedUserBrowserTable' => '/lib/component/all_subscribed_user_browser/all_subscribed_user_browser_table.class.php',
         'AllSubscribedUserBrowserTableCellRenderer' => '/lib/component/all_subscribed_user_browser/all_subscribed_user_browser_table_cell_renderer.class.php',
         'AllSubscribedUserBrowserTableColumnModel' => '/lib/component/all_subscribed_user_browser/all_subscribed_user_browser_table_column_model.class.php',
         'AllSubscribedUserBrowserTableDataProvider' => '/lib/component/all_subscribed_user_browser/all_subscribed_user_browser_table_data_provider.class.php',
         'DirectSubscribedPlatformGroupBrowserTable' => '/lib/component/direct_subscribed_platform_group_browser/direct_subscribed_platform_group_browser_table.class.php',
         'DirectSubscribedPlatformGroupBrowserTableCellRenderer' => '/lib/component/direct_subscribed_platform_group_browser/direct_subscribed_platform_group_browser_table_cell_renderer.class.php',
         'DirectSubscribedPlatformGroupBrowserTableColumnModel' => '/lib/component/direct_subscribed_platform_group_browser/direct_subscribed_platform_group_browser_table_column_model.class.php',
         'DirectSubscribedPlatformGroupBrowserTableDataProvider' => '/lib/component/direct_subscribed_platform_group_browser/direct_subscribed_platform_group_browser_table_data_provider.class.php',
         'PlatformGroupRelUserBrowserTable' => '/lib/component/platform_group_rel_user_browser/platform_group_rel_user_browser_table.class.php',
         'PlatformGroupRelUserBrowserTableCellRenderer' => '/lib/component/platform_group_rel_user_browser/platform_group_rel_user_browser_table_cell_renderer.class.php',
         'PlatformGroupRelUserBrowserTableColumnModel' => '/lib/component/platform_group_rel_user_browser/platform_group_rel_user_browser_table_column_model.class.php',
         'PlatformGroupRelUserBrowserTableDataProvider' => '/lib/component/platform_group_rel_user_browser/platform_group_rel_user_browser_table_data_provider.class.php',
         'SubSubscribedPlatformGroupBrowserTable' => '/lib/component/sub_subscribed_platform_group_browser/sub_subscribed_platform_group_browser_table.class.php',
         'SubSubscribedPlatformGroupBrowserTableCellRenderer' => '/lib/component/sub_subscribed_platform_group_browser/sub_subscribed_platform_group_browser_table_cell_renderer.class.php',
         'SubSubscribedPlatformGroupBrowserTableColumnModel' => '/lib/component/sub_subscribed_platform_group_browser/sub_subscribed_platform_group_browser_table_column_model.class.php',
         'SubSubscribedPlatformGroupBrowserTableDataProvider' => '/lib/component/sub_subscribed_platform_group_browser/sub_subscribed_platform_group_browser_table_data_provider.class.php',
         'SubscribedUserBrowserTable' => '/lib/component/subscribed_user_browser/subscribed_user_browser_table.class.php',
         'SubscribedUserBrowserTableCellRenderer' => '/lib/component/subscribed_user_browser/subscribed_user_browser_table_cell_renderer.class.php',
         'SubscribedUserBrowserTableColumnModel' => '/lib/component/subscribed_user_browser/subscribed_user_browser_table_column_model.class.php',
         'SubscribedUserBrowserTableDataProvider' => '/lib/component/subscribed_user_browser/subscribed_user_browser_table_data_provider.class.php',
         'UnsubscribedGroupBrowserTable' => '/lib/component/unsubscribed_group_browser/unsubscribed_group_browser_table.class.php',
         'UnsubscribedGroupBrowserTableCellRenderer' => '/lib/component/unsubscribed_group_browser/unsubscribed_group_browser_table_cell_renderer.class.php',
         'UnsubscribedGroupBrowserTableColumnModel' => '/lib/component/unsubscribed_group_browser/unsubscribed_group_browser_table_column_model.class.php',
         'UnsubscribedGroupBrowserTableDataProvider' => '/lib/component/unsubscribed_group_browser/unsubscribed_group_browser_table_data_provider.class.php',
         'UnsubscribedUserBrowserTable' => '/lib/component/unsubscribed_user_browser/unsubscribed_user_browser_table.class.php',
         'UnsubscribedUserBrowserTableCellRenderer' => '/lib/component/unsubscribed_user_browser/unsubscribed_user_browser_table_cell_renderer.class.php',
         'UnsubscribedUserBrowserTableColumnModel' => '/lib/component/unsubscribed_user_browser/unsubscribed_user_browser_table_column_model.class.php',
         'UnsubscribedUserBrowserTableDataProvider' => '/lib/component/unsubscribed_user_browser/unsubscribed_user_browser_table_data_provider.class.php',
         'PortfolioConnector' => '/lib/connector/portfolio_connector.class.php',
         'DataManager' => '/lib/storage/data_manager/data_manager.class.php',
         'DoctrineDataManager' => '/lib/storage/data_manager/implementation/doctrine.class.php',
         'Activator' => '/package/activate/activator.class.php',
         'Deactivator' => '/package/deactivate/deactivator.class.php',
         'Installer' => '/package/install/installer.class.php'
    );

    /**
     * Try to load the class
     *
     * @param $classname string
     * @return boolean
     */
    public static function load($classname)
    {
        if (isset(self :: $map[$classname]))
        {
            require_once __DIR__ . self :: $map[$classname];
            return true;
        }

        return false;
    }

    /**
     * Synchronize the autoloader
     *
     * @param $update boolean
     * @return multitype:string
     */
    public static function synch($update)
    {
        return \common\libraries\AutoloaderUtilities :: synch(__DIR__, __DIR__, $update);
    }

}
?>