<?php
namespace application\weblcms\tool\user;

use application\weblcms\course\DataManager as CourseDataManager;
use common\libraries\RecordTableDataProvider;

/**
 * Data provider for an all subscribed course user browser table, including
 * users
 * subscribed through (sub-)groups.
 *
 * @author Stijn Van Hoecke
 * @author Sven Vanpoucke - Hogeschool Gent - Refactoring to RecordTable
 */
class AllSubscribedUserBrowserTableDataProvider extends RecordTableDataProvider
{
    /**
     * Returns the data as a resultset
     *
     * @param \common\libraries\Condition $condition
     * @param $condition
     * @param int $offset
     * @param int $count
     * @param ObjectTableOrder[] $order_property
     *
     * @return \common\libraries\ResultSet
     */
    public function retrieve_data($condition, $offset, $count, $order_property = null)
    {
        return CourseDatamanager :: get_instance()->retrieve_all_course_users(
            $this->get_component()->get_course_id(), $condition, $offset, $count, $order_property
        );
    }

    /**
     * Counts the data
     *
     * @param \common\libraries\Condition $condition
     *
     * @return int
     */
    public function count_data($condition)
    {
        return CourseDatamanager :: get_instance()->count_all_course_users(
            $this->get_component()->get_course_id(), $condition
        );
    }
}
