<?php

namespace application\weblcms\tool\user;

use common\libraries\RecordTableColumnModel;
use common\libraries\DataClassPropertyTableColumn;
use common\libraries\TableColumnModelActionsColumnSupport;

use group\Group;

use application\weblcms\course\CourseGroupRelation;
/**
 * Table column model for a direct subscribed course group browser table.
 *
 * @author Stijn Van Hoecke
 * @author Sven Vanpoucke - Hogeschool Gent - Refactoring from ObjectTable to RecordTable
 */
class DirectSubscribedPlatformGroupBrowserTableColumnModel extends RecordTableColumnModel implements
    TableColumnModelActionsColumnSupport
{
    /**
     * Initializes the columns for the table
     */
    public function initialize_columns()
    {
        $this->add_column(new DataClassPropertyTableColumn(Group :: class_name(), Group :: PROPERTY_NAME));
        $this->add_column(new DataClassPropertyTableColumn(Group :: class_name(), Group :: PROPERTY_CODE));
        $this->add_column(new DataClassPropertyTableColumn(Group :: class_name(), Group :: PROPERTY_DESCRIPTION));

        $this->add_column(new DataClassPropertyTableColumn(
            CourseGroupRelation :: class_name(), CourseGroupRelation :: PROPERTY_STATUS)
        );
    }
}
