<?php
namespace application\weblcms\tool\user;
use common\libraries\Utilities;
use common\libraries\ObjectTable;

/**
 * * ***************************************************************************
 * Table to display a list of subgroups subscribed to a course.
 *
 * @author Stijn Van Hoecke
 *
 *         ****************************************************************************
 */
class SubSubscribedPlatformGroupBrowserTable extends ObjectTable
{
    const DEFAULT_ROW_COUNT = 20;

    /**
     * Constructor
     *
     * @see ContentObjectTable::ContentObjectTable()
     */
    public function __construct($browser, $parameters, $condition, $direct_subscription = true)
    {
        // model - cell renderer - data provider
        $model = new SubSubscribedPlatformGroupBrowserTableColumnModel();
        $renderer = new SubSubscribedPlatformGroupBrowserTableCellRenderer($browser);
        $data_provider = new SubSubscribedPlatformGroupBrowserTableDataProvider($browser, $condition);

        // parent construct
        parent :: __construct(
            $data_provider, Utilities :: get_classname_from_namespace(__CLASS__, true), $model, $renderer
        );

        // defaults
        $this->set_additional_parameters($parameters);
        $this->set_default_row_count(self :: DEFAULT_ROW_COUNT);
    }
}
