<?php
namespace application\weblcms\tool\user;

use group\DataManager as GroupDataManager;
use group\Group;

use common\libraries\DataClassRetrievesParameters;
use common\libraries\ObjectTableDataProvider;

/**
 * * ***************************************************************************
 * Data privider for a course subgroup browser table.
 *
 * @author Stijn Van Hoecke
 *
 *         ****************************************************************************
 */
class SubSubscribedPlatformGroupBrowserTableDataProvider extends ObjectTableDataProvider
{

    /**
     * Constructor
     */
    public function __construct($browser, $condition)
    {
        parent :: __construct($browser, $condition);
    }

    /**
     * Gets the groups
     *
     * @param $offset int
     * @param $count int
     * @param $order_property string
     * @return ResultSet A set of matching groups.
     */
    public function get_objects($offset, $count, $order_property = null)
    {
        $order_property = $this->get_order_property($order_property);
        return GroupDataManager :: retrieves(
                Group :: class_name(),
                new DataClassRetrievesParameters($this->get_condition(), $count, $offset, $order_property));
    }

    /**
     * Counts the groups
     *
     * @return int
     */
    public function get_object_count()
    {
        return GroupDataManager :: count(Group :: class_name(), $this->get_condition());
    }
}
