<?php
namespace application\weblcms\tool\user;

use common\libraries\RecordTableColumnModel;
use common\libraries\TableColumnModelActionsColumnSupport;
use common\libraries\DataClassPropertyTableColumn;

use user\User;

use application\weblcms\course\CourseUserRelation;

/**
 * Table column model for a direct subscribed course user browser table, or
 * users
 * in a direct subscribed group.
 *
 * @author Stijn Van Hoecke
 * @author Sven Vanpoucke - Hogeschool Gent - Refactoring to RecordTable
 */
class SubscribedUserBrowserTableColumnModel extends RecordTableColumnModel implements
    TableColumnModelActionsColumnSupport
{
    const DEFAULT_ORDER_COLUMN_INDEX = 1;

    /****************************************************************************************************************
     * Inherited Functionality                                                                                      *
     ****************************************************************************************************************/

    /**
     * Initializes the columns for the table
     */
    public function initialize_columns()
    {
        $this->add_column(new DataClassPropertyTableColumn(User :: class_name(), User :: PROPERTY_USERNAME));
        $this->add_column(new DataClassPropertyTableColumn(User :: class_name(), User :: PROPERTY_EMAIL));
        $this->add_column(new DataClassPropertyTableColumn(
            CourseUserRelation :: class_name(), CourseUserRelation :: PROPERTY_STATUS)
        );
    }

}
