<?php
namespace application\weblcms\tool\user;

use group\DefaultGroupTableColumnModel;
use common\libraries\StaticTableColumn;
use group\Group;

/**
 * * ***************************************************************************
 * Table column model for an unsubscribed course user browser table.
 *
 * @author Stijn Van Hoecke
 *
 *         ****************************************************************************
 */
class UnsubscribedGroupBrowserTableColumnModel extends DefaultGroupTableColumnModel
{
    /**
     * The tables modification column.
     */
    private static $modification_column;

    // **************************************************************************
    // CONSTRUCTOR
    // **************************************************************************
    /**
     * Constructor
     */
    public function __construct()
    {
        parent :: __construct();
        $this->add_column(self :: get_modification_column());
        $this->set_default_order_column(1);
    }

    /**
     * Gets the modification column
     *
     * @return ContentObjectTableColumn
     */
    public static function get_modification_column()
    {
        if (!isset(self :: $modification_column))
        {
            self :: $modification_column = new StaticTableColumn('');
        }
        return self :: $modification_column;
    }
}
