<?php

namespace application\weblcms\tool\user;

use application\portfolio\PortfolioDataManager;
use application\portfolio\PortfolioManager;
use common\libraries\Theme;
use common\libraries\ToolbarItem;
use common\libraries\Translation;
use repository\ContentObject;
use common\libraries\Application;

/**
 * This  connector allows to add links to the personal portfolios in the user table
 */
class PortfolioConnector implements WeblcmsUserToolConnector
{
    public function is_active()
    {
           
        return Application :: is_active(Application :: determine_namespace('application\portfolio'));
            
            
    }

    public function get_toolbar_items($user_id) 
    {
         $portfoliomanager = new PortfolioManager();
        $pdm = PortfolioDataManager::get_instance();
            $has_portfolio = $pdm->has_user_created_portfolio($user_id);
            if($has_portfolio)
            {
                $portfolio_url = $portfoliomanager->get_url(array($portfoliomanager::PARAM_APPLICATION => 'portfolio', $portfoliomanager :: PARAM_ACTION => $portfoliomanager :: ACTION_VIEW_PORTFOLIO, $portfoliomanager :: PARAM_PORTFOLIO_OWNER_ID => $user_id));
                $toolbar_item = new ToolbarItem(Translation :: get('Portfolio'), Theme :: get_image_path(ContentObject::get_content_object_type_namespace('portfolio')) . 'logo/22.png', $portfolio_url, ToolbarItem :: DISPLAY_ICON);
            }
            else
            {
                $toolbar_item = new ToolbarItem(Translation :: get('NoPortfolio'), Theme :: get_image_path(ContentObject::get_content_object_type_namespace('portfolio')) . 'logo/22_na.png', null, ToolbarItem :: DISPLAY_ICON);
            }
            
            return array($toolbar_item);
       
    }
    

}
?>