<?php
namespace common\extensions\dynamic_form_manager;
/**
 * $Id: viewer.class.php 205 2009-11-13 12:57:33Z vanpouckesven $
 * @package application.common.dynamic_form_manager.component
 * @author Sven Vanpoucke
 */

use common\libraries\Translation;
use common\libraries\BreadcrumbTrail;

class DynamicFormManagerExecuterComponent extends DynamicFormManager
{

    public function run()
    {
        $trail = BreadcrumbTrail :: get_instance();
        $trail->add_help('dynamic form general');

        $form = new DynamicFormExecuteForm($this->get_form(), $this->get_url(), $this->get_user(), $this->get_dynamic_form_title());

        if ($form->validate())
        {
            $success = $form->update_values();
            $this->redirect(Translation :: get($success ? 'DynamicFormExecuted' : 'DynamicFormNotExecuted'), ($success ? false : true), array());
        }
        else
        {
            $this->display_header();
            $form->display();
            $this->display_footer();
        }
    }
}
