<?php
namespace common\extensions\external_repository_manager\implementation\picasa;

use common\libraries\Path;
use common\libraries\Request;
use common\libraries\Redirect;

class EditorComponent extends Manager
{

    public function run()
    {
        $id = Request :: get(Manager :: PARAM_EXTERNAL_REPOSITORY_ID);
        $form = new ExternalObjectForm(ExternalObjectForm :: TYPE_EDIT, 
                $this->get_url(array(Manager :: PARAM_EXTERNAL_REPOSITORY_ID => $id)), $this);
        
        $object = $this->retrieve_external_repository_object($id);
        
        $form->set_external_repository_object($object);
        
        if ($form->validate())
        {
            $success = $form->update_photo();
            
            $parameters = $this->get_parameters();
            $parameters[Manager :: PARAM_EXTERNAL_REPOSITORY_MANAGER_ACTION] = Manager :: ACTION_VIEW_EXTERNAL_REPOSITORY;
            $parameters[Manager :: PARAM_EXTERNAL_REPOSITORY_ID] = $object->get_id();
            
            if ($this->is_stand_alone())
            {
                Redirect :: web_link(Path :: get(WEB_PATH) . 'common/launcher/index.php', $parameters);
            }
            else
            {
                Redirect :: web_link(Path :: get(WEB_PATH) . 'index.php', $parameters);
            }
        }
        else
        {
            $this->display_header();
            $form->display();
            $this->display_footer();
        }
    }
}
