<?php
namespace common\extensions\external_repository_manager\implementation\slideshare;

use repository\ExternalInstance;
use common\extensions\external_repository_manager\StreamingMediaExternalObject;

class ExternalObject extends StreamingMediaExternalObject
{
    const OBJECT_TYPE = 'slideshare';
    const PROPERTY_URLS = 'urls';
    const PROPERTY_EMBED = 'embed';

    public static function get_default_property_names()
    {
        return parent :: get_default_property_names(array(self :: PROPERTY_URLS, self :: PROPERTY_TAGS));
    }

    public function get_urls()
    {
        return $this->get_default_property(self :: PROPERTY_URLS);
    }

    public function set_urls($urls)
    {
        return $this->set_default_property(self :: PROPERTY_URLS, $urls);
    }

    public static function get_object_type()
    {
        return self :: OBJECT_TYPE;
    }

    public function is_usable()
    {
        return $this->get_right(self :: RIGHT_USE);
    }

    public function get_embed()
    {
        return $this->get_default_property(self :: PROPERTY_EMBED);
    }

    public function set_embed($embed)
    {
        return $this->set_default_property(self :: PROPERTY_EMBED, $embed);
    }

    public function get_content_data($external_object)
    {
        $external_repository = \repository\DataManager :: retrieve_by_id(ExternalInstance :: class_name(), 
                $this->get_external_repository_id());
        return DataConnector :: get_instance($external_repository)->download_external_repository_object(
                $external_object);
    }
}
