<?php
namespace common\extensions\external_repository_manager\implementation\youtube;

use common\extensions\external_repository_manager\Component;

use common\libraries\Translation;
use common\libraries\Utilities;

class DeleterComponent extends Manager 
{

    public function run()
    {
        if (! $this->get_external_repository()->get_user_setting('session_token'))
        {
            $this->not_allowed();
        }
        else
        {
            Component :: launch($this);
        }
    }

    public function delete_external_repository_object($id)
    {
        $success = parent :: delete_external_repository_object($id);
        if ($success)
        {
            $parameters = $this->get_parameters();
            $parameters[Manager :: PARAM_EXTERNAL_REPOSITORY_MANAGER_ACTION] = Manager :: ACTION_BROWSE_EXTERNAL_REPOSITORY;
            $this->redirect(Translation :: get('ObjectDeleted', null, Utilities :: COMMON_LIBRARIES), false, 
                    $parameters);
        }
        else
        {
            $parameters = $this->get_parameters();
            $parameters[Manager :: PARAM_EXTERNAL_REPOSITORY_MANAGER_ACTION] = Manager :: ACTION_VIEW_EXTERNAL_REPOSITORY;
            $parameters[Manager :: PARAM_EXTERNAL_REPOSITORY_ID] = $id;
            $this->redirect(Translation :: get('ObjectFailedDeleted', null, Utilities :: COMMON_LIBRARIES), true, 
                    $parameters);
        }
    }
}
