<?php
namespace common\extensions\external_repository_manager\implementation\youtube;

use common\libraries\DelegateComponent;

use common\extensions\external_repository_manager\Component;

use common\libraries\Translation;
use common\libraries\Utilities;

class ExporterComponent extends Manager implements DelegateComponent
{

    public function run()
    {
        if (! $this->get_external_repository()->get_user_setting('session_token'))
        {
            $this->not_allowed();
        }
        else
        {
            Component :: launch($this);
        }
    }

    public function export_external_repository_object($object)
    {
        $success = parent :: export_external_repository_object($object);
        if ($success)
        {
            $parameters = $this->get_parameters();
            $parameters[Manager :: PARAM_EXTERNAL_REPOSITORY_MANAGER_ACTION] = Manager :: ACTION_BROWSE_EXTERNAL_REPOSITORY;
            $parameters[Manager :: PARAM_FEED_TYPE] = Manager :: FEED_TYPE_MYVIDEOS;
            $this->redirect(Translation :: get('ObjectExported', null, Utilities :: COMMON_LIBRARIES), false, 
                    $parameters);
        }
        else
        {
            $parameters = $this->get_parameters();
            $parameters[Manager :: PARAM_EXTERNAL_REPOSITORY_MANAGER_ACTION] = Manager :: ACTION_EXPORT_EXTERNAL_REPOSITORY;
            $this->redirect(Translation :: get('ObjectFailedExported', null, Utilities :: COMMON_LIBRARIES), true, 
                    $parameters);
        }
    }

}
