<?php
namespace common\extensions\external_repository_manager\implementation\youtube;

use common\libraries\DataClassRetrievesParameters;
use repository\ExternalSetting;
use repository\ExternalUserSetting;
use common\libraries\AndCondition;
use common\libraries\EqualityCondition;
use common\libraries\Translation;
use common\libraries\Utilities;

class LogoutComponent extends Manager
{

    public function run()
    {
        $conditions = array();
        $conditions[] = new EqualityCondition(ExternalSetting :: PROPERTY_EXTERNAL_ID, 
                $this->get_external_repository()->get_id());
        $conditions[] = new EqualityCondition(ExternalSetting :: PROPERTY_VARIABLE, 'session_token');
        $conditions[] = new EqualityCondition(ExternalSetting :: PROPERTY_USER_SETTING, 1);
        $condition = new AndCondition($conditions);
        
        $parameters = new DataClassRetrievesParameters($condition, 1);
        $settings = \repository\DataManager :: retrieves(ExternalSetting :: class_name(), $parameters);
        if ($settings->size() > 0)
        {
            $setting = $settings->next_result();
            
            $conditions = array();
            $conditions[] = new EqualityCondition(ExternalUserSetting :: PROPERTY_SETTING_ID, $setting->get_id());
            $conditions[] = new EqualityCondition(ExternalUserSetting :: PROPERTY_USER_ID, $this->get_user_id());
            $condition = new AndCondition($conditions);
            
            $parameters = new DataClassRetrievesParameters($condition, 1);
            $user_settings = \repository\DataManager :: retrieves(ExternalUserSetting :: class_name(), $parameters);
            
            if ($user_settings->size() > 0)
            {
                $user_setting = $user_settings->next_result();
                if ($user_setting->delete())
                {
                    $parameters = $this->get_parameters();
                    $parameters[Manager :: PARAM_EXTERNAL_REPOSITORY_MANAGER_ACTION] = Manager :: ACTION_BROWSE_EXTERNAL_REPOSITORY;
                    $this->redirect(Translation :: get('LogoutSuccessful', null, Utilities :: COMMON_LIBRARIES), false, 
                            $parameters);
                }
                else
                {
                    $parameters = $this->get_parameters();
                    $parameters[Manager :: PARAM_EXTERNAL_REPOSITORY_MANAGER_ACTION] = Manager :: ACTION_BROWSE_EXTERNAL_REPOSITORY;
                    $this->redirect(Translation :: get('LogoutFailed', null, Utilities :: COMMON_LIBRARIES), true, 
                            $parameters);
                }
            }
        }
    }
}
