<?php
namespace common\extensions\external_repository_manager;

use common\libraries\StaticConditionVariable;
use common\libraries\PropertyConditionVariable;
use common\libraries\AndCondition;
use common\libraries\EqualityCondition;
use common\libraries\OrCondition;
use repository\ContentObject;
use common\libraries\NewObjectTableSupport;
use common\libraries\Request;

class ExporterComponent extends Component implements NewObjectTableSupport
{

    public function run()
    {
        $external_repository_id = Request :: get(Manager :: PARAM_EXTERNAL_REPOSITORY_ID);
        if (isset($external_repository_id))
        {
            $object = \repository\DataManager :: retrieve_content_object($external_repository_id);
            $success = $this->export_external_repository_object($object);
            if ($success)
            {
            }
        }
        else
        {
            $this->display_header();
            $table = new ExportTable($this);
            echo ($table->as_html());
            $this->display_footer();
        }
    }

    /*
     * (non-PHPdoc) @see common\libraries.NewObjectTableSupport::get_object_table_condition()
     */
    public function get_object_table_condition($object_table_class_name)
    {
        $conditions = array();
        $type_conditions = array();

        if (ContentObject :: is_available('repository\content_object\document\Document'))
        {
            $types = array(\repository\content_object\document\Document :: class_name());
        }
        else
        {
            $types = array(\repository\content_object\file\File :: class_name());
        }

        foreach ($types as $type)
        {
            $type_conditions[] = new EqualityCondition(
                new PropertyConditionVariable(ContentObject :: class_name(), ContentObject :: PROPERTY_TYPE),
                new StaticConditionVariable($type));
        }

        $conditions[] = new OrCondition($type_conditions);

        if ($this->get_parent()->get_content_object_type_conditions())
        {
            $conditions[] = $this->get_parent()->get_content_object_type_conditions();
        }

        $conditions[] = new EqualityCondition(
            new PropertyConditionVariable(ContentObject :: class_name(), ContentObject :: PROPERTY_OWNER_ID),
            new StaticConditionVariable($this->get_user_id()));
        $conditions[] = new EqualityCondition(
            new PropertyConditionVariable(ContentObject :: class_name(), ContentObject :: PROPERTY_STATE),
            new StaticConditionVariable(ContentObject :: STATE_NORMAL));

        return new AndCondition($conditions);
    }
}
