<?php
namespace common\extensions\external_repository_manager;

use common\libraries\DataClassCountParameters;
use common\libraries\DataClassRetrievesParameters;
use repository\ContentObject;
use repository\content_object\document\Document;
use repository\content_object\file\File;
use common\libraries\NewObjectTableDataProvider;

class ExportTableDataProvider extends NewObjectTableDataProvider
{

    public function get_objects($offset, $count, $order_property = null)
    {
        $order_property = $this->get_order_property($order_property);
        $parameters = new DataClassRetrievesParameters($this->get_condition(), $count, $offset, $order_property);
        return \repository\DataManager :: retrieve_active_content_objects(
            ContentObject :: is_available('repository\content_object\document\Document') ? Document :: class_name() : File :: class_name(),
            $parameters);
    }

    public function get_object_count()
    {
        $parameters = new DataClassCountParameters($this->get_condition());
        return \repository\DataManager :: count_active_content_objects(
            (ContentObject :: is_available('repository\content_object\document\Document') ? Document :: class_name() : File :: class_name()),
            $parameters);
    }
}
