<?php
namespace common\extensions\feedback_manager;




use common\libraries\NotAllowedException;
use core\admin\FeedbackPublication;

use repository\content_object\feedback\Feedback;

use common\libraries\Translation;
/**
 * $Id: creator.class.php 205 2009-11-13 12:57:33Z vanpouckesven $
 * @package application.common.feedback_manager.component
 */

/**
 * Description of updaterclass
 *
 * @author pieter
 */

class FeedbackManagerCreatorComponent extends FeedbackManager implements \repository\viewer\ViewerInterface
{

    public function run()
    {
        if(!$this->can_create_feedback())
        {
            throw new NotAllowedException();
        }

        $application = $this->get_application();
        $publication_id = $this->get_publication_id();
        $complex_wrapper_id = $this->get_complex_wrapper_id();
        $action = $this->get_action();
        
        if (! \repository\viewer\Manager :: is_ready_to_be_published())
        {
            $repository_viewer = \repository\viewer\Manager :: construct($this);
            $repository_viewer->run();
        }
        else
        {
            $objects = \repository\viewer\Manager :: get_selected_objects();
            
            if (! is_array($objects))
            {
                $objects = array($objects);
            }
            
            foreach ($objects as $object)
            {
                $fb = new FeedbackPublication();
                $fb->set_application($application);
                $fb->set_cid($complex_wrapper_id);
                $fid = $object;
                $fb->set_fid($object);
                $fb->set_pid($publication_id);
                $fb->set_creation_date(time());
                $fb->set_modification_date(time());
                $fb->create();
            }
            
            $message = 'FeedbackCreated';
            $this->redirect(Translation :: get($message), false, array(
                    FeedbackManager :: PARAM_ACTION => $this->get_parameter(self :: PARAM_OLD_ACTION),
                    \repository\viewer\Manager :: PARAM_ACTION => null));
        }
    
    }

    public function get_allowed_content_object_types()
    {
        return array(Feedback :: class_name());
    }
}
