<?php
namespace common\extensions\new_feedback_manager;

class Autoloader
{

    /**
     * The array mapping class names to paths
     *
     * @var multitype:string
     */
     private static $map = array(
         'Autoloader' => '/autoloader.class.php',
         'FeedbackManagerForm' => '/lib/form/feedback_form.class.php',
         'FeedbackComponent' => '/lib/manager/feedback_component.class.php',
         'FeedbackManager' => '/lib/manager/feedback_manager.class.php',
         'FeedbackComponentBrowserComponent' => '/lib/manager/component/browser.class.php',
         'FeedbackComponentBrowserOnlyComponent' => '/lib/manager/component/browser_only.class.php',
         'FeedbackComponentCreatorComponent' => '/lib/manager/component/creator.class.php',
         'FeedbackComponentDeleterComponent' => '/lib/manager/component/deleter.class.php',
         'FeedbackComponentUpdaterComponent' => '/lib/manager/component/updater.class.php',
         'Activator' => '/package/activate/activator.class.php',
         'Deactivator' => '/package/deactivate/deactivator.class.php',
         'Installer' => '/package/install/installer.class.php'
    );

    /**
     * Try to load the class
     *
     * @param $classname string
     * @return boolean
     */
    public static function load($classname)
    {
        if (isset(self :: $map[$classname]))
        {
            require_once __DIR__ . self :: $map[$classname];
            return true;
        }

        return false;
    }

    /**
     * Synchronize the autoloader
     *
     * @param $update boolean
     * @return multitype:string
     */
    public static function synch($update)
    {
        return \common\libraries\AutoloaderUtilities :: synch(__DIR__, __DIR__, $update);
    }

}
?>