<?php
namespace common\extensions\new_feedback_manager;

use common\libraries\Display;
use common\libraries\Request;
use common\libraries\Translation;
use common\libraries\Utilities;

use core\admin\FeedbackPublication;

/**
 * $Id: deleter.class.php 191 2009-11-13 11:50:28Z chellee $
 * @package application.common.feedback_manager.component
 */

/**
 * Description of deleterclas
 *
 * @author pieter
 */
class FeedbackComponentDeleterComponent extends FeedbackComponent
{

    public function run()
    {
        $html = $this->as_html();
        
        $this->display_header();
        echo $html;
        $this->display_footer();
    }

    public function as_html()
    {
        $ids = Request :: get(FeedbackManager :: PARAM_FEEDBACK_ID);
        
        if (! $this->get_user())
        {
            Display :: error_message(Translation :: get('NotAllowed', null, Utilities :: COMMON_LIBRARIES));
            exit();
        }
        
        $failures = 0;
        
        if (isset($ids))
        {
            if (! is_array($ids))
            {
                $ids = array($ids);
            }
            
            foreach ($ids as $id)
            {
                $FeedbackPublication = $this->retrieve_feedback_publication($id);
                
                if (! $FeedbackPublication->delete())
                {
                    $failures ++;
                }
            }
            
            $message = $this->get_result($failures, count($ids), 'FeedbackPublicationNotDeleted', 'FeedbackPublicationsNotDeleted', 'FeedbackPublicationDeleted', 'FeedbackPublicationsDeleted');
            
            $parameters = $this->get_publication_parameters();
            $parameters[FeedbackManager :: PARAM_ACTION] = FeedbackManager :: ACTION_BROWSE;
            $this->redirect($message, ($failures > 0) ? true : false, $parameters);
        
        }
        else
        {
            Display :: error_message(Translation :: get('NoObjectSelected', null, Utilities :: COMMON_LIBRARIES));
            exit();
        }
    }
}
