<?php
namespace common\extensions\new_rights_editor_manager;

class Autoloader
{

    /**
     * The array mapping class names to paths
     *
     * @var multitype:string
     */
     private static $map = array(
         'Autoloader' => '/autoloader.class.php',
         'NewRightsEditorManagerAjaxEntityRightLocation' => '/ajax/entity_right_location.class.php',
         'NewRightsEditorManagerAjaxEntityRightLocationClass' => '/ajax/entity_right_location_class.class.php',
         'ManageForm' => '/lib/form/manage_form.class.php',
         'SimpleRightsEditorForm' => '/lib/form/simple_rights_editor_form.class.php',
         'RightsEditorManager' => '/lib/manager/rights_editor_manager.class.php',
         'RightsEditorManagerAdvancedRightsEditorComponent' => '/lib/manager/component/advanced_rights_editor.class.php',
         'RightsEditorManagerEntityRightsSetterComponent' => '/lib/manager/component/entity_rights_setter.class.php',
         'RightsEditorManagerInheritChangerComponent' => '/lib/manager/component/inherit_changer.class.php',
         'RightsEditorManagerManagerComponent' => '/lib/manager/component/manager.class.php',
         'RightsEditorManagerRightsEditorComponent' => '/lib/manager/component/rights_editor.class.php',
         'RightsEditorManagerSimpleRightsEditorComponent' => '/lib/manager/component/simple_rights_editor.class.php',
         'LocationEntityBrowserTable' => '/lib/table/location_entity/location_entity_browser_table.class.php',
         'LocationEntityBrowserTableCellRenderer' => '/lib/table/location_entity/location_entity_browser_table_cell_renderer.class.php',
         'LocationEntityBrowserTableColumnModel' => '/lib/table/location_entity/location_entity_browser_table_column_model.class.php',
         'LocationEntityBrowserTableDataProvider' => '/lib/table/location_entity/location_entity_browser_table_data_provider.class.php',
         'LocationEntityBrowserTreeMenu' => '/lib/table/location_entity/location_entity_browser_tree_menu.class.php',
         'Activator' => '/package/activate/activator.class.php',
         'Deactivator' => '/package/deactivate/deactivator.class.php',
         'Installer' => '/package/install/installer.class.php'
    );

    /**
     * Try to load the class
     *
     * @param $classname string
     * @return boolean
     */
    public static function load($classname)
    {
        if (isset(self :: $map[$classname]))
        {
            require_once __DIR__ . self :: $map[$classname];
            return true;
        }

        return false;
    }

    /**
     * Synchronize the autoloader
     *
     * @param $update boolean
     * @return multitype:string
     */
    public static function synch($update)
    {
        return \common\libraries\AutoloaderUtilities :: synch(__DIR__, __DIR__, $update);
    }

}
?>