<?php

namespace common\extensions\new_rights_editor_manager;

use common\libraries\Translation;

/**
 * @author Sven Vanpoucke
 * @package rights.lib.location_manager.component
 */
class RightsEditorManagerInheritChangerComponent extends RightsEditorManager
{

    /**
     * Runs this component and displays its output.
     */
    public function run()
    {
        $locations = $this->get_locations();
        $failures = 0;
        
        if (! empty($locations))
        {
            
            foreach ($locations as $location)
            {
                $location->switch_inherit();
                
                if (! $location->update())
                {
                    $failures ++;
                }
            }
            
            $message = $this->get_result($failures, count($locations), 'SelectedLocationNotInheriting', 'SelectedLocationsNotInheriting', 'SelectedLocationInheriting', 'SelectedLocationsInheriting');
            
            $this->redirect($message, ($failures ? true : false), array(
                    RightsEditorManager :: PARAM_ACTION => RightsEditorManager :: ACTION_EDIT_ADVANCED_RIGHTS));
        }
        else
        {
            $this->display_error_page(htmlentities(Translation :: get('NoLocationSelected')));
        }
    }

    public function get_additional_parameters()
    {
        return array(self :: PARAM_ENTITY_TYPE);
    }
}
