<?php
namespace common\extensions\rights_editor_manager;

use common\libraries\DataClassRetrievesParameters;
use common\libraries\ObjectTableDataProvider;
use common\libraries\ResultSet;
use Condition;
use group\DataManager as GroupDataManager;
use group\Group;

/**
 * $Id: location_group_browser_table_data_provider.class.php 191 2009-11-13 11:50:28Z chellee $
 * @package application.common.rights_editor_manager.component.location_group_bowser
 */
/**
 * Data provider for a repository browser table.
 *
 * This class implements some functions to allow repository browser tables to
 * retrieve information about the learning objects to display.
 */
class LocationGroupBrowserTableDataProvider extends ObjectTableDataProvider
{

    /**
     * Constructor
     * @param RepositoryManagerComponent $browser
     * @param Condition $condition
     */
    public function __construct($browser, $condition)
    {
        parent :: __construct($browser, $condition);
    }

    /**
     * Gets the learning objects
     * @param int $offset
     * @param int $count
     * @param string $order_property
     * @return ResultSet A set of matching learning objects.
     */
    public function get_objects($offset, $count, $order_property = null)
    {
        $order_property = $this->get_order_property($order_property);
        return GroupDataManager :: retrieves(Group :: class_name(), new DataClassRetrievesParameters($this->get_condition(), $count, $offset, $order_property));
    }

    /**
     * Gets the number of learning objects in the table
     * @return int
     */
    public function get_object_count()
    {
        return GroupDataManager :: count(Group :: class_name(), $this->get_condition());
    }
}
