<?php
namespace common\extensions\video_conferencing_manager;

class Autoloader
{

    /**
     * The array mapping class names to paths
     *
     * @var multitype:string
     */
     private static $map = array(
         'Autoloader' => '/autoloader.class.php',
         'ConferenceObject' => '/lib/conference_object.class.php',
         'ConferenceObjectDisplay' => '/lib/conference_object_display.class.php',
         'ConferenceRights' => '/lib/conference_rights.class.php',
         'DataConnector' => '/lib/data_connector.class.php',
         'Menu' => '/lib/menu.class.php',
         'VideoConferencingManagerInstaller' => '/lib/video_conferencing_manager_installer.class.php',
         'VideoConferencingRenderer' => '/lib/video_conferencing_renderer.class.php',
         'SettingsForm' => '/lib/form/settings.class.php',
         'Component' => '/lib/manager/component.class.php',
         'Manager' => '/lib/manager/manager.class.php',
         'BrowserComponent' => '/lib/manager/component/browser.class.php',
         'ConfigurerComponent' => '/lib/manager/component/configurer.class.php',
         'ViewerComponent' => '/lib/manager/component/viewer.class.php',
         'TableVideoConferencingRenderer' => '/lib/renderer/table.class.php',
         'ConferenceObjectTable' => '/lib/table/conference_object.class.php',
         'DefaultConferenceObjectTableCellRenderer' => '/lib/table/conference_object/default_table_cell_renderer.class.php',
         'DefaultConferenceObjectTableColumnModel' => '/lib/table/conference_object/default_table_column_model.class.php',
         'DefaultConferenceObjectTableDataProvider' => '/lib/table/conference_object/default_table_data_provider.class.php',
         'Activator' => '/package/activate/activator.class.php',
         'Deactivator' => '/package/deactivate/deactivator.class.php',
         'Installer' => '/package/install/installer.class.php'
    );

    /**
     * Try to load the class
     *
     * @param $classname string
     * @return boolean
     */
    public static function load($classname)
    {
        if (isset(self :: $map[$classname]))
        {
            require_once __DIR__ . self :: $map[$classname];
            return true;
        }

        return false;
    }

    /**
     * Synchronize the autoloader
     *
     * @param $update boolean
     * @return multitype:string
     */
    public static function synch($update)
    {
        return \common\libraries\AutoloaderUtilities :: synch(__DIR__, __DIR__, $update);
    }

}
?>