<?php
namespace common\libraries\form;
/*
 * Class for a button, you can add an onclick action via javascript
 */
class Button extends Element
{

    const TEMPLATE = '<input type="button" name="{NAME}" id="{ID}" value="{VALUE}"{ATTRIBUTES}>';

    /*
     * Constructor of the Button class
     */
    public function __construct($name, $value)
    {
        parent :: __construct($name, $value);
    }

    /*
     * Return the HTML of the button
     */
    public function html()
    {
        $parameters = array();
        $parameters['VALUE'] = $this->get_value();
        $parameters['NAME'] = $this->get_name();
        $parameters['ID'] = $this->get_fully_qualified_id();

        $attributes = $this->get_attribute_storage()->get_attributes();
        if ($attributes)
        {
            $parameters['ATTRIBUTES'] = ' ' . $attributes;
        }

        return Renderer :: process(self :: TEMPLATE, $parameters);
    }
}
