<?php
namespace common\libraries\form;
/*
 * Class to create a hidden field
 */
class Hidden extends Element
{

    const TEMPLATE = '<input type="hidden" name="{NAME}" id="{ID}" value="{VALUE}"{ATTRIBUTES}>';

    // Constructor of the Hidden class
    public function __construct($name, $value = null)
    {
        parent :: __construct($name, $value);
    }

    /*
     * This function returns the HTML of the created hidden field
     */
    public function html()
    {
        $parameters = array();
        $parameters['VALUE'] = $this->get_value();
        $parameters['NAME'] = $this->get_fully_qualified_name();
        $parameters['ID'] = $this->get_fully_qualified_id();

        $attributes = $this->get_attribute_storage()->get_attributes();
        if ($attributes)
        {
            $parameters['ATTRIBUTES'] = ' ' . $attributes;
        }

        return Renderer :: process(self :: TEMPLATE, $parameters);
    }
}
