<?php
namespace common\libraries\form;
/*
 * Class to create a passwordfield, it inherits from Element class
 */

class Password extends Element
{

    const TEMPLATE = '<input type="password" name="{NAME}" id="{ID}"{ATTRIBUTES}>';

    /*
     * Constructor for the Password class
     */
    public function __construct($name, $label)
    {
        // call constructor of Element class
        parent :: __construct($name, "", $label);
    }

    public function html()
    {
        $parameters = array();

        $parameters['NAME'] = $this->get_fully_qualified_name();
        $parameters['ID'] = $this->get_fully_qualified_id();

        $attributes = $this->get_attribute_storage()->get_attributes();
        if ($attributes)
        {
            $parameters['ATTRIBUTES'] = ' ' . $attributes;
        }

        return Renderer :: process(self :: TEMPLATE, $parameters);
    }
}
