<?php
namespace common\libraries\form;
/*
 * Class for a resetbutton
 */
class ResetButton extends Element
{
    const TEMPLATE = '<input type="reset" name="{NAME}" id="{ID}" value="{VALUE}"{ATTRIBUTES}>';

    /*
     * Constructor for a resetbutton
     */
    public function __construct($name, $value)
    {
        parent :: __construct($name, $value);
    }

    /*
     * This function returns the HTML of the created submitbutton
    */
    public function html()
    {
        $parameters = array();
        $parameters['VALUE'] = $this->get_value();
        $parameters['NAME'] = $this->get_name();
        $parameters['ID'] = $this->get_fully_qualified_id();

        $attributes = $this->get_attribute_storage()->get_attributes();
        if ($attributes)
        {
            $parameters['ATTRIBUTES'] = ' ' . $attributes;
        }

        return Renderer :: process(self :: TEMPLATE, $parameters);
    }
}
