<?php
namespace common\libraries\form;

/*
 * Main class to create forms
 */
// use common\libraries\DynamicContentMenuItem;
use common\libraries\DynamicFormElementsTab;

class MergedForm extends Form
{
    /*
     * Constructor for a form
     */
    public function __construct($forms, $name = null, $method = null, $action = null)
    {
        if (is_null($name))
        {
            $parts = array();
            foreach ($forms as $form)
            {
                $parts[] = $form->get_name();
            }

            $name = implode('_', $parts);
        }

        if (is_null($method))
        {
            $method = $forms[0]->get_method();
        }

        if (is_null($action))
        {
            $method = $forms[0]->get_action();
        }

        parent :: __construct($name, $method, $action);

        $tabs = array();

        foreach ($forms as $key => $form)
        {
            $elements = new Grouping($form->get_name(), $form->get_name(), true);

            foreach ($form->get_element_storage()->get_elements() as $element)
            {
                if (! $element instanceof StyleButton)
                {
                    $elements->add_element($element);
                }
            }

            $tabs[] = new DynamicFormElementsTab($form->get_name(), $form->get_name(), null, $elements);
            // $tabs[] = new DynamicContentMenuItem($form->get_name(), $form->get_name(), null, $elements, $key == 0);
        }

        // $this->add_element(new Menus($name, null, $tabs));
        $this->add_element(new Tabs($name, null, $tabs));
    }
}
