<?php
namespace common\libraries\form;
/*
 * Class to render the elements that were added to the form
 */

use common\libraries\DynamicContentMenu;


class DefaultMenusRenderer extends DefaultContainerRenderer
{

    public function get_default_template()
    {
        $html = array();

        $html[] = '<div>';
        $html[] = '    {HEADER}';
        $html[] = '    {MENU}';
        $html[] = '    {CONTENT}';
        $html[] = '    {FOOTER}';
        $html[] = '    <div class="clear">&nbsp;</div>';
        $html[] = '</div>';

        return implode("\n", $html);
    }

    public function get_parameters()
    {
        $parameters = array();

        $menu_renderer = new DynamicContentMenu($this->get_element()->get_name());
        $menu_renderer->set_menu_items($this->get_element()->get_menus());

        $html = array();

        $parameters['HEADER'] = $menu_renderer->render_header();
        $parameters['MENU'] = $menu_renderer->render_menu();

        $menus = array();
        $menus[] = $menu_renderer->render_content_header();
        foreach ($this->get_element()->get_menus() as $menu)
        {
            $menus[] = $menu->render_content_header();
            $menus[] = $menu->get_content_function()->render();
            $menus[] = $menu->render_content_footer();
        }
        $menus[] = $menu_renderer->render_small_footer();

        $parameters['CONTENT'] = implode("\n", $menus);
        $parameters['ERRORS'] = $this->get_element()->get_errors();
        $parameters['FOOTER'] = $menu_renderer->render_footer();

        return $parameters;
    }

}
