<?php
namespace common\libraries\package;

class Autoloader
{

    /**
     * The array mapping class names to paths
     *
     * @var multitype:string
     */
     private static $map = array(
         'Autoloader' => '/autoloader.class.php',
         'Action' => '/lib/action.class.php',
         'PackageList' => '/lib/package_list.class.php',
         'Activator' => '/lib/action/activator.class.php',
         'Deactivator' => '/lib/action/deactivator.class.php',
         'Installer' => '/lib/action/installer.class.php',
         'Remover' => '/lib/action/remover.class.php',
         'Upgrader' => '/lib/action/upgrader.class.php',
         'Package' => '/lib/data_class/package.class.php',
         'NotAllowed' => '/lib/interface/not_allowed.interface.php',
         'Cycle' => '/lib/properties/cycle.class.php',
         'Author' => '/lib/properties/authors/author.class.php',
         'Authors' => '/lib/properties/authors/authors.class.php',
         'Dependencies' => '/lib/properties/dependencies/dependencies.class.php',
         'DependencyVerifier' => '/lib/properties/dependencies/dependency_verifier.class.php',
         'Dependency' => '/lib/properties/dependencies/dependency/dependency.class.php',
         'Version' => '/lib/properties/dependencies/dependency/version.class.php',
         'ExtensionsDependency' => '/lib/properties/dependencies/dependency/type/extensions.class.php',
         'RegistrationDependency' => '/lib/properties/dependencies/dependency/type/registration.class.php',
         'ServerDependency' => '/lib/properties/dependencies/dependency/type/server.class.php',
         'SettingsDependency' => '/lib/properties/dependencies/dependency/type/settings.class.php'
    );

    /**
     * Try to load the class
     *
     * @param $classname string
     * @return boolean
     */
    public static function load($classname)
    {
        if (isset(self :: $map[$classname]))
        {
            require_once __DIR__ . self :: $map[$classname];
            return true;
        }

        return false;
    }

    /**
     * Synchronize the autoloader
     *
     * @param $update boolean
     * @return multitype:string
     */
    public static function synch($update)
    {
        return \common\libraries\AutoloaderUtilities :: synch(__DIR__, __DIR__, $update);
    }

}
?>