<?php
namespace common\libraries\package;

use common\libraries\CommonDataManager;
use common\libraries\Translation;
use common\libraries\Registration;

abstract class Activator extends Action
{

    public function get_data_manager()
    {
        return $this->data_manager;
    }

    public function run()
    {
        $registration = CommonDataManager :: get_registration(self :: context());
        
        if (! $registration->is_active())
        {
            
            $registration->set_status(Registration :: STATUS_ACTIVE);
            
            if (! $registration->update())
            {
                return $this->failed(Translation :: get('ActivationFailed'));
            }
            else
            {
                $this->add_message(self :: TYPE_NORMAL, Translation :: get('ActivationSuccessful'));
            }
            
            return $this->successful();
        }
        else
        {
            return $this->failed(Translation :: get('PackageAlreadyActive'));
        }
    }

    /**
     * Creates an application-specific installer.
     * 
     * @param $context string The namespace of the package for which we want to start the installer.
     * @param $values string The form values passed on by the wizard.
     */
    public static function factory($context)
    {
        $class = $context . '\Activator';
        return new $class();
    }
}
