<?php
namespace common\libraries\package;

/**
 *
 * @author Hans De Bisschop
 * @package core.lynx
 */
class Cycle
{
    // Release phases
    const PHASE_NIGHTLY = 'nightly';
    const PHASE_ALPHA = 'alpha';
    const PHASE_BETA = 'beta';
    const PHASE_RELEASE_CANDIDATE = 'release_candidate';
    const PHASE_GENERAL_AVAILABILITY = 'general_availability';
    
    // Release realm
    const REALM_MAIN = 'main';
    const REALM_UNIVERSE = 'universe';

    /**
     *
     * @var string
     */
    private $phase;

    /**
     *
     * @var string
     */
    private $realm;

    /**
     *
     * @param string $phase
     * @param string $realm
     */
    public function __construct($phase, $realm)
    {
        $this->set_phase($phase);
        $this->set_realm($realm);
    }

    /**
     *
     * @return string
     */
    public function get_phase()
    {
        return $this->phase;
    }

    /**
     *
     * @param string $phase
     */
    public function set_phase($phase)
    {
        $this->phase = $phase;
    }

    /**
     *
     * @return string
     */
    public function get_realm()
    {
        return $this->realm;
    }

    /**
     *
     * @param string $realm
     */
    public function set_realm($realm)
    {
        $this->realm = $realm;
    }

    public function is_official()
    {
        return $this->get_realm() == self :: REALM_MAIN;
    }

    public function is_stable()
    {
        return $this->get_phase() == self :: PHASE_GENERAL_AVAILABILITY;
    }
}
