<?php
namespace common\libraries;

/**
 * Parent class for all abstract conditions used to retrieve objects from the storage layer
 *
 * @author Tim De Pauw
 * @author Hans De Bisschop
 * @package common.libraries
 */
class Condition implements Hashable
{

    /**
     * Get an md5 representation of this object for identification purposes
     *
     * @param $hash_parts multitype:string
     * @return string
     */
    public function hash($hash_parts = array())
    {
        $hash_parts[] = self :: class_name();

        return md5(serialize($hash_parts));
    }

    /**
     * Get the fully qualified class name
     *
     * @return string
     */
    public static function class_name()
    {
        return get_called_class();
    }
}
