<?php
namespace common\libraries;

/**
 * A ConditionVariable that describes a regular DataClass property
 *
 * @author Hans De Bisschop
 * @author Sven Vanpoucke - Hogeschool Gent - Refactoring to extension of PropertiesConditionVariable
 *
 * @package common.libraries
 */
class PropertyConditionVariable extends PropertiesConditionVariable
{
    /**
     * The property name of the DataClass object
     *
     * @var string
     */
    private $property;

    /**
     * Constructor
     *
     * @param $class string
     * @param $property string
     */
    public function __construct($class, $property)
    {
        parent :: __construct($class);

        $this->property = $property;
    }

    /**
     * Get the property name of the DataClass object
     *
     * @return string
     */
    public function get_property()
    {
        return $this->property;
    }


    /**
     * Set the property name of the DataClass object
     *
     * @param $property string
     */
    public function set_property($property)
    {
        $this->property = $property;
    }

    /**
     * Get an md5 representation of this object for identification purposes
     *
     * @param string[] $hash_parts
     *
     * @return string
     */
    public function hash($hash_parts = array())
    {
        $hash_parts[] = $this->property;

        return parent :: hash($hash_parts);
    }
}
