<?php
use common\libraries\Session;
use repository\quota\Calculator;
/**
 * QuickForm rule to check if uploading a document is possible compared to the available disk quota.
 */
class HTML_QuickForm_Rule_DiskQuota extends HTML_QuickForm_Rule
{

    /**
     * Function to check if an uploaded file can be stored in the repository
     *
     * @see HTML_QuickForm_Rule
     * @param mixed $file Uploaded file (array)
     * @return boolean True if the filesize doesn't cause a disk quota overflow
     */
    function validate($file)
    {
        $size = $file['size'];
        $calculator = new Calculator(
                \user\DataManager :: retrieve(\user\User :: class_name(), (int) Session :: get_user_id()));

        return $calculator->get_available_user_disk_quota() > $size;
    }
}
?>