<?php
namespace common\libraries;

abstract class TemplateCache
{

    public static function factory($theme, $type)
    {
        $file = dirname(__file__) . '/template_cache/' . $type . '_template_cache.class.php';

        if (! file_exists($file))
            die('Could not load type ' . $type . ' as template cache');

        $classname = __NAMESPACE__ . '\\' . Utilities :: underscores_to_camelcase($type) . 'TemplateCache';
        return new $classname($theme);
    }

    abstract public function cache($handle, $uncompiled_code, $compiled_code);

    abstract public function retrieve_from_cache($handle, $uncompiled_code);
}
