<?php
namespace common\libraries;

abstract class NewGalleryObjectTableCellRenderer
{
    /**
     * The object table
     *
     * @var NewGalleryObjectTable
     */
    private $object_table;

    /**
     * Constructor
     *
     * @param $object_table NewGalleryObjectTable
     */
    public function __construct($object_table)
    {
        $this->object_table = $object_table;
    }

    /**
     *
     * @return \common\libraries\NewGalleryObjectTable
     */
    public function get_object_table()
    {
        return $this->object_table;
    }

    /**
     * Returns the component of the object table
     *
     * @param Application
     */
    public function get_component()
    {
        return $this->get_object_table()->get_component();
    }

    /**
     * Renders a single cell
     *
     * @param $object DataClass
     * @return String
     */
    public function render_cell($object)
    {
        $html = array();

        if ($this instanceof NewGalleryObjectTableCellRendererActionsSupport)
        {
//             $html[] = '<div class="thumbnail_container"></div>';
//             $html[] = '<div class="thumbnail_actions">';
            $html[] = '<div style="width: 20px; float: right;">';
            $html[] = $this->get_object_actions($object);
            $html[] = '</div>';
        }

        $html[] = $this->get_cell_content($object);

        return implode("\n", $html);
    }

    /**
     * Define the unique identifier for the row needed for e.g. checkboxes
     *
     * @param $object <type>
     */
    public function render_id_cell($object)
    {
        return $object->get_id();
    }

    abstract public function get_cell_content($object);
}
