<?php

namespace common\libraries;

/**
 * Class that reads an rss feed using the last rss plugin
 *
 * @package common\libraries
 *
 * @author Sven Vanpoucke - Hogeschool Gent
 */
class LastRssRssReader
{
    /**
     * Parses a url and returns the rss items
     *
     * @param string $url
     * @param int $number_of_items
     *
     * @return string[]
     */
    public function parse_url($url, $number_of_items = 5)
    {
        $rss = new \LastRss($url);

        $rss->set_items_limit($number_of_items);
        $rss->set_cache_dir(Path :: get(SYS_TEMP_PATH));

        return $rss->get_feed_content();
    }

}