<?php
namespace common\libraries;

/**
 *
 * @package common.libraries
 * @author Hans De Bisschop
 */
abstract class ConditionVariableTranslator
{

    private $condition_variable;

    private $connection;

    /**
     *
     * @param $condition_variable \common\libraries\ConditionVariable
     */
    public function __construct(ConditionVariable $condition_variable, $connection = null)
    {
        $this->condition_variable = $condition_variable;
        $this->connection = $connection;
    }

    public function get_condition_variable()
    {
        return $this->condition_variable;
    }

    public function get_connection()
    {
        return $this->connection;
    }

    abstract public function translate();

    public static function factory($type, ConditionVariable $condition_variable, $connection = null)
    {
        $class = __NAMESPACE__ . '\\' . Utilities :: underscores_to_camelcase($type) . Utilities :: get_classname_from_object(
            $condition_variable) . 'Translator';
        return new $class($condition_variable, $connection);
    }

    public static function render($type, ConditionVariable $condition_variable, $connection = null)
    {
        return self :: factory($type, $condition_variable, $connection)->translate();
    }
}
