<?php
namespace common\libraries;

use Exception;

/**
 * The optional parameters for a DataClass storage layer COUNT GROUPED action
 * 
 * @author Hans De Bisschop
 * @package common.libraries
 */
class DataClassCountGroupedParameters extends DataClassPropertyParameters
{

    private $having;

    public function __construct($condition = null, $property = array(), $having = null, Joins $joins = null)
    {
        parent :: __construct($condition, $property, $joins);
        $this->having = $having;
    }

    public function get_having()
    {
        return $this->having;
    }

    public function set_having($having)
    {
        $this->having = $having;
    }

    public function hash($hash_parts = array())
    {
        $hash_parts[] = $this->get_having();
        
        return parent :: hash($hash_parts);
    }

    /**
     * Throw an exception if the DataClassPropertyParameters object is invalid
     * 
     * @throws \Exception
     */
    public static function invalid()
    {
        throw new Exception('Illegal parameter(s) passed to the DataManager :: count_grouped() method.');
    }
}
