<?php
namespace common\libraries;

class DataClassProperties implements Hashable
{
    private $properties;

    /**
     * Constructor
     *
     * @param $properties multitype:\common\libraries\DataClassProperty
     */
    public function __construct($properties = array())
    {
        $this->properties = (is_array($properties) ? $properties : func_get_args());
    }

    /**
     * Gets the properties 
     *
     * @return multitype:\common\libraries\DataClassProperty
     */
    public function get()
    {
        return $this->properties;
    }

    public function add($property)
    {
        $this->properties[] = $property;
    }

    public function hash()
    {
        $hashes = array();
        
        foreach ($this->properties as $property)
        {
            $hashes[] = $property->hash();
        }
        
        sort($hashes);
        
        return md5(serialize($hashes));
    }
}
