<?php

namespace common\libraries;

/**
 * Defines an empty resultset
 *
 * Must be used when you know that the result from the query will be empty and thus the resultset will be empty.
 * Never use "return null or false".
 *
 * @author Sven Vanpoucke - Hogeschool Gent
 */
class EmptyResultSet extends ResultSet
{
    /**
     * Retrieves next item from this result set
     *
     * @param $map_to_object boolean Whether or not to map the record to an object
     * @return mixed The item, or null if none.
     */
    public function next_result($map_to_object = true)
    {
        return null;
    }

    /**
     * Retrieves the number of items in this result set.
     *
     * @return int The number of items.
     */
    public function size()
    {
        return 0;
    }
}