<?php
namespace common\libraries;

/**
 * This class represents a Doctrine ArrayResultSet
 *
 * @package common.libraries
 * @author Sven Vanpoucke - Hogeschool Gent
 */
class DoctrineArrayResultSet extends ArrayResultSet
{
    /**
     * Create a new DoctrineResultSet for handling a set of records
     *
     * @param $data_manager DoctrineDatabase
     * @param $handle Doctrine\DBAL\Driver\PDOStatement
     */
    public function __construct($data_manager, $handle)
    {
        $data = array();

        while ($record = $handle->fetch(\PDO :: FETCH_ASSOC))
        {
            $data[] = $this->process_record($record);
        }

        parent :: __construct($data);
    }
}
