<?php
namespace common\libraries;

/**
 *
 * @package common.libraries.storage.mdb2
 * @author Hans De Bisschop
 */
class Mdb2AggregateConditionTranslator extends Mdb2ConditionTranslator
{

    public function translate()
    {
        $string = '';

        $condition_translations = array();
        $count = 0;

        foreach ($this->get_condition()->get_conditions() as $key => $condition)
        {
            $count ++;
            $translation = Mdb2ConditionTranslator :: render(
                $condition,
                $this->get_deprecated_storage_unit(),
                $this->get_connection());

            if (! empty($translation))
            {
                $condition_translations[] = $translation;
            }
        }

        if (count($condition_translations) > 0)
        {
            $string = '(' . implode($this->get_condition()->get_operator(), $condition_translations) . ')';
        }

        return $string;
    }
}
