<?php
namespace common\libraries;

/**
 *
 * @package common.libraries
 * @author Hans De Bisschop
 */
class Mdb2EqualityConditionTranslator extends Mdb2ConditionTranslator
{

    public function translate()
    {
        $value = $this->get_condition()->get_value();

        if (is_null($value))
        {
            if ($this->get_condition()->get_name() instanceof ConditionVariable)
            {
                return Mdb2ConditionVariableTranslator :: render(
                    $this->get_condition()->get_name(),
                    $this->get_connection()) . ' IS NULL';
            }
            else
            {
                $storage_unit = $this->get_deprecated_storage_unit();

                $name = $this->get_condition()->get_name();
                $condition_storage_unit = $this->get_condition()->get_storage_unit();

                if (! is_null($condition_storage_unit))
                {
                    if ($this->get_condition()->is_alias())
                    {
                        $storage_unit = $condition_storage_unit;
                    }
                    else
                    {
                        $namespace = self :: $source;
                        $data_manager = $namespace . '\DataManager';
                        if (! class_exists($data_manager))
                        {
                            $data_manager = $namespace . '\\' . Utilities :: get_package_name_from_namespace(
                                $namespace,
                                true) . 'DataManager';
                        }
                        $storage_unit = $data_manager :: get_instance()->get_alias($condition_storage_unit);
                    }
                }

                return Mdb2Database :: escape_column_name(
                    $this->get_condition()->get_name(),
                    $storage_unit,
                    $this->get_connection()) . ' IS NULL';
            }
        }
        if ($this->get_condition()->get_name() instanceof ConditionVariable)
        {
            return Mdb2ConditionVariableTranslator :: render(
                $this->get_condition()->get_name(),
                $this->get_connection()) . ' = ' . Mdb2ConditionVariableTranslator :: render(
                $this->get_condition()->get_value(),
                $this->get_connection());
        }
        else
        {
            $storage_unit = $this->get_deprecated_storage_unit();

            $name = $this->get_condition()->get_name();
            $condition_storage_unit = $this->get_condition()->get_storage_unit();

            if (! is_null($condition_storage_unit))
            {
                if ($this->get_condition()->is_alias())
                {
                    $storage_unit = $condition_storage_unit;
                }
                else
                {
                    $namespace = self :: $source;
                    $data_manager = $namespace . '\DataManager';
                    if (! class_exists($data_manager))
                    {
                        $data_manager = $namespace . '\\' . Utilities :: get_package_name_from_namespace(
                            $namespace,
                            true) . 'DataManager';
                    }
                    $storage_unit = $data_manager :: get_instance()->get_alias($condition_storage_unit);
                }
            }
            return Mdb2Database :: escape_column_name(
                $this->get_condition()->get_name(),
                $storage_unit,
                $this->get_connection()) . ' = ' . Mdb2Database :: quote(
                $value,
                null,
                true,
                false,
                $this->get_connection());
        }
    }
}
