<?php
namespace common\libraries;

class Joins
{
    private $joins;

    /**
     * Constructor
     *
     * @param $joins multitype:\common\libraries\Join
     */
    public function __construct($joins = array())
    {
        $this->joins = (is_array($joins) ? $joins : func_get_args());
    }

    /**
     * Gets the joins 
     *
     * @return multitype:\common\libraries\Join
     */
    public function get()
    {
        return $this->joins;
    }

    public function add($join)
    {
        $this->joins[] = $join;
    }

    public function hash()
    {
        $hashes = array();
        
        foreach ($this->joins as $join)
        {
            $hashes[] = $join->hash();
        }
        
        sort($hashes);
        
        return md5(serialize($hashes));
    }
}
