<?php
namespace common\libraries;

use Exception;

class RecordResultSetCache extends RecordCache
{

    public static function add(RecordResultSet $result_set, RecordRetrievesParameters $parameters)
    {
        if (! $parameters instanceof RecordRetrievesParameters)
        {
            throw new Exception('Illegal parameters passed to the RecordResultSetCache');
        }
        
        if (! $result_set instanceof RecordResultSet)
        {
            $type = is_object($result_set) ? get_class($result_set) : gettype($result_set);
            throw new Exception('The RecordResultSetCache cache only allows for caching of ResultSet objects. Currently trying to add: ' . $type . '.');
        }
        
        if (! self :: get($parameters))
        {
            self :: set_cache($parameters->hash(), $result_set);
        }
        
        return true;
    }

}
