<?php

namespace common\libraries;

/**
 * Keep data but do not save them to a cache
 *
 * @author laurent
 */
class CacheDataTransient
{

    public function __construct()
    {
    }

    public function is_dirty()
    {
        return false;
    }

    public function is_clean()
    {
        return true;
    }

    /**
     * Returns true if data have been fetched from the cache. False otherwise.
     * 
     * @return bool
     */
    public function is_loaded()
    {
        return false;
    }

    public function is_stale()
    {
        return false;
    }

    /**
     * Remove all data. 
     */
    public function clear()
    {
        foreach ($this as $key => $value)
        {
            unset($this->$key);
        }
    }
}
