<?php
namespace common\libraries;

//require_once(__DIR__ . '/../../../lib/data_manager.class.php');
//require_once("C:\wamp\www\chamilo-stable\common\libraries\php/lib/data_manager.class.php");

/**
 * Provides a basic framework for creating unit tests.
 * @author Anthony Hurst (Hogeschool Gent)
 */
abstract class DataClassUnitTestCase extends \PHPUnit_Framework_TestCase
{
    /**
     * Creates a standardised error message for inclusion as message in an assertion.
     * @static
     * @param string $value An identifier for the value that failed the assertion.
     * @param mixed $expected The expected value used in the assertion.
     * @param mixed $actual The actual value used in the assertion.
     * @return string The composed message.
     */
    protected static function createErrorMessage($value, $expected, $actual)
    {
        return "Assertion failed on $value. Expected $expected, got $actual.";
    }

    /**
     * Modifies the properties of an entity.
     * @static
     * @param DataClass $entity The entity whose properties are to be modified.
     * @param boolean $alter_id Whether the id must be modified or not.
     * @return void
     */
    abstract protected static function modifyEntity(&$entity, $alter_id);
}
