<?php
namespace common\libraries;

/**
 * Base class for specific removal extensions of web applications
 *
 * @author Hans De Bisschop
 */
class WebApplicationRemover extends \common\libraries\package\Remover
{

    /**
     *
     * @return boolean
     */
    public function extra()
    {
        $context = $this->context();

        $registration = CommonDataManager :: get_registration('core\menu');
        if (! $registration instanceof Registration || ! $registration->is_active())
        {
            return true;
        }

        $condition = new EqualityCondition(
            new PropertyConditionVariable(
                \core\menu\ApplicationItem :: class_name(),
                \core\menu\ApplicationItem :: PROPERTY_APPLICATION),
            new StaticConditionVariable(Utilities :: get_package_name_from_namespace($context)));

        $menu_item = \core\menu\DataManager :: retrieve(\core\menu\ApplicationItem :: class_name(), $condition);

        if ($menu_item instanceof \core\menu\Item)
        {
            return $menu_item->delete();
        }

        return true;
    }
}
