<?php

namespace common\libraries;

/**
 * A rest message renderer to json format
 */

class JsonRestMessageRenderer extends RestMessageRenderer
{

    /**
     * Renders one object
     * @param DataClass $object 
     */
    public function render_object(DataClass $object)
    {
        $this->render_array($object->get_properties());
    }

    /**
     * Renders an array of objects
     * @param array $objects
     */
    public function render_multiple_objects(array $objects)
    {
        $array = array();
        
        foreach ($objects as $object)
        {
            $array[] = $object->get_properties();
        }
        
        $this->render_array($array);
    }

    /**
     * Renders an array in json
     */
    private function render_array(array $array)
    {
        header('Content-Type: application/json');
        echo json_encode($array);
    }
}
