<?php
namespace core\admin\announcement;

use common\libraries\TableFormActionsSupport;
use common\libraries\RecordTable;
use common\libraries\ObjectTableFormActions;
use common\libraries\ObjectTableFormAction;
use common\libraries\Utilities;
use common\libraries\Translation;
use common\libraries\ObjectTable;

class PublicationTable extends RecordTable implements TableFormActionsSupport
{
    const TABLE_IDENTIFIER = Manager :: PARAM_SYSTEM_ANNOUNCEMENT_ID;

    public function get_implemented_form_actions()
    {
        $actions = new ObjectTableFormActions(__NAMESPACE__);
        
        if ($this->get_component()->get_user()->is_platform_admin())
        {
            $actions->add_form_action(
                new ObjectTableFormAction(
                    Manager :: ACTION_DELETE, 
                    Translation :: get('RemoveSelected', null, Utilities :: COMMON_LIBRARIES)));
        }
        
        return $actions;
    }
}
