<?php
namespace core\admin\announcement;

use repository\ContentObject;
use common\libraries\DataClassPropertyTableColumn;
use common\libraries\NewStaticTableColumn;
use common\libraries\TableColumnModelActionsColumnSupport;
use common\libraries\RecordTableColumnModel;

class PublicationTableColumnModel extends RecordTableColumnModel implements TableColumnModelActionsColumnSupport
{
    const COLUMN_STATUS = 'status';
    const COLUMN_PUBLISHED_FOR = 'published_for';

    /**
     * Initializes the columns for the table
     */
    public function initialize_columns()
    {
        $this->add_column(new NewStaticTableColumn(self :: COLUMN_STATUS));
        
        $this->add_column(
            new DataClassPropertyTableColumn(ContentObject :: class_name(), ContentObject :: PROPERTY_TITLE));
        
        $this->add_column(
            new DataClassPropertyTableColumn(ContentObject :: class_name(), ContentObject :: PROPERTY_DESCRIPTION));
        
        $this->add_column(
            new DataClassPropertyTableColumn(Publication :: class_name(), Publication :: PROPERTY_PUBLICATION_DATE));
        
        $this->add_column(
            new DataClassPropertyTableColumn(Publication :: class_name(), Publication :: PROPERTY_PUBLISHER_ID));
        
        $this->add_column(new NewStaticTableColumn(self :: COLUMN_PUBLISHED_FOR));
    }
}
