<?php
namespace core\admin\announcement;

use common\libraries\Utilities;
use common\libraries\Translation;

class Installer extends \common\libraries\package\Installer
{

    /**
     * Constructor
     */
    public function __construct($values)
    {
        parent :: __construct($values, DataManager :: get_instance());
    }

    /**
     * Runs the install-script.
     */
    public function extra()
    {
        $rights_utilities = Rights :: get_instance();
        $location = $rights_utilities->create_subtree_root_location(__NAMESPACE__, 0, Rights :: TREE_TYPE_ROOT, true);

        if (! $location instanceof RightsLocation)
        {
            return false;
        }
        else
        {
            $this->add_message(
                self :: TYPE_NORMAL,
                Translation :: get(
                    'ObjectCreated',
                    array('OBJECT' => Translation :: get('RightsTree')),
                    Utilities :: COMMON_LIBRARIES));
        }

        return true;
    }

    public function get_additional_packages()
    {
        $installers = array();
        $installers[] = 'core\admin\announcement\integration\core\home';
        return $installers;
    }
}
