<?php
namespace core\admin;

class Autoloader
{

    /**
     * The array mapping class names to paths
     *
     * @var multitype:string
     */
     private static $map = array(
         'Autoloader' => '/autoloader.class.php',
         'AdminDataManager' => '/lib/admin_data_manager.class.php',
         'AdminDataManagerInterface' => '/lib/admin_data_manager_interface.class.php',
         'ConfigurationForm' => '/lib/configuration_form.class.php',
         'FeedbackPublication' => '/lib/feedback_publication.class.php',
         'MessageTemplate' => '/lib/message_template.class.php',
         'RemotePackage' => '/lib/remote_package.class.php',
         'ResourceCacheManagerForm' => '/lib/resource_cache_manager_form.class.php',
         'Validation' => '/lib/validation.class.php',
         'AdminManager' => '/lib/admin_manager/admin_manager.class.php',
         'AdminSearchForm' => '/lib/admin_manager/admin_search_form.class.php',
         'AdminManagerAnnouncerComponent' => '/lib/admin_manager/component/announcer.class.php',
         'AdminManagerBrowserComponent' => '/lib/admin_manager/component/browser.class.php',
         'AdminManagerCategoryManagerComponent' => '/lib/admin_manager/component/category_manager.class.php',
         'AdminManagerConfigurerComponent' => '/lib/admin_manager/component/configurer.class.php',
         'AdminManagerDiagnoserComponent' => '/lib/admin_manager/component/diagnoser.class.php',
         'AdminManagerEmailRightsEditorComponent' => '/lib/admin_manager/component/email_rights_editor.class.php',
         'AdminManagerImporterComponent' => '/lib/admin_manager/component/importer.class.php',
         'AdminManagerLanguageComponent' => '/lib/admin_manager/component/language.class.php',
         'AdminManagerLogViewerComponent' => '/lib/admin_manager/component/log_viewer.class.php',
         'AdminManagerResourceCacheManagerComponent' => '/lib/admin_manager/component/resource_cache_manager.class.php',
         'AdminManagerWhoisOnlineComponent' => '/lib/admin_manager/component/whois_online.class.php',
         'WhoisOnlineTable' => '/lib/admin_manager/component/whois_online_table/whois_online_table.class.php',
         'WhoisOnlineTableCellRenderer' => '/lib/admin_manager/component/whois_online_table/whois_online_table_cell_renderer.class.php',
         'WhoisOnlineTableColumnModel' => '/lib/admin_manager/component/whois_online_table/whois_online_table_column_model.class.php',
         'WhoisOnlineTableDataProvider' => '/lib/admin_manager/component/whois_online_table/whois_online_table_data_provider.class.php',
         'AdminCategory' => '/lib/category_manager/admin_category.class.php',
         'AdminCategoryManager' => '/lib/category_manager/admin_category_manager.class.php',
         'DoctrineAdminDataManager' => '/lib/data_manager/doctrine.class.php',
         'Mdb2AdminDataManager' => '/lib/data_manager/mdb2.class.php',
         'PackageTypeImportMenu' => '/lib/menu/package_type_import.class.php',
         'PackageTypeLinksMenu' => '/lib/menu/package_type_links.class.php',
         'PackageTypeSettingsMenu' => '/lib/menu/package_type_settings.class.php',
         'DefaultRegistrationTableCellRenderer' => '/lib/tables/registration_table/default_registration_table_cell_renderer.class.php',
         'DefaultRegistrationTableColumnModel' => '/lib/tables/registration_table/default_registration_table_column_model.class.php',
         'DefaultRemotePackageTableCellRenderer' => '/lib/tables/remote_package_table/default_remote_package_table_cell_renderer.class.php',
         'DefaultRemotePackageTableColumnModel' => '/lib/tables/remote_package_table/default_remote_package_table_column_model.class.php',
         'Activator' => '/package/activate/activator.class.php',
         'Deactivator' => '/package/deactivate/deactivator.class.php',
         'Installer' => '/package/install/installer.class.php',
         'AdminReportingBlock' => '/reporting/admin_reporting_block.class.php',
         'AdminMostUsedCoreApplicationsReportingBlock' => '/reporting/blocks/admin_most_used_core_applications_reporting_block.class.php',
         'AdminMostUsedWebApplicationsReportingBlock' => '/reporting/blocks/admin_most_used_web_applications_reporting_block.class.php',
         'AdminNoOfApplicationsReportingBlock' => '/reporting/blocks/admin_no_of_applications_reporting_block.class.php',
         'AdminDataReportingTemplate' => '/reporting/templates/admin_data_reporting_template.class.php',
         'SettingsConnector' => '/settings/connector.class.php'
    );

    /**
     * Try to load the class
     *
     * @param $classname string
     * @return boolean
     */
    public static function load($classname)
    {
        if (isset(self :: $map[$classname]))
        {
            require_once __DIR__ . self :: $map[$classname];
            return true;
        }

        return false;
    }

    /**
     * Synchronize the autoloader
     *
     * @param $update boolean
     * @return multitype:string
     */
    public static function synch($update)
    {
        return \common\libraries\AutoloaderUtilities :: synch(__DIR__, __DIR__, $update);
    }

}
?>