<?php
namespace core\admin;
use common\libraries\DataClassRetrievesParameters;

use common\libraries\NewObjectTableDataProvider;
/**
 * $Id: whois_online_table_data_provider.class.php 126 2009-11-09 13:11:05Z vanpouckesven $
 *
 * @package admin.lib.admin_manager.component.whois_online_table
 */
/**
 * Data provider for a user browser table. This class implements some functions to allow user browser tables to retrieve
 * information about the users to display.
 */
class WhoisOnlineTableDataProvider extends NewObjectTableDataProvider
{

    /**
     * Gets the users
     *
     * @param $user String
     * @param $category String
     * @param $offset int
     * @param $count int
     * @param $order_property string
     * @return ResultSet A set of matching learning objects.
     */
    public function get_objects($offset, $count, $order_property = null)
    {
        $parameters = new DataClassRetrievesParameters($this->get_condition(), $count, $offset, $this->get_order_property($order_property));
        return \user\DataManager :: retrieves(\user\User :: class_name(), $parameters);
    }

    /**
     * Gets the number of users in the table
     *
     * @return int
     */
    public function get_object_count()
    {
        return \user\DataManager :: count(\user\User :: class_name(), $this->get_condition());
    }
}
