<?php
namespace core\admin;
use user\User;

use common\libraries\Utilities;
use common\libraries\Translation;
use common\libraries\Session;

use reporting\ReportingData;

class AdminNoOfApplicationsReportingBlock extends AdminReportingBlock
{

    public function count_data()
    {
        $reporting_data = new ReportingData();
        $user = \user\DataManager :: retrieve(User :: class_name(), (int) Session :: get_user_id());
        $adm = new AdminManager($user);
        $arr[Translation :: get('NumberOfApplications')] = 0;
        foreach ($adm->get_application_platform_admin_links() as $application_links)
        {
            $arr[Translation :: get('NumberOfApplications')] ++;
        }
        
        $reporting_data->set_categories(array(Translation :: get('NumberOfApplications')));
        $reporting_data->set_rows(array(Translation :: get('Count')));
        
        $reporting_data->add_data_category_row(Translation :: get('NumberOfApplications'), Translation :: get('Count', array(), Utilities :: COMMON_LIBRARIES), $arr[Translation :: get('NumberOfApplications')]);
        return $reporting_data;
    }

    public function retrieve_data()
    {
        return $this->count_data();
    }

    public function get_application()
    {
        return AdminManager :: APPLICATION_NAME;
    }

    public function get_available_displaymodes()
    {
        $modes = array();
        // $modes[ReportingFormatter::DISPLAY_TEXT] = Translation :: get('Text',
        // array(), Utilities :: COMMON_LIBRARIES);
        return $modes;
    }
}
