<?php
namespace core\context_linker;

class Autoloader
{

    /**
     * The array mapping class names to paths
     *
     * @var multitype:string
     */
     private static $map = array(
         'Autoloader' => '/autoloader.class.php',
         'ContextLink' => '/lib/context_link.class.php',
         'ContextLinkerDataManager' => '/lib/context_linker_data_manager.class.php',
         'ContextLinkerDataManagerInterface' => '/lib/context_linker_data_manager_interface.class.php',
         'ContextLinkerManager' => '/lib/context_linker_manager/context_linker_manager.class.php',
         'ContextLinkerManagerBrowserComponent' => '/lib/context_linker_manager/component/browser.class.php',
         'ContextLinkerManagerContextLinksBrowserComponent' => '/lib/context_linker_manager/component/context_links_browser.class.php',
         'ContextLinkerManagerContextLinkCreatorComponent' => '/lib/context_linker_manager/component/context_link_creator.class.php',
         'ContextLinkerManagerContextLinkDeleterComponent' => '/lib/context_linker_manager/component/context_link_deleter.class.php',
         'ContextLinkerManagerContextLinkPublisherComponent' => '/lib/context_linker_manager/component/context_link_publisher.class.php',
         'ContextLinkerManagerContextLinkUpdaterComponent' => '/lib/context_linker_manager/component/context_link_updater.class.php',
         'ContentObjectBrowserTable' => '/lib/context_linker_manager/component/content_object_browser/content_object_browser_table.class.php',
         'ContentObjectBrowserTableCellRenderer' => '/lib/context_linker_manager/component/content_object_browser/content_object_browser_table_cell_renderer.class.php',
         'ContentObjectBrowserTableColumnModel' => '/lib/context_linker_manager/component/content_object_browser/content_object_browser_table_column_model.class.php',
         'ContentObjectBrowserTableDataProvider' => '/lib/context_linker_manager/component/content_object_browser/content_object_browser_table_data_provider.class.php',
         'ContextLinkBrowserTable' => '/lib/context_linker_manager/component/context_link_browser/context_link_browser_table.class.php',
         'ContextLinkBrowserTableCellRenderer' => '/lib/context_linker_manager/component/context_link_browser/context_link_browser_table_cell_renderer.class.php',
         'ContextLinkBrowserTableColumnModel' => '/lib/context_linker_manager/component/context_link_browser/context_link_browser_table_column_model.class.php',
         'ContextLinkBrowserTableDataProvider' => '/lib/context_linker_manager/component/context_link_browser/context_link_browser_table_data_provider.class.php',
         'Mdb2ContextLinkerDataManager' => '/lib/data_manager/mdb2.class.php',
         'ConfirmationForm' => '/lib/forms/confirmation_form.class.php',
         'ContextLinkForm' => '/lib/forms/context_link_form.class.php',
         'DefaultContextLinkTableCellRenderer' => '/lib/tables/context_link_table/default_context_link_table_cell_renderer.class.php',
         'DefaultContextLinkTableColumnModel' => '/lib/tables/context_link_table/default_context_link_table_column_model.class.php',
         'Activator' => '/package/activate/activator.class.php',
         'Deactivator' => '/package/deactivate/deactivator.class.php',
         'ContextLinkerInstaller' => '/package/install/context_linker_installer.class.php',
         'SettingsConnector' => '/settings/connector.class.php'
    );

    /**
     * Try to load the class
     *
     * @param $classname string
     * @return boolean
     */
    public static function load($classname)
    {
        if (isset(self :: $map[$classname]))
        {
            require_once __DIR__ . self :: $map[$classname];
            return true;
        }

        return false;
    }

    /**
     * Synchronize the autoloader
     *
     * @param $update boolean
     * @return multitype:string
     */
    public static function synch($update)
    {
        return \common\libraries\AutoloaderUtilities :: synch(__DIR__, __DIR__, $update);
    }

}
?>