<?php 
namespace core\context_linker;
/**
 *	This is a skeleton for a data manager for the ContextLinker Application.
 *	Data managers must extend this class and implement its abstract methods.
 *
 *  @author Sven Vanpoucke
 *	@author Jens Vanderheyden
 */
Interface ContextLinkerDataManagerInterface
{
	public function initialize();
	public function create_storage_unit($name,$properties,$indexes);

	public function get_next_context_link_id();
	public function create_context_link($context_link);
	public function update_context_link($context_link);
	public function delete_context_link($context_link);
	public function count_context_links($conditions = null);
	public function retrieve_context_link($id);
	public function retrieve_context_links($condition = null, $offset = null, $count = null, $order_property = null);
}
