<?php
namespace core\context_linker;

use common\libraries\StaticTableColumn;

/**
 * Table column model for the context_link browser table
 *
 * @author Sven Vanpoucke
 * @author Jens Vanderheyden
 */

class ContextLinkBrowserTableColumnModel extends DefaultContextLinkTableColumnModel
{
	/**
	 * The tables modification column
	 */
	private static $modification_column;

	/**
	 * Constructor
	 */
	public function __construct()
	{
		parent :: __construct();
		$this->set_default_order_column(1);
		$this->add_column(self :: get_modification_column());
	}

	/**
	 * Gets the modification column
	 * @return ContentObjectTableColumn
	 */
	public static function get_modification_column()
	{
		if (!isset(self :: $modification_column))
		{
			self :: $modification_column = new StaticTableColumn('');
		}
		return self :: $modification_column;
	}
}
