<?php
namespace core\context_linker;

use common\libraries\Translation;
use common\libraries\Application;
use common\libraries\ToolbarItem;
use common\libraries\Theme;
use common\libraries\Request;
use common\libraries\ActionBarRenderer;
use common\libraries\Utilities;


/**
 * context_linker component which allows the user to browse his context_links
 * @author Sven Vanpoucke
 * @author Jens Vanderheyden
 */
class ContextLinkerManagerContextLinksBrowserComponent extends ContextLinkerManager
{
    public function run()
    {
        $this->display_header();

        $html = array();

        $html[]= $this->get_action_bar();
        if(Request :: get(ContextLinkerManager :: PARAM_CONTENT_OBJECT_ID))
        {
            $html[] = $this->get_table();
        }
        else
        {
            $html[] = '<p>' . Translation :: get('NoContentObjectSelected', null, 'repository') . '</p>';
        }

        echo implode("\n", $html);

        $this->display_footer();
    }

    public function get_table()
    {
        $table = new ContextLinkBrowserTable($this, array(Application :: PARAM_APPLICATION => 'context_linker', Application :: PARAM_ACTION => ContextLinkerManager :: ACTION_BROWSE_CONTEXT_LINKS), Request :: get(ContextLinkerManager :: PARAM_CONTENT_OBJECT_ID));
        return $table->as_html();
    }

    public function get_action_bar()
    {
        $action_bar = new ActionBarRenderer(ActionBarRenderer :: TYPE_HORIZONTAL);

        $actions = array();
        $actions[] = new ToolbarItem(Translation :: get('Create', null, Utilities :: COMMON_LIBRARIES) , Theme :: get_common_image_path() . 'action_create.png', $this->get_url(array(ContextLinkerManager :: PARAM_ACTION => ContextLinkerManager :: ACTION_CREATE_CONTEXT_LINK, ContextLinkerManager :: PARAM_CONTENT_OBJECT_ID => Request :: get(ContextLinkerManager :: PARAM_CONTENT_OBJECT_ID))));

        $action_bar->set_common_actions($actions);


        $action_bar->set_search_url($this->get_url());

        return $action_bar->as_html();
    }
}
