<?php
namespace core\help;
/**
 * @package help.lib
 *
 * This is an interface for a data manager for the Help application.
 * Data managers must implement this class.
 *
 * @author Hans De Bisschop
 */
interface HelpDataManagerInterface
{

    public function initialize();

    public function update_help_item($help_item);

    public function create_help_item($help_item);

    public function count_help_items($conditions = null);

    public function retrieve_help_item($id);

    public function retrieve_help_items($condition = null, $offset = null, $count = null, $order_property = null);

    public function create_storage_unit($name, $properties, $indexes);

    public function retrieve_help_item_by_context($context, $identifier, $language);

}
