<?php
namespace core\home;

use common\libraries\JsonAjaxResult;
use common\libraries\AjaxManager;

/**
 *
 * @package home.ajax
 * @author Hans De Bisschop
 */

class HomeAjaxBlockConfigForm extends AjaxManager
{
    const PARAM_BLOCK = 'block';

    const PROPERTY_FORM = 'form';

    /*
     * (non-PHPdoc) @see common\libraries.AjaxManager::required_parameters()
     */
    public function required_parameters()
    {
        return array(self :: PARAM_BLOCK);
    }

    /*
     * (non-PHPdoc) @see common\libraries.AjaxManager::run()
     */
    public function run()
    {
        $user_id = DataManager :: determine_user_id();

        if ($user_id === false)
        {
            JsonAjaxResult :: not_allowed();
        }

        $block = DataManager :: retrieve(HomeBlock :: class_name(), intval($this->get_parameter(self :: PARAM_BLOCK)));

        $form = new HomeBlockConfigForm($block, '');

        if ($block->get_user() == $user_id)
        {
            $result = new JsonAjaxResult(200);
            $result->set_property(self :: PROPERTY_FORM, $form->toHtml());
            $result->display();
        }
        else
        {
            JsonAjaxResult :: not_allowed();
        }
    }
}
