<?php
namespace core\home;

use common\libraries\Translation;
use common\libraries\AjaxManager;
use common\libraries\JsonAjaxResult;

/**
 *
 * @package home.ajax
 * @author Hans De Bisschop
 */

class HomeAjaxTabDelete extends AjaxManager
{
    const PARAM_TAB = 'tab';

    /*
     * (non-PHPdoc) @see common\libraries.AjaxManager::required_parameters()
     */
    public function required_parameters()
    {
        return array(self :: PARAM_TAB);
    }

    /*
     * (non-PHPdoc) @see common\libraries.AjaxManager::run()
     */
    public function run()
    {
        $user_id = DataManager :: determine_user_id();

        if ($user_id === false)
        {
            JsonAjaxResult :: not_allowed();
        }

        $tab = DataManager :: retrieve(HomeTab :: class_name(), intval($this->get_parameter(self :: PARAM_TAB)));

        if ($tab->get_user() == $user_id && $tab->can_be_deleted())
        {
            if ($tab->delete())
            {
                JsonAjaxResult :: success();
            }
            else
            {
                JsonAjaxResult :: general_error(Translation :: get('TabNotDeleted'));
            }
        }
        else
        {
            JsonAjaxResult :: not_allowed();
        }
    }
}
