<?php
namespace core\home;

use common\libraries\StaticConditionVariable;
use common\libraries\PropertyConditionVariable;
use common\libraries\EqualityCondition;
use common\libraries\DataClass;

/**
 *
 * @package home.lib
 */
class HomeBlockRegistration extends DataClass
{
    const CLASS_NAME = __CLASS__;
    const TABLE_NAME = 'block_registration';
    const PROPERTY_CONTEXT = 'context';
    const PROPERTY_BLOCK = 'block';

    /**
     * Get the default properties of all user course categories.
     *
     * @return multitype:string The property names.
     */
    public static function get_default_property_names()
    {
        return parent :: get_default_property_names(array(self :: PROPERTY_CONTEXT, self :: PROPERTY_BLOCK));
    }

    /*
     * (non-PHPdoc) @see common\libraries.DataClass::get_data_manager()
     */
    public function get_data_manager()
    {
        return HomeDataManager :: get_instance();
    }

    /**
     *
     * @return string
     */
    public function get_context()
    {
        return $this->get_default_property(self :: PROPERTY_CONTEXT);
    }

    public function set_context($context)
    {
        $this->set_default_property(self :: PROPERTY_CONTEXT, $context);
    }

    /**
     *
     * @return string
     */
    public function get_block()
    {
        return $this->get_default_property(self :: PROPERTY_BLOCK);
    }

    public function set_block($block)
    {
        $this->set_default_property(self :: PROPERTY_BLOCK, $block);
    }

    /**
     *
     * @return string
     */
    public static function get_table_name()
    {
        return self :: TABLE_NAME;
    }

    public function delete()
    {
        if (! parent :: delete())
        {
            return false;
        }
        else
        {
            $condition = new EqualityCondition(
                    new PropertyConditionVariable(HomeBlock :: class_name(), HomeBlock :: PROPERTY_REGISTRATION_ID),
                    new StaticConditionVariable($this->get_id()));
            $blocks = DataManager :: retrieves(HomeBlock :: class_name(), $condition);

            while ($block = $blocks->next_result())
            {
                if (! $block->delete())
                {
                    return false;
                }
            }
        }

        return true;
    }
}
