<?php
namespace core\home;

use common\libraries\PlatformSetting;
use user\UserManager;
use common\libraries\Utilities;
use common\libraries\Translation;
use common\libraries\Authentication;
use common\libraries\FormValidator;
use common\libraries\Theme;

/**
 * $Id: user.class.php 227 2009-11-13 14:45:05Z kariboe $
 *
 * @package home.lib.home_manager.component
 */
class HomeManagerUserComponent extends HomeManager
{

    /**
     * Runs this component and displays its output. This component is only meant for use within the home-component and
     * not as a standalone item.
     */
    public function run()
    {
    }

    public function render_as_html()
    {
        $html = array();

        $html[] = '<div class="block" id="block_user" style="background-image: url(' . Theme :: get_common_image_path() .
             'block_user.png);">';
        $html[] = '<div class="title">' . Translation :: get('User', null, UserManager :: APPLICATION_NAME) .
             '<a href="#" class="closeEl">[-]</a></div>';
        $html[] = '<div class="description">';
        $html[] = $this->display_anonymous_right_menu();
        $html[] = '<div style="clear: both;"></div>';
        $html[] = '</div>';
        $html[] = '</div>';

        return implode("\n", $html);
    }

    public function display_anonymous_right_menu()
    {
        global $loginFailed, $plugins;
        $html = array();

        if (! Authentication :: is_valid())
        {
            $html[] = $this->display_login_form();

            if ($loginFailed)
            {
                $html[] = $this->handle_login_failed();
            }
        }
        else
        {
            $html[] = '<a href="index.php?logout=true">Logout</a>';
        }

        return implode("\n", $html);
    }

    public function handle_login_failed()
    {
        $message = Translation :: get("InvalidId");
        $allow_registration = PlatformSetting :: get('allow_registration', 'core\admin');

        if ($allow_registration == 'true')
        {
            $message = Translation :: get("InvalidForSelfRegistration");
        }

        return "<div id=\"login_fail\">" . $message . "</div>";
    }

    public function display_login_form()
    {
        $form = new FormValidator('formLogin');
        $renderer = & $form->defaultRenderer();
        $renderer->setElementTemplate(
            '<div>{label}&nbsp;<!-- BEGIN required --><span style="color: #ff0000">*</span><!-- END required --></div><div>{element}</div>');
        $renderer->setElementTemplate('<div>{element}</div>', 'submitAuth');
        $form->addElement('text', 'login', Translation :: get('UserName'), array('size' => 15));
        $form->addRule(
            'login',
            Translation :: get('ThisFieldIsRequired', null, Utilities :: COMMON_LIBRARIES),
            'required');
        $form->addElement('password', 'password', Translation :: get('Pass'), array('size' => 15));
        $form->addRule(
            'password',
            Translation :: get('ThisFieldIsRequired', null, Utilities :: COMMON_LIBRARIES),
            'required');
        $form->addElement('submit', 'submitAuth', Translation :: get('Ok', null, Utilities :: COMMON_LIBRARIES));
        return $form->toHtml();
    }
}
