<?php
namespace core\lynx\manager;

class Autoloader
{

    /**
     * The array mapping class names to paths
     *
     * @var multitype:string
     */
     private static $map = array(
         'Autoloader' => '/autoloader.class.php',
         'PackageDisplay' => '/lib/display.class.php',
         'PackageActivator' => '/lib/action/activator.class.php',
         'PackageDeactivator' => '/lib/action/deactivator.class.php',
         'PackageInstaller' => '/lib/action/installer.class.php',
         'PackageRemover' => '/lib/action/remover.class.php',
         'PackageUpgrader' => '/lib/action/upgrader.class.php',
         'Manager' => '/lib/manager/manager.class.php',
         'ActivatorComponent' => '/lib/manager/component/activator.class.php',
         'BrowserComponent' => '/lib/manager/component/browser.class.php',
         'DeactivatorComponent' => '/lib/manager/component/deactivator.class.php',
         'InstallerComponent' => '/lib/manager/component/installer.class.php',
         'RemoverComponent' => '/lib/manager/component/remover.class.php',
         'UpgraderComponent' => '/lib/manager/component/upgrader.class.php',
         'ViewerComponent' => '/lib/manager/component/viewer.class.php',
         'PackageTypeMenu' => '/lib/menu/package_type.class.php',
         'RegistrationTable' => '/lib/table/registration/table.class.php',
         'RegistrationTableCellRenderer' => '/lib/table/registration/table_cell_renderer.class.php',
         'RegistrationTableColumnModel' => '/lib/table/registration/table_column_model.class.php',
         'RegistrationTableDataProvider' => '/lib/table/registration/table_data_provider.class.php',
         'Activator' => '/package/activate/activator.class.php',
         'Deactivator' => '/package/deactivate/deactivator.class.php',
         'Installer' => '/package/install/installer.class.php'
    );

    /**
     * Try to load the class
     *
     * @param $classname string
     * @return boolean
     */
    public static function load($classname)
    {
        if (isset(self :: $map[$classname]))
        {
            require_once __DIR__ . self :: $map[$classname];
            return true;
        }

        return false;
    }

    /**
     * Synchronize the autoloader
     *
     * @param $update boolean
     * @return multitype:string
     */
    public static function synch($update)
    {
        return \common\libraries\AutoloaderUtilities :: synch(__DIR__, __DIR__, $update);
    }

}
?>