<?php
namespace core\lynx;

use common\libraries\CommonDataManager;
use common\libraries\Redirect;
use common\libraries\Translation;
use common\libraries\Theme;

class ApplicationUpgraderComponent extends UpgraderComponent
{

    public function initialize()
    {
        $application_registrations = CommonDataManager :: get_registrations_by_type('application');

        foreach ($application_registrations as $application_registration)
        {
            $this->add_package($application_registration->get_context());
        }
    }

    public function upgrade_successfull()
    {
        $image = Theme :: get_image_path(__NAMESPACE__) . 'package_action/finished.png';
        $title = Translation :: get('PlatformUpgraded');

        $result = Translation :: get(
            'ApplicationsUpgraded',
            array(
                'URL' => Redirect :: get_link(null, array(), array(self :: PARAM_APPLICATION))
            )
        );

        return $this->render_upgrade_step($image, $title, $result);
    }
}
