<?php
namespace core\lynx\remote;

use common\libraries\SubManager;

class Manager extends SubManager
{
    const PARAM_ACTION = 'manager_action';
    const PARAM_PACKAGE_ID = 'package_id';

    const ACTION_BROWSE = 'browser';
    const ACTION_VIEW = 'viewer';
    const ACTION_SYNCHRONIZE = 'synchronizer';
    const ACTION_DOWNLOAD = 'download';
    const ACTION_INSTALL = 'installer';

    const DEFAULT_ACTION = self :: ACTION_BROWSE;

    public static function get_action_parameter()
    {
        return self :: PARAM_ACTION;
    }

    /**
     * Helper function for the Application class,
     * pending access to class constants via variables in PHP 5.3
     * e.g.
     * $name = $class :: DEFAULT_ACTION
     *
     * DO NOT USE IN THIS APPLICATION'S CONTEXT
     * Instead use:
     * - self :: DEFAULT_ACTION in the context of this class
     * - YourApplicationManager :: DEFAULT_ACTION in all other application
     * classes
     */
    public function get_default_action()
    {
        return self :: DEFAULT_ACTION;
    }

    public static function launch($application)
    {
        parent :: launch(null, $application);
    }
}
