<?php
namespace core\lynx\source;

use common\libraries\ActionBarRenderer;
use common\libraries\PatternMatchCondition;
use common\libraries\NewObjectTableSupport;

class BrowserComponent extends Manager implements NewObjectTableSupport
{

    private $action_bar;

    /**
     * Runs this component and displays its output.
     */
    public function run()
    {
        $this->action_bar = $this->get_action_bar();
        $source_table = new SourceTable($this);

        $this->display_header();
        echo $this->action_bar->as_html();
        echo $source_table->as_html();
        $this->display_footer();
    }

    public function get_object_table_condition($object_table_class_name)
    {
        $query = $this->action_bar->get_query();

        if (isset($query) && $query != '')
        {
            return new PatternMatchCondition(Source :: PROPERTY_NAME, '*' . $query . '*');
        }
    }

    public function get_action_bar()
    {
        $action_bar = new ActionBarRenderer(ActionBarRenderer :: TYPE_HORIZONTAL);
        $action_bar->set_search_url($this->get_url());

        // $action_bar->add_common_action(
        // new ToolbarItem(Translation :: get('InstallLocal'),
        // Theme :: get_image_path() . 'action_install_local.png',
        // $this->get_url(array(Manager :: PARAM_ACTION => Manager :: ACTION_LOCAL_PACKAGE)),
        // ToolbarItem :: DISPLAY_ICON_AND_LABEL));
        // $action_bar->add_common_action(
        // new ToolbarItem(Translation :: get('InstallRemote'),
        // Theme :: get_image_path() . 'action_install_remote.png',
        // $this->get_url(array(Manager :: PARAM_ACTION => Manager :: ACTION_REMOTE_PACKAGE)),
        // ToolbarItem :: DISPLAY_ICON_AND_LABEL));

        return $action_bar;
    }
}
