<?php

namespace core\menu;

use common\libraries\Header;

use common\libraries\Utilities;

class LinkApplicationItem extends LinkItem
{
    const PROPERTY_SECTION = 'section';

    const CLASS_NAME = __CLASS__;

    public function __construct($default_properties = array(), $additional_properties = null)
    {
        parent :: __construct($default_properties, $additional_properties);
        $this->set_type(__CLASS__);
    }

    public static function get_type_name()
    {
        return Utilities :: get_classname_from_namespace(self :: CLASS_NAME);
    }

    public function get_section()
    {
        return $this->get_additional_property(self :: PROPERTY_SECTION);
    }

    public function set_section($section)
    {
        return $this->set_additional_property(self :: PROPERTY_SECTION, $section);
    }

    public static function get_additional_property_names()
    {
        $properties = parent :: get_additional_property_names();
        $properties[] = self :: PROPERTY_SECTION;
        return $properties;
    }

    public function is_selected()
    {
        $current_section = Header :: get_section();
        if ($current_section == $this->get_section())
        {
            return true;
        }
        return false;
    }
}
