<?php
namespace core\menu;

/**
 * @author Hans De Bisschop
 */
use common\libraries\Utilities;

abstract class ItemRenderer
{
    private $menu_renderer;
    private $item;

    /**
     * @param User|null $user
     */
    public function __construct($menu_renderer, $item)
    {
        $this->item = $item;
        $this->menu_renderer = $menu_renderer;
    }

    public static function factory($menu_renderer, $item)
    {
        $class = __NAMESPACE__ . '\\' . Utilities:: underscores_to_camelcase($menu_renderer :: TYPE) . Utilities :: get_package_name_from_namespace($item->get_type()) . 'Renderer';
        $renderer = new $class($menu_renderer, $item);
        return $renderer;
    }

    public static function as_html($menu_renderer, $item)
    {
        return self :: factory($menu_renderer, $item)->render();
    }

    /**
     * Renders the menu
     * @return string
     */
    abstract public function render();

    public function get_item()
    {
    	return $this->item;
    }

    public function get_menu_renderer()
    {
    	return $this->menu_renderer;
    }
}
