<?php
namespace core\menu;

/**
 * @author Hans De Bisschop
 */
use common\libraries\Translation;





class SiteMapCategoryItemRenderer extends ItemRenderer
{

    public function render()
    {
        $html = array();
        
        $html[] = '<div class="category">';
        $html[] = '<h1>';
        $html[] = '<a href="#">' . $this->get_item()->get_titles()->get_translation(Translation :: get_instance()->get_language()) . '</a>';
        $html[] = '</h1>';
        
        if ($this->get_item()->has_children())
        {
            foreach ($this->get_item()->get_children() as $child)
            {
                $html[] = ItemRenderer :: as_html($this->get_menu_renderer(), $child);
            }
        }
        
        $html[] = '<div class="clear"></div>';
        $html[] = '</div>';
        
        return implode("\n", $html);
    }
}
