<?php
namespace core\metadata;
Interface MetadataDataManagerInterface
{

    public function create_storage_unit($name, $properties, $indexes);

    public function get_next_metadata_attribute_association_id();

    public function create_metadata_attribute_association($metadata_attribute_association);

    public function update_metadata_attribute_association($metadata_attribute_association);

    public function delete_metadata_attribute_associations($table_name, $metadata_element);

    public function count_metadata_attribute_associations($condition = null);

    public function retrieve_metadata_attribute_association($id);

    public function retrieve_metadata_attribute_associations($condition = null, $offset = null, $max_objects = null, $order_by = null);

    public function get_next_metadata_namespace_id();

    public function create_metadata_namespace($metadata_namespace);

    public function update_metadata_namespace($metadata_namespace);

    public function delete_metadata_namespace($metadata_namespace);

    public function count_metadata_namespaces($condition = null);

    public function retrieve_metadata_namespace($id);

    public function retrieve_metadata_namespaces($condition = null, $offset = null, $max_objects = null, $order_by = null);

    public function get_next_content_object_property_metadata_id();

    public function create_content_object_property_metadata($content_object_property_metadata);

    public function update_content_object_property_metadata($content_object_property_metadata);

    public function delete_content_object_property_metadata($content_object_property_metadata);

    public function count_content_object_property_metadatas($condition = null);

    public function retrieve_content_object_property_metadata($id);

    public function retrieve_content_object_property_metadatas($condition = null, $offset = null, $max_objects = null, $order_by = null);

    public function get_next_metadata_element_id();

    public function create_metadata_element($metadata_element);

    public function update_metadata_element($metadata_element);

    public function delete_metadata_element($metadata_element);

    public function count_metadata_elements($condition = null);

    public function retrieve_metadata_element($id);

    public function retrieve_metadata_elements($condition = null, $offset = null, $max_objects = null, $order_by = null);

    public function get_next_content_object_metadata_element_value_id();

    public function create_content_object_metadata_element_value($metadata_element_value);

    public function update_content_object_metadata_element_value($metadata_element_value);

    public function delete_content_object_metadata_element_value($metadata_element_value);

    public function count_content_object_metadata_element_values($condition = null);

    public function retrieve_content_object_metadata_element_value($id);

    public function retrieve_content_object_metadata_element_values($condition = null, $offset = null, $max_objects = null, $order_by = null);

    public function retrieve_full_content_object_metadata_element_values($condition = null, $offset = null, $max_objects = null, $order_by = null);

    public function get_next_user_metadata_element_value_id();

    public function create_user_metadata_element_value($user_metadata_element_value);

    public function update_user_metadata_element_value($user_metadata_element_value);

    public function delete_user_metadata_element_value($user_metadata_element_value);

    public function count_user_metadata_element_values($condition = null);

    public function retrieve_user_metadata_element_value($id);

    public function retrieve_group_metadata_element_values($condition = null, $offset = null, $max_objects = null, $order_by = null);

    public function get_next_group_metadata_element_value_id();

    public function create_group_metadata_element_value($group_metadata_element_value);

    public function update_group_metadata_element_value($group_metadata_element_value);

    public function delete_group_metadata_element_value($group_metadata_element_value);

    public function count_group_metadata_element_values($condition = null);

    public function retrieve_group_metadata_element_value($id);

    //
    //    function retrieve_metadata_element_values($condition = null, $offset = null, $max_objects = null, $order_by = null);
    //
    //    function retrieve_metadata_element_values($condition = null, $offset = null, $max_objects = null, $order_by = null);
    //    function get_next_metadata_element_value_id();
    //
    //    function create_metadata_element_value($metadata_element_value);
    //
    //    function update_metadata_element_value($metadata_element_value);
    //
    //    function delete_metadata_element_value($metadata_element_value);
    //
    //    function count_metadata_element_values($condition = null);
    //
    //    function retrieve_metadata_element_value($id);
    //
    //    function retrieve_metadata_element_values($condition = null, $offset = null, $max_objects = null, $order_by = null);
    

    public function get_next_metadata_attribute_id();

    public function create_metadata_attribute($metadata_attribute);

    public function update_metadata_attribute($metadata_attribute);

    public function delete_metadata_attribute($metadata_attribute);

    public function count_metadata_attributes($condition = null);

    public function retrieve_metadata_attribute($id);

    public function retrieve_metadata_attributes($condition = null, $offset = null, $max_objects = null, $order_by = null);

    public function get_next_metadata_attribute_value_id();

    public function create_metadata_attribute_value($metadata_attribute_value);

    public function update_metadata_attribute_value($metadata_attribute_value);

    public function delete_metadata_attribute_value($metadata_attribute_value);

    public function count_metadata_attribute_values($condition = null);

    public function retrieve_metadata_attribute_value($id);

    public function retrieve_metadata_attribute_values($condition = null, $offset = null, $max_objects = null, $order_by = null);

    public function get_next_metadata_element_nesting_id();

    public function create_metadata_element_nesting($metadata_element_nesting);

    public function update_metadata_element_nesting($metadata_element_nesting);

    public function delete_metadata_element_nestings($table_name, $metadata_element_nesting);

    public function count_metadata_element_nestings($condition = null);

    public function retrieve_metadata_element_nesting($id);

    public function retrieve_metadata_element_nestings($condition = null, $offset = null, $max_objects = null, $order_by = null);

    public function retrieve_metadata_default_values($condition = null, $offset = null, $max_objects = null, $order_by = null);

    public function count_metadata_default_values($condition = null);

    public function retrieve_metadata_default_value($id);

    public function create_metadata_default_value(MetadataDefaultValue $metadata_default_value);

    public function update_metadata_default_value(MetadataDefaultValue $metadata_default_value);

    public function delete_metadata_default_value(MetadataDefaultValue $metadata_default_value);
}
