<?php
namespace core\metadata;

use repository\ContentObject;
use common\libraries\ObjectTableDataProvider;

/**
 * Data provider for a metadata_element_value table
 * 
 * @author Sven Vanpoucke
 * @author Jens Vanderheyden
 */
class ContentObjectMetadataElementValueBrowserTableDataProvider extends ObjectTableDataProvider
{

    /**
     * Constructor
     * 
     * @param ApplicationComponent $browser
     * @param Condition $condition
     */
    public function __construct($browser, $condition)
    {
        parent :: __construct($browser, $condition);
    }

    /**
     * Retrieves the objects
     * 
     * @param int $offset
     * @param int $count
     * @param string $order_property
     * @return ResultSet A set of objects
     */
    public function get_objects($offset, $count, $order_property = null)
    {
        $order_property = $this->get_order_property($order_property);
        
        // return $this->get_browser()->retrieve_metadata_element_values($this->get_condition(), $offset, $count,
        // $order_property);
        return \repository\DataManager :: retrieve_active_content_objects(ContentObject :: class_name(), 
                $this->get_condition());
        
        // return \repository\DataManager :: retrieve_content_objects();
    }

    /**
     * Gets the number of objects in the table
     * 
     * @return int
     */
    public function get_object_count()
    {
        return \repository\DataManager :: count_active_content_objects(ContentObject :: class_name(), 
                $this->get_condition());
    }
}
