<?php
namespace core\metadata;
use common\libraries\ObjectTableDataProvider;
use common\libraries\DataClassCountParameters;
use group\DataManager as GroupDataManager;

/**
 * Data provider for a metadata_element_value table
 *
 * @author Sven Vanpoucke
 * @author Jens Vanderheyden
 */
class GroupMetadataElementValueBrowserTableDataProvider extends ObjectTableDataProvider
{

    /**
     * Constructor
     * @param ApplicationComponent $browser
     * @param Condition $condition
     */
    public function __construct($browser, $condition)
    {
        parent :: __construct($browser, $condition);
    }

    /**
     * Retrieves the objects
     * @param int $offset
     * @param int $count
     * @param string $order_property
     * @return ResultSet A set of objects
     */
    public function get_objects($offset, $count, $order_property = null)
    {
        $order_property = $this->get_order_property($order_property);
        
        //return $this->get_browser()->retrieve_metadata_element_values($this->get_condition(), $offset, $count, $order_property);
        return GroupDataManager :: retrieves(Group :: class_name(), new DataClassRetrievesParameters($this->get_condition(), $count, $offset, $order_property));
    
     //return \repository\DataManager :: retrieve_content_objects();
    }

    /**
     * Gets the number of objects in the table
     * @return int
     */
    public function get_object_count()
    {
        return GroupDataManager :: count(Group :: CLASS_NAME, new DataClassCountParameters($this->get_condition()));
    }
}
