<?php
namespace core\metadata;

use common\libraries\Translation;
use common\libraries\Utilities;

/**
 * Component to delete metadata_elements objects
 * @author Sven Vanpoucke
 * @author Jens Vanderheyden
 */
class MetadataManagerMetadataElementDeleterComponent extends MetadataManager
{

    /**
     * Runs this component and displays its output.
     */
    public function run()
    {
        $id = $_GET[MetadataManager :: PARAM_METADATA_ELEMENT];
        
        if (! empty($id))
        {
            if (! is_array($ids))
            {
                $ids = array($ids);
            }
            
            $metadata_element = $this->retrieve_metadata_element($id);
            
            if (! $metadata_element->delete())
            {
                $fail = true;
                $message = 'ObjectNotDeleted';
                if ($metadata_element->has_errors())
                    $message .= implode("\n", $metadata_element->get_errors());
            }
            else
            {
                $message = 'ObjectDeleted';
            }
            
            $this->redirect(Translation :: get($message, array('OBJECT' => Translation :: get('MetadataElement')), Utilities :: COMMON_LIBRARIES), ($fail ? true : false), array(
                    MetadataManager :: PARAM_ACTION => MetadataManager :: ACTION_BROWSE_METADATA_ELEMENTS));
        }
        else
        {
            $this->display_error_page(htmlentities(Translation :: get('NoObjectSelected', array(
                    'OBJECT' => Translation :: get('MetadataElement')), Utilities :: COMMON_LIBRARIES)));
        }
    }
}
