<?php
namespace core\metadata;


use common\libraries\Translation;
use repository\content_object\handbook\Metadata;

use repository\RepositoryManager;

/**
 * Component to create a new handbook_publication object
 */
class MetadataManagerMetadataImporterComponent extends MetadataManager
{

    /**
     * Runs this component and displays its output.
     */
    public function run()
    {
        $import_form = new MetadataImportForm('import', 'post', $this->get_url(),
                $this->get_parameter(RepositoryManager :: PARAM_CATEGORY_ID), $this->get_user());

        if ($import_form->validate())
        {
            $success = $import_form->import_metadata();

            $messages = array();
            $errors = array();
            if ($success)
            {
                $messages[] = Translation :: get('ContentObjectImported');
            }
            else
            {
                $errors[] = Translation :: get('ContentObjectNotImported');
            }

            $messages = array_merge($messages, $import_form->get_messages());
            $warnings = $import_form->get_warnings();
            $errors = array_merge($errors, $import_form->get_errors());
            $log = $import_form->get_log();

            $this->display_header();
            echo implode('/n', $messages);
            echo '</br>';
            echo implode('/n', $warnings);
            echo '</br>';
            echo implode('/n', $errors);
            echo '</br>';
            echo $log;
            $this->display_footer();
        }
        else
        {
            $this->display_header();
            $import_form->display();
            $this->display_footer();
        }
    }
}
