<?php
namespace core\metadata;
use common\libraries\ObjectTableCellRenderer;

/**
 * Default cell renderer for the metadata_element table
 *
 * @author Sven Vanpoucke
 * @author Jens Vanderheyden
 */
class DefaultMetadataElementTableCellRenderer extends ObjectTableCellRenderer
{

    /**
     * Constructor
     */
    public function __construct()
    {
    }

    /**
     * Renders a table cell
     * @param ContentObjectTableColumnModel $column The column which should be
     * rendered
     * @param MetadataElement $metadata_element - The metadata_element
     * @return string A HTML representation of the rendered table cell
     */
    public function render_cell($column, $metadata_element)
    {
        switch ($column->get_name())
        {
            case MetadataElement :: PROPERTY_ID :
                return $metadata_element->get_id();
            case DefaultMetadataElementTableColumnModel :: COLUMN_PREFIX :
                return $metadata_element->get_ns_prefix();
            case MetadataElement :: PROPERTY_NAME :
                return $metadata_element->get_name();
            default :
                return '&nbsp;';
        }
    }

    public function render_id_cell($object)
    {
        return $object->get_id();
    }
}
