<?php
namespace core\metadata;
use common\libraries\ObjectTableCellRenderer;

/**
 * Default cell renderer for the metadata_element_value table
 *
 * @author Sven Vanpoucke
 * @author Jens Vanderheyden
 */
class DefaultMetadataElementValueTableCellRenderer extends ObjectTableCellRenderer
{

    /**
     * Constructor
     */
    public function __construct()
    {
    }

    /**
     * Renders a table cell
     *
     * @param $column ContentObjectTableColumnModel The column which should be rendered
     * @param $metadata_element_value MetadataElementValue - The metadata_element_value
     * @return string A HTML representation of the rendered table cell
     */
    public function render_cell($column, $metadata_element_value)
    {
        switch ($column->get_name())
        {
            case MetadataElementValue :: PROPERTY_CONTENT_OBJECT_ID :
                return $metadata_element_value->get_content_object_id();
            case MetadataElementValue :: PROPERTY_ELEMENT_ID :
                return $metadata_element_value->get_element_id();
            case MetadataElementValue :: PROPERTY_VALUE :
                return $metadata_element_value->get_value();
            default :
                return '&nbsp;';
        }
    }

    public function render_id_cell($object)
    {
        return $object->get_id();
    }
}
