<?php
namespace core\metadata;

use common\libraries\Translation;

/**
 * $Id: settings_metadata_connector.class.php 211 2009-11-13 13:28:39Z vanpouckesven $
 * @package metadata.settings
 */

/**
 * Simple connector class to facilitate rendering settings forms by
 * preprocessing data from the datamanagers to a simple array format.
 * @author Hans De Bisschop
 */

class SettingsConnector
{

    public function retrieve_namespaces()
    {
        $namespaces = MetadataManager :: retrieve_metadata_namespaces();

        if ($namespaces->size())
        {
            $spaces[0] = Translation :: get('SelectNamespace');

            while ($namespace = $namespaces->next_result())
            {
                $spaces[$namespace->get_id()] = $namespace->get_name();
            }
        }
        else
        {
            $spaces[0] = Translation :: get('NoNamespaceDefined');
        }
        return $spaces;
    }

}
