<?php
namespace core\migration;

class Autoloader
{

    /**
     * The array mapping class names to paths
     *
     * @var multitype:string
     */
     private static $map = array(
         'Autoloader' => '/autoloader.class.php',
         'FailedElement' => '/lib/failed_element.class.php',
         'FileRecovery' => '/lib/file_recovery.class.php',
         'IdReference' => '/lib/id_reference.class.php',
         'MigrationBlock' => '/lib/migration_block.class.php',
         'MigrationBlockRegistration' => '/lib/migration_block_registration.class.php',
         'MigrationDatabase' => '/lib/migration_database.class.php',
         'MigrationDatabaseConnection' => '/lib/migration_database_connection.class.php',
         'MigrationDataClass' => '/lib/migration_data_class.class.php',
         'MigrationDataManager' => '/lib/migration_data_manager.class.php',
         'MigrationDataManagerInterface' => '/lib/migration_data_manager_interface.class.php',
         'MigrationElement' => '/lib/migration_element.class.php',
         'MigrationPostProcess' => '/lib/migration_post_process.class.php',
         'MigrationProperties' => '/lib/migration_properties.class.php',
         'PlatformMigrationDataManager' => '/lib/platform_migration_data_manager.class.php',
         'Mdb2MigrationDataManager' => '/lib/data_manager/mdb2.class.php',
         'MigrationForm' => '/lib/forms/migration_form.class.php',
         'MigrationManager' => '/lib/migration_manager/migration_manager.class.php',
         'MigrationManagerMigrationComponent' => '/lib/migration_manager/component/migration.class.php',
         'MigrationManagerSettingsCleanerComponent' => '/lib/migration_manager/component/settings_cleaner.class.php',
         'MigrationWizard' => '/lib/migration_manager/component/migration_wizard/migration_wizard.class.php',
         'ConfirmMigrationWizardPage' => '/lib/migration_manager/component/migration_wizard/pages/confirm_migration_wizard_page.class.php',
         'MigrationBlockMigrationWizardPage' => '/lib/migration_manager/component/migration_wizard/pages/migration_block_migration_wizard_page.class.php',
         'MigrationWizardDisplay' => '/lib/migration_manager/component/migration_wizard/pages/migration_wizard_display.class.php',
         'MigrationWizardPage' => '/lib/migration_manager/component/migration_wizard/pages/migration_wizard_page.class.php',
         'MigrationWizardProcess' => '/lib/migration_manager/component/migration_wizard/pages/migration_wizard_process.class.php',
         'CourseDataMigrationBlock' => '/lib/platform/dokeos185/course_data_migration_block.class.php',
         'Dokeos185CourseDataMigrationDataClass' => '/lib/platform/dokeos185/dokeos185_course_data_migration_data_class.class.php',
         'Dokeos185DataManager' => '/lib/platform/dokeos185/dokeos185_data_manager.class.php',
         'Dokeos185MigrationDataClass' => '/lib/platform/dokeos185/dokeos185_migration_data_class.class.php',
         'Dokeos185MigrationProperties' => '/lib/platform/dokeos185/dokeos185_migration_properties.class.php',
         'Dokeos185TextFieldParser' => '/lib/platform/dokeos185/dokeos185_text_field_parser.class.php',
         'Dokeos185Announcement' => '/lib/platform/dokeos185/data_class/dokeos185_announcement.class.php',
         'Dokeos185Assignment' => '/lib/platform/dokeos185/data_class/dokeos185_assignment.class.php',
         'Dokeos185Blog' => '/lib/platform/dokeos185/data_class/dokeos185_blog.class.php',
         'Dokeos185BlogAttachment' => '/lib/platform/dokeos185/data_class/dokeos185_blog_attachment.class.php',
         'Dokeos185BlogComment' => '/lib/platform/dokeos185/data_class/dokeos185_blog_comment.class.php',
         'Dokeos185BlogPost' => '/lib/platform/dokeos185/data_class/dokeos185_blog_post.class.php',
         'Dokeos185BlogRating' => '/lib/platform/dokeos185/data_class/dokeos185_blog_rating.class.php',
         'Dokeos185BlogRelUser' => '/lib/platform/dokeos185/data_class/dokeos185_blog_rel_user.class.php',
         'Dokeos185BlogTask' => '/lib/platform/dokeos185/data_class/dokeos185_blog_task.class.php',
         'Dokeos185BlogTaskRelUser' => '/lib/platform/dokeos185/data_class/dokeos185_blog_task_rel_user.class.php',
         'Dokeos185CalendarEvent' => '/lib/platform/dokeos185/data_class/dokeos185_calendar_event.class.php',
         'Dokeos185ChatConnected' => '/lib/platform/dokeos185/data_class/dokeos185_chat_connected.class.php',
         'Dokeos185Class' => '/lib/platform/dokeos185/data_class/dokeos185_class.class.php',
         'Dokeos185ClassUser' => '/lib/platform/dokeos185/data_class/dokeos185_class_user.class.php',
         'Dokeos185Course' => '/lib/platform/dokeos185/data_class/dokeos185_course.class.php',
         'Dokeos185CourseCategory' => '/lib/platform/dokeos185/data_class/dokeos185_course_category.class.php',
         'Dokeos185CourseDescription' => '/lib/platform/dokeos185/data_class/dokeos185_course_description.class.php',
         'Dokeos185CourseRelClass' => '/lib/platform/dokeos185/data_class/dokeos185_course_rel_class.class.php',
         'Dokeos185CourseRelUser' => '/lib/platform/dokeos185/data_class/dokeos185_course_rel_user.class.php',
         'Dokeos185CourseSetting' => '/lib/platform/dokeos185/data_class/dokeos185_course_setting.class.php',
         'Dokeos185Document' => '/lib/platform/dokeos185/data_class/dokeos185_document.class.php',
         'Dokeos185DropboxCategory' => '/lib/platform/dokeos185/data_class/dokeos185_dropbox_category.class.php',
         'Dokeos185DropboxFeedback' => '/lib/platform/dokeos185/data_class/dokeos185_dropbox_feedback.class.php',
         'Dokeos185DropboxFile' => '/lib/platform/dokeos185/data_class/dokeos185_dropbox_file.class.php',
         'Dokeos185DropboxPerson' => '/lib/platform/dokeos185/data_class/dokeos185_dropbox_person.class.php',
         'Dokeos185DropboxPost' => '/lib/platform/dokeos185/data_class/dokeos185_dropbox_post.class.php',
         'Dokeos185ForumAttachment' => '/lib/platform/dokeos185/data_class/dokeos185_forum_attachment.class.php',
         'Dokeos185ForumCategory' => '/lib/platform/dokeos185/data_class/dokeos185_forum_category.class.php',
         'Dokeos185ForumForum' => '/lib/platform/dokeos185/data_class/dokeos185_forum_forum.class.php',
         'Dokeos185ForumMailcue' => '/lib/platform/dokeos185/data_class/dokeos185_forum_mail_cue.class.php',
         'Dokeos185ForumPost' => '/lib/platform/dokeos185/data_class/dokeos185_forum_post.class.php',
         'Dokeos185ForumThread' => '/lib/platform/dokeos185/data_class/dokeos185_forum_thread.class.php',
         'Dokeos185GradebookCategory' => '/lib/platform/dokeos185/data_class/dokeos185_gradebook_category.class.php',
         'Dokeos185GradebookEvaluation' => '/lib/platform/dokeos185/data_class/dokeos185_gradebook_evaluation.class.php',
         'Dokeos185GradebookLink' => '/lib/platform/dokeos185/data_class/dokeos185_gradebook_link.class.php',
         'Dokeos185GradebookResult' => '/lib/platform/dokeos185/data_class/dokeos185_gradebook_result.class.php',
         'Dokeos185GradebookScoreDisplay' => '/lib/platform/dokeos185/data_class/dokeos185_gradebook_score_display.class.php',
         'Dokeos185Group' => '/lib/platform/dokeos185/data_class/dokeos185_group.class.php',
         'Dokeos185GroupCategory' => '/lib/platform/dokeos185/data_class/dokeos185_group_category.class.php',
         'Dokeos185GroupRelTutor' => '/lib/platform/dokeos185/data_class/dokeos185_group_rel_tutor.class.php',
         'Dokeos185GroupRelUser' => '/lib/platform/dokeos185/data_class/dokeos185_group_rel_user.class.php',
         'Dokeos185ItemProperty' => '/lib/platform/dokeos185/data_class/dokeos185_item_property.class.php',
         'Dokeos185Link' => '/lib/platform/dokeos185/data_class/dokeos185_link.class.php',
         'Dokeos185LinkCategory' => '/lib/platform/dokeos185/data_class/dokeos185_link_category.class.php',
         'Dokeos185Lp' => '/lib/platform/dokeos185/data_class/dokeos185_lp.class.php',
         'Dokeos185LpItem' => '/lib/platform/dokeos185/data_class/dokeos185_lp_item.class.php',
         'Dokeos185LpItemView' => '/lib/platform/dokeos185/data_class/dokeos185_lp_item_view.class.php',
         'Dokeos185LpIvInteraction' => '/lib/platform/dokeos185/data_class/dokeos185_lp_iv_interaction.class.php',
         'Dokeos185LpIvObjective' => '/lib/platform/dokeos185/data_class/dokeos185_lp_iv_objective.class.php',
         'Dokeos185LpView' => '/lib/platform/dokeos185/data_class/dokeos185_lp_view.class.php',
         'Dokeos185OnlineConnected' => '/lib/platform/dokeos185/data_class/dokeos185_online_connected.class.php',
         'Dokeos185OnlineLink' => '/lib/platform/dokeos185/data_class/dokeos185_online_link.class.php',
         'Dokeos185OpenidAssociation' => '/lib/platform/dokeos185/data_class/dokeos185_openid_association.class.php',
         'Dokeos185PermissionGroup' => '/lib/platform/dokeos185/data_class/dokeos185_permission_group.class.php',
         'Dokeos185PermissionTask' => '/lib/platform/dokeos185/data_class/dokeos185_permission_task.class.php',
         'Dokeos185PermissionUser' => '/lib/platform/dokeos185/data_class/dokeos185_permission_user.class.php',
         'Dokeos185PersonalAgenda' => '/lib/platform/dokeos185/data_class/dokeos185_personal_agenda.class.php',
         'Dokeos185PhpSession' => '/lib/platform/dokeos185/data_class/dokeos185_php_session.class.php',
         'Dokeos185Quiz' => '/lib/platform/dokeos185/data_class/dokeos185_quiz.class.php',
         'Dokeos185QuizAnswer' => '/lib/platform/dokeos185/data_class/dokeos185_quiz_answer.class.php',
         'Dokeos185QuizQuestion' => '/lib/platform/dokeos185/data_class/dokeos185_quiz_question.class.php',
         'Dokeos185QuizRelQuestion' => '/lib/platform/dokeos185/data_class/dokeos185_quiz_rel_question.class.php',
         'Dokeos185Resource' => '/lib/platform/dokeos185/data_class/dokeos185_resource.class.php',
         'Dokeos185Role' => '/lib/platform/dokeos185/data_class/dokeos185_role.class.php',
         'Dokeos185RoleGroup' => '/lib/platform/dokeos185/data_class/dokeos185_rolegroup.class.php',
         'Dokeos185RolePermissions' => '/lib/platform/dokeos185/data_class/dokeos185_role_permissions.class.php',
         'Dokeos185RoleUser' => '/lib/platform/dokeos185/data_class/dokeos185_role_user.class.php',
         'Dokeos185Session' => '/lib/platform/dokeos185/data_class/dokeos185_session.class.php',
         'Dokeos185SessionRelCourse' => '/lib/platform/dokeos185/data_class/dokeos185_session_rel_course.class.php',
         'Dokeos185SessionRelCourseRelUser' => '/lib/platform/dokeos185/data_class/dokeos185_session_rel_course_rel_user.class.php',
         'Dokeos185SessionRelUser' => '/lib/platform/dokeos185/data_class/dokeos185_session_rel_user.class.php',
         'Dokeos185SettingsCurrent' => '/lib/platform/dokeos185/data_class/dokeos185_settings_current.class.php',
         'Dokeos185SharedSurvey' => '/lib/platform/dokeos185/data_class/dokeos185_shared_survey.class.php',
         'Dokeos185SharedSurveyQuestion' => '/lib/platform/dokeos185/data_class/dokeos185_shared_survey_question.class.php',
         'Dokeos185SharedSurveyQuestionOption' => '/lib/platform/dokeos185/data_class/dokeos185_shared_survey_question_option.class.php',
         'Dokeos185Survey' => '/lib/platform/dokeos185/data_class/dokeos185_survey.class.php',
         'Dokeos185SurveyAnswer' => '/lib/platform/dokeos185/data_class/dokeos185_survey_answer.class.php',
         'Dokeos185SurveyInvitation' => '/lib/platform/dokeos185/data_class/dokeos185_survey_invitation.class.php',
         'Dokeos185SurveyQuestion' => '/lib/platform/dokeos185/data_class/dokeos185_survey_question.class.php',
         'Dokeos185SurveyQuestionOption' => '/lib/platform/dokeos185/data_class/dokeos185_survey_question_option.class.php',
         'Dokeos185SysAnnouncement' => '/lib/platform/dokeos185/data_class/dokeos185_sys_announcement.class.php',
         'Dokeos185Templates' => '/lib/platform/dokeos185/data_class/dokeos185_templates.class.php',
         'Dokeos185Tool' => '/lib/platform/dokeos185/data_class/dokeos185_tool.class.php',
         'Dokeos185ToolIntro' => '/lib/platform/dokeos185/data_class/dokeos185_tool_intro.class.php',
         'Dokeos185TrackCBrowsers' => '/lib/platform/dokeos185/data_class/dokeos185_track_cbrowsers.class.php',
         'Dokeos185TrackCCountries' => '/lib/platform/dokeos185/data_class/dokeos185_track_ccountries.class.php',
         'Dokeos185TrackCOs' => '/lib/platform/dokeos185/data_class/dokeos185_track_cos.class.php',
         'Dokeos185TrackCProviders' => '/lib/platform/dokeos185/data_class/dokeos185_track_cproviders.class.php',
         'Dokeos185TrackCReferers' => '/lib/platform/dokeos185/data_class/dokeos185_track_creferers.class.php',
         'Dokeos185TrackEAccess' => '/lib/platform/dokeos185/data_class/dokeos185_track_eaccess.class.php',
         'Dokeos185TrackEAttempt' => '/lib/platform/dokeos185/data_class/dokeos185_track_eattempt.class.php',
         'Dokeos185TrackECourseAccess' => '/lib/platform/dokeos185/data_class/dokeos185_track_ecourse_access.class.php',
         'Dokeos185TrackEDefault' => '/lib/platform/dokeos185/data_class/dokeos185_track_edefault.class.php',
         'Dokeos185TrackEDownloads' => '/lib/platform/dokeos185/data_class/dokeos185_track_edownloads.class.php',
         'Dokeos185TrackEExercices' => '/lib/platform/dokeos185/data_class/dokeos185_track_eexercices.class.php',
         'Dokeos185TrackEHotpotatoes' => '/lib/platform/dokeos185/data_class/dokeos185_track_ehotpotatoes.class.php',
         'Dokeos185TrackEHotspot' => '/lib/platform/dokeos185/data_class/dokeos185_track_ehotspot.class.php',
         'Dokeos185TrackELastaccess' => '/lib/platform/dokeos185/data_class/dokeos185_track_elastaccess.class.php',
         'Dokeos185TrackELinks' => '/lib/platform/dokeos185/data_class/dokeos185_track_elinks.class.php',
         'Dokeos185TrackELogin' => '/lib/platform/dokeos185/data_class/dokeos185_track_elogin.class.php',
         'Dokeos185TrackEOnline' => '/lib/platform/dokeos185/data_class/dokeos185_track_eonline.class.php',
         'Dokeos185TrackEOpen' => '/lib/platform/dokeos185/data_class/dokeos185_track_eopen.class.php',
         'Dokeos185TrackEUploads' => '/lib/platform/dokeos185/data_class/dokeos185_track_euploads.class.php',
         'Dokeos185User' => '/lib/platform/dokeos185/data_class/dokeos185_user.class.php',
         'Dokeos185UserCourseCategory' => '/lib/platform/dokeos185/data_class/dokeos185_user_course_category.class.php',
         'ClassesMigrationBlock' => '/lib/platform/dokeos185/migration_block/classes_migration_block.class.php',
         'CoursesMigrationBlock' => '/lib/platform/dokeos185/migration_block/courses_migration_block.class.php',
         'CourseAnnouncementsMigrationBlock' => '/lib/platform/dokeos185/migration_block/course_announcements_migration_block.class.php',
         'CourseAssignmentsMigrationBlock' => '/lib/platform/dokeos185/migration_block/course_assignments_migration_block.class.php',
         'CourseBlogsMigrationBlock' => '/lib/platform/dokeos185/migration_block/course_blogs_migration_block.class.php',
         'CourseCalendarEventsMigrationBlock' => '/lib/platform/dokeos185/migration_block/course_calendar_events_migration_block.class.php',
         'CourseDocumentsMigrationBlock' => '/lib/platform/dokeos185/migration_block/course_documents_migration_block.class.php',
         'CourseDropboxesMigrationBlock' => '/lib/platform/dokeos185/migration_block/course_dropboxes_migration_block.class.php',
         'CourseForumsMigrationBlock' => '/lib/platform/dokeos185/migration_block/course_forums_migration_block.class.php',
         'CourseGroupsMigrationBlock' => '/lib/platform/dokeos185/migration_block/course_groups_migration_block.class.php',
         'CourseLearningPathsMigrationBlock' => '/lib/platform/dokeos185/migration_block/course_learning_paths_migration_block.class.php',
         'CourseLinksMigrationBlock' => '/lib/platform/dokeos185/migration_block/course_links_migration_block.class.php',
         'CourseMetaDataMigrationBlock' => '/lib/platform/dokeos185/migration_block/course_metadata_migration_block.class.php',
         'CourseQuizzesMigrationBlock' => '/lib/platform/dokeos185/migration_block/course_quizzes_migration_block.class.php',
         'CourseScormsMigrationBlock' => '/lib/platform/dokeos185/migration_block/course_scorms_migration_block.class.php',
         'CourseStudentPublicationsMigrationBlock' => '/lib/platform/dokeos185/migration_block/course_student_publications_migration_block.class.php',
         'CourseSurveysMigrationBlock' => '/lib/platform/dokeos185/migration_block/course_surveys_migration_block.class.php',
         'PersonalAgendasMigrationBlock' => '/lib/platform/dokeos185/migration_block/personal_agendas_migration_block.class.php',
         'SettingsMigrationBlock' => '/lib/platform/dokeos185/migration_block/settings_migration_block.class.php',
         'TrackersMigrationBlock' => '/lib/platform/dokeos185/migration_block/trackers_migration_block.class.php',
         'UsersMigrationBlock' => '/lib/platform/dokeos185/migration_block/users_migration_block.class.php',
         'HtmPostProcess' => '/lib/platform/dokeos185/post_process/htm_post_process.class.php',
         'LocationsPostProcess' => '/lib/platform/dokeos185/post_process/locations_post_process.class.php',
         'Dokeos185EmbeddedMediaTextFieldParser' => '/lib/platform/dokeos185/text_field_parser/dokeos185_embedded_media_text_field_parser.class.php',
         'Dokeos185FlashHtmTextFieldParser' => '/lib/platform/dokeos185/text_field_parser/dokeos185_flash_htm_text_field_parser.class.php',
         'Dokeos185ImageTextFieldParser' => '/lib/platform/dokeos185/text_field_parser/dokeos185_image_text_field_parser.class.php',
         'Activator' => '/package/activate/activator.class.php',
         'Deactivator' => '/package/deactivate/deactivator.class.php',
         'MigrationInstaller' => '/package/install/migration_installer.class.php',
         'DataClassGenerator' => '/util/data_class_generator/data_class_generator.class.php'
    );

    /**
     * Try to load the class
     *
     * @param $classname string
     * @return boolean
     */
    public static function load($classname)
    {
        if (isset(self :: $map[$classname]))
        {
            require_once __DIR__ . self :: $map[$classname];
            return true;
        }

        return false;
    }

    /**
     * Synchronize the autoloader
     *
     * @param $update boolean
     * @return multitype:string
     */
    public static function synch($update)
    {
        return \common\libraries\AutoloaderUtilities :: synch(__DIR__, __DIR__, $update);
    }

}
?>