<?php
require_once dirname(__FILE__) . '/../../../../../../common/global.inc.php';

use repository\content_object\document\Document;
use repository\ContentObject;
use common\libraries\PatternMatchCondition;
use repository\content_object\file\File;
use core\migration\Dokeos185TextFieldParser;

$condition = new PatternMatchCondition(File :: PROPERTY_FILENAME, '*.htm*',
        (ContentObject :: is_type_available('document') ? Document :: get_type_name() : File :: get_type_name()));
$documents = \repository\DataManager :: retrieve_active_content_objects(
        (ContentObject :: is_type_available('document') ? Document :: class_name() : File :: class_name()), $condition);

$parser = Dokeos185TextFieldParser :: factory();

while ($document = $documents->next_result())
{
    $file = $document->get_full_path();
    $contents = file_get_contents($file);
    $contents = $parser->parse($contents);
    file_put_contents($file, $contents);
}
