<?php
namespace group;
use common\libraries\Utilities;
use common\libraries\DataClass;
use common\libraries\EqualityCondition;
use common\libraries\AndCondition;

/**
 * $Id: group_rel_user.class.php 224 2009-11-13 14:40:30Z kariboe $
 * @package group.lib
 */
/**
 * @author Hans de Bisschop
 * @author Dieter De Neef
 */

class GroupRelUser extends DataClass
{
    const CLASS_NAME = __CLASS__;
    
    const PROPERTY_GROUP_ID = 'group_id';
    const PROPERTY_USER_ID = 'user_id';

    public function get_group_id()
    {
        return $this->get_default_property(self :: PROPERTY_GROUP_ID);
    }

    public function set_group_id($group_id)
    {
        $this->set_default_property(self :: PROPERTY_GROUP_ID, $group_id);
    }

    public function get_user_id()
    {
        return $this->get_default_property(self :: PROPERTY_USER_ID);
    }

    public function set_user_id($user_id)
    {
        $this->set_default_property(self :: PROPERTY_USER_ID, $user_id);
    }

    /**
     * Get the default properties of all groups.
     * @return array The property names.
     */
    public static function get_default_property_names()
    {
        return array(self :: PROPERTY_GROUP_ID, self :: PROPERTY_USER_ID);
    }

    /**
     * inherited
     */
    public function get_data_manager()
    {
        return DataManager :: get_instance();
    }

    public function create()
    {
        return $this->get_data_manager()->create($this);
    }


    public function delete()
    {
        $conditions = array();
        $conditions[] = new EqualityCondition(GroupRelUser :: PROPERTY_GROUP_ID, $this->get_group_id());
        $conditions[] = new EqualityCondition(GroupRelUser :: PROPERTY_USER_ID, $this->get_user_id());
        $condition = new AndCondition($conditions);

        return $this->get_data_manager()->new_delete(GroupRelUser :: CLASS_NAME, $condition);
    }

    public function update()
    {
        return $this->get_data_manager()->update_group_rel_user($this);
    }

    public static function get_table_name()
    {
        return Utilities :: get_classname_from_namespace(self :: CLASS_NAME, true);
    }
}
