<?php
namespace reporting;
/**
 * @package reporting.lib
 *
 * This is an interface for a data manager for the Reporting application.
 * Data managers must implement this class.
 *
 * @author Hans De Bisschop
 */
interface ReportingDataManagerInterface
{

    public function initialize();

    public function create_storage_unit($name, $properties, $indexes);

    public function create_reporting_block($reporting_block);

    public function update_reporting_block($reporting_block);

    public function retrieve_reporting_block_by_name($blockname);

    public function retrieve_reporting_blocks($condition = null, $offset = null, $count = null, $order_property = null);

    public function count_reporting_blocks($condition = null);

    public function retrieve_reporting_block($block_id);

    public function create_reporting_template_registration($reporting_template_registration);

    public function update_reporting_template_registration($reporting_template_registration);

    public function retrieve_reporting_template_registrations($condition = null, $offset = null, $count = null, $order_property = null);

    public function count_reporting_template_registrations($condition = null);

    public function retrieve_reporting_template_registration($reporting_template_registration_id);

    public function delete_reporting_template_registrations($condition = null);

    public function delete_reporting_blocks($condition = null);

    public function delete_orphaned_block_template_relations();

    public function retrieve_reporting_template_object($classname);

}
