<?php
namespace reporting\viewer;

class Autoloader
{

    /**
     * The array mapping class names to paths
     *
     * @var multitype:string
     */
     private static $map = array(
         'Autoloader' => '/autoloader.class.php',
         'Manager' => '/lib/manager/manager.class.php',
         'SaverComponent' => '/lib/manager/component/saver.class.php',
         'ViewerComponent' => '/lib/manager/component/viewer.class.php',
         'AbstractBlockRenditionImplementation' => '/lib/rendition/block/abstract_rendition_implementation.class.php',
         'CsvBlockRendition' => '/lib/rendition/block/csv_rendition.class.php',
         'DummyBlockRenditionImplementation' => '/lib/rendition/block/dummy_rendition_implementation.class.php',
         'HtmlBlockRendition' => '/lib/rendition/block/html_rendition.class.php',
         'JsonBlockRendition' => '/lib/rendition/block/json_rendition.class.php',
         'OdsBlockRendition' => '/lib/rendition/block/ods_rendition.class.php',
         'BlockRendition' => '/lib/rendition/block/rendition.class.php',
         'BlockRenditionImplementation' => '/lib/rendition/block/rendition_implementation.class.php',
         'XlsxBlockRendition' => '/lib/rendition/block/xlsx_rendition.class.php',
         'XmlBlockRendition' => '/lib/rendition/block/xml_rendition.class.php',
         'CsvDefaultBlockRendition' => '/lib/rendition/block/csv/default.class.php',
         'HtmlChartBlockRendition' => '/lib/rendition/block/html/chart.class.php',
         'HtmlCsvBlockRendition' => '/lib/rendition/block/html/csv.class.php',
         'HtmlOdsBlockRendition' => '/lib/rendition/block/html/ods.class.php',
         'HtmlTableBlockRendition' => '/lib/rendition/block/html/table.class.php',
         'HtmlXlsxBlockRendition' => '/lib/rendition/block/html/xlsx.class.php',
         'HtmlXmlBlockRendition' => '/lib/rendition/block/html/xml.class.php',
         'HtmlAreaChartBlockRendition' => '/lib/rendition/block/html/chart/area.class.php',
         'HtmlBarChartBlockRendition' => '/lib/rendition/block/html/chart/bar.class.php',
         'HtmlLineChartBlockRendition' => '/lib/rendition/block/html/chart/line.class.php',
         'HtmlPieChartBlockRendition' => '/lib/rendition/block/html/chart/pie.class.php',
         'HtmlPolarChartBlockRendition' => '/lib/rendition/block/html/chart/polar.class.php',
         'HtmlRadarChartBlockRendition' => '/lib/rendition/block/html/chart/radar.class.php',
         'HtmlRingChartBlockRendition' => '/lib/rendition/block/html/chart/ring.class.php',
         'HtmlStackedAreaChartBlockRendition' => '/lib/rendition/block/html/chart/stacked_area.class.php',
         'HtmlStackedBarChartBlockRendition' => '/lib/rendition/block/html/chart/stacked_bar.class.php',
         'HtmlThreeDeePieChartBlockRendition' => '/lib/rendition/block/html/chart/three_dee_pie.class.php',
         'JsonDefaultContentObjectRendition' => '/lib/rendition/template/json/default.class.php',
         'OdsDefaultBlockRendition' => '/lib/rendition/block/ods/default.class.php',
         'XlsxDefaultBlockRendition' => '/lib/rendition/block/xlsx/default.class.php',
         'XmlDefaultBlockRendition' => '/lib/rendition/block/xml/default.class.php',
         'AbstractTemplateRenditionImplementation' => '/lib/rendition/template/abstract_rendition_implementation.class.php',
         'CsvTemplateRendition' => '/lib/rendition/template/csv_rendition.class.php',
         'DummyTemplateRenditionImplementation' => '/lib/rendition/template/dummy_rendition_implementation.class.php',
         'HtmlTemplateRendition' => '/lib/rendition/template/html_rendition.class.php',
         'JsonTemplateRendition' => '/lib/rendition/template/json_rendition.class.php',
         'OdsTemplateRendition' => '/lib/rendition/template/ods_rendition.class.php',
         'TemplateRendition' => '/lib/rendition/template/rendition.class.php',
         'TemplateRenditionImplementation' => '/lib/rendition/template/rendition_implementation.class.php',
         'XlsxTemplateRendition' => '/lib/rendition/template/xlsx_rendition.class.php',
         'XmlTemplateRendition' => '/lib/rendition/template/xml_rendition.class.php',
         'CsvDefaultTemplateRendition' => '/lib/rendition/template/csv/default.class.php',
         'HtmlDefaultTemplateRendition' => '/lib/rendition/template/html/default.class.php',
         'OdsDefaultTemplateRendition' => '/lib/rendition/template/ods/default.class.php',
         'XlsxDefaultTemplateRendition' => '/lib/rendition/template/xlsx/default.class.php',
         'XmlDefaultTemplateRendition' => '/lib/rendition/template/xml/default.class.php',
         'Activator' => '/package/activate/activator.class.php',
         'Deactivator' => '/package/deactivate/deactivator.class.php',
         'Installer' => '/package/install/installer.class.php'
    );

    /**
     * Try to load the class
     *
     * @param $classname string
     * @return boolean
     */
    public static function load($classname)
    {
        if (isset(self :: $map[$classname]))
        {
            require_once __DIR__ . self :: $map[$classname];
            return true;
        }

        return false;
    }

    /**
     * Synchronize the autoloader
     *
     * @param $update boolean
     * @return multitype:string
     */
    public static function synch($update)
    {
        return \common\libraries\AutoloaderUtilities :: synch(__DIR__, __DIR__, $update);
    }

}
?>