<?php
namespace reporting\viewer;

/**
 *
 * @author Hans De Bisschop & Magali Gillard
 * @package reporting.viewer
 */
abstract class AbstractTemplateRenditionImplementation
{

    /**
     *
     * @var \common\libraries\Application
     */
    private $context;

    /**
     *
     * @var \reporting\ReportingTemplate
     */
    private $template;

    /**
     *
     * @param \common\libraries\Application $context
     * @param ReportingTemplate $template
     */
    public function __construct($context, ReportingTemplate $template)
    {
        $this->context = $context;
        $this->template = $template;
    }

    /**
     *
     * @return \common\libraries\Application
     */
    public function get_context()
    {
        return $this->context;
    }

    /**
     *
     * @param \common\libraries\Application $context
     */
    public function set_context($context)
    {
        $this->context = $context;
    }

    /**
     *
     * @return \reporting\ReportingTemplate
     */
    public function get_template()
    {
        return $this->template;
    }

    /**
     *
     * @param ReportingTemplate $template
     */
    public function set_template(ReportingTemplate $template)
    {
        $this->template = $template;
    }

    /**
     *
     * @return string
     */
    abstract public function get_view();

    /**
     *
     * @return string
     */
    abstract public function get_format();
}
