<?php
namespace repository\content_object\announcement\integration\core\home;

use common\libraries\Translation;
use common\libraries\EqualityCondition;
use common\libraries\Session;

/**
 *
 * @package repository.content_object.announcement.block
 * @author Hans De Bisschop
 */
class Connector
{

    public function get_objects()
    {
        $options = array();
        $condition = new EqualityCondition(\repository\ContentObject :: PROPERTY_OWNER_ID, Session :: get_user_id());
        $objects = \repository\DataManager :: retrieve_active_content_objects(
                \repository\content_object\announcement\Announcement :: class_name(), $condition);

        if ($objects->size() == 0)
        {
            $options[0] = Translation :: get('CreateAnnouncementFirst');
        }
        else
        {
            while ($object = $objects->next_result())
            {
                $options[$object->get_id()] = $object->get_title();
            }
        }

        return $options;
    }
}
