<?php
namespace repository\content_object\assessment;

use repository\ContentObject;
use common\libraries\ObjectTableDataProvider;

/**
 * $Id: object_browser_table_data_provider.class.php 200 2009-11-13 12:30:04Z kariboe $
 * 
 * @package repository.lib.complex_builder.assessment.component.assessment_merger
 */
/**
 * Data provider for a repository browser table. This class implements some functions to allow repository browser tables
 * to retrieve information about the learning objects to display.
 */
class ObjectBrowserTableDataProvider extends ObjectTableDataProvider
{

    /**
     * Constructor
     * 
     * @param ObjectManagerComponent $browser
     * @param Condition $condition
     */
    public function __construct($browser, $condition)
    {
        parent :: __construct($browser, $condition);
    }

    /**
     * Gets the learning objects
     * 
     * @param int $offset
     * @param int $count
     * @param string $order_property
     * @return ResultSet A set of matching learning objects.
     */
    public function get_objects($offset, $count, $order_property = null)
    {
        $order_property = $this->get_order_property($order_property);
        
        // We always use title as second sorting parameter
        // $order_property[] = ContentObject :: PROPERTY_TITLE;
        
        return \repository\DataManager :: retrieve_active_content_objects(ContentObject :: class_name(), 
                $this->get_condition());
    }

    /**
     * Gets the number of learning objects in the table
     * 
     * @return int
     */
    public function get_object_count()
    {
        return \repository\DataManager :: count_active_content_objects(ContentObject :: class_name(), 
                $this->get_condition());
    }
}
