<?php
namespace repository\content_object\assessment;

use repository\content_object\assessment_match_text_question\AssessmentMatchTextQuestionOption;

/**
 *
 * @package repository.lib.complex_display.assessment.component.viewer.wizard.inc.score_calculator
 */
class AssessmentMatchTextQuestionScoreCalculator extends ScoreCalculator
{

    public function calculate_score()
    {
        $user_answers = $this->get_answer();
        $user_answer = trim($user_answers[0]);
        $question = $this->get_question();
        $use_wildcards = $question->get_use_wildcards();
        $ignore_case = $question->get_ignore_case();
        $max_score = $question->get_best_option()->get_score();
        $options = $question->get_options();

        $result = 0;
        foreach ($options as $option)
        {
            if ($option->matches($user_answer, $ignore_case, $use_wildcards))
            {
                return $this->make_score_relative($option->get_score(), $max_score);
            }
        }
        return $result;
    }
}
