<?php
namespace repository\content_object\assessment_match_text_question;

use repository\ComplexContentObjectItem;

/**
 *
 * @package repository.lib.content_object.match_text_question
 */

/**
 * This class represents a complex assessment (used to create complex learning objects)
 */
class ComplexAssessmentMatchTextQuestion extends ComplexContentObjectItem
{
    const PROPERTY_WEIGHT = 'weight';
    const PROPERTY_FEEDBACK_ANSWER = 'feedback_answer';

    public static function get_additional_property_names()
    {
        return array(self :: PROPERTY_WEIGHT, self :: PROPERTY_FEEDBACK_ANSWER);
    }

    public function get_weight()
    {
        return $this->get_additional_property(self :: PROPERTY_WEIGHT);
    }

    public function set_weight($value)
    {
        $this->set_additional_property(self :: PROPERTY_WEIGHT, $value);
    }

    public function get_feedback_answer()
    {
        return $this->get_additional_property(self :: PROPERTY_FEEDBACK_ANSWER);
    }

    public function set_feedback_answer($value)
    {
        $this->set_additional_property(self :: PROPERTY_FEEDBACK_ANSWER, $value);
    }

    // TODO: should be moved to an additional parent layer "complex_question" which offers this implementation to EACH
    // complex question object.
    public function get_default_question_weight()
    {
        $reference = parent :: get_ref_object();
        if ($reference)
        {
            return $reference->get_default_weight();
        }
        return 1;
    }

    /**
     * If we set the parent, we update the default weight to the parents default.
     */
    public function set_parent($parent)
    {
        // TODO: should be moved to an additional parent layer "complex_question" which offers this implementation to
        // EACH
        // complex question object.
        parent :: set_parent($parent);
        $this->set_weight($this->get_default_question_weight());
    }
}
