<?php
namespace repository\content_object\assessment_match_text_question;

/**
 *
 * @package repository.lib.content_object.match_text_question
 */
use common\libraries\StringUtilities;

/**
 * This class represents an option in a match tex question.
 */
class AssessmentMatchTextQuestionOption
{

    private $value;

    private $score;

    private $feedback;

    public function __construct($value, $score, $feedback)
    {
        $this->value = $value;
        $this->score = $score;
        $this->feedback = $feedback;
    }

    public function get_value()
    {
        return $this->value;
    }

    public function get_score()
    {
        return $this->score;
    }

    public function get_feedback()
    {
        return $this->feedback;
    }

    public function has_feedback()
    {
        return StringUtilities :: has_value($this->get_feedback(), true);
    }

    public function set_feedback($value)
    {
        $this->feedback = $value;
    }

    public function matches($answer, $ignore_case, $use_wildcards)
    {
        if ($use_wildcards)
        {
            $star = '__star__';
            $value = str_replace('*', $star, $this->get_value());
            $value = preg_quote($value);
            $value = str_replace($star, '.*', $value);
            $value = "/$value/" . ($ignore_case ? 'i' : '');
            return preg_match($value, $answer) > 0;
        }
        else
        {
            if ($ignore_case)
            {
                return strtolower($answer) == strtolower($this->get_value());
            }
            else
            {
                return $answer == $this->get_value();
            }
        }
    }
}
