<?php
namespace repository\content_object\assessment_multiple_choice_question;

use repository\ContentObjectResourceRenderer;

use common\libraries\Translation;

use repository\ContentObjectRendition;

class HtmlDescriptionRenditionImplementation extends HtmlRenditionImplementation
{

    public function render()
    {
        return ContentObjectRendition :: launch($this);
    }

    public function get_description()
    {
        $html = array();

        $lo = $this->get_content_object();
        $options = $lo->get_options();
        $type = $lo->get_answer_type();

        switch ($type)
        {
            case AssessmentMultipleChoiceQuestion :: ANSWER_TYPE_RADIO :
                $type = 'radio';
                break;
            case AssessmentMultipleChoiceQuestion :: ANSWER_TYPE_CHECKBOX :
                $type = 'checkbox';
                break;
        }

        $html[] = '<table class="data_table">';
        $html[] = '<thead>';
        $html[] = '<tr>';
        $html[] = '<th class="checkbox"></th>';
        $html[] = '<th>' . Translation :: get('Options') . '</th>';
        $html[] = '</tr>';
        $html[] = '</thead>';
        $html[] = '<tbody>';

        foreach ($options as $index => $option)
        {
            $html[] = '<tr class="' . ($index % 2 == 0 ? 'row_even' : 'row_odd') . '">';
            $html[] = '<td><input type="' . $type . '" name="option[]"/></td>';

            $renderer = new ContentObjectResourceRenderer($this->get_context(), $option->get_value());
            $html[] = '<td>' . $renderer->run() . '</td>';

            $html[] = '</tr>';
        }

        $html[] = '</tbody>';
        $html[] = '</table>';
        return implode("\n", $html);
    }
}
