<?php
namespace repository\content_object\dailymotion;

use common\libraries\Text;

use repository\ContentObjectRendition;

class HtmlDescriptionRenditionImplementation extends HtmlRenditionImplementation
{

    public function render()
    {
        return ContentObjectRendition :: launch($this);
    }

    public function get_description()
    {
        $object = $this->get_content_object();
        
        $target = $this->get_link_target();
        $target = $target ? ' target="' . $target . '" ' : '';
        
        $video_url = $object->get_url();
        $video_url_components = parse_url($video_url);
        
        $video_url_custom = str_replace("video", "swf", $video_url_components["path"]);
        $video_query_components = Text :: parse_query_string($video_url_components['query']);
        $video_element = '<embed style="margin-bottom: 1em;" height="' . $object->get_height() . '" width="' . $object->get_width() . '"src="http://www.dailymotion.com/' . $video_url_custom . '"></embed>';
        
        return '<div class="link_url" style="margin-top: 1em;">' . $video_element . '<br/><a href="' . htmlentities($object->get_url()) . '"' . $target . '>' . htmlentities($object->get_url()) . '</a></div>';
    
    }
}
