<?php
namespace repository\content_object\file;


use common\libraries\Utilities;


class HtmlInlineRenditionImplementation extends HtmlRenditionImplementation
{
    const PARAM_WIDTH = 'width';
    const PARAM_HEIGHT = 'height';
    const PARAM_BORDER = 'border';
    const PARAM_MARGIN_HORIZONTAL = 'margin-horizontal';
    const PARAM_MARGIN_VERTICAL = 'margin-vertical';
    const PARAM_ALIGN = 'align';
    const PARAM_ALT = 'alt';
    const PARAM_STYLE = 'style';

    public function render($parameters)
    {
        $object = $this->get_content_object();

        $class = __NAMESPACE__ . '\HtmlInline' . Utilities :: underscores_to_camelcase($object->get_extension()) . 'RenditionImplementation';

        if (!class_exists($class))
        {
            $document_type = $object->determine_type();
            $class = __NAMESPACE__ . '\HtmlInline' . Utilities :: underscores_to_camelcase($document_type) . 'RenditionImplementation';
        }

        $rendition = new $class($this->get_context(), $this->get_content_object());
        return $rendition->render($parameters);
    }
}
