<?php
namespace repository\content_object\fill_in_blanks_question;

use common\libraries\Translation;
use repository\ComplexContentObjectItemForm;

/**
 * $Id: complex_fill_in_blanks_question_form.class.php 200 2009-11-13 12:30:04Z kariboe $
 *
 * @package repository.lib.question_types.fill_in_blanks_question
 */
/**
 * This class represents a form to create or update complex assessments
 */
class ComplexFillInBlanksQuestionForm extends ComplexContentObjectItemForm
{
    const PROPERTY_RECALCULATE_WEIGHT = 'recalculate_weight';

    public function get_elements()
    {
        $elements[] = $this->createElement(
            'checkbox',
            self :: PROPERTY_RECALCULATE_WEIGHT,
            Translation :: get('RecalculateWeight'));

        $elements[] = $this->createElement(
            'text',
            ComplexFillInBlanksQuestion :: PROPERTY_WEIGHT,
            Translation :: get('Weight'),
            array("size" => "50", 'disabled' => 'disabled'));

        $elements[] = $this->createElement(
            'checkbox',
            ComplexFillInBlanksQuestion :: PROPERTY_RANDOM,
            Translation :: get('RandomizeAnswers'));

        $elements[] = $this->createElement(
            'radio',
            ComplexFillInBlanksQuestion :: PROPERTY_FEEDBACK_OPTIONS,
            Translation :: get('FeedbackOptions'),
            Translation :: get('FeedbackOptionsAll'),
            ComplexFillInBlanksQuestion :: FEEDBACK_OPTIONS_ALL);

        $elements[] = $this->createElement(
            'radio',
            ComplexFillInBlanksQuestion :: PROPERTY_FEEDBACK_OPTIONS,
            '',
            Translation :: get('FeedbackOptionsSelected'),
            ComplexFillInBlanksQuestion :: FEEDBACK_OPTIONS_SELECTED);

        $elements[] = $this->createElement(
            'checkbox',
            ComplexFillInBlanksQuestion :: PROPERTY_FEEDBACK_ANSWER,
            Translation :: get('FeedbackAnswer'));

        return $elements;
    }

    public function get_default_values()
    {
        $cloi = $this->get_complex_content_object_item();

        if (isset($cloi))
        {
            $defaults[ComplexFillInBlanksQuestion :: PROPERTY_WEIGHT] = $cloi->get_weight() ? $cloi->get_weight() : 0;
            $defaults[self :: PROPERTY_RECALCULATE_WEIGHT] = 1;
            $defaults[ComplexFillInBlanksQuestion :: PROPERTY_RANDOM] = $cloi->get_random() ? $cloi->get_random() : 0;
            $defaults[ComplexFillInBlanksQuestion :: PROPERTY_FEEDBACK_OPTIONS] = $cloi->get_feedback_options();
            $defaults[ComplexFillInBlanksQuestion :: PROPERTY_FEEDBACK_ANSWER] = $cloi->get_feedback_answer() ? $cloi->get_feedback_answer() : 0;
        }

        return $defaults;
    }

    // Inherited
    public function create_complex_content_object_item()
    {
        $cloi = $this->get_complex_content_object_item();
        $values = $this->exportValues();
        $cloi->set_weight($values[ComplexFillInBlanksQuestion :: PROPERTY_WEIGHT]);
        $cloi->set_random($values[ComplexFillInBlanksQuestion :: PROPERTY_RANDOM]);
        $cloi->set_feedback_options($values[ComplexFillInBlanksQuestion :: PROPERTY_FEEDBACK_OPTIONS]);
        $cloi->set_feedback_answer($values[ComplexFillInBlanksQuestion :: PROPERTY_FEEDBACK_ANSWER]);
        return parent :: create_complex_content_object_item();
    }

    public function create_cloi_from_values($values)
    {
        $cloi = $this->get_complex_content_object_item();
        $cloi->set_weight($values[ComplexFillInBlanksQuestion :: PROPERTY_WEIGHT]);
        $cloi->set_random($values[ComplexFillInBlanksQuestion :: PROPERTY_RANDOM]);
        $cloi->set_feedback_options($values[ComplexFillInBlanksQuestion :: PROPERTY_FEEDBACK_OPTIONS]);
        $cloi->set_feedback_answer($values[ComplexFillInBlanksQuestion :: PROPERTY_FEEDBACK_ANSWER]);
        return parent :: create_complex_content_object_item();
    }

    public function update_cloi_from_values($values)
    {
        $cloi = $this->get_complex_content_object_item();

        if ($values[self :: PROPERTY_RECALCULATE_WEIGHT] == 1)
        {
            $cloi->set_weight($cloi->get_ref_object()->get_default_weight());
        }
        else
        {
            $cloi->set_weight($values[ComplexFillInBlanksQuestion :: PROPERTY_WEIGHT]);
        }

        $cloi->set_random($values[ComplexFillInBlanksQuestion :: PROPERTY_RANDOM]);
        $cloi->set_feedback_options($values[ComplexFillInBlanksQuestion :: PROPERTY_FEEDBACK_OPTIONS]);
        $cloi->set_feedback_answer($values[ComplexFillInBlanksQuestion :: PROPERTY_FEEDBACK_ANSWER]);
        return parent :: update_complex_content_object_item();
    }

    // Inherited
    public function update_complex_content_object_item()
    {
        $cloi = $this->get_complex_content_object_item();
        $values = $this->exportValues();

        if ($values[self :: PROPERTY_RECALCULATE_WEIGHT] == 1)
        {
            $cloi->set_weight($cloi->get_ref_object()->get_default_weight());
        }
        else
        {
            $cloi->set_weight($values[ComplexFillInBlanksQuestion :: PROPERTY_WEIGHT]);
        }

        $cloi->set_random($values[ComplexFillInBlanksQuestion :: PROPERTY_RANDOM]);
        $cloi->set_feedback_options($values[ComplexFillInBlanksQuestion :: PROPERTY_FEEDBACK_OPTIONS]);
        $cloi->set_feedback_answer($values[ComplexFillInBlanksQuestion :: PROPERTY_FEEDBACK_ANSWER]);
        return parent :: update_complex_content_object_item();
    }
}
