<?php
namespace repository\content_object\forum;

use common\libraries\DelegateComponent;
use common\libraries\SubselectCondition;
use common\libraries\Translation;
use common\libraries\BreadcrumbTrail;
use common\libraries\EqualityCondition;
use common\libraries\AndCondition;
use repository\ContentObjectRenditionImplementation;
use repository\ContentObjectRendition;
use repository\ComplexBuilder;
use repository\ContentObject;
use repository\content_object\forum_post\ForumPost;
use repository\ComplexContentObjectItem;
use repository\ComplexBrowserTable;
use repository\content_object\forum_topic\ForumTopic;
use repository\content_object\forum_topic\ComplexForumTopic;
use repository\ContentObjectTypeSelectorSupport;

/**
 * $Id: browser.class.php 200 2009-11-13 12:30:04Z kariboe $
 *
 * @package repository.lib.complex_builder.forum.component
 */
class ForumBuilderBrowserComponent extends ForumBuilder implements ContentObjectTypeSelectorSupport, DelegateComponent
{

    public function run()
    {
        $menu_trail = $this->get_complex_content_object_breadcrumbs();
        $trail = BreadcrumbTrail :: get_instance();
        $trail->add_help('repository forum builder');

        if ($this->get_complex_content_object_item())
        {
            $content_object = \repository\DataManager :: retrieve_content_object(
                $this->get_complex_content_object_item()->get_ref());
        }
        else
        {
            $content_object = $this->get_root_content_object();
        }

        $this->display_header();
        echo ContentObjectRenditionImplementation :: launch(
            $content_object,
            ContentObjectRendition :: FORMAT_HTML,
            ContentObjectRendition :: VIEW_FULL,
            $this);
        echo '<br />';
        echo $this->get_creation_links($content_object);
        echo '<div class="clear">&nbsp;</div><br />';

        echo $this->get_table_html();

        echo '<div class="clear">&nbsp;</div>';

        $this->display_footer();
    }

    public function get_table_html()
    {
        $parameters = array(
            ComplexBuilder :: PARAM_COMPLEX_CONTENT_OBJECT_ITEM_ID => ($this->get_complex_content_object_item() ? $this->get_complex_content_object_item()->get_id() : null));
        $html = array();
        if ($this->get_complex_content_object_item())
        {
            $parameters[ComplexBuilder :: PARAM_COMPLEX_CONTENT_OBJECT_ITEM_ID] = $this->get_complex_content_object_item()->get_id();
        }

        // if ($this->get_complex_content_object_item() instanceof ComplexForumTopic)
        // {
        // $conditions = array();
        // $conditions[] = $this->get_complex_content_object_table_condition();
        // $subcondition = new EqualityCondition(ContentObject :: PROPERTY_TYPE, ForumPost :: class_name());
        // $conditions[] = new SubselectCondition(ComplexContentObjectItem :: PROPERTY_REF, ContentObject ::
        // PROPERTY_ID, 'content_object', $subcondition);
        // $condition = new AndCondition($conditions);

        // $html[] = '<h3>' . Translation :: get('Posts') . '</h3>';
        // $table = new ComplexBrowserTable($this, array_merge($this->get_parameters(), $parameters), $condition, true,
        // new ForumPostBrowserTableColumnModel($this), new ForumPostBrowserTableCellRenderer($this, $condition));
        // $html[] = $table->as_html();
        // }
        // else
        // {
        $conditions = array();
        $conditions[] = $this->get_complex_content_object_table_condition();
        $subcondition = new EqualityCondition(ContentObject :: PROPERTY_TYPE, Forum :: class_name());
        $conditions[] = new SubselectCondition(
            ComplexContentObjectItem :: PROPERTY_REF,
            ContentObject :: PROPERTY_ID,
            'content_object',
            $subcondition);
        $condition = new AndCondition($conditions);

        $html[] = '<h3>' . Translation :: get('Forums') . '</h3>';
        $table = new ComplexBrowserTable(
            $this,
            array_merge($this->get_parameters(), $parameters),
            $condition,
            true,
            null,
            null,
            'forum_table');
        $html[] = $table->as_html();

        $conditions = array();
        $conditions[] = $this->get_complex_content_object_table_condition();
        $subcondition = new EqualityCondition(ContentObject :: PROPERTY_TYPE, ForumTopic :: class_name());
        $conditions[] = new SubselectCondition(
            ComplexContentObjectItem :: PROPERTY_REF,
            ContentObject :: PROPERTY_ID,
            'content_object',
            $subcondition);
        $condition = new AndCondition($conditions);

        $html[] = '<br /><h3>' . Translation :: get('ForumTopics') . '</h3>';
        $table = new ComplexBrowserTable(
            $this,
            array_merge($this->get_parameters(), $parameters),
            $condition,
            true,
            new ForumBrowserTableColumnModel($this),
            new ForumBrowserTableCellRenderer($this, $condition),
            'topic_table');
        $html[] = $table->as_html();
        // }

        return implode("\n", $html);
    }

    public function get_content_object_type_creation_url($type)
    {
        return $this->get_url(
            array(
                ComplexBuilder :: PARAM_BUILDER_ACTION => ComplexBuilder :: ACTION_CREATE_COMPLEX_CONTENT_OBJECT_ITEM,
                ComplexBuilder :: PARAM_TYPE => $type,
                ComplexBuilder :: PARAM_COMPLEX_CONTENT_OBJECT_ITEM_ID => ($this->get_complex_content_object_item() ? $this->get_complex_content_object_item()->get_id() : null)));
    }

    public function get_user_id()
    {
    }
}
