<?php
namespace repository\content_object\forum;

use common\libraries\Utilities;
use common\libraries\Request;
use common\libraries\Translation;
use repository\ComplexBuilder;

/**
 * $Id: sticky.class.php 200 2009-11-13 12:30:04Z kariboe $
 * 
 * @package repository.lib.complex_builder.forum.component
 */
class ForumBuilderStickyComponent extends ForumBuilder
{

    public function run()
    {
        $topic = \repository\DataManager :: retrieve_complex_content_object_item(
                Request :: get(ComplexBuilder :: PARAM_SELECTED_COMPLEX_CONTENT_OBJECT_ITEM_ID));
        
        if ($topic->get_forum_type() == 1)
        {
            $topic->set_forum_type(null);
            $message = Translation :: get('TopicUnStickied');
        }
        else
        {
            $topic->set_forum_type(1);
            $message = Translation :: get('TopicStickied');
        }
        $success = $topic->update();
        
        if (! $success)
        {
            $message = Translation :: get('ObjectNotUpdated', array('OBJECT' => Translation :: get('ForumTopic')), 
                    Utilities :: COMMON_LIBRARIES);
        }
        
        $this->redirect($message, ($success ? false : true), 
                array(
                        ComplexBuilder :: PARAM_COMPLEX_CONTENT_OBJECT_ITEM_ID => Request :: get(
                                ComplexBuilder :: PARAM_COMPLEX_CONTENT_OBJECT_ITEM_ID), 
                        ComplexBuilder :: PARAM_BUILDER_ACTION => ComplexBuilder :: ACTION_BROWSE));
    }
}
