<?php
namespace repository\content_object\forum;

use repository\ComplexDisplay;
use common\libraries\Translation;

/**
 * Component class responsible for the subscribing process of a forum.
 *
 * @author Mattias De Pauw - Hogeschool Gent
 * @author Maarten Volckaert - Hogeschool Gent
 * ForumComplexDisplayForumSubscribeComponent
 */
class ForumComplexDisplayForumSubscribeComponent extends ForumComplexDisplay
{
    public function run()
    {
        $succes = false;
        
        $forum = $this->get_selected_complex_content_object_item();
        
       
        $params = array();
        $params[ComplexDisplay :: PARAM_DISPLAY_ACTION] = ForumComplexDisplay :: ACTION_VIEW_FORUM;
        $params[ComplexDisplay :: PARAM_SELECTED_COMPLEX_CONTENT_OBJECT_ITEM_ID] = $this->get_complex_content_object_item_id();

        $succes = DataManager :: create_subscribe($this->get_user_id(), $forum->get_ref());
        
        if($succes)
        {
            $message = Translation :: get("SuccesSubscribe");       
            $this->redirect($message, false , $params);
        }
        else
        {
            $message = Translation :: get("UnSuccesSubscribe");
            $this->redirect($message,true , $params);
        }
    }
}
