<?php
namespace repository\content_object\forum;

use repository\content_object\forum\DataManager;
use repository\ComplexDisplay;

use common\libraries\Request;
use common\libraries\Translation;

/**
 * Component class responsible for the unsubscrbing of a forum.
 *
 * @author Mattias De Pauw - Hogeschool Gent
 * @author Maarten Volckaert - Hogeschool Gent
 */
class ForumComplexDisplayForumUnsubscribeComponent extends ForumComplexDisplay
{
    /**
     * this function checks if their is a subscribe and if their is one deletes it 
     */
    public function run()
    {
        $succes = false;
        $subscribe_id = Request :: get(ForumComplexDisplay :: PARAM_SUBSCRIBE_ID);
        
        $params = array();
        $params[ComplexDisplay :: PARAM_DISPLAY_ACTION] = ForumComplexDisplay :: ACTION_VIEW_FORUM;
        $params[ComplexDisplay :: PARAM_COMPLEX_CONTENT_OBJECT_ITEM_ID] = $this->get_complex_content_object_item_id();
    
        if($subscribe_id)
        {
            $subscribe = DataManager :: retrieve_by_id(ForumSubscribe :: class_name(), $subscribe_id);
            $succes = $subscribe->delete();
            if($succes)
            {
                 $message = Translation :: get("SuccesUnSubscribe");
            }
            else
            {
                 $message = Translation :: get("UnSuccesUnSubscribe");
            }
        
        }else
        {
            $message = Translation :: get("UnSuccesUnSubscribe");
        }
       
        $this->redirect($message,($succes ? false : true ), $params);
    }
}
