<?php
namespace repository\content_object\glossary;

use repository\ComplexContentObjectItem;
use common\libraries\ObjectTableDataProvider;

/**
 * $Id: glossary_viewer_table_data_provider.class.php 200 2009-11-13 12:30:04Z kariboe $
 * 
 * @package repository.lib.complex_display.glossary.component.glossary_viewer
 */
/**
 * This class represents a data provider for a results candidate table
 */
class GlossaryViewerTableDataProvider extends ObjectTableDataProvider
{

    private $renderer;

    /**
     * Constructor.
     *
     * @param \common\libraries\ApplicationManagerComponent $renderer
     */
    public function __construct($renderer)
    {
        $this->renderer = $renderer;
    }
    
    /*
     * @inherited
     */
    public function get_objects($offset, $count, $order_property = null)
    {
        $order_property = $this->get_order_property($order_property);
        return $this->renderer->get_objects($offset, $count, $order_property);
    }

    /**
     * @inherited
     */
    public function get_object_count()
    {
        return $this->renderer->count_objects();
    }
}
