<?php
namespace repository\content_object\learning_path;

use repository\ContentObjectRendition;
use repository\ContentObjectRenditionImplementation;
use repository\ComplexDisplay;

/**
 *
 * @package repository.content_object.learning_path
 */
class LearningPathDocumentContentObjectDisplay extends LearningPathContentObjectDisplay
{

    public function display_content_object($content_object, $learning_path_item_attempt_data, $continue_url, $previous_url,
            $jump_urls)
    {
        $html = array();
        $html[] = $this->add_tracking_javascript();

        if ($content_object->is_showable())
        {
            $parameters = array();
            $parameters[ComplexDisplay :: PARAM_DISPLAY_ACTION] = LearningPathComplexDisplay :: ACTION_EMBED;
            $parameters[LearningPathDisplayEmbedder :: PARAM_EMBEDDER_ACTION] = LearningPathDisplayEmbedder :: ACTION_DOCUMENT;
            $parameters[self :: PARAM_EMBEDDED_CONTENT_OBJECT_ID] = $content_object->get_id();

            $html[] = $this->display_link($this->get_parent()->get_url($parameters));
        }
        else
        {
            $html[] = ContentObjectRenditionImplementation :: launch($content_object,
                    ContentObjectRendition :: FORMAT_HTML, ContentObjectRendition :: VIEW_FULL, $this);
        }

        return implode("\n", $html);
    }
}
