<?php
namespace repository\content_object\link\integration\core\home;

use common\libraries\PropertyConditionVariable;
use common\libraries\StaticConditionVariable;
use common\libraries\Translation;
use common\libraries\EqualityCondition;
use common\libraries\Session;

/**
 *
 * @package repository.content_object.link.block
 * @author Hans De Bisschop
 */
class Connector
{

    public function get_link_objects()
    {
        $options = array();
        $condition = new EqualityCondition(
            new PropertyConditionVariable(\repository\ContentObject::class_name(),
                \repository\ContentObject::PROPERTY_OWNER_ID),
            new StaticConditionVariable(Session::get_user_id())
        );
        $objects = \repository\DataManager :: retrieve_active_content_objects(
                \repository\content_object\link\Link :: class_name(), $condition);

        if ($objects->size() == 0)
        {
            $options[0] = Translation :: get('CreateLinkFirst');
        }
        else
        {
            while ($object = $objects->next_result())
            {
                $options[$object->get_id()] = $object->get_title();
            }
        }

        return $options;
    }
}
