<?php
namespace repository\content_object\mediamosa;

use common\extensions\external_repository_manager\implementation\mediamosa\DataConnector;
use common\libraries\EqualityCondition;
use repository\ExternalSync;
use repository\ContentObjectRenditionImplementation;

class RenditionImplementation extends ContentObjectRenditionImplementation
{
    private $mediamosa_object;

    private $mediamosa_external_repository_manager_connector;

    private $connection_lost;

    public function set_mediamosa_object()
    {
        if (! $this->mediamosa_external_repository_manager_connector)
        {
            $object = $this->get_content_object();

            $condition = new EqualityCondition(ExternalSync :: PROPERTY_CONTENT_OBJECT_ID, $object->get_id());
            $sync = \repository\DataManager :: retrieve_external_sync($condition);

            $external_repository = $sync->get_external();
            $this->mediamosa_external_repository_manager_connector = DataConnector :: get_instance($external_repository);
        }

        if (! $this->mediamosa_object)
        {
            if (! $this->mediamosa_object = $this->mediamosa_external_repository_manager_connector->retrieve_mediamosa_asset(
                $sync->get_external_object_id()))
            {
                $this->connection_lost = true;
            }
        }
    }

    public function get_mediamosa_object()
    {
        return $this->mediamosa_object;
    }

    public function get_mediamosa_external_repository_manager_connector()
    {
        return $this->mediamosa_external_repository_manager_connector;
    }

    public function is_connection_lost()
    {
        return $this->connection_lost;
    }
}
