<?php
namespace repository\content_object\portfolio;

class Autoloader
{

    /**
     * The array mapping class names to paths
     *
     * @var multitype:string
     */
     private static $map = array(
         'Autoloader' => '/autoloader.class.php',
         'PortfolioDifference' => '/lib/difference.class.php',
         'PortfolioDifferenceDisplay' => '/lib/difference_display.class.php',
         'PortfolioDisplay' => '/lib/display.class.php',
         'PortfolioBuilder' => '/lib/builder/portfolio_builder.class.php',
         'PortfolioBuilderBrowserComponent' => '/lib/builder/component/browser.class.php',
         'PortfolioBuilderCreatorComponent' => '/lib/builder/component/creator.class.php',
         'PortfolioBuilderDeleterComponent' => '/lib/builder/component/deleter.class.php',
         'PortfolioBuilderMoverComponent' => '/lib/builder/component/mover.class.php',
         'PortfolioBuilderParentChangerComponent' => '/lib/builder/component/parent_changer.class.php',
         'PortfolioBuilderPreviewComponent' => '/lib/builder/component/preview.class.php',
         'PortfolioBuilderUpdaterComponent' => '/lib/builder/component/updater.class.php',
         'PortfolioBuilderViewerComponent' => '/lib/builder/component/viewer.class.php',
         'PortfolioBrowserTableCellRenderer' => '/lib/builder/component/browser/portfolio_browser_table_cell_renderer.class.php',
         'PortfolioComplexDisplayPreview' => '/lib/complex_display/portfolio_complex_display_preview.class.php',
         'ComplexPortfolio' => '/lib/data_class/complex_content_object_item.class.php',
         'Portfolio' => '/lib/data_class/content_object.class.php',
         'DataManager' => '/lib/data_manager/data_manager.class.php',
         'DataManagerInterface' => '/lib/data_manager/data_manager_interface.class.php',
         'DoctrineDataManager' => '/lib/data_manager/implementation/doctrine.class.php',
         'Mdb2DataManager' => '/lib/data_manager/implementation/mdb2.class.php',
         'ComplexPortfolioForm' => '/lib/form/complex_content_object_item.class.php',
         'PortfolioForm' => '/lib/form/content_object.class.php',
         'Activator' => '/package/activate/activator.class.php',
         'Deactivator' => '/package/deactivate/deactivator.class.php',
         'Installer' => '/package/install/installer.class.php',
         'Remover' => '/package/remove/remover.class.php'
    );

    /**
     * Try to load the class
     *
     * @param $classname string
     * @return boolean
     */
    public static function load($classname)
    {
        if (isset(self :: $map[$classname]))
        {
            require_once __DIR__ . self :: $map[$classname];
            return true;
        }

        return false;
    }

    /**
     * Synchronize the autoloader
     *
     * @param $update boolean
     * @return multitype:string
     */
    public static function synch($update)
    {
        return \common\libraries\AutoloaderUtilities :: synch(__DIR__, __DIR__, $update);
    }

}
?>