<?php
namespace repository\content_object\portfolio;

use repository\content_object\document\Document;
use repository\content_object\page\Page;
use repository\content_object\webpage\Webpage;
use common\libraries\Utilities;
use common\libraries\ComplexContentObjectSupport;
use repository\ContentObject;
use repository\content_object\portfolio_item\PortfolioItem;
use repository\content_object\file\File;
use repository\content_object\link\Link;
use repository\content_object\youtube\Youtube;
use repository\content_object\rss_feed\RssFeed;

/**
 * $Id: portfolio.class.php 200 2009-11-13 12:30:04Z kariboe $
 *
 * @package repository.lib.content_object.portfolio
 */
/**
 * This class represents an portfolio
 */
class Portfolio extends ContentObject implements ComplexContentObjectSupport
{
    const CLASS_NAME = __CLASS__;

    public static function get_type_name()
    {
        return Utilities :: camelcase_to_underscores(Utilities :: get_classname_from_namespace(self :: CLASS_NAME));
    }

    public function get_allowed_types()
    {
        return array(Portfolio :: class_name(), PortfolioItem :: class_name());
    }

    public function get_allowed_content()
    {
        $types = array(Document :: class_name(), Portfolio :: class_name(), Link :: class_name(), Youtube :: class_name(),
                RssFeed :: class_name());

        $optional_types = array( File :: class_name(), Webpage :: class_name(),
                Page :: class_name());

        foreach ($optional_types as $optional_type)
        {
            if (ContentObject :: is_available($optional_type))
            {
                $types[] = $optional_type;
            }
        }

        return $types;
    }
}
