<?php
namespace repository\content_object\rss_feed;

use common\libraries\Path;
use common\libraries\RssReader;
use common\libraries\Translation;
use common\libraries\Theme;

class HtmlInlineRenditionImplementation extends HtmlRenditionImplementation
{

    public function render()
    {
        $object = $this->get_content_object();
        $html = array();

        $html[] = '<div class="content_object" style="background-image: url(' . $object->get_icon_path() . ');">';
        $html[] = '<div class="title">' . Translation :: get('Description') . '</div>';
        // $html[] = ContentObjectRendition ::
        // factory($this)->get_description();
        $html[] = '<div class="link_url" style="margin-top: 1em;"><a href="' . htmlentities($object->get_url()) . '">' . htmlentities($object->get_url()) . '</a></div>';
        $html[] = '</div>';

        $feed = self :: parse_file($object->get_url());

        foreach ($feed['items'] as $item)
        {
            $html[] = '<div class="content_object" style="background-image: url(' . Theme :: get_image_path() . 'logo/22_item.png);">';
            $html[] = '<div class="title">' . $item['title'] . '</div>';
            $html[] = html_entity_decode($item['description']);
            $html[] = '<div class="link_url" style="margin-top: 1em;"><a href="' . htmlentities($item['link']) . '">' . htmlentities($item['link']) . '</a></div>';
            $html[] = '</div>';
        }

        return implode("\n", $html);
    }

    public static function parse_file($url)
    {
        $rss_reader = RssReader :: factory();
        return $rss_reader->parse_url($url);
    }
}
