<?php
namespace repository\content_object\scorm_item;

class Autoloader
{

    /**
     * The array mapping class names to paths
     *
     * @var multitype:string
     */
     private static $map = array(
         'Autoloader' => '/autoloader.class.php',
         'ScormItemDifference' => '/lib/difference.class.php',
         'ScormItemDifferenceDisplay' => '/lib/difference_display.class.php',
         'ScormItemDisplay' => '/lib/display.class.php',
         'ConditionRule' => '/lib/condition_rules/condition_rule.class.php',
         'ConditionRules' => '/lib/condition_rules/condition_rules.class.php',
         'RuleCondition' => '/lib/condition_rules/rule_condition.class.php',
         'ComplexScormItem' => '/lib/data_class/complex_content_object_item.class.php',
         'ScormItem' => '/lib/data_class/content_object.class.php',
         'DataManager' => '/lib/data_manager/data_manager.class.php',
         'DataManagerInterface' => '/lib/data_manager/data_manager_interface.class.php',
         'DoctrineDataManager' => '/lib/data_manager/implementation/doctrine.class.php',
         'Mdb2DataManager' => '/lib/data_manager/implementation/mdb2.class.php',
         'ComplexScormItemForm' => '/lib/form/complex_content_object_item.class.php',
         'ScormItemForm' => '/lib/form/content_object.class.php',
         'Objective' => '/lib/objectives/objective.class.php',
         'Objectives' => '/lib/objectives/objectives.class.php',
         'Activator' => '/package/activate/activator.class.php',
         'Deactivator' => '/package/deactivate/deactivator.class.php',
         'Installer' => '/package/install/installer.class.php',
         'Remover' => '/package/remove/remover.class.php'
    );

    /**
     * Try to load the class
     *
     * @param $classname string
     * @return boolean
     */
    public static function load($classname)
    {
        if (isset(self :: $map[$classname]))
        {
            require_once __DIR__ . self :: $map[$classname];
            return true;
        }

        return false;
    }

    /**
     * Synchronize the autoloader
     *
     * @param $update boolean
     * @return multitype:string
     */
    public static function synch($update)
    {
        return \common\libraries\AutoloaderUtilities :: synch(__DIR__, __DIR__, $update);
    }

}
?>