<?php
namespace repository\content_object\slideshare;

use common\libraries\Utilities;
use common\libraries\Versionable;
use repository\ContentObject;
use common\libraries\EqualityCondition;
use repository\ExternalInstance;
use common\libraries\AndCondition;

/**
 * $Id: slideshare.class.php 200 2009-11-13 12:30:04Z kariboe $
 *
 * @package repository.lib.content_object.slideshare
 */
class Slideshare extends ContentObject implements Versionable
{
    const CLASS_NAME = __CLASS__;
    const PROPERTY_EMBED = 'embed';

    public static function get_type_name()
    {
        return Utilities :: get_classname_from_namespace(self :: CLASS_NAME, true);
    }

    public function get_embed()
    {
        $default = $this->get_synchronization_data()->get_external_object()->get_default_properties();
        return $default['embed'];
    }

    public static function is_type_available()
    {
        $conditions = array();
        $conditions[] = new EqualityCondition(
            ExternalInstance :: PROPERTY_TYPE,
            \common\extensions\external_repository_manager\Manager :: get_namespace('slideshare'));
        $conditions[] = new EqualityCondition(ExternalInstance :: PROPERTY_ENABLED, 1);
        $condition = new AndCondition($conditions);

        $external_repositories = \repository\DataManager :: retrieves(ExternalInstance :: class_name(), $condition);
        return $external_repositories->size() == 1;
    }
}
