<?php
namespace repository\content_object\slideshare;

use common\libraries\Translation;
use common\libraries\Utilities;
use repository\ContentObjectForm;
use repository\ExternalSync;

/**
 * $Id: slideshare_form.class.php 200 2009-11-13 12:30:04Z kariboe $
 * 
 * @package repository.lib.content_object.slideshare
 */
class SlideshareForm extends ContentObjectForm
{

    protected function build_creation_form()
    {
        parent :: build_creation_form();
        $this->addElement('category', Translation :: get('Properties'));
        
        $external_repositories = \repository\ExternalRepositoryComponent :: get_links(
                array(\common\extensions\external_repository_manager\Manager :: context()), 
                array(Slideshare :: context()), true);
        if ($external_repositories)
        {
            $this->addElement('static', null, null, $external_repositories);
        }
        
        $this->addElement('hidden', ExternalSync :: PROPERTY_EXTERNAL_ID);
        $this->addElement('hidden', ExternalSync :: PROPERTY_EXTERNAL_OBJECT_ID);
        
        $this->addElement('category');
    }

    protected function build_editing_form()
    {
        parent :: build_creation_form();
    }

    public function setDefaults($defaults = array ())
    {
        parent :: setDefaults($defaults);
    }

    public function create_content_object()
    {
        $object = new Slideshare();
        $this->set_content_object($object);
        
        $success = parent :: create_content_object();
        
        if ($success)
        {
            $external_repository_id = (int) $this->exportValue(ExternalSync :: PROPERTY_EXTERNAL_ID);
            
            $external_respository_sync = new ExternalSync();
            $external_respository_sync->set_external_id($external_repository_id);
            $external_respository_sync->set_external_object_id(
                    (string) $this->exportValue(ExternalSync :: PROPERTY_EXTERNAL_OBJECT_ID));
            $external_object = $external_respository_sync->get_external_object();
            
            ExternalSync :: quicksave($object, $external_object, $external_repository_id);
        }
        
        return $success;
    }

    public function update_content_object()
    {
        $object = $this->get_content_object();
        return parent :: update_content_object();
    }
}
