<?php
namespace repository\content_object\soundcloud;

class Autoloader
{

    /**
     * The array mapping class names to paths
     *
     * @var multitype:string
     */
     private static $map = array(
         'Autoloader' => '/autoloader.class.php',
         'SoundcloudDifference' => '/lib/difference.class.php',
         'SoundcloudDifferenceDisplay' => '/lib/difference_display.class.php',
         'SoundcloudDisplay' => '/lib/display.class.php',
         'ComplexSoundcloud' => '/lib/data_class/complex_content_object_item.class.php',
         'Soundcloud' => '/lib/data_class/content_object.class.php',
         'DataManager' => '/lib/data_manager/data_manager.class.php',
         'DataManagerInterface' => '/lib/data_manager/data_manager_interface.class.php',
         'DoctrineDataManager' => '/lib/data_manager/implementation/doctrine.class.php',
         'Mdb2DataManager' => '/lib/data_manager/implementation/mdb2.class.php',
         'ComplexSoundcloudForm' => '/lib/form/complex_content_object_item.class.php',
         'SoundcloudForm' => '/lib/form/content_object.class.php',
         'RenditionImplementation' => '/lib/implementation/rendition.class.php',
         'HtmlRenditionImplementation' => '/lib/implementation/rendition/html.class.php',
         'HtmlDescriptionRenditionImplementation' => '/lib/implementation/rendition/html/description.class.php',
         'HtmlInlineRenditionImplementation' => '/lib/implementation/rendition/html/inline.class.php',
         'HtmlPreviewRenditionImplementation' => '/lib/implementation/rendition/html/preview.class.php',
         'HtmlShortRenditionImplementation' => '/lib/implementation/rendition/html/short.class.php',
         'HtmlThumbnailRenditionImplementation' => '/lib/implementation/rendition/html/thumbnail.class.php',
         'Activator' => '/package/activate/activator.class.php',
         'Deactivator' => '/package/deactivate/deactivator.class.php',
         'Installer' => '/package/install/installer.class.php',
         'Remover' => '/package/remove/remover.class.php'
    );

    /**
     * Try to load the class
     *
     * @param $classname string
     * @return boolean
     */
    public static function load($classname)
    {
        if (isset(self :: $map[$classname]))
        {
            require_once __DIR__ . self :: $map[$classname];
            return true;
        }

        return false;
    }

    /**
     * Synchronize the autoloader
     *
     * @param $update boolean
     * @return multitype:string
     */
    public static function synch($update)
    {
        return \common\libraries\AutoloaderUtilities :: synch(__DIR__, __DIR__, $update);
    }

}
?>