<?php
namespace repository\content_object\system_announcement;

use common\libraries\Session;
use common\libraries\AjaxManager;
use common\libraries\JsonAjaxResult;

class SystemAnnouncementAjaxClearParameter extends AjaxManager
{
    const PARAM_PARAMETER = 'parameter';

    /* (non-PHPdoc)
     * @see common\libraries.AjaxManager::required_parameters()
     */
    public function required_parameters()
    {
        return array(self :: PARAM_PARAMETER);
    }

    /* (non-PHPdoc)
     * @see common\libraries.AjaxManager::run()
     */
    public function run()
    {
        $parameter = $this->get_parameter(self :: PARAM_PARAMETER);
        $parameter = explode('_', $parameter, 3);

        $session = unserialize(Session :: retrieve('advanced_filter'));

        if ($parameter[1] == 'system_announcement')
        {
            switch ($parameter[2])
            {
                case 'icon' :
                    unset($session[SystemAnnouncement :: PROPERTY_ICON]);
                    break;
            }

            Session :: register('advanced_filter', serialize($session));
            JsonAjaxResult :: success();
        }
        else
        {
            JsonAjaxResult :: bad_request();
        }
    }
}
