<?php
namespace repository\content_object\template;

use common\libraries\Translation;

use repository\ContentObjectForm;

/**
 * $Id: template_form.class.php 200 2009-11-13 12:30:04Z kariboe $
 * @package repository.lib.content_object.template
 */
/**
 * This class represents a form to create or update templates
 */
class TemplateForm extends ContentObjectForm
{

    protected function build_creation_form()
    {
        parent :: build_creation_form();
        $this->addElement('category', Translation :: get('Properties'));
        $this->build_default_form();
        $this->addElement('category');
    }

    protected function build_editing_form()
    {
        parent :: build_editing_form();
        $this->addElement('category', Translation :: get('Properties'));
        $this->build_default_form();
        $this->addElement('category');
    }

    private function build_default_form()
    {
        $this->add_html_editor(Template :: PROPERTY_DESIGN, Translation :: get('Design'), false);

    }

    public function setDefaults($defaults = array())
    {
        $lo = $this->get_content_object();
        if (isset($lo))
        {
            $defaults[Template :: PROPERTY_DESIGN] = $lo->get_design();
        }

        parent :: setDefaults($defaults);
    }

    public function create_content_object()
    {
        $values = $this->exportValues();

        $object = new Template();
        $object->set_design($values[Template :: PROPERTY_DESIGN]);
        parent :: set_content_object($object);
        return parent :: create_content_object();
    }

    public function update_content_object()
    {
        $values = $this->exportValues();

        $object = $this->get_content_object();
        $object->set_design($values[Template :: PROPERTY_DESIGN]);
        parent :: set_content_object($object);
        return parent :: update_content_object();
    }
}
