<?php
namespace repository\content_object\webpage;

class Autoloader
{

    /**
     * The array mapping class names to paths
     *
     * @var multitype:string
     */
     private static $map = array(
         'Autoloader' => '/autoloader.class.php',
         'WebpageAjaxClearParameter' => '/ajax/clear_parameter.class.php',
         'AdvancedFilter' => '/lib/advanced_filter.class.php',
         'WebpageDifference' => '/lib/difference.class.php',
         'WebpageDifferenceDisplay' => '/lib/difference_display.class.php',
         'WebpageDisplay' => '/lib/display.class.php',
         'RepositoryBrowserTable' => '/lib/browser/repository_browser_table.class.php',
         'RepositoryBrowserTableCellRenderer' => '/lib/browser/repository_browser_table_cell_renderer.class.php',
         'RepositoryBrowserTableColumnModel' => '/lib/browser/repository_browser_table_column_model.class.php',
         'RepositoryBrowserTableDataProvider' => '/lib/browser/repository_browser_table_data_provider.class.php',
         'ComplexWebpage' => '/lib/data_class/complex_content_object_item.class.php',
         'Webpage' => '/lib/data_class/content_object.class.php',
         'DataManager' => '/lib/data_manager/data_manager.class.php',
         'DataManagerInterface' => '/lib/data_manager/data_manager_interface.class.php',
         'DoctrineDataManager' => '/lib/data_manager/implementation/doctrine.class.php',
         'Mdb2DataManager' => '/lib/data_manager/implementation/mdb2.class.php',
         'ComplexWebpageForm' => '/lib/form/complex_content_object_item.class.php',
         'WebpageForm' => '/lib/form/content_object.class.php',
         'ExportImplementation' => '/lib/implementation/export.class.php',
         'ImportImplementation' => '/lib/implementation/import.class.php',
         'RenditionImplementation' => '/lib/implementation/rendition.class.php',
         'CpoExportImplementation' => '/lib/implementation/export/cpo.class.php',
         'ZipExportImplementation' => '/lib/implementation/export/zip.class.php',
         'CpoDefaultExportImplementation' => '/lib/implementation/export/cpo/default.class.php',
         'ZipDefaultExportImplementation' => '/lib/implementation/export/zip/default.class.php',
         'CpoImportImplementation' => '/lib/implementation/import/cpo.class.php',
         'HtmlRenditionImplementation' => '/lib/implementation/rendition/html.class.php',
         'JsonRenditionImplementation' => '/lib/implementation/rendition/json.class.php',
         'HtmlDescriptionRenditionImplementation' => '/lib/implementation/rendition/html/description.class.php',
         'HtmlInlineRenditionImplementation' => '/lib/implementation/rendition/html/inline.class.php',
         'HtmlShortRenditionImplementation' => '/lib/implementation/rendition/html/short.class.php',
         'JsonImageRenditionImplementation' => '/lib/implementation/rendition/json/image.class.php',
         'Activator' => '/package/activate/activator.class.php',
         'Deactivator' => '/package/deactivate/deactivator.class.php',
         'Installer' => '/package/install/installer.class.php',
         'Remover' => '/package/remove/remover.class.php'
    );

    /**
     * Try to load the class
     *
     * @param $classname string
     * @return boolean
     */
    public static function load($classname)
    {
        if (isset(self :: $map[$classname]))
        {
            require_once __DIR__ . self :: $map[$classname];
            return true;
        }

        return false;
    }

    /**
     * Synchronize the autoloader
     *
     * @param $update boolean
     * @return multitype:string
     */
    public static function synch($update)
    {
        return \common\libraries\AutoloaderUtilities :: synch(__DIR__, __DIR__, $update);
    }

}
?>