<?php
namespace repository\content_object\wiki;

use common\libraries\Request;
use common\libraries\Translation;
use common\libraries\Utilities;
use common\libraries\ObjectTable;
use common\libraries\ObjectTableFormActions;
use common\libraries\ObjectTableFormAction;
use repository\ComplexDisplay;

/**
 * $Id: wiki_page_table.class.php 200 2009-11-13 12:30:04Z kariboe $
 * @package repository.lib.complex_display.wiki.component.wiki_page_table
 */

class WikiPageTable extends ObjectTable
{

    /**
     * Constructor.
     */
    public function __construct($browser, $condition)
    {
        $model = new WikiPageTableColumnModel();
        $renderer = new WikiPageTableCellRenderer($browser);
        $data_provider = new WikiPageTableDataProvider($browser, $condition);
        parent :: __construct(
            $data_provider, Utilities :: get_classname_from_namespace(__CLASS__, true), $model, $renderer
        );

        $actions = new ObjectTableFormActions(__NAMESPACE__, ComplexDisplay :: PARAM_DISPLAY_ACTION);

        $actions->add_form_action(
            new ObjectTableFormAction(
                ComplexDisplay :: ACTION_DELETE_COMPLEX_CONTENT_OBJECT_ITEM, Translation :: get(
                    'RemoveSelected', null, Utilities :: COMMON_LIBRARIES
                )
            )
        );
        $this->set_form_actions($actions);

    }

    public function handle_table_action()
    {
        $class = Utilities :: get_classname_from_namespace(__CLASS__, true);
        $ids = self :: get_selected_ids($class);
        Request :: set_get(ComplexDisplay :: PARAM_SELECTED_COMPLEX_CONTENT_OBJECT_ITEM_ID, $ids);
    }
}
