<?php
namespace repository\integration\core\home;

use common\libraries\Translation;

/**
 * Block to display streaming media.
 *
 * @copyright (c) 2011 University of Geneva
 * @license GNU General Public License - http://www.gnu.org/copyleft/gpl.html
 * @author lopprecht
 */
class Streaming extends Block
{

    /**
     * Returns the list of type names that this block can map to.
     *
     * @return array
     */
    public static function get_supported_types()
    {
        $result = array();
        /*
         * $result[] = Dailymotion :: get_type_name(); $result[] = Matterhorn :: get_type_name(); $result[] = Mediamosa
         * :: get_type_name(); $result[] = Slideshare :: get_type_name(); $result[] = Soundcloud :: get_type_name();
         * $result[] = Vimeo :: get_type_name(); $result[] = Youtube :: get_type_name();
         */

        $result[] = 'repository\content_object\daily_motion\DailyMotion';
        $result[] = 'repository\content_object\matternhorn\Matterhorn';
        $result[] = 'repository\content_object\mediamosa\Mediamosa';
        $result[] = 'repository\content_object\slideshare\slideshare';
        $result[] = 'repository\content_object\soundcloud\Soundcloud';
        $result[] = 'repository\content_object\vimeo\Vimeo';
        $result[] = 'repository\content_object\youtube\Youtube';

        return $result;
    }

    public function __construct($parent, $block_info, $configuration)
    {
        parent :: __construct($parent, $block_info, $configuration);
        $this->default_title = Translation :: get('Streaming');
    }

    public function is_visible()
    {
        return true; // i.e.display on homepage when anonymous
    }

    /**
     * Returns the html to display when the block is configured.
     *
     * @return string
     */
    public function display_content()
    {
        $content_object = $this->get_object();

        $rendition_implementation = \repository\ContentObjectRenditionImplementation :: factory($content_object,
                \repository\ContentObjectRendition :: FORMAT_HTML, \repository\ContentObjectRendition :: VIEW_DESCRIPTION,
                $this);
        $rendition = \repository\ContentObjectRendition :: factory($rendition_implementation);

        return $rendition->render();
    }
}
