<?php
namespace repository\integration\core\home;

use common\libraries\Translation;
use repository\ContentObjectRendition;
use repository\ContentObjectRenditionImplementation;

/**
 * Description of twitter
 *
 * @copyright (c) 2011 University of Geneva
 * @license GNU General Public License - http://www.gnu.org/copyleft/gpl.html
 * @author laurent opprecht
 */
class TwitterSearch extends Block
{

    public function __construct($parent, $block_info, $configuration)
    {
        parent :: __construct($parent, $block_info, $configuration);
        $this->default_title = Translation :: get('TwitterSearch');
    }

    /**
     * Returns the list of type names that this block can map to.
     *
     * @return array
     */
    public static function get_supported_types()
    {
        $result = array();
        $result[] = \repository\content_object\twitter_search\TwitterSearch :: class_name();
        return $result;
    }

    public function is_visible()
    {
        return true; // i.e.display on homepage when anonymous
    }

    public function get_scrollbar()
    {
        return (bool) $this->get('scrollbar');
    }

    public function get_loop()
    {
        return (bool) $this->get('loop');
    }

    public function get_live()
    {
        return (bool) $this->get('live');
    }

    public function get_hashtags()
    {
        return (bool) $this->get('hashtags');
    }

    public function get_timestamp()
    {
        return (bool) $this->get('timestamp');
    }

    public function get_avatars()
    {
        return (bool) $this->get('avatars');
    }

    public function get_toptweets()
    {
        return (bool) $this->get('toptweets');
    }

    public function display_content()
    {
        $content_object = $this->get_object();
        $rendition_implementation = ContentObjectRenditionImplementation :: factory($content_object,
                ContentObjectRendition :: FORMAT_HTML, ContentObjectRendition :: VIEW_DESCRIPTION, $this);
        $scrollbar = $this->get_scrollbar();
        $loop = $this->get_loop();
        $live = $this->get_live();
        $hashtags = $this->get_hashtags();
        $timestamp = $this->get_timestamp();
        $avatars = $this->get_avatars();
        $toptweets = $this->get_toptweets();
        return $rendition_implementation->get_widget($scrollbar, $loop, $live, $hashtags, $timestamp, $avatars,
                $toptweets);
    }
}
