<?php
namespace repository\integration\webservice;

use common\libraries\Translation;
use common\libraries\EqualityCondition;
use common\libraries\DeleteObjectWebserviceHandler;

class CategoryDeleteWebserviceHandler extends DeleteObjectWebserviceHandler
{

    public function get_object()
    {
        return \repository\DataManager :: retrieve_categories(
                new EqualityCondition(\repository\RepositoryCategory :: PROPERTY_ID, $this->get_id()))->next_result();
    }

    public function get_object_translation()
    {
        return Translation :: get('Category');
    }

    public function is_allowed_to_delete_object($object)
    {
        return ($this->get_user()->is_platform_admin() || $object->get_user_id() == $this->get_user_id());
    }
}
