<?php
namespace repository\integration\webservice;

use common\libraries\Translation;
use common\libraries\CreateObjectWebserviceHandler;

class ContentObjectAttachmentCreateWebserviceHandler extends CreateObjectWebserviceHandler
{

    public function get_object()
    {
        return new \repository\ContentObjectAttachment();
    }

    public function get_object_translation()
    {
        return Translation :: get('ContentObjectAttachment');
    }

    public function manipulate_data($object, $extra_properties = null)
    {
        return $object;
    }

    public function is_allowed_to_create_object($object)
    {
        if ($this->get_user()->is_platform_admin())
        {
            return true;
        }
        $content_object = \repository\DataManager :: retrieve_content_object($object->get_content_object_id());
        if ($content_object->get_owner_id() != $this->get_user_id())
        {
            return false;
        }
        $attachment = \repository\DataManager :: retrieve_content_object($object->get_attachment_id());
        if ($attachment->get_owner_id() != $this->get_user_id())
        {
            return false;
        }
        return true;
    }
}
