<?php
namespace repository;

use common\libraries\Translation;
use common\libraries\JsonAjaxResult;
use common\libraries\Session;
use common\libraries\AjaxManager;

class RepositoryAjaxCheckCategoryName extends AjaxManager
{
    const PARAM_NAME = 'name';
    const PARAM_PARENT_ID = 'parent_id';
    
    /*
     * (non-PHPdoc) @see common\libraries.AjaxManager::required_parameters()
     */
    public function required_parameters()
    {
        return array(self :: PARAM_NAME, self :: PARAM_PARENT_ID);
    }
    
    /*
     * (non-PHPdoc) @see common\libraries.AjaxManager::run()
     */
    public function run()
    {
        $category_name = $this->get_parameter(self :: PARAM_NAME);
        $parent_id = $this->get_parameter(self :: PARAM_PARENT_ID);
        
        if (! DataManager :: check_category_name(Session :: get_user_id(), $parent_id, $category_name))
        {
            JsonAjaxResult :: success();
        }
        else
        {
            JsonAjaxResult :: error(409, Translation :: get('CategoryAlreadyExists'));
        }
    }
}
