<?php
namespace repository;

use common\libraries\AjaxManager;
use common\libraries\JsonAjaxResult;

class RepositoryAjaxRenditionImplementation extends AjaxManager
{
    const PARAM_CONTENT_OBJECT_ID = 'content_object_id';
    const PARAM_FORMAT = 'format';
    const PARAM_VIEW = 'view';
    const PARAM_PARAMETERS = 'parameters';
    
    const PROPERTY_RENDITION = 'rendition';

    /* (non-PHPdoc)
     * @see common\libraries.AjaxManager::required_parameters()
     */
    public function required_parameters()
    {
        return array(self :: PARAM_CONTENT_OBJECT_ID, self :: PARAM_FORMAT, self :: PARAM_VIEW, self :: PARAM_PARAMETERS);
    }

    /* (non-PHPdoc)
     * @see common\libraries.AjaxManager::run()
     */
    public function run()
    {
        $object = \repository\DataManager :: retrieve_content_object($this->get_parameter(self :: PARAM_CONTENT_OBJECT_ID));
        $display = ContentObjectRenditionImplementation :: factory($object, $this->get_parameter(self :: PARAM_FORMAT), $this->get_parameter(self :: PARAM_VIEW), $this);
        
        $result = new JsonAjaxResult(200);
        $result->set_property(self :: PROPERTY_RENDITION, $display->render($this->get_parameter(self :: PARAM_PARAMETERS)));
        $result->display();
    }
}
