<?php
namespace repository;

use common\libraries\ObjectTableOrder;
use common\libraries\DataClassRetrievesParameters;
use common\libraries\StaticConditionVariable;
use common\libraries\PropertyConditionVariable;
use common\libraries\Utilities;
use common\libraries\Authentication;
use common\libraries\Request;
use common\libraries\EqualityCondition;
use common\libraries\Session;
use common\libraries\AndCondition;
use common\libraries\OrCondition;
use common\libraries\PatternMatchCondition;

/**
 * $Id: search_complete.php 200 2009-11-13 12:30:04Z kariboe $
 *
 * @package repository.ajax
 */
require_once dirname(__FILE__) . '/../../../common/global.inc.php';

$response = array();

if (Authentication :: is_valid())
{
    $query = Request :: get('term');

    $conditions = array();
    // $conditions[] = new EqualityCondition(ContentObject :: PROPERTY_PARENT_ID, $this->get_parent_id());
    $conditions[] = new EqualityCondition(
        new PropertyConditionVariable(ContentObject :: class_name(), ContentObject :: PROPERTY_OWNER_ID),
        new StaticConditionVariable(Session :: get_user_id()));
    $or_conditions[] = new PatternMatchCondition(
        new PropertyConditionVariable(ContentObject :: class_name(), ContentObject :: PROPERTY_TITLE),
        '*' . $query . '*');
    $or_conditions[] = new PatternMatchCondition(
        new PropertyConditionVariable(ContentObject :: class_name(), ContentObject :: PROPERTY_DESCRIPTION),
        '*' . $query . '*');
    $conditions[] = new OrCondition($or_conditions);
    $condition = new AndCondition($conditions);

    $parameters = new DataClassRetrievesParameters(
        $condition,
        null,
        null,
        array(new ObjectTableOrder(ContentObject :: PROPERTY_TITLE)));
    $objects = DataManager :: retrieve_active_content_objects(ContentObject :: class_name(), $parameters);

    while ($object = $objects->next_result())
    {
        $response[] = array(
            'id' => $object->get_id(),
            'label' => Utilities :: truncate_string($object->get_title(), 23),
            'value' => $object->get_title());
    }
}

echo json_encode($response);
