<?php
namespace repository;

class Autoloader
{

    /**
     * The array mapping class names to paths
     *
     * @var multitype:string
     */
    private static $map = array(
        'Autoloader' => '/autoloader.class.php',
        'RepositoryAjaxCheckCategoryName' => '/ajax/check_category_name.class.php',
        'RepositoryAjaxCheckTitle' => '/ajax/check_title.class.php',
        'RepositoryAjaxUploadImage' => '/ajax/upload_image.class.php',
        'RepositoryAjaxClearParameter' => '/ajax/clear_parameter.class.php',
        'RepositoryAjaxContentObjectUpdate' => '/ajax/content_object_update.class.php',
        'RepositoryAjaxRenditionImplementation' => '/ajax/rendition_implementation.class.php',
        'AbstractContentObjectExportImplementation' => '/lib/abstract_content_object_export_implementation.class.php',
        'AbstractContentObjectImportImplementation' => '/lib/abstract_content_object_import_implementation.class.php',
        'AbstractContentObjectRenditionImplementation' => '/lib/abstract_content_object_rendition_implementation.class.php',
        'ComplexContentObjectItem' => '/lib/complex_content_object_item.class.php',
        'ComplexContentObjectItemForm' => '/lib/complex_content_object_item_form.class.php',
        'ComplexContentObjectMenu' => '/lib/complex_content_object_menu.class.php',
        'ComplexContentObjectPath' => '/lib/complex_content_object_path.class.php',
        'ComplexContentObjectPathNode' => '/lib/complex_content_object_path_node.class.php',
        'ContentObject' => '/lib/content_object.class.php',
        'ContentObjectActivator' => '/lib/content_object_activator.class.php',
        'ContentObjectAdvancedFilter' => '/lib/content_object_advanced_filter.class.php',
        'ContentObjectAttachment' => '/lib/content_object_attachment.class.php',
        'ContentObjectCategoryMenu' => '/lib/content_object_category_menu.class.php',
        'ContentObjectDeactivator' => '/lib/content_object_deactivator.class.php',
        'ContentObjectDescriptionRenderer' => '/lib/content_object_description_renderer.class.php',
        'ContentObjectDifference' => '/lib/content_object_difference.class.php',
        'ContentObjectDifferenceDisplay' => '/lib/content_object_difference_display.class.php',
        'ContentObjectDisplay' => '/lib/content_object_display.class.php',
        'ContentObjectDisplayContext' => '/lib/content_object_display_context.class.php',
        'ContentObjectExport' => '/lib/content_object_export.class.php',
        'ContentObjectExportController' => '/lib/content_object_export_controller.class.php',
        'ContentObjectExportImplementation' => '/lib/content_object_export_implementation.class.php',
        'ContentObjectForm' => '/lib/content_object_form.class.php',
        'ContentObjectGroupShare' => '/lib/content_object_group_share.class.php',
        'ContentObjectImport' => '/lib/content_object_import.class.php',
        'ContentObjectImportController' => '/lib/content_object_import_controller.class.php',
        'ContentObjectCopier' => '/lib/content_object_copier.class.php',
        'ContentObjectImportForm' => '/lib/content_object_import_form.class.php',
        'ContentObjectImportImplementation' => '/lib/content_object_import_implementation.class.php',
        'ContentObjectImportParameters' => '/lib/content_object_import_parameters.class.php',
        'ContentObjectInclude' => '/lib/content_object_include.class.php',
        'ContentObjectIncludeParser' => '/lib/content_object_include_parser.class.php',
        'ContentObjectInstaller' => '/lib/content_object_installer.class.php',
        'ContentObjectOwnerChanger' => '/lib/content_object_owner_changer.class.php',
        'ContentObjectPublicationAttributes' => '/lib/content_object_publication_attributes.class.php',
        'ContentObjectPubFeedback' => '/lib/content_object_pub_feedback.class.php',
        'ContentObjectRemover' => '/lib/content_object_remover.class.php',
        'ContentObjectRenderer' => '/lib/content_object_renderer.class.php',
        'ContentObjectRendition' => '/lib/content_object_rendition.class.php',
        'ContentObjectRenditionImplementation' => '/lib/content_object_rendition_implementation.class.php',
        'ContentObjectResourceRenderer' => '/lib/content_object_resource_renderer.class.php',
        'ContentObjectShare' => '/lib/content_object_share.class.php',
        'ContentObjectTypeSelector' => '/lib/content_object_type_selector.class.php',
        'ContentObjectTypeSelectorSupport' => '/lib/content_object_type_selector_support.class.php',
        'ContentObjectUpdater' => '/lib/content_object_updater.class.php',
        'ContentObjectUserShare' => '/lib/content_object_user_share.class.php',
        'Difference_Engine' => '/lib/difference_engine.class.php',
        'Text_MappedDiff' => '/lib/difference_engine.class.php',
        'Difference_Engine_Engine_xdiff' => '/lib/difference_engine.class.php',
        'Difference_Engine_Engine_native' => '/lib/difference_engine.class.php',
        'Difference_Engine_Op' => '/lib/difference_engine.class.php',
        'Difference_Engine_Op_copy' => '/lib/difference_engine.class.php',
        'Difference_Engine_Op_delete' => '/lib/difference_engine.class.php',
        'Difference_Engine_Op_add' => '/lib/difference_engine.class.php',
        'Difference_Engine_Op_change' => '/lib/difference_engine.class.php',
        'DummyContentObjectExportImplementation' => '/lib/dummy_content_object_export_implementation.class.php',
        'DummyContentObjectImportImplementation' => '/lib/dummy_content_object_import_implementation.class.php',
        'DummyContentObjectRenditionImplementation' => '/lib/dummy_content_object_rendition_implementation.class.php',
        'ExportParameters' => '/lib/export_parameters.class.php',
        'ExternalInstance' => '/lib/external_instance.class.php',
        'ExternalRepositoryUserQuotum' => '/lib/external_repository_user_quotum.class.php',
        'ExternalSetting' => '/lib/external_setting.class.php',
        'ExternalSync' => '/lib/external_sync.class.php',
        'ExternalUserSetting' => '/lib/external_user_setting.class.php',
        'ImportParameters' => '/lib/import_parameters.class.php',
        'LegacyContentObjectDisplayContext' => '/lib/legacy_content_object_display_context.class.php',
        'ObjectTypeMenu' => '/lib/object_type_menu.class.php',
        'RepositoryDataClass' => '/lib/repository_data_class.class.php',
        'RepositoryMenu' => '/lib/repository_menu.class.php',
        'RepositoryRights' => '/lib/repository_rights.class.php',
        'RightsLocation' => '/lib/rights_location.class.php',
        'RightsLocationEntityRight' => '/lib/rights_location_entity_right.class.php',
        'SharedContentObjectRelCategory' => '/lib/shared_content_object_rel_category.class.php',
        'UserView' => '/lib/user_view.class.php',
        'UserViewMenu' => '/lib/user_view_menu.class.php',
        'UserViewRelContentObject' => '/lib/user_view_rel_content_object.class.php',
        'RepositoryBookmarklet' => '/lib/bookmarklet/repository_bookmarklet.class.php',
        'AddResourceBookmarklet' => '/lib/bookmarklet/type/add_resource_bookmarklet.class.php',
        'RepositoryCategory' => '/lib/category_manager/repository_category.class.php',
        'RepositoryCategoryManager' => '/lib/category_manager/repository_category_manager.class.php',
        'RepositoryCategoryTreeMenu' => '/lib/category_manager/repository_category_tree_menu.class.php',
        'SharedRepositoryCategoryTreeMenu' => '/lib/category_manager/shared_repository_category_tree_menu.class.php',
        'ImpactViewTable' => '/lib/category_manager/impact_view_table/impact_view_table.class.php',
        'ImpactViewTableCellRenderer' => '/lib/category_manager/impact_view_table/impact_view_table_cell_renderer.class.php',
        'ImpactViewTableColumnModel' => '/lib/category_manager/impact_view_table/impact_view_table_column_model.class.php',
        'ImpactViewTableDataProvider' => '/lib/category_manager/impact_view_table/impact_view_table_data_provider.class.php',
        'ComplexBuilder' => '/lib/complex_builder/complex_builder.class.php',
        'ComplexBuilderComponent' => '/lib/complex_builder/complex_builder_component.class.php',
        'ComplexMenu' => '/lib/complex_builder/complex_menu.class.php',
        'ComplexBuilderComponentAttachmentViewerComponent' => '/lib/complex_builder/component/attachment_viewer.class.php',
        'ComplexBuilderComponentBrowserComponent' => '/lib/complex_builder/component/browser.class.php',
        'ComplexBuilderComponentCreatorComponent' => '/lib/complex_builder/component/creator.class.php',
        'ComplexBuilderComponentDeleterComponent' => '/lib/complex_builder/component/deleter.class.php',
        'ComplexBuilderComponentMoverComponent' => '/lib/complex_builder/component/mover.class.php',
        'ComplexBuilderComponentParentChangerComponent' => '/lib/complex_builder/component/parent_changer.class.php',
        'ComplexBuilderComponentPreviewComponent' => '/lib/complex_builder/component/preview.class.php',
        'ComplexBuilderComponentUpdaterComponent' => '/lib/complex_builder/component/updater.class.php',
        'ComplexBuilderComponentViewerComponent' => '/lib/complex_builder/component/viewer.class.php',
        'ComplexDisplay' => '/lib/complex_display/complex_display.class.php',
        'ComplexDisplayComponent' => '/lib/complex_display/complex_display_component.class.php',
        'ComplexDisplayPreview' => '/lib/complex_display/complex_display_preview.class.php',
        'ComplexDisplaySupport' => '/lib/complex_display/complex_display_support.class.php',
        'ComplexDisplayComponentAttachmentViewerComponent' => '/lib/complex_display/component/attachment_viewer.class.php',
        'ComplexDisplayComponentComplexFeedbackComponent' => '/lib/complex_display/component/complex_feedback.class.php',
        'ComplexDisplayComponentContentObjectUpdaterComponent' => '/lib/complex_display/component/content_object_updater.class.php',
        'ComplexDisplayComponentCreatorComponent' => '/lib/complex_display/component/creator.class.php',
        'ComplexDisplayComponentDeleterComponent' => '/lib/complex_display/component/deleter.class.php',
        'ComplexDisplayComponentFeedbackDeleterComponent' => '/lib/complex_display/component/feedback_deleter.class.php',
        'ComplexDisplayComponentFeedbackEditComponent' => '/lib/complex_display/component/feedback_editor.class.php',
        'ComplexDisplayComponentReportingTemplateViewerComponent' => '/lib/complex_display/component/reporting_template_viewer.class.php',
        'ComplexDisplayComponentUpdaterComponent' => '/lib/complex_display/component/updater.class.php',
        'CpoContentObjectExport' => '/lib/content_object_export/cpo_content_object_export.class.php',
        'CpoContentObjectExportController' => '/lib/content_object_export/cpo_content_object_export_controller.class.php',
        'HtmlContentObjectExport' => '/lib/content_object_export/html_content_object_export.class.php',
        'HtmlContentObjectExportController' => '/lib/content_object_export/html_content_object_export_controller.class.php',
        'IcalContentObjectExport' => '/lib/content_object_export/ical_content_object_export.class.php',
        'IcalContentObjectExportController' => '/lib/content_object_export/ical_content_object_export_controller.class.php',
        'QtiContentObjectExport' => '/lib/content_object_export/qti_content_object_export.class.php',
        'QtiContentObjectExportController' => '/lib/content_object_export/qti_content_object_export_controller.class.php',
        'ZipContentObjectExport' => '/lib/content_object_export/zip_content_object_export.class.php',
        'ZipContentObjectExportController' => '/lib/content_object_export/zip_content_object_export_controller.class.php',
        'CpoDefaultContentObjectExport' => '/lib/content_object_export/cpo/default.class.php',
        'HtmlDefaultContentObjectExport' => '/lib/content_object_export/html/default.class.php',
        'IcalDefaultContentObjectExport' => '/lib/content_object_export/ical/default.class.php',
        'QtiDefaultContentObjectExport' => '/lib/content_object_export/qti/default.class.php',
        'QtiQuestionSerializer' => '/lib/content_object_export/qti/qti_question_serializer.class.php',
        'QtiSerializerBase' => '/lib/content_object_export/qti/qti_serializer_base.class.php',
        'QtiSerializerExport' => '/lib/content_object_export/qti/qti_serializer_export.class.php',
        'QtiAssessmentMatchingQuestionSerializer' => '/lib/content_object_export/qti/serializer/qti_assessment_matching_question_serializer.class.php',
        'QtiAssessmentMatchNumericQuestionSerializer' => '/lib/content_object_export/qti/serializer/qti_assessment_match_numeric_question_serializer.class.php',
        'QtiAssessmentMatchTextQuestionSerializer' => '/lib/content_object_export/qti/serializer/qti_assessment_match_text_question_serializer.class.php',
        'QtiAssessmentMatrixQuestionSerializer' => '/lib/content_object_export/qti/serializer/qti_assessment_matrix_question_serializer.class.php',
        'QtiAssessmentMultipleChoiceQuestionSerializer' => '/lib/content_object_export/qti/serializer/qti_assessment_multiple_choice_question_serializer.class.php',
        'QtiAssessmentOpenQuestionSerializer' => '/lib/content_object_export/qti/serializer/qti_assessment_open_question_serializer.class.php',
        'QtiAssessmentRatingQuestionSerializer' => '/lib/content_object_export/qti/serializer/qti_assessment_rating_question_serializer.class.php',
        'QtiAssessmentSelectQuestionSerializer' => '/lib/content_object_export/qti/serializer/qti_assessment_select_question_serializer.class.php',
        'QtiAssessmentSerializer' => '/lib/content_object_export/qti/serializer/qti_assessment_serializer.class.php',
        'QtiFillInBlanksQuestionSerializer' => '/lib/content_object_export/qti/serializer/qti_fill_in_blanks_question_serializer.class.php',
        'QtiHotspotQuestionSerializer' => '/lib/content_object_export/qti/serializer/qti_hotspot_question_serializer.class.php',
        'QtiMatchQuestionSerializer' => '/lib/content_object_export/qti/serializer/qti_match_question_serializer.class.php',
        'QtiOrderingQuestionSerializer' => '/lib/content_object_export/qti/serializer/qti_ordering_question_serializer.class.php',
        'ZipDefaultContentObjectExport' => '/lib/content_object_export/zip/default.class.php',
        'CpoContentObjectImportController' => '/lib/content_object_import/cpo/controller.class.php',
        'CpoContentObjectImportForm' => '/lib/content_object_import/cpo/form.class.php',
        'CpoContentObjectImport' => '/lib/content_object_import/cpo/import.class.php',
        'CpoContentObjectImportParameters' => '/lib/content_object_import/cpo/object_parameters.class.php',
        'CpoImportParameters' => '/lib/content_object_import/cpo/parameters.class.php',
        'DocumentContentObjectImportController' => '/lib/content_object_import/document/controller.class.php',
        'DocumentContentObjectImportForm' => '/lib/content_object_import/document/form.class.php',
        'DocumentImportParameters' => '/lib/content_object_import/document/parameters.class.php',
        'FileContentObjectImportController' => '/lib/content_object_import/file/controller.class.php',
        'FileContentObjectImportForm' => '/lib/content_object_import/file/form.class.php',
        'FileImportParameters' => '/lib/content_object_import/file/parameters.class.php',
        'HotpotatoesContentObjectImportController' => '/lib/content_object_import/hotpotatoes/controller.class.php',
        'HotpotatoesContentObjectImportForm' => '/lib/content_object_import/hotpotatoes/form.class.php',
        'HotpotatoesImportParameters' => '/lib/content_object_import/hotpotatoes/parameters.class.php',
        'IcalContentObjectImportController' => '/lib/content_object_import/ical/controller.class.php',
        'IcalContentObjectImportForm' => '/lib/content_object_import/ical/form.class.php',
        'IcalContentObjectImport' => '/lib/content_object_import/ical/ical_content_object_import.class.php',
        'IcalContentObjectImportParameters' => '/lib/content_object_import/ical/object_parameters.class.php',
        'IcalImportParameters' => '/lib/content_object_import/ical/parameters.class.php',
        'QtiContentObjectImportController' => '/lib/content_object_import/qti/controller.class.php',
        'QtiContentObjectImportForm' => '/lib/content_object_import/qti/form.class.php',
        'QtiContentObjectImport' => '/lib/content_object_import/qti/import.class.php',
        'QtiContentObjectImportParameters' => '/lib/content_object_import/qti/object_parameters.class.php',
        'QtiImportParameters' => '/lib/content_object_import/qti/parameters.class.php',
        'QtiBuilderBase' => '/lib/content_object_import/qti/object_import/qti_builder_base.class.php',
        'QtiBuilderImport' => '/lib/content_object_import/qti/object_import/qti_builder_import.class.php',
        'QtiQuestionBuilder' => '/lib/content_object_import/qti/object_import/qti_question_builder.class.php',
        'QtiAssessmentBuilder' => '/lib/content_object_import/qti/object_import/builder/qti_assessment_builder.class.php',
        'QtiAssessmentMatchingQuestionBuilder' => '/lib/content_object_import/qti/object_import/builder/qti_assessment_matching_question_builder.class.php',
        'QtiAssessmentMatchNumericQuestionBuilder' => '/lib/content_object_import/qti/object_import/builder/qti_assessment_match_numeric_question_builder.class.php',
        'QtiAssessmentMatchTextQuestionBuilder' => '/lib/content_object_import/qti/object_import/builder/qti_assessment_match_text_question_builder.class.php',
        'QtiAssessmentMatrixQuestionBuilder' => '/lib/content_object_import/qti/object_import/builder/qti_assessment_matrix_question_builder.class.php',
        'QtiAssessmentMultipleChoiceQuestionBuilder' => '/lib/content_object_import/qti/object_import/builder/qti_assessment_multiple_choice_question_builder.class.php',
        'QtiAssessmentOpenQuestionBuilder' => '/lib/content_object_import/qti/object_import/builder/qti_assessment_open_question_builder.class.php',
        'QtiAssessmentRatingQuestionBuilder' => '/lib/content_object_import/qti/object_import/builder/qti_assessment_rating_question_builder.class.php',
        'QtiAssessmentSelectQuestionBuilder' => '/lib/content_object_import/qti/object_import/builder/qti_assessment_select_question_builder.class.php',
        'QtiFillInBlanksQuestionBuilder' => '/lib/content_object_import/qti/object_import/builder/qti_fill_in_blanks_question_builder.class.php',
        'FillInBlanksQuestionRenderer' => '/lib/content_object_import/qti/object_import/builder/qti_fill_in_blanks_question_builder.class.php',
        'QtiHotspotQuestionBuilder' => '/lib/content_object_import/qti/object_import/builder/qti_hotspot_question_builder.class.php',
        'QtiMatchQuestionBuilder' => '/lib/content_object_import/qti/object_import/builder/qti_match_question_builder.class.php',
        'QtiOrderingQuestionBuilder' => '/lib/content_object_import/qti/object_import/builder/qti_ordering_question_builder.class.php',
        'ScormContentObjectImportController' => '/lib/content_object_import/scorm/controller.class.php',
        'ScormContentObjectImportForm' => '/lib/content_object_import/scorm/form.class.php',
        'ScormImportParameters' => '/lib/content_object_import/scorm/parameters.class.php',
        'VimeoContentObjectImportController' => '/lib/content_object_import/vimeo/controller.class.php',
        'VimeoContentObjectImportForm' => '/lib/content_object_import/vimeo/form.class.php',
        'VimeoImportParameters' => '/lib/content_object_import/vimeo/parameters.class.php',
        'WebpageContentObjectImportController' => '/lib/content_object_import/webpage/controller.class.php',
        'WebpageContentObjectImportForm' => '/lib/content_object_import/webpage/form.class.php',
        'WebpageImportParameters' => '/lib/content_object_import/webpage/parameters.class.php',
        'YoutubeContentObjectImportController' => '/lib/content_object_import/youtube/controller.class.php',
        'YoutubeContentObjectImportForm' => '/lib/content_object_import/youtube/form.class.php',
        'YoutubeImportParameters' => '/lib/content_object_import/youtube/parameters.class.php',
        'ZipContentObjectImportController' => '/lib/content_object_import/zip/controller.class.php',
        'ZipContentObjectImportForm' => '/lib/content_object_import/zip/form.class.php',
        'ZipImportParameters' => '/lib/content_object_import/zip/parameters.class.php',
        'RarContentObjectImportController' => '/lib/content_object_import/rar/controller.class.php',
        'RarContentObjectImportForm' => '/lib/content_object_import/rar/form.class.php',
        'RarImportParameters' => '/lib/content_object_import/rar/parameters.class.php',
        'HtmlContentObjectRendition' => '/lib/content_object_rendition/html_content_object_rendition.class.php',
        'JsonContentObjectRendition' => '/lib/content_object_rendition/json_content_object_rendition.class.php',
        'XmlContentObjectRendition' => '/lib/content_object_rendition/xml_content_object_rendition.class.php',
        'HtmlDescriptionContentObjectRendition' => '/lib/content_object_rendition/html/description.class.php',
        'HtmlFullContentObjectRendition' => '/lib/content_object_rendition/html/full.class.php',
        'HtmlInlineContentObjectRendition' => '/lib/content_object_rendition/html/inline.class.php',
        'HtmlPreviewContentObjectRendition' => '/lib/content_object_rendition/html/preview.class.php',
        'HtmlShortContentObjectRendition' => '/lib/content_object_rendition/html/short.class.php',
        'HtmlThumbnailContentObjectRendition' => '/lib/content_object_rendition/html/thumbnail.class.php',
        'JsonFullContentObjectRendition' => '/lib/content_object_rendition/json/full.class.php',
        'JsonImageContentObjectRendition' => '/lib/content_object_rendition/json/image.class.php',
        'XmlFullContentObjectRendition' => '/lib/content_object_rendition/xml/full.class.php',
        'XmlPreviewContentObjectRendition' => '/lib/content_object_rendition/xml/preview.class.php',
        'XmlShortContentObjectRendition' => '/lib/content_object_rendition/xml/short.class.php',
        'DefaultContentObjectGalleryTableCellRenderer' => '/lib/content_object_table/default_content_object_gallery_table_cell_renderer.class.php',
        'DefaultContentObjectGalleryTablePropertyModel' => '/lib/content_object_table/default_content_object_gallery_table_property_model.class.php',
        'DefaultContentObjectTableCellRenderer' => '/lib/content_object_table/default_content_object_table_cell_renderer.class.php',
        'DefaultContentObjectTableColumnModel' => '/lib/content_object_table/default_content_object_table_column_model.class.php',
        'DefaultSharedContentObjectsTableCellRenderer' => '/lib/content_object_table/default_shared_content_objects_table_cell_renderer.class.php',
        'DefaultSharedContentObjectsTableColumnModel' => '/lib/content_object_table/default_shared_content_objects_table_column_model.class.php',
        'DefaultSharedContentObjectTableCellRenderer' => '/lib/content_object_table/default_shared_content_object_table_cell_renderer.class.php',
        'DefaultSharedContentObjectTableColumnModel' => '/lib/content_object_table/default_shared_content_object_table_column_model.class.php',
        'DataManager' => '/lib/data_manager/data_manager.class.php',
        'DataManagerInterface' => '/lib/data_manager/data_manager_interface.class.php',
        'DatabaseComplexContentObjectItemResultSet' => '/lib/data_manager/database/database_complex_content_object_item_result_set.class.php',
        'DatabaseContentObjectResultSet' => '/lib/data_manager/database/database_content_object_result_set.class.php',
        'DoctrineDataManager' => '/lib/data_manager/implementation/doctrine.class.php',
        'Mdb2RepositoryDataManager' => '/lib/data_manager/implementation/mdb2.class.php',
        'ExternalInstanceManager' => '/lib/external_instance_manager/external_instance_manager.class.php',
        'ExternalInstanceManagerActivatorComponent' => '/lib/external_instance_manager/component/activator.class.php',
        'ExternalInstanceManagerBrowserComponent' => '/lib/external_instance_manager/component/browser.class.php',
        'ExternalInstanceManagerCreatorComponent' => '/lib/external_instance_manager/component/creator.class.php',
        'ExternalInstanceManagerDeactivatorComponent' => '/lib/external_instance_manager/component/deactivator.class.php',
        'ExternalInstanceManagerDeleterComponent' => '/lib/external_instance_manager/component/deleter.class.php',
        'ExternalInstanceManagerRightsEditorComponent' => '/lib/external_instance_manager/component/rights_editor.class.php',
        'ExternalInstanceManagerUpdaterComponent' => '/lib/external_instance_manager/component/updater.class.php',
        'ExternalInstanceBrowserTable' => '/lib/external_instance_manager/component/external_instance_browser/external_instance_browser_table.class.php',
        'ExternalInstanceBrowserTableCellRenderer' => '/lib/external_instance_manager/component/external_instance_browser/external_instance_browser_table_cell_renderer.class.php',
        'ExternalInstanceBrowserTableColumnModel' => '/lib/external_instance_manager/component/external_instance_browser/external_instance_browser_table_column_model.class.php',
        'ExternalInstanceBrowserTableDataProvider' => '/lib/external_instance_manager/component/external_instance_browser/external_instance_browser_table_data_provider.class.php',
        'DefaultExternalInstanceTableCellRenderer' => '/lib/external_instance_manager/external_instance_table/default_external_instance_table_cell_renderer.class.php',
        'DefaultExternalInstanceTableColumnModel' => '/lib/external_instance_manager/external_instance_table/default_external_instance_table_column_model.class.php',
        'ExternalInstanceForm' => '/lib/external_instance_manager/forms/external_instance_form.class.php',
        'DefaultExternalLinkTableCellRenderer' => '/lib/external_link_table/default_external_link_table_cell_renderer.class.php',
        'DefaultExternalLinkTableColumnModel' => '/lib/external_link_table/default_external_link_table_column_model.class.php',
        'AddResourceForm' => '/lib/form/add_resource_form.class.php',
        'AdvancedFilterForm' => '/lib/form/advanced_filter_form.class.php',
        'RepositoryFilterForm' => '/lib/form/repository_filter_form.class.php',
        'UserViewForm' => '/lib/form/user_view_form.class.php',
        'IncludeChamiloParser' => '/lib/includes/include_chamilo_parser.class.php',
        'IncludeEmbedParser' => '/lib/includes/include_embed_parser.class.php',
        'IncludeFlashParser' => '/lib/includes/include_flash_parser.class.php',
        'IncludeImageParser' => '/lib/includes/include_image_parser.class.php',
        'IncludeWikiParser' => '/lib/includes/include_wiki_parser.class.php',
        'IncludeYoutubeParser' => '/lib/includes/include_youtube_parser.class.php',
        'DefaultLinkTableCellRenderer' => '/lib/link_table/default_link_table_cell_renderer.class.php',
        'DefaultLinkTableColumnModel' => '/lib/link_table/default_link_table_column_model.class.php',
        'DefaultPublicationTableCellRenderer' => '/lib/publication_table/default_publication_table_cell_renderer.class.php',
        'DefaultPublicationTableColumnModel' => '/lib/publication_table/default_publication_table_column_model.class.php',
        'GalleryTableContentObjectRenderer' => '/lib/renderer/gallery_table_content_object_renderer.class.php',
        'SlideshowContentObjectRenderer' => '/lib/renderer/slideshow_content_object_renderer.class.php',
        'TableContentObjectRenderer' => '/lib/renderer/table_content_object_renderer.class.php',
        'RepositoryManager' => '/lib/repository_manager/repository_manager.class.php',
        'RepositorySearchForm' => '/lib/repository_manager/repository_search_form.class.php',
        'RepositoryManagerAttachmentViewerComponent' => '/lib/repository_manager/component/attachment_viewer.class.php',
        'RepositoryManagerBrowserComponent' => '/lib/repository_manager/component/browser.class.php',
        'RepositoryManagerBuilderComponent' => '/lib/repository_manager/component/builder.class.php',
        'RepositoryManagerCategoryManagerComponent' => '/lib/repository_manager/component/category_manager.class.php',
        'RepositoryManagerComparerComponent' => '/lib/repository_manager/component/comparer.class.php',
        'RepositoryManagerCopierComponent' => '/lib/repository_manager/component/copier.class.php',
        'RepositoryManagerContentObjectManagerComponent' => '/lib/repository_manager/component/content_object_manager.class.php',
        'RepositoryManagerContentObjectShareRightsDeleterComponent' => '/lib/repository_manager/component/content_object_share_rights_deleter.class.php',
        'RepositoryManagerCreatorComponent' => '/lib/repository_manager/component/creator.class.php',
        'RepositoryManagerDeleterComponent' => '/lib/repository_manager/component/deleter.class.php',
        'RepositoryManagerDocumentDownloaderComponent' => '/lib/repository_manager/component/document_downloader.class.php',
        'RepositoryManagerDoublesViewerComponent' => '/lib/repository_manager/component/doubles_viewer.class.php',
        'RepositoryManagerEditorComponent' => '/lib/repository_manager/component/editor.class.php',
        'RepositoryManagerExporterComponent' => '/lib/repository_manager/component/exporter.class.php',
        'RepositoryManagerExporterCpComponent' => '/lib/repository_manager/component/exporter_cp.class.php',
        'RepositoryManagerExternalInstanceComponent' => '/lib/repository_manager/component/external_instance.class.php',
        'RepositoryManagerExternalInstanceManagerComponent' => '/lib/repository_manager/component/external_instance_manager.class.php',
        'ExternalRepositoryComponent' => '/lib/repository_manager/component/external_repository.class.php',
        'HtmlEditorFileComponent' => '/lib/repository_manager/component/html_editor_file.class.php',
        'RepositoryManagerImporterComponent' => '/lib/repository_manager/component/importer.class.php',
        'RepositoryManagerLinkDeleterComponent' => '/lib/repository_manager/component/link_deleter.class.php',
        'RepositoryManagerMetadataEditorComponent' => '/lib/repository_manager/component/metadata_editor.class.php',
        'RepositoryManagerMoverComponent' => '/lib/repository_manager/component/mover.class.php',
        'RepositoryManagerPermanentDeleterComponent' => '/lib/repository_manager/component/permanent_deleter.class.php',
        'PreviewerComponent' => '/lib/repository_manager/component/previewer.class.php',
        'RepositoryManagerPublicationBrowserComponent' => '/lib/repository_manager/component/publication_browser.class.php',
        'RepositoryManagerPublicationDeleterComponent' => '/lib/repository_manager/component/publication_deleter.class.php',
        'RepositoryManagerPublicationUpdaterComponent' => '/lib/repository_manager/component/publication_updater.class.php',
        'RepositoryManagerPublisherComponent' => '/lib/repository_manager/component/publisher.class.php',
        'RepositoryManagerQuotaComponent' => '/lib/repository_manager/component/quota.class.php',
        'RepositoryManagerRecyclerComponent' => '/lib/repository_manager/component/recycler.class.php',
        'RepositoryManagerRecycleBinBrowserComponent' => '/lib/repository_manager/component/recycle_bin_browser.class.php',
        'RepositoryViewerComponent' => '/lib/repository_manager/component/repository_viewer.class.php',
        'RepositoryManagerResourceAdderComponent' => '/lib/repository_manager/component/resource_adder.class.php',
        'RepositoryManagerRestorerComponent' => '/lib/repository_manager/component/restorer.class.php',
        'RepositoryManagerReverterComponent' => '/lib/repository_manager/component/reverter.class.php',
        'RepositoryManagerSharedContentObjectsBrowserComponent' => '/lib/repository_manager/component/shared_content_objects_browser.class.php',
        'RepositoryManagerSharedContentObjectsDeleterComponent' => '/lib/repository_manager/component/shared_content_objects_deleter.class.php',
        'RepositoryManagerSharedContentObjectsMoverComponent' => '/lib/repository_manager/component/shared_content_objects_mover.class.php',
        'RepositoryManagerShareContentObjectsComponent' => '/lib/repository_manager/component/share_content_objects.class.php',
        'RepositoryManagerTemplateBrowserComponent' => '/lib/repository_manager/component/template_browser.class.php',
        'RepositoryManagerTemplateCreatorComponent' => '/lib/repository_manager/component/template_creator.class.php',
        'RepositoryManagerTemplateDeleterComponent' => '/lib/repository_manager/component/template_deleter.class.php',
        'RepositoryManagerTemplateImporterComponent' => '/lib/repository_manager/component/template_importer.class.php',
        'RepositoryManagerUnlinkerComponent' => '/lib/repository_manager/component/unlinker.class.php',
        'RepositoryManagerUserViewBrowserComponent' => '/lib/repository_manager/component/user_view_browser.class.php',
        'RepositoryManagerUserViewCreatorComponent' => '/lib/repository_manager/component/user_view_creator.class.php',
        'RepositoryManagerUserViewDeleterComponent' => '/lib/repository_manager/component/user_view_deleter.class.php',
        'RepositoryManagerUserViewUpdaterComponent' => '/lib/repository_manager/component/user_view_updater.class.php',
        'VideoConferencingComponent' => '/lib/repository_manager/component/video_conferencing.class.php',
        'RepositoryManagerViewerComponent' => '/lib/repository_manager/component/viewer.class.php',
        'RepositoryBrowserTable' => '/lib/repository_manager/component/browser/repository_browser_table.class.php',
        'RepositoryBrowserTableCellRenderer' => '/lib/repository_manager/component/browser/repository_browser_table_cell_renderer.class.php',
        'RepositoryBrowserTableColumnModel' => '/lib/repository_manager/component/browser/repository_browser_table_column_model.class.php',
        'RepositoryBrowserTableDataProvider' => '/lib/repository_manager/component/browser/repository_browser_table_data_provider.class.php',
        'DoublesBrowserTable' => '/lib/repository_manager/component/browser/doubles_browser/doubles_browser_table.class.php',
        'DoublesBrowserTableCellRenderer' => '/lib/repository_manager/component/browser/doubles_browser/doubles_browser_table_cell_renderer.class.php',
        'DoublesBrowserTableColumnModel' => '/lib/repository_manager/component/browser/doubles_browser/doubles_browser_table_column_model.class.php',
        'DoublesBrowserTableDataProvider' => '/lib/repository_manager/component/browser/doubles_browser/doubles_browser_table_data_provider.class.php',
        'RepositorySharedContentObjectsBrowserTable' => '/lib/repository_manager/component/browser/shared_content_objects_browser/repository_shared_content_objects_browser_table.class.php',
        'RepositorySharedContentObjectsBrowserTableCellRenderer' => '/lib/repository_manager/component/browser/shared_content_objects_browser/repository_shared_content_objects_browser_table_cell_renderer.class.php',
        'RepositorySharedContentObjectsBrowserTableColumnModel' => '/lib/repository_manager/component/browser/shared_content_objects_browser/repository_shared_content_objects_browser_table_column_model.class.php',
        'RepositorySharedContentObjectsBrowserTableDataProvider' => '/lib/repository_manager/component/browser/shared_content_objects_browser/repository_shared_content_objects_browser_table_data_provider.class.php',
        'TemplateBrowserTable' => '/lib/repository_manager/component/browser/template_browser/template_browser_table.class.php',
        'TemplateBrowserTableCellRenderer' => '/lib/repository_manager/component/browser/template_browser/template_browser_table_cell_renderer.class.php',
        'TemplateBrowserTableColumnModel' => '/lib/repository_manager/component/browser/template_browser/template_browser_table_column_model.class.php',
        'ComplexBrowserTable' => '/lib/repository_manager/component/complex_browser/complex_browser_table.class.php',
        'ComplexBrowserTableCellRenderer' => '/lib/repository_manager/component/complex_browser/complex_browser_table_cell_renderer.class.php',
        'ComplexBrowserTableColumnModel' => '/lib/repository_manager/component/complex_browser/complex_browser_table_column_model.class.php',
        'ComplexBrowserTableDataProvider' => '/lib/repository_manager/component/complex_browser/complex_browser_table_data_provider.class.php',
        'ExportBrowserTable' => '/lib/repository_manager/component/export_browser/export_browser_table.class.php',
        'ExportBrowserTableCellRenderer' => '/lib/repository_manager/component/export_browser/export_browser_table_cell_renderer.class.php',
        'ExportBrowserTableColumnModel' => '/lib/repository_manager/component/export_browser/export_browser_table_column_model.class.php',
        'ExportBrowserTableDataProvider' => '/lib/repository_manager/component/export_browser/export_browser_table_data_provider.class.php',
        'ExportTable' => '/lib/repository_manager/component/export_browser/sortable_table.class.php',
        'ExternalLinkBrowserTable' => '/lib/repository_manager/component/external_link_browser/external_link_browser_table.class.php',
        'ExternalLinkBrowserTableCellRenderer' => '/lib/repository_manager/component/external_link_browser/external_link_browser_table_cell_renderer.class.php',
        'ExternalLinkBrowserTableColumnModel' => '/lib/repository_manager/component/external_link_browser/external_link_browser_table_column_model.class.php',
        'ExternalLinkBrowserTableDataProvider' => '/lib/repository_manager/component/external_link_browser/external_link_browser_table_data_provider.class.php',
        'RepositoryBrowserGalleryTable' => '/lib/repository_manager/component/gallery_browser/repository_browser_gallery_table.class.php',
        'RepositoryBrowserGalleryTableCellRenderer' => '/lib/repository_manager/component/gallery_browser/repository_browser_gallery_table_cell_renderer.class.php',
        'RepositoryBrowserGalleryTableDataProvider' => '/lib/repository_manager/component/gallery_browser/repository_browser_gallery_table_data_provider.class.php',
        'RepositoryBrowserGalleryTablePropertyModel' => '/lib/repository_manager/component/gallery_browser/repository_browser_gallery_table_property_model.class.php',
        'LinkBrowserTable' => '/lib/repository_manager/component/link_browser/link_browser_table.class.php',
        'LinkBrowserTableCellRenderer' => '/lib/repository_manager/component/link_browser/link_browser_table_cell_renderer.class.php',
        'LinkBrowserTableColumnModel' => '/lib/repository_manager/component/link_browser/link_browser_table_column_model.class.php',
        'LinkBrowserTableDataProvider' => '/lib/repository_manager/component/link_browser/link_browser_table_data_provider.class.php',
        'PublicationBrowserTable' => '/lib/repository_manager/component/publication_browser/publication_browser_table.class.php',
        'PublicationBrowserTableCellRenderer' => '/lib/repository_manager/component/publication_browser/publication_browser_table_cell_renderer.class.php',
        'PublicationBrowserTableColumnModel' => '/lib/repository_manager/component/publication_browser/publication_browser_table_column_model.class.php',
        'PublicationBrowserTableDataProvider' => '/lib/repository_manager/component/publication_browser/publication_browser_table_data_provider.class.php',
        'PublisherWizard' => '/lib/repository_manager/component/publisher_wizard/publisher_wizard.class.php',
        'LocationSelectionPublisherWizardPage' => '/lib/repository_manager/component/publisher_wizard/pages/location_selection_publisher_wizard_page.class.php',
        'PublisherWizardDisplay' => '/lib/repository_manager/component/publisher_wizard/pages/publisher_wizard_display.class.php',
        'PublisherWizardPage' => '/lib/repository_manager/component/publisher_wizard/pages/publisher_wizard_page.class.php',
        'PublisherWizardProcess' => '/lib/repository_manager/component/publisher_wizard/pages/publisher_wizard_process.class.php',
        'RecycleBinBrowserTable' => '/lib/repository_manager/component/recycle_bin_browser/recycle_bin_browser_table.class.php',
        'RecycleBinBrowserTableCellRenderer' => '/lib/repository_manager/component/recycle_bin_browser/recycle_bin_browser_table_cell_renderer.class.php',
        'RecycleBinBrowserTableColumnModel' => '/lib/repository_manager/component/recycle_bin_browser/recycle_bin_browser_table_column_model.class.php',
        'RecycleBinBrowserTableDataProvider' => '/lib/repository_manager/component/recycle_bin_browser/recycle_bin_browser_table_data_provider.class.php',
        'UserViewBrowserTable' => '/lib/repository_manager/component/user_view_browser/user_view_browser_table.class.php',
        'UserViewBrowserTableCellRenderer' => '/lib/repository_manager/component/user_view_browser/user_view_browser_table_cell_renderer.class.php',
        'UserViewBrowserTableColumnModel' => '/lib/repository_manager/component/user_view_browser/user_view_browser_table_column_model.class.php',
        'UserViewBrowserTableDataProvider' => '/lib/repository_manager/component/user_view_browser/user_view_browser_table_data_provider.class.php',
        'RepositoryVersionBrowserTable' => '/lib/repository_manager/component/version_browser/repository_version_browser_table.class.php',
        'RepositoryVersionBrowserTableCellRenderer' => '/lib/repository_manager/component/version_browser/repository_version_browser_table_cell_renderer.class.php',
        'RepositoryVersionBrowserTableColumnModel' => '/lib/repository_manager/component/version_browser/repository_version_browser_table_column_model.class.php',
        'RepositoryVersionBrowserTableDataProvider' => '/lib/repository_manager/component/version_browser/repository_version_browser_table_data_provider.class.php',
        'ShareManager' => '/lib/share_manager/share_manager.class.php',
        'ShareManagerBrowserComponent' => '/lib/share_manager/component/browser.class.php',
        'ShareManagerCreateComponent' => '/lib/share_manager/component/create.class.php',
        'ShareManagerDeleteComponent' => '/lib/share_manager/component/delete.class.php',
        'ShareManagerUpdateComponent' => '/lib/share_manager/component/update.class.php',
        'ContentObjectGroupShareRightsBrowserTable' => '/lib/share_manager/component/content_object_group_share_rights_browser/content_object_group_share_rights_browser_table.class.php',
        'ContentObjectGroupShareRightsBrowserTableCellRenderer' => '/lib/share_manager/component/content_object_group_share_rights_browser/content_object_group_share_rights_browser_table_cell_renderer.class.php',
        'ContentObjectGroupShareRightsBrowserTableColumnModel' => '/lib/share_manager/component/content_object_group_share_rights_browser/content_object_group_share_rights_browser_table_column_model.class.php',
        'ContentObjectGroupShareRightsBrowserTableDataProvider' => '/lib/share_manager/component/content_object_group_share_rights_browser/content_object_group_share_rights_browser_table_data_provider.class.php',
        'ActionColumn' => '/lib/share_manager/component/content_object_user_share_rights_browser/action_column.class.php',
        'ContentObjectUserShareRightsBrowserTable' => '/lib/share_manager/component/content_object_user_share_rights_browser/content_object_user_share_rights_browser_table.class.php',
        'ContentObjectUserShareRightsBrowserTableCellRenderer' => '/lib/share_manager/component/content_object_user_share_rights_browser/content_object_user_share_rights_browser_table_cell_renderer.class.php',
        'ContentObjectUserShareRightsBrowserTableColumnModel' => '/lib/share_manager/component/content_object_user_share_rights_browser/content_object_user_share_rights_browser_table_column_model.class.php',
        'ContentObjectUserShareRightsBrowserTableDataProvider' => '/lib/share_manager/component/content_object_user_share_rights_browser/content_object_user_share_rights_browser_table_data_provider.class.php',
        'ShareRightColumn' => '/lib/share_manager/component/content_object_user_share_rights_browser/share_right_column.class.php',
        'ContentObjectShareForm' => '/lib/share_manager/forms/content_object_share_form.class.php',
        'FormValidatorHtmlEditorTemplates' => '/lib/templates/templates.class.php',
        'common\libraries\FormValidatorCkeditorHtmlEditorTemplates' => '/lib/templates/editor/ckeditor.class.php',
        'common\libraries\FormValidatorTinymceHtmlEditorTemplates' => '/lib/templates/editor/tinymce.class.php',
        'HtmlEditorRepositoryViewer' => '/lib/viewer/viewer.class.php',
        'HtmlEditorProcessor' => '/lib/viewer/processor/processor.class.php',
        'HtmlEditorCkeditorChamiloProcessor' => '/lib/viewer/processor/ckeditor/chamilo.class.php',
        'HtmlEditorCkeditorHandbookItemProcessor' => '/lib/viewer/processor/ckeditor/handbook_item.class.php',
        'HtmlEditorChamiloRepositoryViewer' => '/lib/viewer/type/chamilo/viewer.class.php',
        'HtmlEditorChamiloRepositoryViewerBrowserComponent' => '/lib/viewer/type/chamilo/component/browser.class.php',
        'HtmlEditorChamiloRepositoryViewerCreatorComponent' => '/lib/viewer/type/chamilo/component/creator.class.php',
        'HtmlEditorChamiloRepositoryViewerImportedSelecterComponent' => '/lib/viewer/type/chamilo/component/imported_selecter.class.php',
        'HtmlEditorChamiloRepositoryViewerImporterComponent' => '/lib/viewer/type/chamilo/component/importer.class.php',
        'HtmlEditorChamiloRepositoryViewerViewerComponent' => '/lib/viewer/type/chamilo/component/viewer.class.php',
        'ContentObjectTable' => '/lib/viewer/type/chamilo/component/content_object_table/table.class.php',
        'ContentObjectTableCellRenderer' => '/lib/viewer/type/chamilo/component/content_object_table/table_cell_renderer.class.php',
        'ContentObjectTableColumnModel' => '/lib/viewer/type/chamilo/component/content_object_table/table_column_model.class.php',
        'ContentObjectTableDataProvider' => '/lib/viewer/type/chamilo/component/content_object_table/table_data_provider.class.php',
        'HtmlEditorHandbookItemRepositoryViewer' => '/lib/viewer/type/handbook_item/viewer.class.php',
        'HtmlEditorHandbookItemRepositoryViewerBrowserComponent' => '/lib/viewer/type/handbook_item/component/browser.class.php',
        'HtmlEditorHandbookItemRepositoryViewerCreatorComponent' => '/lib/viewer/type/handbook_item/component/creator.class.php',
        'HtmlEditorHandbookItemRepositoryViewerViewerComponent' => '/lib/viewer/type/handbook_item/component/viewer.class.php',
        'HandbookItemContentObjectTable' => '/lib/viewer/type/handbook_item/component/content_object_table/table.class.php',
        'HandbookItemContentObjectTableCellRenderer' => '/lib/viewer/type/handbook_item/component/content_object_table/table_cell_renderer.class.php',
        'HandbookItemContentObjectTableColumnModel' => '/lib/viewer/type/handbook_item/component/content_object_table/table_column_model.class.php',
        'HandbookItemContentObjectTableDataProvider' => '/lib/viewer/type/handbook_item/component/content_object_table/table_data_provider.class.php',
        'Activator' => '/package/activate/activator.class.php',
        'Deactivator' => '/package/deactivate/deactivator.class.php',
        'Installer' => '/package/install/installer.class.php');

    /**
     * Try to load the class
     *
     * @param $classname string
     * @return boolean
     */
    public static function load($classname)
    {
        if (isset(self :: $map[$classname]))
        {
            require_once __DIR__ . self :: $map[$classname];
            return true;
        }

        return false;
    }

    /**
     * Synchronize the autoloader
     *
     * @param $update boolean
     * @return multitype:string
     */
    public static function synch($update)
    {
        return \common\libraries\AutoloaderUtilities :: synch(__DIR__, __DIR__, $update);
    }
}
?>