<?php

namespace repository;

use common\libraries\Translation;
use common\libraries\Path;

/**
 * Description of add_resource_bookmarklet
 *
 * @copyright (c) 2011 University of Geneva
 * @license GNU General Public License - http://www.gnu.org/copyleft/gpl.html
 * @author Laurent Opprecht
 */
class AddResourceBookmarklet extends RepositoryBookmarklet
{

    public function __construct($name = '', $width = '', $height = '')
    {
        $name = $name ? $name : Translation :: get('AddToChamilo');
        $width = $width ? $width : 900;
        $height = $height ? $height : 700;
        $base_path = Path :: get(WEB_PATH) . 'core.php?application=repository&go=resource_adder';
        parent :: __construct($name, $width, $height, $base_path);
        $this->set_feature('location', 'yes');
        $this->set_feature('links', 'no');
        $this->set_feature('scrollbars', 'no');
        $this->set_feature('toolbar', 'no');
    }

    public function get_resource_javascript()
    {
        return Path :: get(WEB_PATH) . 'repository/resources/javascript/bookmarklet_add_resource.js';
    }

    //    /**
//     * Returns the action done by the bookmarklet
//     * @return string
//     */
//    protected function get_action(){
//        $WINDOW = $this->get_open_window();
//        $JAVASCRIPT = htmlspecialchars($this->get_resource_javascript());
//
//        $result = <<<EOT
//var d=document,w=window,o=false,c=null,h=null;
//c=function(){chamilo_execute();};
//if(w.chamilo===undefined)
//{
// o=d.createElement('script');
// o.src='$JAVASCRIPT';
// o.type='text/javascript';
// h=d.getElementsByTagName('head')[0];
// w.chamilo=true;
// o.onload = o.onreadystatechange = function()
// {
//  if(!this.readyState || this.readyState == 'loaded' || this.readyState == 'complete')
//  {
//   c();
//   o.onload = o.onreadystatechange = null;
//  }
// };
// h.appendChild(o);
//}
//else
//{
// c();
//}
//EOT;
//
//        //uri='$BASE&url='+encodeURIComponent(window.location.href)+'&title='+encodeURIComponent(document.title)+'&description='+encodeURIComponent(''+(window.getSelection?window.getSelection():document.getSelection?document.getSelection():document.selection.createRange().text));$WINDOW
//        /*
//        $result = <<<EOT
//var uri=encodeURIComponent(window.location.href);
//var title=encodeURIComponent(document.title);
//var description=encodeURIComponent(''+(window.getSelection?window.getSelection():document.getSelection?document.getSelection():document.selection.createRange().text));
//var html=escape('<html>'+document.documentElement.innerHTML+'</html>');
//        $WINDOW
//EOT;*/
//        //var html = encodeURIComponent((new XMLSerializer()).serializeToString(document.documentElement));
//        return $result;
//    }
}
