<?php
namespace repository;

use common\libraries\Request;
use common\libraries\Translation;
use common\libraries\EqualityCondition;
use common\libraries\Utilities;
use common\libraries\Display;

class ComplexDisplayComponentFeedbackDeleterComponent extends ComplexDisplayComponent
{

    private $cid;

    private $pid;

    public function run()
    {
        if ($this->get_parent()->get_parent()->is_allowed_to_delete_feedback())
        {
            if (Request :: get('fid'))
                $feedback_ids = Request :: get('fid');
            else
                $feedback_ids = $_POST['fid'];
            
            if (Request :: get('selected_cloi'))
                $this->cid = Request :: get('selected_cloi');
            else
                $this->cid = $_POST['selected_cloi'];
            
            if (Request :: get('pid'))
                $this->pid = Request :: get('pid');
            else
                $this->pid = $_POST['pid'];
            
            if (! is_array($feedback_ids))
            {
                $feedback_ids = array($feedback_ids);
            }
            
            $failures = 0;
            foreach ($feedback_ids as $index => $fid)
            {
                $condition = new EqualityCondition(ContentObjectPubFeedback :: PROPERTY_FEEDBACK_ID, $fid);
                $feedbacks = DataManager :: retrieves(ContentObjectPubFeedback :: class_name(), $condition);
                while ($feedback = $feedbacks->next_result())
                {
                    if (! $feedback->delete())
                    {
                        $failures ++;
                    }
                }
            }
            
            $succes = ($failures == 0);
            
            if (count($feedback_ids) > 1)
            {
                $message = htmlentities(
                        Translation :: get(($succes ? 'ObjectsDeleted' : 'ObjectsDeleted'), 
                                array('OBJECTS' => Translation :: get('ContentObjectFeedbacks')), 
                                Utilities :: COMMON_LIBRARIES));
            }
            else
            {
                $message = htmlentities(
                        Translation :: get(($succes ? 'ObjectDeleted' : 'ObjectDeleted'), 
                                array('OBJECT' => Translation :: get('ContentObjectFeedback')), 
                                Utilities :: COMMON_LIBRARIES));
            }
            
            $this->redirect($message, (! $succes), 
                    array(                    // Tool :: PARAM_ACTION => Request ::
                           // get('tool_action'),
                    'display_action' => 'discuss', 'pid' => $this->pid, 'selected_cloi' => $this->cid));
        }
        else
        {
            Display :: not_allowed();
            return;
        }
    }
}
