<?php
namespace repository;

use common\libraries\Request;
use common\libraries\Translation;
use common\libraries\BreadcrumbTrail;
use common\libraries\EqualityCondition;
use common\libraries\Utilities;
use common\libraries\Display;

class ComplexDisplayComponentFeedbackEditComponent extends ComplexDisplayComponent
{

    public function run()
    {
        if ($this->get_parent()->get_parent()->is_allowed_to_edit_feedback())
        {
            $cid = Request :: get('selected_cloi') ? Request :: get('selected_cloi') : $_POST['selected_cloi'];
            // $pid = Request :: get(Tool :: PARAM_PUBLICATION_ID) ? Request ::
            // get(Tool :: PARAM_PUBLICATION_ID) : $_POST[Tool ::
            // PARAM_PUBLICATION_ID];
            $fid = Request :: get(ContentObjectPubFeedback :: PROPERTY_FEEDBACK_ID) ? Request :: get(
                    ContentObjectPubFeedback :: PROPERTY_FEEDBACK_ID) : $_POST[ContentObjectPubFeedback :: PROPERTY_FEEDBACK_ID];
            
            $condition = new EqualityCondition(ContentObjectPubFeedback :: PROPERTY_FEEDBACK_ID, $fid);
            $feedbacks = DataManager :: retrieves(ContentObjectPubFeedback :: class_name(), $condition);
            while ($feedback = $feedbacks->next_result())
            {
                $feedback_display = DataManager :: retrieve_content_object($feedback->get_feedback_id());
                $form = ContentObjectForm :: factory(ContentObjectForm :: TYPE_EDIT, $feedback_display, 'edit', 'post', 
                        $this->get_url(
                                array(ComplexDisplay :: PARAM_DISPLAY_ACTION => ComplexDisplay :: ACTION_EDIT_FEEDBACK, 
                                        ContentObjectPubFeedback :: PROPERTY_FEEDBACK_ID => $fid, 
                                        'selected_cloi' => $cid, 
                                        // Tool :: PARAM_PUBLICATION_ID => $pid,
                                        'details' => Request :: get('details'))));
                
                if ($form->validate() || Request :: get('validated'))
                {
                    $succes = $form->update_content_object();
                    /*
                     * if($succes && $form->is_version()) {
                     * $feedback_display->set_ref($content_object->get_latest_version()->get_id()); if(!
                     * $feedback_display->update()) { $succes = false; } }
                     */
                    $feedback_display->update();
                    $message = htmlentities(
                            Translation :: get(($succes ? 'ObjectUpdated' : 'ObjectNotUpdated'), 
                                    array('OBJECT' => Translation :: get('ContentObjectFeedback')), 
                                    Utilities :: COMMON_LIBRARIES));
                    
                    $params = array();
                    if (Request :: get('pid') != null)
                    {
                        $params['pid'] = Request :: get('pid');
                        $params['tool_action'] = 'view';
                    }
                    if ($cid != null)
                    {
                        $params['selected_cloi'] = $cid;
                        $params['tool_action'] = Request :: get('tool_action');
                        $params['display_action'] = 'discuss';
                    }
                    
                    if (Request :: get('fid') != null)
                    {
                        $params['fid'] = Request :: get('fid');
                    }
                    
                    $this->redirect($message, (! $succes), $params);
                }
                else
                {
                    $trail = BreadcrumbTrail :: get_instance();
                    $trail->add_help('courses general');
                    
                    $this->display_header();
                    $form->display();
                    $this->display_footer();
                }
            }
        }
        else
        {
            Display :: not_allowed();
            return;
        }
    }
}
