<?php
namespace repository;

use common\libraries\Utilities;

/**
 *
 * @package repository.lib
 *
 *          A class to export a ContentObject.
 */
abstract class ContentObjectExportImplementation extends AbstractContentObjectExportImplementation
{

    public static function launch(ContentObjectExportController $controller, ContentObject $content_object, $format, $type)
    {
        return self :: factory($controller, $content_object, $format, $type)->render();
    }

    public static function factory(ContentObjectExportController $controller, ContentObject $content_object, $format, $type)
    {
        $namespace = Utilities :: get_namespace_from_object($content_object);
        $class = $namespace . '\\' . Utilities :: underscores_to_camelcase($format) . Utilities :: underscores_to_camelcase($type) . 'ExportImplementation';

        if (! class_exists($class, true))
        {
            $class = __NAMESPACE__ . '\\' . Utilities :: underscores_to_camelcase($format) . Utilities :: underscores_to_camelcase($type) . 'ContentObjectExport';
            return new $class(new DummyContentObjectExportImplementation($controller, $content_object));
        }
        else
        {
            return new $class($controller, $content_object);
        }
    }

    public static function get_types(array $types = array())
    {
        $types[] = ContentObjectExport :: FORMAT_CPO;
        return $types;
    }

    public static function get_types_for_object($content_object_namespace)
    {
        $class = $content_object_namespace . '\\' . 'ExportImplementation';

        if (! class_exists($class, true))
        {
            return self :: get_types();
        }
        else
        {
            return $class :: get_types();
        }
    }

}
