<?php
namespace repository;

class WebpageImportParameters extends ImportParameters
{
    const CLASS_NAME = __CLASS__;

    /**
     *
     * @var int
     */
    private $document_type;

    /**
     *
     * @var \common\libraries\FileProperties
     */
    private $file;

    /**
     *
     * @var string
     */
    private $link;

    /**
     *
     * @param string $type
     * @param int $user
     * @param int $category
     * @param \common\libraries\FileProperties $file
     * @param multitype:mixed $values
     */
    public function __construct($type, $user, $category, $file, $values)
    {
        parent :: __construct($type, $user, $category);
        $this->document_type = $values[WebpageContentObjectImportForm :: PARAM_WEBPAGE_TYPE];
        $this->file = $file;
        $this->link = $values[WebpageContentObjectImportForm :: PROPERTY_LINK];
    }

    /**
     *
     * @return \common\libraries\FileProperties
     */
    public function get_file()
    {
        return $this->file;
    }

    /**
     *
     * @param \common\libraries\FileProperties $file
     */
    public function set_file($file)
    {
        $this->file = $file;
    }

    /**
     *
     * @return string
     */
    public function get_link()
    {
        return $this->link;
    }

    /**
     *
     * @param string $link
     */
    public function set_link($link)
    {
        $this->link = $link;
    }

    /**
     *
     * @return int
     */
    public function get_document_type()
    {
        return $this->document_type;
    }

    /**
     *
     * @param int $document_type
     */
    public function set_document_type($document_type)
    {
        $this->document_type = $document_type;
    }
}
