<?php
namespace repository;

use common\libraries\Utilities;
use common\libraries\DataClass;

class ContentObjectInclude extends DataClass
{
    const CLASS_NAME = __CLASS__;
    const PROPERTY_CONTENT_OBJECT_ID = 'content_object_id';
    const PROPERTY_INCLUDE_ID = 'include_id';

    private $include_object;

    /**
     *
     * @return string
     */
    public static function get_table_name()
    {
        return Utilities :: get_classname_from_namespace(self :: CLASS_NAME, true);
    }

    /**
     * Get the default properties of all content object attachments.
     *
     * @param array $extended_property_names
     *
     * @return array The property names.
     */
    public static function get_default_property_names($extended_property_names = array())
    {
        return parent :: get_default_property_names(
            array(self :: PROPERTY_CONTENT_OBJECT_ID, self :: PROPERTY_INCLUDE_ID)
        );
    }

    public function get_content_object_id()
    {
        return $this->get_default_property(self :: PROPERTY_CONTENT_OBJECT_ID);
    }

    public function set_content_object_id($content_object_id)
    {
        $this->set_default_property(self :: PROPERTY_CONTENT_OBJECT_ID, $content_object_id);
    }

    public function get_include_id()
    {
        return $this->get_default_property(self :: PROPERTY_INCLUDE_ID);
    }

    public function set_include_id($include_id)
    {
        $this->set_default_property(self :: PROPERTY_INCLUDE_ID, $include_id);
    }

    public function get_include_object()
    {
        if (! isset($this->include_object))
        {
            $this->include_object = DataManager :: retrieve_content_object($this->get_include_id());
        }
        return $this->include_object;
    }
}
