<?php
namespace repository;

use common\libraries\Utilities;

/**
 *
 * @package repository.lib
 *         
 *          A class to render a ContentObject.
 */
abstract class ContentObjectRenditionImplementation extends AbstractContentObjectRenditionImplementation
{

    public static function launch(ContentObject $content_object, $format, $view, $context)
    {
        return self :: factory($content_object, $format, $view, $context)->render();
    }

    public static function factory(ContentObject $content_object, $format, $view, $context)
    {
        $namespace = Utilities :: get_namespace_from_object($content_object);
        $class = $namespace . '\\' . Utilities :: underscores_to_camelcase($format) . Utilities :: underscores_to_camelcase($view) . 'RenditionImplementation';
        if (! class_exists($class, true))
        {
            // $class = __NAMESPACE__ . '\\' . Utilities ::
            // underscores_to_camelcase($format) . Utilities ::
            // underscores_to_camelcase($view) . 'ContentObjectRendition';
            // return new $class(new
            // DummyContentObjectRenditionImplementation($context,
            // $content_object));
            
            return new DummyContentObjectRenditionImplementation($context, $content_object, $format, $view);
        }
        else
        {
            return new $class($context, $content_object);
        }
    }

    public function get_view()
    {
        $class_name_parts = explode('_', Utilities :: get_classname_from_object($this, true));
        return $class_name_parts[1];
    }

    public function get_format()
    {
        $class_name_parts = explode('_', Utilities :: get_classname_from_object($this, true));
        return $class_name_parts[0];
    }
}
