<?php
namespace repository;

use common\libraries\DataClassRetrievesParameters;
use common\libraries\ObjectTableDataProvider;

class ExternalInstanceBrowserTableDataProvider extends ObjectTableDataProvider
{

    /**
     * Constructor
     * 
     * @param $browser ExternalInstanceManager
     * @param $condition Condition
     */
    public function __construct($browser, $condition)
    {
        parent :: __construct($browser, $condition);
    }

    /**
     *
     * @param $offset int
     * @param $count int
     * @param $order_property string
     * @return ResultSet A set of matching external repositories.
     */
    public function get_objects($offset, $count, $order_property = null)
    {
        $parameters = new DataClassRetrievesParameters($this->get_condition(), $count, $offset, 
                $this->get_order_property($order_property));
        return DataManager :: retrieves(ExternalInstance :: class_name(), 
                $parameters);
    }

    public function get_object_count()
    {
        return DataManager :: count(ExternalInstance :: class_name(), $this->get_condition());
    }
}
