<?php
namespace repository;

use common\libraries\DataClassRetrievesParameters;
use common\libraries\DataClassCountParameters;
use common\libraries\ObjectTableDataProvider;

/**
 * $Id: repository_browser_table_data_provider.class.php 204 2009-11-13 12:51:30Z kariboe $
 *
 * @package repository.lib.repository_manager.component.browser
 */
class RepositoryBrowserTableDataProvider extends ObjectTableDataProvider
{

    private $type;

    /**
     * Constructor
     *
     * @param $browser RepositoryManagerComponent
     * @param $condition Condition
     */
    public function __construct($browser, $condition, $type)
    {
        parent :: __construct($browser, $condition);
        $this->type = $type;
    }

    public function get_objects($offset, $count, $order_property = null)
    {
        $order_property = $this->get_order_property($order_property);
        $parameters = new DataClassRetrievesParameters($this->get_condition(), $count, $offset, $order_property);
        return DataManager :: retrieve_active_content_objects($this->type, $parameters);
    }

    public function get_object_count()
    {
        $parameters = new DataClassCountParameters($this->get_condition());
        return DataManager :: count_active_content_objects($this->type, $parameters);
    }
}
