<?php
namespace repository;

use common\libraries\Theme;
use common\libraries\ObjectTable;

class ExportBrowserTable extends ObjectTable
{
    const DEFAULT_NAME = 'export_browser_table';
    
    private $browser;

    public function __construct($browser)
    {
        $this->browser = $browser;
        $model = new ExportBrowserTableColumnModel($browser);
        $renderer = new ExportBrowserTableCellRenderer($browser);
        $data_provider = new ExportBrowserTableDataProvider($browser);
        parent :: __construct($data_provider, ExportBrowserTable :: DEFAULT_NAME, $model, $renderer);
        
        $this->set_additional_parameters($browser->get_parameters());
        $this->set_default_row_count(count($browser->get_content_object_ids()));
    }

    public function get_objects($offset, $count, $order_column, $order_direction)
    {
        $table_data = parent :: get_objects($offset, $count, $order_column, $order_direction);
        $export_types = $this->browser->get_export_types();
        $row = array(' ', ' ');
        foreach ($export_types as $export_type)
        {
            $row[] = '<a href="' . $this->browser->get_content_objects_exporting_url($this->browser->get_export_types_cache($export_type), $export_type) . '">' . Theme :: get_common_image('action_export') . '</a>';
        }
        $table_data[] = $row;
        return $table_data;
    }
}
