<?php
namespace repository;

use common\libraries\ObjectTableColumnModel;
use common\libraries\ObjectTableColumn;
use common\libraries\StaticTableColumn;

class ExportBrowserTableColumnModel extends ObjectTableColumnModel
{
    private $browser;

    /**
     * Constructor
     */
    public function __construct($browser)
    {
        parent :: __construct();
        $this->browser = $browser;
        $this->get_default_columns();
    }

    private function get_default_columns()
    {
        $this->add_column(new ObjectTableColumn(ContentObject :: PROPERTY_TYPE));
        $this->add_column(new ObjectTableColumn(ContentObject :: PROPERTY_TITLE));

        foreach ($this->browser->get_export_types() as $type)
        {
            $this->add_column(new StaticTableColumn($type));
        }
    }
}
