<?php
namespace repository;

use common\libraries\Request;
use common\libraries\Utilities;
use common\libraries\GalleryObjectTable;

/**
 * $Id: repository_browser_gallery_table.class.php 204 2009-11-13 12:51:30Z kariboe $
 * @package repository.lib.repository_manager.component.browser
 */

/**
 * Table to display a set of content objects.
 */
class RepositoryBrowserGalleryTable extends GalleryObjectTable
{
    const DEFAULT_NAME = 'repository_browser_gallery_table';

    /**
     * Constructor
     * @see ContentObjectTable::ContentObjectTable()
     */
    public function __construct($browser, $parameters, $condition)
    {
        $type = $browser->get_repository_browser()->get_advanced_search_form()->get_type();
        if (! $type)
        {
            $type = ContentObject :: class_name();
        }

        $property_model = new RepositoryBrowserGalleryTablePropertyModel();
        $cell_renderer = new RepositoryBrowserGalleryTableCellRenderer($browser);
        $data_provider = new RepositoryBrowserGalleryTableDataProvider($browser, $condition, $type);

        parent :: __construct($data_provider, self :: DEFAULT_NAME, $cell_renderer, $property_model);

        $this->set_default_row_count(4);
        $this->set_default_column_count(4);
        $this->set_additional_parameters($parameters);
    }

    public static function handle_table_action()
    {
        $class = Utilities :: get_classname_from_namespace(__CLASS__, true);
        $ids = self :: get_selected_ids($class);
        Request :: set_get(RepositoryManager :: PARAM_CONTENT_OBJECT_ID, $ids);
    }
}
