<?php
namespace repository;

use common\libraries\DataClassCountParameters;
use common\libraries\DataClassRetrievesParameters;
use common\libraries\GalleryObjectTableDataProvider;

/**
 * $Id: repository_browser_gallery_table_data_provider.class.php 204 2009-11-13 12:51:30Z kariboe $
 *
 * @package repository.lib.repository_manager.component.browser
 */
/**
 * Data provider for a repository browser table. This class implements some functions to allow repository browser tables
 * to retrieve information about the content objects to display.
 */
class RepositoryBrowserGalleryTableDataProvider extends GalleryObjectTableDataProvider
{

    public function __construct($browser, $condition, $type)
    {
        parent :: __construct($browser, $condition);
        $this->type = $type;
    }

    /**
     * Gets the content objects
     *
     * @param int $offset
     * @param int $count
     * @param string $order_property
     * @return ResultSet A set of matching content objects.
     */
    public function get_objects($offset, $count, $order_property = null)
    {
        $order_property = $this->get_order_property($order_property);
        return DataManager :: retrieve_active_content_objects(
            $this->type,
            new DataClassRetrievesParameters($this->get_condition(), $count, $offset, $order_property));
    }

    /**
     * Gets the number of content objects in the table
     *
     * @return int
     */
    public function get_object_count()
    {
        return DataManager :: count_active_content_objects(
            $this->type,
            new DataClassCountParameters($this->get_condition()));
    }
}
