<?php
namespace repository;

use common\libraries\Utilities;
use common\libraries\Request;
use common\libraries\Translation;

class PreviewerComponent extends RepositoryManager
{

    public function display_header()
    {
        parent :: small_header();

        $html[] = '<div class="warning-banner">';
        $html[] = Translation :: get('PreviewModeWarning');
        $html[] = '</div>';
        echo implode("\n", $html);
    }

    public function display_footer()
    {
        $this->small_footer();
    }

    public function run()
    {
        $content_object = $this->get_root_content_object();
        $this->set_parameter(RepositoryManager :: PARAM_CONTENT_OBJECT_ID, $content_object->get_id());

        if ($content_object)
        {
            ComplexDisplayPreview :: launch($content_object->get_type(), $this);
        }
        else
        {
            $this->display_error_page(Translation :: get('NoObjectSelected', null, Utilities :: COMMON_LIBRARIES));
        }
    }

    public function get_root_content_object()
    {
        $content_object_id = Request :: get(RepositoryManager :: PARAM_CONTENT_OBJECT_ID);
        return \repository\DataManager :: retrieve_content_object($content_object_id);
    }
}
