<?php
namespace repository;

use common\libraries\Translation;
use common\libraries\ObjectTableColumn;
use common\libraries\StaticTableColumn;

/**
 * $Id: recycle_bin_browser_table_column_model.class.php 204 2009-11-13
 * 12:51:30Z kariboe $
 * 
 * @package repository.lib.repository_manager.component.recycle_bin_browser
 */

/**
 * Table column model for the recycle bin browser table
 */
class RecycleBinBrowserTableColumnModel extends DefaultContentObjectTableColumnModel
{
    /**
     * Column for the action links
     */
    private static $action_column;

    /**
     * Constructor
     */
    public function __construct()
    {
        parent :: __construct();
        $this->set_default_order_column(0);
        $col = new ObjectTableColumn(ContentObject :: PROPERTY_PARENT_ID);
        $col->set_title(Translation :: get('OriginalLocation'));
        $this->add_column($col);
        $this->add_column(self :: get_action_column());
    }

    /**
     * Gets the action column
     * 
     * @return ContentObjectTableColumn
     */
    public static function get_action_column()
    {
        if (! isset(self :: $action_column))
        {
            self :: $action_column = new StaticTableColumn('');
        }
        return self :: $action_column;
    }
}
