<?php
namespace repository;

use common\libraries\Request;
use repository\content_object\file\File;

class RepositoryViewerComponent extends RepositoryManager
{
    const PARAM_ELEMENT_NAME = 'element_name';

    public function run()
    {
        $element_name = $this->get_element_name();
        $this->set_parameter(self :: PARAM_ELEMENT_NAME, $element_name);

        if (! \repository\viewer\Manager :: is_ready_to_be_published())
        {
            $repository_viewer = \repository\viewer\Manager :: construct($this);
            $repository_viewer->set_maximum_select(\repository\viewer\Manager :: SELECT_SINGLE);
            $repository_viewer->run();
        }
        else
        {
            $this->display_header();

            $object_id = \repository\viewer\Manager :: get_selected_objects();
            $object = \repository\DataManager :: retrieve_content_object($object_id, File :: class_name());

            $html = array();
            $html[] = '<script type="text/javascript">';
            $html[] = 'window.opener.$("input[name=' . $element_name . '_title]").val("' . addslashes(
                $object->get_title()) . '");';
            $html[] = 'window.opener.$("input[name=' . $element_name . ']").val("' . addslashes($object->get_id()) .
                 '");';
            $html[] = 'window.close();';
            $html[] = '</script>';

            echo (implode("\n", $html));
            $this->display_footer();
        }
    }

    public function get_element_name()
    {
        return Request :: get(self :: PARAM_ELEMENT_NAME);
    }

    public function get_allowed_content_object_types()
    {
        return array(File :: class_name());
    }

    public function display_header()
    {
        $this->small_header();
    }

    public function display_footer()
    {
        $this->small_footer();
    }
}
