<?php
namespace repository;

use common\libraries\Utilities;
use common\libraries\Translation;
use common\libraries\ObjectTableFormAction;
use common\libraries\ObjectTable;

class ContentObjectTable extends ObjectTable
{
    const DEFAULT_NAME = 'image_content_object_table';

    public function __construct($parent, $owner, $types, $query, $table_actions)
    {
        $data_provider = new ContentObjectTableDataProvider($owner, $types, $query, $parent);
        $column_model = new ContentObjectTableColumnModel();
        $cell_renderer = new ContentObjectTableCellRenderer($parent);
        parent :: __construct($data_provider, self :: DEFAULT_NAME, $column_model, $cell_renderer);

        if ($parent->get_maximum_select() != \repository\viewer\Manager :: SELECT_SINGLE)
        {
            $actions = array();
            $actions[] = new ObjectTableFormAction(
                \repository\viewer\Manager :: PARAM_PUBLISH_SELECTED,
                Translation :: get('PublishSelected', null, Utilities :: COMMON_LIBRARIES),
                false);
        }

        $this->set_form_actions($actions);
    }
}
