<?php
namespace repository\viewer;

use repository\ContentObject;
use repository\DefaultContentObjectTableCellRenderer;

/**
 * This class is a cell renderer for a publication candidate table
 */
class ContentObjectTableCellRenderer extends DefaultContentObjectTableCellRenderer
{

    private $browser;

    /**
     * Constructor.
     */
    public function __construct($browser)
    {
        $this->browser = $browser;
    }

    /*
     * Inherited
     */
    public function render_cell($column, $content_object)
    {
        if ($column === ContentObjectTableColumnModel :: get_action_column())
        {
            return $this->get_actions($content_object);
        }
        return parent :: render_cell($column, $content_object);
    }

    public function get_actions(ContentObject $content_object)
    {
        return $this->browser->get_default_browser_actions($content_object)->as_html();
    }
}
