<?php
namespace repository\viewer;

use common\libraries\ObjectTableColumnModel;
use common\libraries\ObjectTableColumn;
use repository\ContentObject;
use common\libraries\StaticTableColumn;

/**
 * This class represents a column model for a publication candidate table
 */
class ContentObjectTableColumnModel extends ObjectTableColumnModel
{

    /**
     * The column with the action buttons.
     */
    private static $action_column;

    /**
     * Constructor.
     */
    public function __construct()
    {
        parent :: __construct(self :: get_columns(), 1, SORT_ASC);
    }

    /**
     * Gets the columns of this table.
     *
     * @return array An array of all columns in this table.
     * @see ContentObjectTableColumn
     */
    public function get_columns()
    {
        $columns = array();
        $columns[] = new ObjectTableColumn(ContentObject :: PROPERTY_TYPE);
        $columns[] = new ObjectTableColumn(ContentObject :: PROPERTY_TITLE);
        $columns[] = new ObjectTableColumn(ContentObject :: PROPERTY_DESCRIPTION);
        $columns[] = self :: get_action_column();
        return $columns;
    }

    /**
     * Gets the column wich contains the action buttons.
     *
     * @return ContentObjectTableColumn The action column.
     */
    public static function get_action_column()
    {
        if (! isset(self :: $action_column))
        {
            self :: $action_column = new StaticTableColumn('');
        }
        return self :: $action_column;
    }
}
