<?php

namespace rights;

use common\libraries\AdvancedElementFinderElement;

use group\GroupAjaxPlatformGroupsFeed;

/**
 * Feed to return the platform groups for the platform group entity
 *
 * @package roup
 *
 * @author Sven Vanpoucke
 */
class RightsAjaxPlatformGroupEntityFeed extends GroupAjaxPlatformGroupsFeed
{
    /**
     * The length for the filter prefix to remove
     */
    const FILTER_PREFIX_LENGTH = 2;

    /**
     * Returns the element for a specific group
     *
     * @param \group\Group $group
     *
     * @return AdvancedElementFinderElement
     */
    public function get_group_element($group)
    {
        return new AdvancedElementFinderElement(PlatformGroupEntity :: ENTITY_TYPE . '_' . $group->get_id(),
            'type type_group', $group->get_name(), $group->get_code(),
            AdvancedElementFinderElement :: TYPE_SELECTABLE_AND_FILTER);
    }

    /**
     * Returns the element for a specific user
     *
     * @param \user\User $user
     *
     * @return AdvancedElementFinderElement
     */
    public function get_user_element($user)
    {
        return new AdvancedElementFinderElement(UserEntity :: ENTITY_TYPE . '_' . $user->get_id(), 'type type_user',
            $user->get_fullname(), $user->get_official_code());
    }

}
