<?php
namespace rights;

use group\Group;
use group\DataManager as GroupDataManager;
use common\libraries\Path;
use common\libraries\Application;
use common\libraries\SubManager;
use common\libraries\Request;
use common\libraries\DataClassRetrievesParameters;

/**
 * $Id: group_right_manager.class.php 214 2009-11-13 13:57:37Z vanpouckesven $
 *
 * @package rights.lib.group_right_manager
 */
class GroupRightManager extends SubManager
{
    const PARAM_GROUP_RIGHT_ACTION = 'action';
    const PARAM_GROUP = 'group';
    const PARAM_SOURCE = 'source';
    const PARAM_LOCATION = 'location';
    const ACTION_BROWSE_GROUP_RIGHTS = 'browser';
    const ACTION_BROWSE_LOCATION_GROUP_RIGHTS = 'group';
    const ACTION_SET_GROUP_RIGHTS = 'setter';
    const DEFAULT_ACTION = self :: ACTION_BROWSE_GROUP_RIGHTS;

    public function __construct($rights_manager)
    {
        parent :: __construct($rights_manager);

        $rights_template_action = Request :: get(self :: PARAM_GROUP_RIGHT_ACTION);
        if ($rights_template_action)
        {
            $this->set_parameter(self :: PARAM_GROUP_RIGHT_ACTION, $rights_template_action);
        }
    }

    public function retrieve_locations($condition = null, $offset = null, $count = null, $order_property = null)
    {
        return $this->get_parent()->retrieve_locations($condition, $offset, $count, $order_property);
    }

    public function count_locations($conditions = null)
    {
        return $this->get_parent()->count_locations($conditions);
    }

    public function retrieve_location($location_id)
    {
        return $this->get_parent()->retrieve_location($location_id);
    }

    public function retrieve_group_right_location($right_id, $group_id, $location_id)
    {
        return $this->get_parent()->retrieve_group_right_location($right_id, $group_id, $location_id);
    }

    public function retrieve_groups($condition = null, $offset = null, $count = null, $order_property = null)
    {
        return GroupDataManager :: retrieves(
            Group :: class_name(),
            new DataClassRetrievesParameters($condition, $count, $offset, $order_property));
    }

    public function count_groups($conditions = null)
    {
        return GroupDataManager :: count(Group :: class_name(), $conditions);
    }

    /**
     * Helper function for the SubManager class, pending access to class constants via variables in PHP 5.3 e.g. $name =
     * $class :: DEFAULT_ACTION DO NOT USE IN THIS SUBMANAGER'S CONTEXT Instead use: - self :: DEFAULT_ACTION in the
     * context of this class - YourSubManager :: DEFAULT_ACTION in all other application classes
     */
    public static function get_default_action()
    {
        return self :: DEFAULT_ACTION;
    }

    /**
     * Helper function for the SubManager class, pending access to class constants via variables in PHP 5.3 e.g. $name =
     * $class :: PARAM_ACTION DO NOT USE IN THIS SUBMANAGER'S CONTEXT Instead use: - self :: PARAM_ACTION in the context
     * of this class - YourSubManager :: PARAM_ACTION in all other application classes
     */
    public static function get_action_parameter()
    {
        return self :: PARAM_GROUP_RIGHT_ACTION;
    }

    /**
     *
     * @param Application $application
     */
    public static function launch($application)
    {
        parent :: launch(__CLASS__, $application);
    }
}
