<?php
namespace rights;

use common\libraries\Utilities;
use common\libraries\DataClass;
/**
 * $Id: rights_template_right_location.class.php 214 2009-11-13 13:57:37Z vanpouckesven $
 * @package rights.lib
 * @author Hans de Bisschop
 */

class RightsTemplateRightLocation extends DataClass
{
    const CLASS_NAME = __CLASS__;
    const PROPERTY_RIGHT_ID = 'right_id';
    const PROPERTY_LOCATION_ID = 'location_id';
    const PROPERTY_RIGHTS_TEMPLATE_ID = 'rights_template_id';
    const PROPERTY_VALUE = 'value';

    /**
     * Get the default properties of all users.
     * @return array The property names.
     */
    public static function get_default_property_names()
    {
        return array(self :: PROPERTY_RIGHT_ID, self :: PROPERTY_RIGHTS_TEMPLATE_ID, self :: PROPERTY_LOCATION_ID, 
                self :: PROPERTY_VALUE);
    }

    /**
     * inherited
     */
    public function get_data_manager()
    {
        return RightsDataManager :: get_instance();
    }

    public function get_right_id()
    {
        return $this->get_default_property(self :: PROPERTY_RIGHT_ID);
    }

    public function set_right_id($right_id)
    {
        $this->set_default_property(self :: PROPERTY_RIGHT_ID, $right_id);
    }

    public function get_rights_template_id()
    {
        return $this->get_default_property(self :: PROPERTY_RIGHTS_TEMPLATE_ID);
    }

    public function set_rights_template_id($rights_template_id)
    {
        $this->set_default_property(self :: PROPERTY_RIGHTS_TEMPLATE_ID, $rights_template_id);
    }

    public function get_location_id()
    {
        return $this->get_default_property(self :: PROPERTY_LOCATION_ID);
    }

    public function set_location_id($location_id)
    {
        $this->set_default_property(self :: PROPERTY_LOCATION_ID, $location_id);
    }

    public function get_value()
    {
        return $this->get_default_property(self :: PROPERTY_VALUE);
    }

    public function set_value($value)
    {
        $this->set_default_property(self :: PROPERTY_VALUE, $value);
    }

    public function invert()
    {
        $value = $this->get_value();
        $this->set_value(! $value);
    }

    public function is_enabled()
    {
        return $this->get_value() == true;
    }

    public static function get_table_name()
    {
        return Utilities :: get_classname_from_namespace(self :: CLASS_NAME, true);
    }
    
    //DMTODO: move delete_rights_template here
    function delete()
    {
//        // Delete all rights_template_right_locations for that specific rights_template
//        $condition = new EqualityCondition(RightsTemplateRightLocation :: PROPERTY_RIGHTS_TEMPLATE_ID, $rights_template->get_id());
//        $this->delete_rights_template_right_locations($condition);
//
//        // Delete all links between this rights_template and users
//        // Code comes here ...
//        $udm = UserDataManager :: get_instance();
//
//        $condition = new EqualityCondition(UserRightsTemplate :: PROPERTY_RIGHTS_TEMPLATE_ID, $rights_template->get_id());
//        $udm->delete_user_rights_templates($condition);
//
//        // Delete all links between this rights_template and groups
//        // Code comes here ...
//        $condition = new EqualityCondition(GroupRightsTemplate :: PROPERTY_RIGHTS_TEMPLATE_ID, $rights_template->get_id());
//        GroupDataManager :: deletes(GroupRightsTemplate :: CLASS_NAME, $condition);
//
//        // Delete the actual rights_template
//
//
//        $condition = new EqualityCondition(RightsTemplate :: PROPERTY_ID, $rights_template->get_id());
//        return $this->delete(RightsTemplate :: get_table_name(), $condition);
    }
}
