<?php

namespace rights;

/**
 * Description of rights_user_entity
 *
 * @author Pieterjan Broekaert
 */
class RightsUserEntity implements RightsEntityInterface
{
    const ENTITY_TYPE = 1;
    
    private $user_cache;
    private static $instance;

    public static function get_instance($course_id)
    {
        if (! isset(self :: $instance))
        {
            self :: $instance = new self($course_id);
        }
        return self :: $instance;
    }

    public function get_entity_items($user_id)
    {        
        if (is_null($this->user_cache[$user_id]))
        {
            $this->user_cache[$user_id][$user_id] = $user_id;
        }
        
        return $this->user_cache[$user_id];
    }

    public function get_entity_type()
    {
        return RightsUserEntity :: ENTITY_TYPE;
    }

    /*
     * deprecated
     */
    public function get_entity_right_location($right, $entity_id, $location_id)
    {
        $object = DataManager :: retrieve_user_right_location($right, $entity_id, $location_id);
        
        if ($object instanceof UserRightLocation)
        {
            return $object->get_value();
        }
        else
        {
            return 0;
        }
    }
}
