<?php
namespace user\integration\reporting;

class Autoloader
{

    /**
     * The array mapping class names to paths
     *
     * @var multitype:string
     */
     private static $map = array(
         'Autoloader' => '/autoloader.class.php',
         'Block' => '/lib/block.class.php',
         'ActiveInactiveBlock' => '/lib/blocks/active_inactive_block.class.php',
         'BrowserBlock' => '/lib/blocks/browser_block.class.php',
         'CountryBlock' => '/lib/blocks/country_block.class.php',
         'LoginBlock' => '/lib/blocks/login.class.php',
         'LoginMonthBlock' => '/lib/blocks/logins_month.class.php',
         'LoginDayBlock' => '/lib/blocks/login_day.class.php',
         'LoginHourBlock' => '/lib/blocks/login_hour.class.php',
         'NoOfUsersBlock' => '/lib/blocks/no_of_users_block.class.php',
         'NoOfUsersPictureBlock' => '/lib/blocks/no_of_users_picture_block.class.php',
         'OperatingSystemBlock' => '/lib/blocks/operating_system_block.class.php',
         'ProviderBlock' => '/lib/blocks/provider_block.class.php',
         'RefererBlock' => '/lib/blocks/referer_block.class.php',
         'DataTemplate' => '/lib/templates/data.class.php',
         'LoginTemplate' => '/lib/templates/login.class.php',
         'Template' => '/lib/templates/template.class.php',
         'Activator' => '/package/activate/activator.class.php',
         'Deactivator' => '/package/deactivate/deactivator.class.php',
         'Installer' => '/package/install/installer.class.php'
    );

    /**
     * Try to load the class
     *
     * @param $classname string
     * @return boolean
     */
    public static function load($classname)
    {
        if (isset(self :: $map[$classname]))
        {
            require_once __DIR__ . self :: $map[$classname];
            return true;
        }

        return false;
    }

    /**
     * Synchronize the autoloader
     *
     * @param $update boolean
     * @return multitype:string
     */
    public static function synch($update)
    {
        return \common\libraries\AutoloaderUtilities :: synch(__DIR__, __DIR__, $update);
    }

}
?>