<?php
namespace user\integration\reporting;

use tracking\Tracker;
use reporting\ReportingData;
use common\libraries\Translation;
use common\libraries\EqualityCondition;
use common\libraries\AndCondition;

class LoginHourBlock extends Block
{

    public function count_data()
    {
        $reporting_data = new ReportingData();
        $conditions = array();
        $conditions[] = new EqualityCondition(\user\integration\tracking\LoginLogout :: PROPERTY_TYPE, 'login');
        $user_id = $this->get_user_id();
        if (isset($user_id))
        {
            $conditions[] = new EqualityCondition(\user\integration\tracking\LoginLogout :: PROPERTY_USER_ID, $user_id);
        }
        $condition = new AndCondition($conditions);

        $data = Tracker :: get_data(\user\integration\tracking\LoginLogout :: CLASS_NAME,
                \user\UserManager :: APPLICATION_NAME, $condition);

        $hours = Block :: getDateArray($data, 'G');

        $hours_names = array(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24);
        $reporting_data->set_categories($hours_names);
        $reporting_data->set_rows(array(Translation :: get('Logins')));

        foreach ($hours_names as $key => $name)
        {
            $reporting_data->add_data_category_row($name, Translation :: get('Logins'),
                    ($hours[$key] ? $hours[$key] : 0));
        }
        return $reporting_data;
    }

    public function retrieve_data()
    {
        return $this->count_data();
    }

    public function get_application()
    {
        return \user\UserManager :: APPLICATION_NAME;
    }

    public function get_views()
    {
        return array(\reporting\viewer\HtmlBlockRendition :: VIEW_TABLE, \reporting\viewer\HtmlBlockRendition :: VIEW_PIE,
                \reporting\viewer\HtmlBlockRendition :: VIEW_BAR, \reporting\viewer\HtmlBlockRendition :: VIEW_LINE,
                \reporting\viewer\HtmlBlockRendition :: VIEW_AREA, \reporting\viewer\HtmlBlockRendition :: VIEW_CSV,
                \reporting\viewer\HtmlBlockRendition :: VIEW_XLSX, \reporting\viewer\HtmlBlockRendition :: VIEW_ODS,
                \reporting\viewer\HtmlBlockRendition :: VIEW_XML);
    }
}
