<?php
namespace user\integration\reporting;

use tracking\Tracker;
use reporting\ReportingData;
use common\libraries\Translation;
use common\libraries\EqualityCondition;
use common\libraries\AndCondition;
use common\libraries\Utilities;

class LoginMonthBlock extends Block
{

    public function count_data()
    {
        $reporting_data = new ReportingData();
        $conditions = array();
        $conditions[] = new EqualityCondition(\user\integration\tracking\LoginLogout :: PROPERTY_TYPE, 'login');
        $user_id = $this->get_user_id();
        if (isset($user_id))
        {
            $conditions[] = new EqualityCondition(\user\integration\tracking\LoginLogout :: PROPERTY_USER_ID, $user_id);
        }
        $condition = new AndCondition($conditions);

        $data = Tracker :: get_data(\user\integration\tracking\LoginLogout :: CLASS_NAME,
                \user\UserManager :: APPLICATION_NAME, $condition);

        $months_names = array(Translation :: get('JanuaryLong', null, Utilities :: COMMON_LIBRARIES),
                Translation :: get('FebruaryLong', null, Utilities :: COMMON_LIBRARIES),
                Translation :: get('MarchLong', null, Utilities :: COMMON_LIBRARIES),
                Translation :: get('AprilLong', null, Utilities :: COMMON_LIBRARIES),
                Translation :: get('MayLong', null, Utilities :: COMMON_LIBRARIES),
                Translation :: get('JuneLong', null, Utilities :: COMMON_LIBRARIES),
                Translation :: get('JulyLong', null, Utilities :: COMMON_LIBRARIES),
                Translation :: get('AugustLong', null, Utilities :: COMMON_LIBRARIES),
                Translation :: get('SeptemberLong', null, Utilities :: COMMON_LIBRARIES),
                Translation :: get('OctoberLong', null, Utilities :: COMMON_LIBRARIES),
                Translation :: get('NovemberLong', null, Utilities :: COMMON_LIBRARIES),
                Translation :: get('DecemberLong', null, Utilities :: COMMON_LIBRARIES));
        $months = Block :: getDateArray($data, 'n');

        $reporting_data->set_categories($months_names);
        $reporting_data->set_rows(array(Translation :: get('Logins')));

        foreach ($months_names as $key => $name)
        {
            $reporting_data->add_data_category_row($name, Translation :: get('Logins'),
                    ($months[$key + 1] ? $months[$key + 1] : 0));
        }
        return $reporting_data;
    }

    public function retrieve_data()
    {
        return $this->count_data();
    }

    public function get_application()
    {
        return \user\UserManager :: APPLICATION_NAME;
    }

    public function get_views()
    {
        return array(\reporting\viewer\HtmlBlockRendition :: VIEW_TABLE, \reporting\viewer\HtmlBlockRendition :: VIEW_PIE,
                \reporting\viewer\HtmlBlockRendition :: VIEW_CSV, \reporting\viewer\HtmlBlockRendition :: VIEW_XLSX,
                \reporting\viewer\HtmlBlockRendition :: VIEW_ODS, \reporting\viewer\HtmlBlockRendition :: VIEW_XML);
    }
}
