<?php
namespace user\integration\reporting;

use reporting\Reporting;
use reporting\ReportingData;
use common\libraries\Translation;
use common\libraries\EqualityCondition;

class RefererBlock extends Block
{

    public function count_data()
    {
        $reporting_data = new ReportingData();
        $tracker = new \user\integration\tracking\Referrer();
        $condition = new EqualityCondition(\user\integration\tracking\Referrer :: PROPERTY_TYPE, 'referer');
        $description[0] = Translation :: get('Referers');

        $data = Reporting :: array_from_tracker($tracker, $condition, $description);
        $keys = array_keys($data);
        $reporting_data->set_categories($keys);
        $reporting_data->set_rows(array(Translation :: get('Referers')));

        foreach ($keys as $key => $name)
        {
            $reporting_data->add_data_category_row($name, Translation :: get('Referers'), $data[$name]);
        }
        return $reporting_data;
    }

    public function retrieve_data()
    {
        return $this->count_data();
    }

    public function get_application()
    {
        return \user\UserManager :: APPLICATION_NAME;
    }

    public function get_views()
    {
        return array(\reporting\viewer\HtmlBlockRendition :: VIEW_TABLE, \reporting\viewer\HtmlBlockRendition :: VIEW_PIE,
                \reporting\viewer\HtmlBlockRendition :: VIEW_BAR, \reporting\viewer\HtmlBlockRendition :: VIEW_LINE,
                \reporting\viewer\HtmlBlockRendition :: VIEW_AREA, \reporting\viewer\HtmlBlockRendition :: VIEW_CSV,
                \reporting\viewer\HtmlBlockRendition :: VIEW_XLSX, \reporting\viewer\HtmlBlockRendition :: VIEW_ODS,
                \reporting\viewer\HtmlBlockRendition :: VIEW_XML);
    }
}
