<?php
namespace user\integration\reporting;

use common\libraries\Request;
use reporting\ReportingTemplate;

class LoginTemplate extends ReportingTemplate
{

    public function __construct($parent)
    {
        parent :: __construct($parent);

        $user_id = Request :: get(\user\UserManager :: PARAM_USER_USER_ID);
        $this->set_parameter(\user\UserManager :: PARAM_USER_USER_ID, $user_id);

        $this->add_reporting_block(new LoginDayBlock($this));
        $this->add_reporting_block(new LoginHourBlock($this));
        $this->add_reporting_block(new LoginMonthBlock($this));
        $this->add_reporting_block(new LoginBlock($this));
    }

    public function get_application()
    {
        return \user\UserManager :: APPLICATION_NAME;
    }

    public function display_context()
    {
    }
}
