<?php
namespace user;

use common\libraries\EqualityCondition;

use common\libraries\Utilities;
use common\libraries\DataClass;
/**
 * $Id: buddy_list_category.class.php 211 2009-11-13 13:28:39Z vanpouckesven $
 *
 * @author Sven Vanpoucke
 * @package user.lib
 */
class BuddyListCategory extends DataClass
{
    const CLASS_NAME = __CLASS__;

    const PROPERTY_ID = 'id';
    const PROPERTY_TITLE = 'title';
    const PROPERTY_USER_ID = 'user_id';

    /**
     * Get the default properties of all users quota objects.
     *
     * @return array The property names.
     */
    public static function get_default_property_names($extended_property_names = array())
    {
        return parent :: get_default_property_names(array(self :: PROPERTY_TITLE, self :: PROPERTY_USER_ID));
    }

    /**
     * inherited
     */
    public function get_data_manager()
    {
        return UserDataManager :: get_instance();
    }

    public function get_title()
    {
        return $this->get_default_property(self :: PROPERTY_TITLE);
    }

    public function set_title($title)
    {
        $this->set_default_property(self :: PROPERTY_TITLE, $title);
    }

    public function get_user_id()
    {
        return $this->get_default_property(self :: PROPERTY_USER_ID);
    }

    public function set_user_id($user_id)
    {
        $this->set_default_property(self :: PROPERTY_USER_ID, $user_id);
    }

    public static function get_table_name()
    {
        return Utilities :: camelcase_to_underscores(array_pop(explode('\\', self :: CLASS_NAME)));

        // return Utilities :: camelcase_to_underscores(self :: CLASS_NAME);
    }

    public function delete()
    {
        $condition = new EqualityCondition(BuddyListItem :: PROPERTY_CATEGORY_ID, $this->get_id());
        $success = DataManager :: updates(BuddyListItem :: class_name(), array(
                BuddyListItem :: PROPERTY_CATEGORY_ID => 0), $condition);

        if (! $success)
        {
            return false;
        }

        return parent :: delete();
    }
}
