<?php

namespace user;

use common\libraries\Redirect;
use common\libraries\Translation;

/**
 * @package user.lib.user_manager.component
 * Component to change back from user view to your normal account
 * @author Sven Vanpoucke
 */
class UserManagerAdminUserComponent extends UserManager
{

    /**
     * Runs this component and displays its output.
     */
    public function run()
    {
        $admin_user = \common\libraries\Session :: retrieve('_as_admin');
        
        if ($admin_user)
        {
            $checkurl = \common\libraries\Session :: retrieve('checkChamiloURL');
            \common\libraries\Session :: clear();
            \common\libraries\Session :: register('_uid', $admin_user);
            \common\libraries\Session :: register('checkChamiloURL', $checkurl);

            $this->redirect(null, false, array(), array(), false, Redirect :: TYPE_LINK, Redirect :: TYPE_INDEX);

        }
        else
        {
            $this->display_error_page(Translation :: get('NotAllowed'));
        }
    }

}
