<?php
namespace user;

use common\libraries\Utilities;
use common\libraries\Translation;
use common\libraries\Display;
use common\libraries\Request;
use common\libraries\AdministrationComponent;

/**
 *
 * @package user.lib.user_manager.component
 * @author Hans De Bisschop
 */
class UserManagerDeactivatorComponent extends UserManagerActiveChangerComponent implements AdministrationComponent
{

    /**
     * Runs this component and displays its output.
     */
    public function run()
    {
        if (! $this->get_user()->is_platform_admin())
        {
            $this->display_header();
            Display :: error_message(Translation :: get("NotAllowed", null, Utilities :: COMMON_LIBRARIES));
            $this->display_footer();
            exit();
        }

        Request :: set_get(self :: PARAM_ACTIVE, 0);
        parent :: run();
    }
}
