<?php
namespace user;

use common\libraries\Translation;
use common\libraries\Display;
use common\libraries\AdministrationComponent;
use common\libraries\BreadcrumbTrail;
use common\libraries\Utilities;
use common\extensions\dynamic_form_manager\DynamicFormManager;

/**
 * $Id: user_field_builder.class.php 211 2009-11-13 13:28:39Z vanpouckesven $
 *
 * @package user.lib.user_manager.component
 */
class UserManagerUserFieldsBuilderComponent extends UserManager implements AdministrationComponent
{

    /**
     * Runs this component and displays its output.
     */
    public function run()
    {
        if (! $this->get_user()->is_platform_admin())
        {
            $this->display_header();
            Display :: error_message(Translation :: get("NotAllowed", null, Utilities :: COMMON_LIBRARIES));
            $this->display_footer();
            exit();
        }

        $form_builder = new DynamicFormManager($this, UserManager :: APPLICATION_NAME, 'account_fields',
                DynamicFormManager :: TYPE_BUILDER);
        $form_builder->run();
    }

    public function add_additional_breadcrumbs(BreadcrumbTrail $breadcrumbtrail)
    {
        $breadcrumbtrail->add_help('user_fields_builder');
    }
}
