<?php
namespace webservice;
/**
 * @package group.lib
 *
 * This is an interface for a data manager for the Webservice application.
 * Data managers must implement this class.
 *
 * @author Hans De Bisschop
 */
interface WebserviceDataManagerInterface
{

    public function initialize();

    public function count_webservices($conditions = null);

    public function truncate_webservice($id);

    public function retrieve_webservice($id);

    public function retrieve_webservice_by_name($name);

    public function retrieve_webservices($condition = null, $offset = null, $count = null, $order_property = null);

    public function retrieve_webservice_category($id);

    public function retrieve_webservice_categories($condition = null, $offset = null, $count = null, $order_property = null);

    public function delete_webservice($webservice);

    public function update_webservice($webservice);

    public function create_webservice($webservice);

    public function create_webservice_category($webservice_category);

}
